
<?php
function CurrencyConverterApi_config()
{
	return array(
		"name" => "Currency Converter Api",
		"description" => "<p></p>",
		"version" => "1.0",
		"author" => 'currencyconverterapi.com',
		"author_url" => 'https://www.currencyconverterapi.com/',
		"configs" => array(
			"api_key" => array(
				"Name" => "API KEY",
				"Type" => "text",
				"Size" => "200",
				"Description" => "Enter API Key here",
				"Default" => "",
			),
			"api_plan" => array(
				"Name" => "Plan Type",
				"Type" => "radio",
				"Options" => "Free,Paid",
				"Description" => "Select Plan Type",
				"Default" => "Free",
			)
		)
	);
}

function CurrencyConverterApi_call($url){
	// Open CURL session:
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	// Get the data:
	$json = curl_exec($ch);
	curl_close($ch);
	// Decode JSON response:
	return json_decode($json);	
}

function CurrencyConverterApi_link($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];

    $query = "";
    $parts = explode(',',$to);
    foreach ($parts as $other) {$query .=$from.'_'.$other.',';}
    $query =  rtrim($query,',');

    $url = "https://free.currconv.com/api/v7/convert?q=".$query."&compact=ultra&apiKey=".$app_id;
	$result = CurrencyConverterApi_call($url);
	if(!empty($result->error)) return ['status'=>'error','message'=>$result->error];
	 $rates = [];
    foreach ($result as $key => $value) {
        $key = substr($key,-3);
        $rates[$key] = $value;
    }    
	return ['status'=>'success','rates_list'=>$rates];
}
function CurrencyConverterApi_test_api($arg){
	$exchange = $arg['exchange'];
	$app_id = $exchange['api_key'];
	$url = "https://free.currconv.com/api/v7/convert?q=USD_PHP&compact=ultra&apiKey=".$app_id;
	$result = CurrencyConverterApi_call($url);
	if(!empty($result->error)) return ['status'=>'error','message'=>$result->error];
	return ['status'=>'success'];
}
?>