<?php
function CurrencyLayer_config()
{
	return array(
		"name" => "Currency Layer",
		"description" => "<p></p>",
		"version" => "1.0",
		"author" => 'currencylayer.com',
		"author_url" => 'https://currencylayer.com/',
		"configs" => array(
			"api_key" => array(
				"Name" => "API KEY",
				"Type" => "text",
				"Size" => "200",
				"Description" => "Enter API Key here",
				"Default" => "",
			),
			"api_plan" => array(
				"Name" => "Plan Type",
				"Type" => "radio",
				"Options" => "Free,Paid",
				"Description" => "Select Plan Type",
				"Default" => "Free",
			)
		)
	);
}

function CurrencyLayer_call($url){
	// Open CURL session:
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	// Get the data:
	$json = curl_exec($ch);
	curl_close($ch);
	// Decode JSON response:
	return json_decode($json);	
}

function CurrencyLayer_link($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];
	 $url = "http://apilayer.net/api/live?access_key=".$app_id."&currencies=".$to."&source=".$from."&format=1";
	 $result = CurrencyLayer_call($url);
	
	if($result->error) return ['status'=>'error','message'=>$result->error->info];
	 $rates = [];
    foreach ($result->quotes as $key => $value) {
        $rates[$key] = $value;
    } 
	return ['status'=>'success','rates_list'=>$rates];
}
function CurrencyLayer_test_api($arg){
	$exchange = $arg['exchange'];
	$app_id = $exchange['api_key'];
	$url = "http://apilayer.net/api/live?access_key=".$app_id;
	$result = CurrencyLayer_call($url);
	if($result->error) return ['status'=>'error','message'=>$result->error->info];
	return ['status'=>'success'];
}
?>