

<?php
function exchangeratesapi_config()
{
	return array(
		"name" => "Exchange Rates Api",
		"description" => "<p></p>",
		"version" => "1.0",
		"author" => 'exchangeratesapi.io',
		"author_url" => 'http://exchangeratesapi.io/',
		"configs" => array(
			"api_key" => array(
				"Name" => "API KEY",
				"Type" => "text",
				"Size" => "200",
				"Description" => "Enter API Key here",
				"Default" => "",
			),
			"api_plan" => array(
				"Name" => "Plan Type",
				"Type" => "radio",
				"Options" => "Free,Paid",
				"Description" => "Select Plan Type",
				"Default" => "Free",
			)
		)
	);
}

function exchangeratesapi_call($url){
	// Initialize CURL:
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	// Store the data:
	$json = curl_exec($ch);
	curl_close($ch);
	// Decode JSON response:
	return json_decode($json, true);
}

function exchangeratesapi_link($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];

	 $isHttps = ($api_plan == "Paid") ? "https://":"http://";
	$url = $isHttps."api.exchangeratesapi.io/v1/latest?access_key=".$app_id."&base=".$from."&symbols=".$to."&format=1";
	$result = exchangeratesapi_call($url);
	if(!empty($result["error"])){
		if($result["error"]["code"] == "base_currency_access_restricted") 
			return ['status'=>'error','message'=>"Please upgrade to premium plan for selected base currency..."];
			return ['status'=>'error','message'=>$result["error"]["message"]];
	}
	 $rates = [];
    foreach ($result["rates"] as $key => $value) {
        $rates[$key] = $value;
    }    
	return ['status'=>'success','rates_list'=>$rates];
}
function exchangeratesapi_test_api($arg){
	$exchange = $arg['exchange'];
	$currency = $arg['currency'];
	$app_id = $exchange['api_key'];
	$from = $currency['from'];
	$to = $currency['to'];
	 $api_plan = $exchange['api_plan'];
	 $isHttps = ($api_plan == "Paid") ? "https://":"http://";
	$url = $isHttps."api.exchangeratesapi.io/v1/latest?access_key=".$app_id."&base=".$from."&symbols=".$to."&format=1";
	$result = exchangeratesapi_call($url);

	if(!empty($result["error"])){
		if($result["error"]["code"] == "base_currency_access_restricted") 
			return ['status'=>'error','message'=>"Please upgrade to premium plan for selected base currency..."];
			return ['status'=>'error','message'=>$result["error"]["message"]];
	}
	return ['status'=>'success'];
}
?>