<?php
function fixer_config()
{
	return array(
		"name" => "Fixer",
		"description" => "<p></p>",
		"version" => "1.0",
		"author" => 'fixer.io',
		"author_url" => 'https://fixer.io/',
		"configs" => array(
			"api_key" => array(
				"Name" => "API KEY",
				"Type" => "text",
				"Size" => "200",
				"Description" => "Enter API Key here",
				"Default" => "",
			),
			"api_plan" => array(
				"Name" => "Plan Type",
				"Type" => "radio",
				"Options" => "Free,Paid",
				"Description" => "Select Plan Type",
				"Default" => "Free",
			)
		)
	);
}

function fixer_call($url){
	// Open CURL session:
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	// Get the data:
	$json = curl_exec($ch);
	curl_close($ch);
	// Decode JSON response:
	return json_decode($json);	
}

function fixer_link($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];

	 if(empty($to))
		return ['status'=>'error','message'=>"Others Currencies required to fetch rates..."];
	 $url = "http://data.fixer.io/api/latest?access_key=".$app_id."&base=".$from."&symbols=".$to;
	 $result = fixer_call($url);

	if($result->error) return ['status'=>'error','message'=>fixer_api_errors($result->error->code)];
	 $rates = [];
    foreach ($result->rates as $key => $value) {
        $rates[$key] = $value;
    } 

	return ['status'=>'success','rates_list'=>$rates];
}
function fixer_test_api($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];

	 if(empty($to))
		return ['status'=>'error','message'=>"Others Currencies required to fetch rates..."];
	 $url = "http://data.fixer.io/api/latest?access_key=".$app_id."&base=".$from."&symbols=".$to;
	$result = fixer_call($url);
	if($result->error) return ['status'=>'error','message'=>fixer_api_errors($result->error->code)];
	return ['status'=>'success'];
}

    function fixer_api_errors($err){
        switch($err){
        case 404 :  $error = "The requested resource does not exist."; break;
        case 101 :  $error = "No API Key was specified or an invalid API Key was specified."; break;
        case 103 :  $error = "The requested API endpoint does not exist."; break;
        case 104 :  $error = "The maximum allowed API amount of monthly API requests has been reached."; break;
        case 105 :  $error = "The current subscription plan does not support this API endpoint., or Change Your Base Currency."; break;
        case 106 :  $error = "The current request did not return any results."; break;
        case 102 :  $error = "The account this API request is coming from is inactive."; break;
        case 201 :  $error = "An invalid base currency has been entered."; break;
        case 202 :  $error = "One or more invalid symbols have been specified."; break;
        case 301 :  $error = "No date has been specified. [historical]"; break;
        case 302 :  $error = "An invalid date has been specified. [historical, convert]"; break;
        case 403 :  $error = "No or an invalid amount has been specified. [convert]"; break;
        case 501 :  $error = "No or an invalid timeframe has been specified. [timeseries]"; break;
        case 502 :  $error = "No or an invalid \"start_date\" has been specified. [timeseries, fluctuation]"; break;
        case 503 :  $error = "No or an invalid \"end_date\" has been specified. [timeseries, fluctuation]"; break;
        case 504 :  $error = "An invalid timeframe has been specified. [timeseries, fluctuation]"; break;
        case 505 :  $error = "The specified timeframe is too long, exceeding 365 days. [timeseries, fluctuation]"; break;
        }
        return $error;
    }

?>