<?php 
include "token.php";
function gblicensingv1_info()
{
    return ["name" => "License Hosts v1", "version" => "1.2","RequiresServer" => false];
}
function gblicensingv1_TestConnection($params=[])
{
    if (empty(_s('serveraccesshash',$params,""))) return "Wrong ServerHash";
}
function gblicensingv1_call($action="",$args=[])
{
    global $token;
    $args['token'] = $token;
    $query = http_build_query($args);
    $ch = curl_init();
    curl_setopt($ch,CURLOPT_URL,"https://api.licensehosts.com/resellerapi/".$action."?".$query);
    curl_setopt($ch,CURLOPT_USERAGENT, 'Licensehosts');
    //curl_setopt($ch,CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query($args));
    $res = curl_exec($ch);
    return json_decode($res,true);
}
function gblicensingv1_softwares()
{
    return gblicensingv1_call("getsoftwares",[]);
}
function gblicensingv1_config($params=[])
{
    $query = "create table if not exists `mod_licensing` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`serviceid` INT( 10 ) NOT NULL ,`addon_id` INT(10) NOT NULL DEFAULT  0,`licensekey` TEXT NOT NULL ,`validdomain` TEXT NOT NULL ,`validip` TEXT NOT NULL ,`validdirectory` TEXT NOT NULL ,`reissues` INT( 1 ) NOT NULL ,`status` ENUM( 'Active', 'Reissued', 'Suspended', 'Expired' ) NOT NULL ,`lastaccess` datetime NOT NULL default '0000-00-00 00:00:00')";
    full_query($query);
    $query = "create table if not exists `mod_licensinglog` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`licenseid` INT( 10 ) NOT NULL ,`domain` TEXT NOT NULL ,`ip` TEXT NOT NULL ,`path` TEXT NOT NULL ,`message` TEXT NOT NULL ,`datetime` datetime NOT NULL default '0000-00-00 00:00:00')";
    full_query($query);
    $query = "create table if not exists `mod_licensingbans` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`type` VARCHAR(1) NOT NULL ,`value` TEXT NOT NULL ,`notes` TEXT NOT NULL )";
    full_query($query);
    $configs =  [
        "configoption1" => ["Name"=>"Package Name","Type" => "text", "Size" => "25", "Loader" => function ($params)
    {
        $res = gblicensingv1_softwares();
        $supportUpdateAddons = [];
        $supportUpdateAddons[0] = "None";
        $softwares = gblicensingv1_softwares();
        foreach ($softwares as $software)
        {
            $k = _s("key",$software,0);
            $v = _s("name",$software,0);
            $supportUpdateAddons[$k] = $v;
        }        
        return $supportUpdateAddons;
    }, "SimpleMode" => true],
    "configoption3" => ["Name"=>"Allow Reissue","Type" => "dropdown", "Description" => "Select Yes to allow license reissue from clientarea", "Options" => ["Yes","No"],"Default"=>"Yes"],
    "configoption4" => ["Name"=>"Domain Conflicts","Type" => "dropdown", "Description" => "Select Yes to Validate domain conflicts by Api  where license installed", "Options" => ["Yes","No"],"Default"=>"Yes"],
    "configoption5" => ["Name"=>"IP Conflicts","Type" => "dropdown", "Description" => "Set to Yes to validate IP address by Api  where license installed", "Options" =>["Yes","No"],"Default"=>"Yes"],
    "configoption6" => ["Name"=>"Directory Conflicts","Type" => "dropdown", "Description" => "Set to Yes to validate directory where license installed", "Options" =>["Yes","No"],"Default"=>"Yes"],
    ];
    $info = gblicensingv1_info();
    $info["configs"]=$configs;
    return $info;
}
function gblicensingv1_genkey($length, $prefix)
{
    if(!$length) $length = 10;
    $seeds = "abcdef0123456789";
    $key = NULL;
    $seeds_count = strlen($seeds) - 1;
    for( $i = 0; $i < $length; $i++ ) 
    {
        $key .= $seeds[rand(0, $seeds_count)];
    }
    $licensekey = $prefix . $key;
    $result = get_one("mod_licensing",["licensekey" => $licensekey],"COUNT(*) as total_rows");
    $total_rows = _s('total_rows',$result,0);
    if($total_rows) $licensekey = gblicensingv1_genkey($length, $prefix);
    return $licensekey;
}

function gblicensingv1_product_name($params=[])
{
    return $params['productpackage'];
}
function gblicensingv1_CreateAccount(array $params) 
{
    if (!array_key_exists('IP',$params['customfields'])) return ["status"=>"error","message"=>"Ip Null!"];
    if (empty($params['customfields']['IP'])) return ["status"=>"error","message"=>"Ip Empty!"];
	$result = get_one("mod_licensing",["serviceid"=>$params['serviceid']],"");
	if ($result) return ["status"=>"error","message"=>"A license has already been generated for this item"];
	$length = "5";
    $productname=gblicensingv1_product_name($params);
	$prefix = $productname."-";
	$cycle = $params['product']['service_billing_cycle_months'];
	if (!is_numeric($cycle)) $cycle = 1;    
    $res = gblicensingv1_call("register",['key'=>$productname,'ip'=>$params['customfields']['IP'],'month'=>$cycle]);
    if($res["status"] == "success")
    {
        updateService(["status" => "Active"],["id"=>$params["serviceid"]]);
        $licensekey = gblicensingv1_genkey($length,$prefix);
        insert_query( "mod_licensing",["serviceid" => $params['serviceid'], "licensekey" => $licensekey, "validdomain" => "", "validip" => $params['customfields']['IP'], "validdirectory" => "", "reissues" => "0", "status" => "Active"]);
        updateService(["domain_name" => $params['customfields']['IP'], "user_name" => "","password" => $licensekey],["id"=>$params["serviceid"]]);
        return ["status"=>"success","message"=>"License Account Created Successfully"];
    }
    return ["status"=>"error","message"=>$res["message"]];
}
function gblicensingv1_SuspendAccount($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = gblicensingv1_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
	$productname=gblicensingv1_product_name($params);
    $res = gblicensingv1_call("deactivate",['key'=>$productname,'ip'=>$params['customfields']['IP']]);
    if($res["status"]=="success")
    {
        update_query("mod_licensing",["status" => "Suspended"],["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
        return ["status"=>"success","message"=>"Account Suspended Successfully"];
    }
    return ["status"=>"error","message"=>$res["message"]];
}
function gblicensingv1_UnsuspendAccount($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = gblicensingv1_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
    $productname=gblicensingv1_product_name($params);
    $res = gblicensingv1_call("activate",['key'=>$productname,'ip'=>$params['customfields']['IP']]);
    if($res["status"]=="success")
    {
        update_query("mod_licensing",["status" => "Active"],["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
        return ["status"=>"success","message"=>"Account UnSuspended Successfully"];
    }
    return ["status"=>"error","message"=>$res["message"]];
}

function gblicensingv1_AdminCustomButtonArray($params=[])
{
    $status = $params["productstatus"];
    if(in_array($status,["Terminated","Pending","Completed","Cancelled","Fraud"])) return [];
    if($status == "Active") return ["Renew license" =>"ReNew"];
    if($status == "Suspended") return ["Delete license" =>"revoke"];
}
function gblicensingv1_ClientAreaCustomButtonArray($params=[])
{
    return [];
    return ["ChangeIp"=>"ChangeIp"];
}
function gblicensingv1_revoke($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = gblicensingv1_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
    $productname=gblicensingv1_product_name($params);
    $res = gblicensingv1_call("delete",['key'=>$productname,'ip'=>$params['customfields']['IP']]);
    if($res["status"]=="success")
    {    
        $isDeleted = delete_query("mod_licensing",["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
        if($isDeleted)
        {
            updateService(["status"=>"Terminated"],["id"=>$params["serviceid"]]);
            return ["status"=>"success","message"=>"Account Terminated Successfully"];
        }
        return ["status"=>"success","message"=>"Account Terminated Successfully"];
    }
    return ["status"=>"error","message"=>"Account Termination failed"];
}
function gblicensingv1_TerminateAccount($params)
{
    return gblicensingv1_revoke($params);
}
function gblicensingv1_ReNew($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = gblicensingv1_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
    $productname=gblicensingv1_product_name($params);
    $cycle = $params['product']['service_billing_cycle_months'];
    if (!is_numeric($cycle)) $cycle = 1;
    $res = gblicensingv1_call("register",['key'=>$productname,'ip'=>$params['customfields']['IP'],"month"=>$cycle]);
    if($res["status"]=="success")  return ["status"=>"success","message"=>"Account Renew Successfully"];
    return ["status"=>"error","message"=>$res["message"]];
}
function gblicensingv1_valid_input_clean($vals="")
{
    if(!empty($vals))
    {
        $vals = explode(",", $vals);
        foreach( $vals as $k => $v ) 
        {
            $vals[$k] = trim($v, " \t\n\r");
        }
        if(!empty($vals)) return implode(",", $vals);
    }
    return "";
}
function gblicensingv1_AdminServicesTabFields($params)
{
    $license = gblicensingv1_get_license($params);
    if($license) 
    {
        $licenseId = _s("id",$license,0);
        $validdomain = _s("validdomain",$license,"");
        $validip = _s("validip",$license,"");
        $validdirectory = _s("validdirectory",$license,"");
        $reissues = _s("reissues",$license,"");
        $status = _s("status",$license,"");
        $lastaccess = _s("lastaccess",$license,"");
        $licensekey = _s("licensekey",$license,"");
        return [
            'License KEY' => '<div class="clearfix col-md-12"><input type="text" value="'.$licensekey.'" class="form-control input-150" readonly/></div>',
            'Valid Directory' => '<div class="clearfix col-md-12"><input type="text" value="'.$validdirectory.'" class="form-control input-150" readonly/></div>',
        ];
    }
    return [];
}
function gblicensingv1_AdminServicesTabFieldsSave($params)
{
    update_query("mod_licensing",[
        "validdomain"=>gblicensingv1_valid_input_clean($_POST["modulefields"][0]),
        "validip"=>gblicensingv1_valid_input_clean($_POST["modulefields"][1]),
        "validdirectory"=>gblicensingv1_valid_input_clean($_POST["modulefields"][2]),
        "status"=>$_POST["modulefields"][3]],
        ["serviceid" => $params["serviceid"]]);
}
function gblicensingv1_ClientArea($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $licenseData = gblicensingv1_get_license($params);
    $licenseKey = _s("licensekey",$licenseData,"");
    $validDomain = _s("validdomain",$licenseData,"");
    $validdirectory = _s("validdirectory",$licenseData,"");
    $status = _s("status",$licenseData,"");
    $validIp = $params['customfields']['IP'];
    if(empty($validdirectory))
    {
        $productname=gblicensingv1_product_name($params);
        $res = gblicensingv1_call("licenseinfo",['key'=>$productname,'ip'=>$params['customfields']['IP']]);
        $validDirectory= _s("message",$res,"");
    }

    $allowReissues = $params["product"]["configurations"]["configoption3"];
    $allowDomainConflicts = $params["product"]["configurations"]["configoption4"];
    $allowIpConflicts = $params["product"]["configurations"]["configoption5"];
    $allowDirectoryConflicts = $params["product"]["configurations"]["configoption6"];
    $allowReissues = $allowReissues == "Yes" ? true:false;
    $allowDomainConflicts = $allowDomainConflicts == "Yes" ? true:false;
    $allowIpConflicts = $allowIpConflicts == "Yes" ? true:false;
    $allowDirectoryConflicts = $allowDirectoryConflicts == "Yes" ? true:false;
    $allowReissues = true;   

    return [
        "overrideDisplayTitle" => $productName,
        "overrideBreadcrumb" =>
        [
            ["clientarea.php?action=products&module=licencepro",WsLang("mylicenses")],
            ["clientarea.php?action=productdetails#",WsLang("manageLicense")]
        ],
        "templatefile"=>"managelicense.tpl",
        'templatepath' => 'modules/servers/licencepro/templates/',
        "vars"=>[
            "licensekey" => $licenseKey,
            "validdomain" => $validDomain,
            "validip" => $validIp,
            "validdirectory" => $validDirectory,
            "status" => $status,
            "allowreissues" => $allowReissues,
            "allowDomainConflicts" => $allowDomainConflicts,
            "allowIpConflicts" => $allowIpConflicts,
            "allowDirectoryConflicts" => $allowDirectoryConflicts
        ]
    ];
}
function gblicensingv1_ChangeIp($params)
{
    $license = gblicensingv1_get_license($params);
    $id = _s("id",$license,0);
    $reissues = _s("reissues",$license,0);
    if($license < 303)
    {
        $oIP = $params['customfields']['IP'];
        $productname=gblicensingv1_product_name($params);
        $IPc = _s("IPc",$_POST,"");
        if(empty($IPc)) return ["status"=>"error","message"=>"Please enter New IP address"];
        if($IPc == $oIP) return ["status"=>"error","message"=>"Old and New IPs must be different"];
        $res = gblicensingv1_call("changeiplicense",['key'=>$productname,'ip'=>$params['customfields']['IP'],'ip_new'=>$IPc]);
        if($res["status"]=="success")
        {  
            update_query('hosting',['domain_name'=>$IPc],['id'=>$params["serviceid"]]);
            UpdateCustomFieldValue(['value'=>$IPc],['relid'=>$params["serviceid"],'value' => $params['customfields']['IP']]);
            $reissues++;
            update_query("mod_licensing",["reissues"=>$reissues],["id"=>$id]);
            return ["status"=>"success","message"=>"IP Changed Successfully"];
        }
        return ["status"=>"error","message"=>$res["message"]];
    }
    return ["status"=>"error","message"=>"this license has changed IP for too many times, contact support"];
}
function gblicensingv1_does_license_exist(array $params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $isExist = select_query("mod_licensing","",["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
    return !empty($isExist) ? true:false;
}
function gblicensingv1_get_license(array $params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    return get_one("mod_licensing",["serviceid"=>$params["serviceid"],"addon_id"=>$addonId],"");
}