<?php 
function licencepro_info()
{
    return ["name" => "licencepro License", "version" => "1.1","RequiresServer" => false];
}
function licencepro_TestConnection($params=[])
{
    if (empty(_s('serveraccesshash',$params,""))) return "Wrong ServerHash";
}
function licencepro_config($params=[])
{
    $query = "create table if not exists `mod_licensing` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`serviceid` INT( 10 ) NOT NULL ,`addon_id` INT(10) NOT NULL DEFAULT  0,`licensekey` TEXT NOT NULL ,`validdomain` TEXT NOT NULL ,`validip` TEXT NOT NULL ,`validdirectory` TEXT NOT NULL ,`reissues` INT( 1 ) NOT NULL ,`status` ENUM( 'Active', 'Reissued', 'Suspended', 'Expired' ) NOT NULL ,`lastaccess` datetime NOT NULL default '0000-00-00 00:00:00')";
    full_query($query);
    $query = "create table if not exists `mod_licensinglog` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`licenseid` INT( 10 ) NOT NULL ,`domain` TEXT NOT NULL ,`ip` TEXT NOT NULL ,`path` TEXT NOT NULL ,`message` TEXT NOT NULL ,`datetime` datetime NOT NULL default '0000-00-00 00:00:00')";
    full_query($query);
    $query = "create table if not exists `mod_licensingbans` (`id` INT( 10 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,`type` VARCHAR(1) NOT NULL ,`value` TEXT NOT NULL ,`notes` TEXT NOT NULL )";
    full_query($query);
    $configs =  [
        "configoption1" => ["Name"=>"Package Name","Type" => "text", "Size" => "25", "Loader" => function ($params)
    {
        $supportUpdateAddons = [];
        $supportUpdateAddons[00] = "None";
        $supportUpdateAddons[10] = "cPanel";
        $supportUpdateAddons[11] = "cPanelDedicated";
        $supportUpdateAddons[12] = "CloudLinux";
        $supportUpdateAddons[13] = "LiteSpeed";
        $supportUpdateAddons[14] = "LiteSpeedAdc";
        $supportUpdateAddons[15] = "Cxs";
        $supportUpdateAddons[16] = "WHMreseller";
        $supportUpdateAddons[17] = "JetBackup";
        $supportUpdateAddons[18] = "imunify360";
        $supportUpdateAddons[19] = "PleskLinuxVPS";
        $supportUpdateAddons[20] = "PleskLinuxDedicated";
        $supportUpdateAddons[21] = "directadmin";
        $supportUpdateAddons[22] = "dareseller";
        $supportUpdateAddons[23] = "whmsonic";
        $supportUpdateAddons[24] = "osm";
        $supportUpdateAddons[25] = "softaculous";
        $supportUpdateAddons[26] = "virtualizor";
        $supportUpdateAddons[27] = "whmcs";
        $supportUpdateAddons[28] = "sitepad";
        $supportUpdateAddons[29] = "SYSCare";
        $supportUpdateAddons[30] = "CPGuard";
        return $supportUpdateAddons;
    }, "SimpleMode" => true],
    "configoption2" => ["Name"=>"Reseller Token","Type" => "text", "Size" => "150", "Description" => "Enter Reseller Token which provided by licence.cheap",],
    "configoption3" => ["Name"=>"Allow Reissue","Type" => "dropdown", "Description" => "Select Yes to allow license reissue from clientarea", "Options" => ["Yes","No"],"Default"=>"Yes"],
    "configoption4" => ["Name"=>"Domain Conflicts","Type" => "dropdown", "Description" => "Select Yes to Validate domain conflicts by Api  where license installed", "Options" => ["Yes","No"],"Default"=>"Yes"],
    "configoption5" => ["Name"=>"IP Conflicts","Type" => "dropdown", "Description" => "Set to Yes to validate IP address by Api  where license installed", "Options" =>["Yes","No"],"Default"=>"Yes"],
    "configoption6" => ["Name"=>"Directory Conflicts","Type" => "dropdown", "Description" => "Set to Yes to validate directory where license installed", "Options" =>["Yes","No"],"Default"=>"Yes"],
    ];    
    $info = licencepro_info();
    $info["configs"]=$configs;
    return $info;
}
function licencepro_genkey($length, $prefix)
{
    if(!$length) $length = 10;
    $seeds = "abcdef0123456789";
    $key = NULL;
    $seeds_count = strlen($seeds) - 1;
    for( $i = 0; $i < $length; $i++ ) 
    {
        $key .= $seeds[rand(0, $seeds_count)];
    }
    $licensekey = $prefix . $key;
    $result = get_one("mod_licensing",["licensekey" => $licensekey],"COUNT(*) as total_rows");
    $total_rows = _s('total_rows',$result,0);
    if($total_rows) $licensekey = licencepro_genkey($length, $prefix);
    return $licensekey;
}
function licencepro_call($params=[],$args=[])
{
    $reseller_token = $params["product"]["configurations"]["configoption2"];
    $args['token'] = $reseller_token;
    $ch = curl_init();
    curl_setopt($ch,CURLOPT_URL,"http://api.resellercenter.ir/rc/");
    curl_setopt($ch,CURLOPT_USERAGENT, 'ResellerCenter');
    curl_setopt($ch,CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query($args));
    $res = curl_exec($ch);
    return json_decode($res,true);
}
function licencepro_product_name($params=[])
{
    $prod= array('10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30');
    $rep = array('Cpanel','CpanelDedicated','CloudLinux','LiteSpeed','LiteSpeedAdc','Cxs','WHMreseller','JetBackup','imunify360','PleskLinuxVPS','PleskLinuxDedicated','directadmin','dareseller','whmsonic','osm','softaculous','virtualizor','whmcs','sitepad','SYSCare','CPGuard');
    return str_replace($prod,$rep,$params['productpackage']);
}
function licencepro_CreateAccount(array $params) 
{
    if (!array_key_exists('IP',$params['customfields'])) return ["status"=>"error","message"=>"Ip Null!"];
    if (empty($params['customfields']['IP'])) return ["status"=>"error","message"=>"Ip Empty!"];
	$result = get_one("mod_licensing",["serviceid"=>$params['serviceid']],"");
	if ($result) return ["status"=>"error","message"=>"A license has already been generated for this item"];
	$length = "5";
	$prefix = "RC-";
	$productname=licencepro_product_name($params);
	$cycle = $params['product']['service_billing_cycle_months'];
	if (!is_numeric($cycle)) $cycle = 1;
    $res = licencepro_call($params,['action'=>'license','Product'=>$productname,'Ip'=>$params['customfields']['IP'],'billingcycle'=>$cycle]);
    if($res["ok"] == "True")
    {
        updateService(["status" => "Active"],["id"=>$params["serviceid"]]);
        $licensekey = licencepro_genkey($length,$prefix);
        insert_query( "mod_licensing",["serviceid" => $params['serviceid'], "licensekey" => $licensekey, "validdomain" => "", "validip" => $params['customfields']['IP'], "validdirectory" => "", "reissues" => "0", "status" => "Active"]);
        updateService(["domain_name" => $params['customfields']['IP'], "user_name" => "","password" => $licensekey],["id"=>$params["serviceid"]]);
        return ["status"=>"success","message"=>"License Account Created Successfully"];
    }
    return ["status"=>"error","message"=>$res["message"]];
}
function licencepro_SuspendAccount($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = licencepro_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
	$productname=licencepro_product_name($params);
    $res = licencepro_call($params,['action'=>'Ban','Product'=>$productname,'Ip'=>$params['customfields']['IP']]);
    if($res["ok"]=="True")
    {
        update_query("mod_licensing",["status" => "Suspended"],["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
        return ["status"=>"success","message"=>"Account Suspended Successfully"];
    }
    return ["status"=>"error","message"=>$res["message"]];
}
function licencepro_UnsuspendAccount($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = licencepro_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
    $productname=licencepro_product_name($params);
    $res = licencepro_call($params,['action'=>'UnBan','Product'=>$productname,'Ip'=>$params['customfields']['IP']]);
    if($res["ok"]=="True")
    {
        update_query("mod_licensing",["status" => "Active"],["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
        return ["status"=>"success","message"=>"Account UnSuspended Successfully"];
    }
    return ["status"=>"error","message"=>$res["message"]];
}

function licencepro_AdminCustomButtonArray($params=[])
{
    $status = $params["productstatus"];
    if(in_array($status,["Terminated","Pending","Completed","Cancelled","Fraud"])) return [];
    if($status == "Active") return ["Renew license" =>"ReNew"];
    if($status == "Suspended") return ["Delete license" =>"revoke"];
}
function licencepro_ClientAreaCustomButtonArray($params=[])
{
    return [];
    return ["ChangeIp"=>"ChangeIp"];
}
function licencepro_revoke($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = licencepro_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
    $isDeleted = delete_query("mod_licensing",["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
    if($isDeleted)
    {
        updateService(["status"=>"Terminated"],["id"=>$params["serviceid"]]);
        return ["status"=>"success","message"=>"Account Terminated Successfully"];
    }
    return ["status"=>"error","message"=>"Account Termination failed"];
}
function licencepro_TerminateAccount($params)
{
    return licencepro_revoke($params);
}
function licencepro_ReNew($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $existingLicense = licencepro_does_license_exist($params);
    if(!$existingLicense) return ["status"=>"error","message"=>"No license exists for this item"];
    $productname=licencepro_product_name($params);
    $cycle = $params['product']['service_billing_cycle_months'];
    if (!is_numeric($cycle)) $cycle = 1;
    $res = licencepro_call($params,['action'=>'ReNew','Product'=>$productname,'Ip'=>$params['customfields']['IP'],'billingcycle'=>$cycle]);
    if($res["ok"]=="True") return ["status"=>"success","message"=>"Account Renew Successfully"];
    return ["status"=>"error","message"=>$res["message"]];
}
function licencepro_valid_input_clean($vals="")
{
    if(!empty($vals))
    {
        $vals = explode(",", $vals);
        foreach( $vals as $k => $v ) 
        {
            $vals[$k] = trim($v, " \t\n\r");
        }
        if(!empty($vals)) return implode(",", $vals);
    }
    return "";
}
function licencepro_AdminServicesTabFields($params)
{
    $license = licencepro_get_license($params);
    if($license) 
    {
        $licenseId = _s("id",$license,0);
        $validdomain = _s("validdomain",$license,"");
        $validip = _s("validip",$license,"");
        $validdirectory = _s("validdirectory",$license,"");
        $reissues = _s("reissues",$license,"");
        $status = _s("status",$license,"");
        $lastaccess = _s("lastaccess",$license,"");
        $licensekey = _s("licensekey",$license,"");
        return [
            'License KEY' => '<div class="clearfix col-md-12"><input type="text" value="'.$licensekey.'" class="form-control input-150" readonly/></div>',
            'Valid Directory' => '<div class="clearfix col-md-12"><input type="text" value="'.$validdirectory.'" class="form-control input-150" readonly/></div>',
        ];
    }
    return [];
}
function licencepro_AdminServicesTabFieldsSave($params)
{
    update_query("mod_licensing",[
        "validdomain"=>licencepro_valid_input_clean($_POST["modulefields"][0]),
        "validip"=>licencepro_valid_input_clean($_POST["modulefields"][1]),
        "validdirectory"=>licencepro_valid_input_clean($_POST["modulefields"][2]),
        "status"=>$_POST["modulefields"][3]],
        ["serviceid" => $params["serviceid"]]);
}
function licencepro_ClientArea($params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $licenseData = licencepro_get_license($params);
    $licenseKey = _s("licensekey",$licenseData,"");
    $validDomain = _s("validdomain",$licenseData,"");
    $validdirectory = _s("validdirectory",$licenseData,"");
    $status = _s("status",$licenseData,"");
    $validIp = $params['customfields']['IP'];
    if(empty($validdirectory))
    {
        $res = licencepro_call($params,['action'=>'ShowHelp','serviceid'=>$params["serviceid"]]);
        $validDirectory= _s("message",$res,"");
    }

    $allowReissues = $params["product"]["configurations"]["configoption3"];
    $allowDomainConflicts = $params["product"]["configurations"]["configoption4"];
    $allowIpConflicts = $params["product"]["configurations"]["configoption5"];
    $allowDirectoryConflicts = $params["product"]["configurations"]["configoption6"];
    $allowReissues = $allowReissues == "Yes" ? true:false;
    $allowDomainConflicts = $allowDomainConflicts == "Yes" ? true:false;
    $allowIpConflicts = $allowIpConflicts == "Yes" ? true:false;
    $allowDirectoryConflicts = $allowDirectoryConflicts == "Yes" ? true:false;
    $allowReissues = true;   

    return [
        "overrideDisplayTitle" => $productName,
        "overrideBreadcrumb" =>
        [
            ["clientarea.php?action=products&module=licencepro",WsLang("mylicenses")],
            ["clientarea.php?action=productdetails#",WsLang("manageLicense")]
        ],
        "templatefile"=>"managelicense.tpl",
        'templatepath' => 'modules/servers/licencepro/templates/',
        "vars"=>[
            "licensekey" => $licenseKey,
            "validdomain" => $validDomain,
            "validip" => $validIp,
            "validdirectory" => $validDirectory,
            "status" => $status,
            "allowreissues" => $allowReissues,
            "allowDomainConflicts" => $allowDomainConflicts,
            "allowIpConflicts" => $allowIpConflicts,
            "allowDirectoryConflicts" => $allowDirectoryConflicts
        ]
    ];
}
function licencepro_ChangeIp($params)
{
    $license = licencepro_get_license($params);
    $id = _s("id",$license,0);
    $reissues = _s("reissues",$license,0);
    if($license < 303)
    {
        $oIP = $params['customfields']['IP'];
        $productname=licencepro_product_name($params);
        $IPc = _s("IPc",$_POST,"");
        if(empty($IPc)) return ["status"=>"error","message"=>"Please enter New IP address"];
        if($IPc == $oIP) return ["status"=>"error","message"=>"Old and New IPs must be different"];
        $res = licencepro_call($params,['action'=>'ChangeIp','Product'=>$productname,'Ip'=>$params['customfields']['IP'],'Replace'=>$IPc]);
        if($res["ok"]=="True")
        {
            update_query('hosting',['domain_name'=>$IPc],['id'=>$params["serviceid"]]);
            UpdateCustomFieldValue(['value'=>$IPc],['relid'=>$params["serviceid"],'value' => $params['customfields']['IP']]);
            $reissues++;
            update_query("mod_licensing",["reissues"=>$reissues],["id"=>$id]);
            return ["status"=>"success","message"=>"IP Changed Successfully"];
        }
        return ["status"=>"error","message"=>$res["message"]];
    }
    return ["status"=>"error","message"=>"this license has changed IP for too many times, contact support"];
}
function licencepro_does_license_exist(array $params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    $isExist = select_query("mod_licensing","",["serviceid"=>$params["serviceid"],"addon_id"=>$addonId]);
    return !empty($isExist) ? true:false;
}
function licencepro_get_license(array $params)
{
    $addonId = 0;
    if(array_key_exists("addonId", $params)) $addonId= $params["addonId"];
    $addonId = (int)$addonId>0 ? $addonId:0;
    return get_one("mod_licensing",["serviceid"=>$params["serviceid"],"addon_id"=>$addonId],"");
}