<style>
/*
 CSS for the main interaction
*/
.tabset > input[type="radio"] {
  position: absolute;
  left: -200vw;
}

.tabset .tab-panel {
  display: none;
}

.tabset > input:first-child:checked ~ .tab-panels > .tab-panel:first-child,
.tabset > input:nth-child(3):checked ~ .tab-panels > .tab-panel:nth-child(2),
.tabset > input:nth-child(5):checked ~ .tab-panels > .tab-panel:nth-child(3),
.tabset > input:nth-child(7):checked ~ .tab-panels > .tab-panel:nth-child(4),
.tabset > input:nth-child(9):checked ~ .tab-panels > .tab-panel:nth-child(5),
.tabset > input:nth-child(11):checked ~ .tab-panels > .tab-panel:nth-child(6) {
  display: block;
}
.tabset > label {
  position: relative;
  display: inline-block;
  padding: 15px 15px 25px;
  border: 1px solid transparent;
  border-bottom: 0;
  cursor: pointer;
  font-weight: 600;
}

.tabset > label::after {
  content: "";
  position: absolute;
  left: 15px;
  bottom: 10px;
  width: 22px;
  height: 4px;
  background: #8d8d8d;
}

input:focus-visible + label {
  outline: 2px solid rgba(0,102,204,1);
  border-radius: 3px;
}

.tabset > label:hover,
.tabset > input:focus + label,
.tabset > input:checked + label {
  color: #06c;
}

.tabset > label:hover::after,
.tabset > input:focus + label::after,
.tabset > input:checked + label::after {
  background: #06c;
}

.tabset > input:checked + label {
  border-color: #ccc;
  border-bottom: 1px solid #fff;
  margin-bottom: -1px;
}

.tab-panel {
  padding: 30px 0;
  border-top: 1px solid #ccc;
}
</style>
{if $status != "Active"}
<div class="alert alert-danger">
     License support and Updates are disabled
</div>
{if $suspendreason}
    <p style="text-align: left";>{$suspendreason}</p>
{/if}
{else}
<div class="alert alert-success">
     License support and Updates are Enabled
</div>
{/if}
{if $status == "Reissued"}
    <div class="alert alert-success text-center">
        {$LANG.licensingaddon.reissuestatusmsg}
    </div>
{/if}
<div class="tabset">
  <input type="radio" name="tabset" id="tab1" aria-controls="Lic-Information" checked>
  <label for="tab1">Information</label>
  <input type="radio" name="tabset" id="tab2" aria-controls="Lic-Installation">
  <label for="tab2">Installation</label>
  <input type="radio" name="tabset" id="tab3" aria-controls="Lic-Change-Ip-Address">
  <label for="tab3">Change IP Address</label>
  
  <div class="tab-panels">
    <section id="Lic-Information" class="tab-panel">
        <p style="text-align: left";>Please do not hesitate to contact us if you had any issue or need additional support. support is free without extra charge</p><br>
        <h4 style="text-align: left";>Your license key (Your license ID)</h4>
        <input type="text" class="form-control" readonly="true" value="{$licensekey}" />
        <h4 style="text-align: left";>Licensed IP Address</h4>
        <textarea rows="1" class="form-control" readonly="true">{$validip}</textarea>
    </section>
    <section id="Lic-Installation" class="tab-panel">
        <h3 style="display: inline-block;">To install your license please run the following command in your server</h3>
        {if !$allowDirectoryConflicts}
            <h4 style="text-align: left";>Installation command</h4>
            <p style="text-align: left";>* You can contact support if you had any issues in installing our licenses</p>
            <pre style = "background: #f4f4f4;border: 1px solid #ddd;border-left: 3px solid #f36d33;color: #666;page-break-inside: avoid;font-family: monospace;font-size: 15px;line-height: 1.6;margin-bottom: 1.6em;max-width: 100%;overflow: auto;padding: 1em 1.5em;display: block;word-wrap: break-word;" class="language-bash" rows="5" dir="ltr" class="form-control" readonly="true">{$validdirectory}</pre>
        {/if}
    </section>
    <section id="Lic-Change-Ip-Address" class="tab-panel">
        <h4 style="text-align: left";>Change license IP address</h4>
        <p> Write your new IP and click Change IP</p>
        <div class="col-md-6">
            <form  method="post" action="" autocomplete="off"  onsubmit="ws.service_form_actions(this); return false;"  class="col-md-12 w-100  pull-left">
                <input type="hidden" name="id" value="{$myservice.id}">
                <input type="hidden" name="modop" value="custom">        
                <input type="hidden" name="act" value="ChangeIp">
                <input type="text" name="IPc" class="form-control" value="" required>
                <div class="clearfix"></div><br>
                    <button type="submit" class="btn btn-success btn-sm btn-block pull-right" {if $status != "Active"} disabled{/if}>Change IP</button>
            </form>
        </div>
    </section>
  </div>
</div>