<!-- Style -->
{$style}
<style>
/*
 CSS for the main interaction
*/
.tabset > input[type="radio"] {
  position: absolute;
  left: -200vw;
}

.tabset {
    margin-top: -87px;    
}
.tabset .tab-panel {
  display: none;
}

.tabset > input:first-child:checked ~ .tab-panels > .tab-panel:first-child,
.tabset > input:nth-child(3):checked ~ .tab-panels > .tab-panel:nth-child(2),
.tabset > input:nth-child(5):checked ~ .tab-panels > .tab-panel:nth-child(3),
.tabset > input:nth-child(7):checked ~ .tab-panels > .tab-panel:nth-child(4),
.tabset > input:nth-child(9):checked ~ .tab-panels > .tab-panel:nth-child(5),
.tabset > input:nth-child(11):checked ~ .tab-panels > .tab-panel:nth-child(6) {
  display: block;
}


.tabset > label {
  position: relative;
  display: inline-block;
  padding: 15px 15px 25px;
  border: 1px solid transparent;
  border-bottom: 0;
  cursor: pointer;
  font-weight: 600;
  background:#fff;
}

.tabset > label::after {
  content: "";
  position: absolute;
  left: 15px;
  bottom: 10px;
  width: 22px;
  height: 4px;
  background: #8d8d8d;
}

input:focus-visible + label {
  outline: 2px solid rgba(0,102,204,1);
  border-radius: 3px;
}

.tabset > label:hover,
.tabset > input:focus + label,
.tabset > input:checked + label {
  color: #06c;
}

.tabset > label:hover::after,
.tabset > input:focus + label::after,
.tabset > input:checked + label::after {
  background: #06c;
}

.tabset > input:checked + label {
  border-color: #ccc;
  border-bottom: 1px solid #fff;
  margin-bottom: -1px;
}

.tab-panel {
  padding: 30px 0;
  border-top: 1px solid #ccc;
}
</style>
{if !empty($error_msg) }
<div class="alert alert-danger"><b>Error:</b> {$error_msg}</div>
{/if}
<div class="clearfix"></div><br>
<div class="card mb-1">
    <div class="card-body">
        <div class="tabset">
          <!-- Tab 1 -->
          <input type="radio" name="tabset" id="tab1" aria-controls="onssl-info" checked>
          <label for="tab1">SSL Information</label>
          <!-- Tab 4 -->
          <input type="radio" name="tabset" id="tab4" aria-controls="onssl-csr">
          <label for="tab4">CSR</label>
          <!-- Tab 2 -->
          <input type="radio" name="tabset" id="tab2" aria-controls="onssl-certificate">
          <label for="tab2">SSL Certificate</label>
          <!-- Tab 3 -->
          <input type="radio" name="tabset" id="tab3" aria-controls="onssl-cabundle">
          <label for="tab3">Intermediate CA Bundle</label>
          
          <div class="tab-panels">
            <section id="onssl-info" class="tab-panel">
              <h2>SSL Information:</h2>
                <div class="row">
                    <div class="col-md-4 pull-left"><b>Supplier ID:</b> {$supplier_id}</div>
                    <div class="col-md-4 pull-left"><b>Approval Email:</b> {$approval_email}</div>
                    <div class="col-md-4 pull-left"><b>Contact Email:</b> {$contact_email}</div>
                    <div class="col-md-4 pull-left"><b>Expiry Date:</b> {$expiry_date}</div>
                    <div class="col-md-4 pull-left"><b>Status:</b> {$order_status}</div>
                    <div class="col-md-4 pull-left"><b>DV Method:</b> {$dv_method}</div>
                    <div class="col-md-4 pull-left"><b>Product:</b> {$product_type}</div>
                    <div class="col-md-4 pull-left"><b>Renewable Date:</b> {$renewable}</div>
                </div>
          </section>
            <section id="onssl-csr" class="tab-panel">
              <h2>CSR</h2>
              <textarea class="form-control opensrs_ssl_textbox"  rows="20" name="csr"> {$csr} </textarea>
            </section>
            <section id="onssl-certificate" class="tab-panel">
              <h2>SSL Certificate</h2>
              <textarea class="form-control opensrs_ssl_textbox" rows="20" name="cert"> {$cert} </textarea>
            </section>
            <section id="onssl-cabundle" class="tab-panel">
              <h2>Intermediate CA Bundle</h2>
              <textarea class="form-control opensrs_ssl_textbox"  rows="20" name="ca_certs"> {$ca_bundle} </textarea>
            </section>
          </div>
          
        </div>
    </div>
</div>