<?php
    if (!defined("WHASOLS")) die("This file cannot be accessed directly");
    require_once dirname(__FILE__) . "/namecheapapi.php";  
    function Namecheapssl_hook_sync()
    {
        set_time_limit(0);        
        $r = NcSql::q("select module_configurations from products_list where server_type='namecheapssl'");
        while ($row=NcSql::fetchAssoc($r))
        {
            $mconf = $row['module_configurations'];
            if(!empty($mconf))
            {
                $mconf = json_decode($mconf,true);
                $user = $mconf["configoption1"];
                $password = $mconf["configoption2"];
                $TestMode = $mconf["TestMode"];
                $user = ($TestMode == "yes") ? $mconf["SandboxUsername"]:$mconf["Username"];
                $password = ($TestMode == "yes") ? $mconf["SandboxApiKey"]:$mconf["ApiKey"];
                $debugMode = ($TestMode == "yes") ? true:true;
                Namecheapssl_hook_sync_2($user,$password,$debugMode);
            }
        }        
    }
    
    
    function Namecheapssl_hook_sync_2($user,$password,$debugMode = false){
        
        namecheapssl_log('hook.sync', 'sync_hook_started', $user);
        $sync_date_offset = NcSql::sql2cell("select value from mod_namecheapssl_settings where name='sync_date_offset'");        
        $api = new NamecheapApi($user, $password, $debugMode);
        $iPageSize = 22;
        $requestParams = array("Page" => 1, "PageSize" => $iPageSize);
        try{
            $response = $api->request("namecheap.ssl.getList", $requestParams);
            $result = $api->parseResponse($response);            
        }catch(Exception $e){
            echo $e->getMessage();
            return;
            //exit();
        }        
        if ($result) $iTotalPages = (int)  ceil($result['Paging']['TotalItems']/$iPageSize);          
        for($i=1;$i<=$iTotalPages;$i++){
            if (1!=$i){
                try{
                    $requestParams = array("Page" => $i, "PageSize" => $iPageSize);
                    $response = $api->request("namecheap.ssl.getList", $requestParams);
                    $result = $api->parseResponse($response);            
                }catch(Exception $e){
                    echo $e->getMessage();
                    return;
                    //exit();
                }
            }           
            foreach ($result["SSLListResult"]["SSL"] as $aCertInfo){
                
                if ('active'==$aCertInfo['@attributes']['Status'] || 'replaced'==$aCertInfo['@attributes']['Status']){
                    
                    
                    // synchronize expire date
                    list($month, $day, $year) = explode("/", $aCertInfo['@attributes']['ExpireDate']);
                    
                    // 
                    $res = NcSql::q("SELECT h.id FROM `hosting` h INNER JOIN `ssl_orders` s ON s.serviceid=h.id  WHERE s.remoteid='".(int)$aCertInfo['@attributes']['CertificateID']."' AND h.`nextduedate` != '".NcSql::e("$year-$month-$day")."'");
                    
                    if (NcSql::numRows($res)){
                        $iHostingId = array_shift(NcSql::fetchArray($res));
                        
                        $duedate = "$year-$month-$day";
                        if($sync_date_offset){
                             $duedate = date('Y-m-d',strtotime($duedate . "-$sync_date_offset days"));
                        }
                        
                        $sql = "update `hosting`
                                   set `nextduedate` = '".NcSql::e($duedate)."',
                                       `nextinvoicedate` = '". NcSql::e($duedate)."'
                                 where `id` = '".(int)$iHostingId."'";                        
                        NcSql::q($sql);
                        namecheapssl_log('hook.sync', 'sync_hook_updated_duedate', array("$duedate"),$iHostingId);
                    }
                    
                    // sync domain
                    if(!empty($aCertInfo['@attributes']['HostName']) && 'active'==$aCertInfo['@attributes']['Status']){
                        $domain = NcSql::e($aCertInfo['@attributes']['HostName']);
                        $res = NcSql::q("SELECT h.id FROM `hosting` h INNER JOIN `ssl_orders` s ON s.serviceid=h.id  WHERE s.remoteid='{$aCertInfo['@attributes']['CertificateID']}' AND h.`domain` != '$domain'");
                        if (NcSql::numRows($res)){
                            $iHostingId = array_shift(NcSql::fetchArray($res));
                            $sql = "update `hosting`
                                        set `domain` = '$domain'
                                        where `id` = '".(int)$iHostingId."'";								 
                            NcSql::q($sql);
                            namecheapssl_log('hook.sync', 'sync_hook_updated_domain', array($domain),$iHostingId);
                        }
                    }   
                }
                if ('replaced'==$aCertInfo['@attributes']['Status'])
                {
                    // synchronize reissue state
                    $sql ="SELECT * FROM ssl_orders WHERE remoteid='".(int)$aCertInfo['@attributes']['CertificateID']."'";
                    $r = NcSql::q($sql);
                    if (NcSql::numRows($r))
                    {
                        $aWhmcsCert = NcSql::fetchAssoc($r);
                        // get replaced certificate info                            
                        try{
                            $replaced_cert_request_params = array('CertificateID' => (int)$aWhmcsCert['remoteid']);        
                            $replaced_cert_response = $api->request("namecheap.ssl.getInfo", $replaced_cert_request_params);
                            $replaced_cert_result = $api->parseResponse($replaced_cert_response);
                            
                            if (!empty($replaced_cert_result["SSLGetInfoResult"]["@attributes"]["ReplacedBy"])){
                                
                                $replacedBy = (int)$replaced_cert_result["SSLGetInfoResult"]["@attributes"]["ReplacedBy"];
                                if(0==$replacedBy){
                                    echo 'Wrong "replaced by" attribute: ' . $replaced_cert_result["SSLGetInfoResult"]["@attributes"]["ReplacedBy"];
                                    return;
                                    //exit();
                                }
                                
                                $sql = "UPDATE ssl_orders SET remoteid='$replacedBy' WHERE remoteid='".(int)$aCertInfo['@attributes']['CertificateID']."'";
                                NcSql::q($sql);
                                
                                $sql = "UPDATE mod_namecheapssl SET certificate_id='$replacedBy' WHERE certificate_id='".(int)$aCertInfo['@attributes']['CertificateID']."'";
                                NcSql::q($sql);
                                
                                namecheapssl_log('hook.sync', 'sync_hook_updated_remoteid', array($aCertInfo['@attributes']['CertificateID'], $replacedBy),$aWhmcsCert['serviceid']);
                                
                            }
                            
                        }catch(Exception $e){
                            echo $e->getMessage();
                            return;
                        }
                    }
                }           
            }   
        }   
    }    
    function Namecheapssl_hook_report()
    {
        // create html for report
        $dateEnd = date('Y-m-d H:i:00');        
        $dateStart = date('Y-m-d H:i:59',  mktime(date('H'), date('i'), date('s'), date('n'), date('d')-1));
        $query = "select log.*,c.email from mod_namecheapssl_log log left join clients AS c ON (log.userid=c.id AND user='client') WHERE log.date BETWEEN '". NcSql::e($dateStart)."' AND '". NcSql::e($dateEnd)."' AND `debug`=0 ";
        $r = NcSql::q($query);
        if(NcSql::numRows($r))
        {
            $html = "Namecheap SSL Module Cron Job Report for $dateStart-$dateEnd <br><br>";
            while($row= NcSql::fetchAssoc($r)){
                $html .= "{$row['date']}; {$row['description']}; " . ('client' == $row['user'] ? ' User(client): ' . $row['email'] : ' Admin user: ' . $row['user']) . "({$row['userid']});" .  ( !empty($row['serviceid']) ? "Service id: {$row['serviceid']}; " : '') ;
                $html .= '<br>';
                
            }            
            sendAdminNotification('system', "SSL Actions Report", $html);
        }        
    }
    
    
    
    function Namecheapssl_hook_prevent_san_reduction($params)
    {
        if(!empty($params['filename']) && !empty($params['type']) && $params['filename']=='upgrade' && $params['type']=='configoptions')
        {
            if(!empty($params['configoptions'])&&!empty($params['id'])){
                
                $r = NcSql::q('SELECT products_list.server_type FROM products_list JOIN hosting ON hosting.packageid=products_list.id WHERE hosting.id='.(int)$params['id']);
                if(!$r){return;}
                $row = NcSql::fetchAssoc($r);
                if('namecheapssl'!==$row['server_type']) return;
                // so, it's definitely an upgrade page for namecheapssl product
                foreach($params['configoptions'] as $configid=>$newvalue)
                {                    
                    // check if options is san and related to namecheap module product
                    $r = NcSql::q("SELECT * FROM products_config_groups_options_childs WHERE id=".(int)$configid."");
                    $row = NcSql::fetchAssoc($r);
                    if(substr($row['title'],0,3)==='san')
                    {
                        // it's a san option; we need to check old value
                        $r = NcSql::q("SELECT qty FROM hosting_config_options WHERE relid=".(int)$params['id'] . " AND optionid=".(int)$configid);
                        $row = NcSql::fetchAssoc($r);
                        $qty = $row['qty'];
                        // this is it
                        if($newvalue<$qty){
                            $location = $params['SystemURL'] . '?m=namecheap_ssl&san_reduction';
                            header("Location: $location");
                            exit();
                        }                        
                    }
                }
            }
        }
        
    }
    
    
    if (function_exists('add_hook')){
        add_hook("DailyCronJob", 11, "Namecheapssl_hook_sync");
        add_hook("DailyCronJob", 12, "Namecheapssl_hook_report");        
        add_hook("ClientAreaPage", 10, 'Namecheapssl_hook_prevent_san_reduction');        
    }
    
?>