<?php
function openexchangerates_config()
{
	return array(
		"name" => "Open Exchange Rates",
		"description" => "<p></p>",
		"version" => "1.0",
		"author" => 'openexchangerates.org',
		"author_url" => 'https://openexchangerates.org/',
		"configs" => array(
			"api_key" => array(
				"Name" => "API KEY",
				"Type" => "text",
				"Size" => "200",
				"Description" => "Enter API Key here",
				"Default" => "",
			),
			"api_plan" => array(
				"Name" => "Plan Type",
				"Type" => "radio",
				"Options" => "Free,Paid",
				"Description" => "Select Plan Type",
				"Default" => "Free",
			)
		)
	);
}

function openexchangerates_call($url){
	// Open CURL session:
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	// Get the data:
	$json = curl_exec($ch);
	curl_close($ch);
	// Decode JSON response:
	return json_decode($json);	
}

function openexchangerates_link($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = str_replace(" ","",$currency['to']);
	 if(empty($app_id)) return ['status'=>'error','message'=>"API Key missing..."];
	 if(empty($to)) return ['status'=>'error','message'=>"Other Currencies required to fetch rates..."];
	 $url = "https://openexchangerates.org/api/latest.json?app_id=".$app_id."&base=".$from."&symbols=".$to;
	 $result = openexchangerates_call($url);
	if($result->error == true) return ['status'=>'error','message'=>$result->description];
	 $rates = [];
    foreach ($result->rates as $key => $value) {
        $rates[$key] = $value;
    } 	 
	return ['status'=>'success','rates_list'=>$rates];
}
function openexchangerates_test_api($arg){
	$currency = $arg['currency'];
	$exchange = $arg['exchange'];
	 $app_id = $exchange['api_key'];
	 $api_plan = $exchange['api_plan'];
	 $amount = $currency['amount'];
	 $from = $currency['from'];
	 $to = $currency['to'];
	if(empty($app_id)) return ['status'=>'error','message'=>"API Key missing..."];
	$url = "https://openexchangerates.org/api/latest.json?app_id=".$app_id."&base=".$from;
	$result = openexchangerates_call($url);
	$error =  $result->error;
	if($error == true) return ['status'=>'error','message'=>$result->description];
	return ['status'=>'success'];
}
?>