<?php 
if ( ! defined('WHASOLS')) exit('No direct script access allowed');
use Carbon\Carbon;
class Invoices_model extends CI_Model {
    private $uid =0;
    private $trans_id =0;
    private $last_paid_amount =0;
    private $aTemplate = "";
    private $tpath = "";
    private $type="";
    private $PaymentDescription="";
    public function __construct()
    {
        parent::__construct();
        $uinfo = $this->Account->GetCurrentUser();
        $this->uid = _s('userid', $uinfo, 0);
        $this->aTemplate = config_item('aTemplate');
        $this->tpath = ltrim($this->aTemplate, '/').'templates/invoices/';            
    }
    function AddFeeToInvoice($invoice_id)
    {
        // Remove any existing gateway fees for this invoice
        $this->db->delete(WST_INV_DETAIL, ["invoice_id" => $invoice_id, "type" => "GatewayFee"]);
        // Get invoice information
        $info = $this->invoice_info($invoice_id);
        if (empty($info)) return;
        $currency = _s("currency", $info, 0);
        $iuser_id = _s("user_id", $info, 0);
        $payment_method = _s("payment_method", $info, 0);
        $InvoiceAmount = _s("sale_amount", $info, 0) - _s("discount_amount", $info, 0);
        // Exit early if no invoice amount
        if ($InvoiceAmount <= 0) return;
        $GatewayInfo = $this->Gateway->gateway_variables($payment_method);
        if (empty($GatewayInfo["configs"])) return; // Exit early if no gateway configs
        $configs = $GatewayInfo["configs"]["gateway"];

        // Get fee details from configs
        $FeeFixed = _s("fixed_fee", $configs, 0);
        $FeePercentage = _s("percentage_fee", $configs, 0);
        $FeeMax = _s("max_fee", $configs, 0);
        // Exit early if no fees are applicable

        if (($FeeFixed + $FeePercentage) <= 0) return;

        // Calculate the applicable fee
        $FeeCalc = $FeeFixed + ($FeePercentage>0 ? $InvoiceAmount*($FeePercentage/100):0);
        $FeeApplicable = $FeeMax > 0 ? min($FeeCalc, $FeeMax) : $FeeCalc;
        $FeeApplicable = round($FeeApplicable,2);
        // Exit early if no applicable fee
        if ($FeeApplicable <= 0) return;
        // Prepare fee description
        $description = "Gateway Transaction Fee (";
        if ($FeeFixed > 0) $description .= $FeeFixed;
        if ($FeeFixed > 0 && $FeePercentage > 0) $description .= "+";
        if ($FeePercentage > 0) $description .= $FeePercentage . "%";
        $description .= ")";
        // Add fee to invoice
        $_POST = ["iid" => $invoice_id,"name" => $description,"qty" => 1,"rate" => $FeeApplicable,"cost" => $FeeApplicable,"discount" => 0,"icurrency" => $currency,"iuser_id" => $iuser_id,"type"=>"GatewayFee"];
        $this->invoice_item_add();
    }
    function ChangePaymentMethodToInvoice($arg=[])
    {
        $clientid = _s('clientid', $arg, 0);
        $invoice_id = _s('invoice_id', $arg, 0);
        $payment_method = _s('payment_method', $arg, 1);
        if(!empty($payment_method))
        {
            $isUpdated = $this->db->update(WST_INV, ['payment_method'=>$payment_method], ['id'=>$invoice_id, 'user_id'=>$clientid]);
            if($isUpdated)
            {
                $this->AddFeeToInvoice($invoice_id);
                return ["status"=>"success", "message"=>"Payment Method Updated Successfully"];
            }
            return ["status"=>"error", "message"=>"Payment Method Updation failed"];
        }
        return ["status"=>"error", "message"=>"Payment Method ID Required"];
    }
    function invoice_printable($invoice_id=0){
    $html = '<div class="print-ready">';
    $html .= $this->invoice_view($invoice_id, 'ADMIN');
    $html .= '</div>';
    echo $html;
    ?>
    <script>window.print();</script>
    <?php 
    exit(0);
    }
    function invoice_view_as_client($invoice_id=0)
    {
        $html = '';
        $html .= $this->invoice_view($invoice_id, 'ADMIN');
        echo $html;
        exit(0);
    }
  function invoice_download_pdf($invoice_id=0)
  {
        $INVOICE_PDF_SIZE = GetConfigs('INVOICE_PDF_SIZE');
        $html = $this->invoice_view($invoice_id, 'ADMIN', 'DOWNLOAD');
        header('Content-type: application/pdf');
        $this->pdf->loadHtml($html);
        // (Optional) Setup the paper size and orientation
        $this->pdf->setPaper($INVOICE_PDF_SIZE);
        // Render the HTML as PDF
        $this->pdf->render();
        $this->pdf->stream($invoice_id, array("Attachment"=>0));
        exit(0);
    }
  function invoice_download_pdf_by_client($invoice_id=0){
      $INVOICE_PDF_SIZE = GetConfigs('INVOICE_PDF_SIZE');
    $html = $this->invoice_view($invoice_id, 'CLIENT', 'DOWNLOAD');
    header('Content-type: application/pdf');
    $this->pdf->loadHtml($html);
    // (Optional) Setup the paper size and orientation
    $this->pdf->setPaper($INVOICE_PDF_SIZE);
    // Render the HTML as PDF
     $this->pdf->render();
     $this->pdf->stream($invoice_id, array("Attachment"=>0));
    exit(0);
    }    
    function invoices_status_by_id($id=0)
    {
       return $this->db->select('*')->where(['id'=>$id])->limit(1)->get(WST_INV_STATUS)->row();
    }
    function unpaid_invoices_by_user_id($user_id=0)
    {
        if($user_id > 0) return full_query("select * from ".WST_INV." where user_id=? and status in (2, 7) and invoice_type is null", [$user_id]);
        return [];
    }
    function InvoicesCountByProduct($arg=[])
    {
      $pid =_s('pid', $arg);
      $user_id =_s('clientid', $arg);
      $type =_s('type', $arg);
      if($pid>0 && $user_id>0)
      {
        $sql = "select count(id) as items from invoices_details where pid='$pid' and user_id='$user_id'";
        if($type == 'DOMAIN'){
          $sql .= " and type in ('domain-register', 'domain-transfer', 'DomainRenewal')";
        }
        $sql .= " and invoice_id in (select id from invoices where status=3 and user_id='$user_id')";
        $result = get_one($sql);     
        return _s('items', $result, 0);
      }
      return 0;
    }
    function CreateMassPaymentInvoices($user_id=0, $source="CLIENT")
    {
        if($source == "CLIENT" && $user_id!=$this->uid) return ["status"=>"error", "message"=>"Client ID not matched with login Client", "id"=>0];
        $invoices = $this->unpaid_invoices_by_user_id($user_id);
        if(empty($invoices)) return ["status"=>"error", "message"=>"Unpaid/Overdue Invoices not found", "id"=>0];
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1){ return array("2", WsLang('MsgUpdateProfileCurrency'));}
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        $bcCode = _s('code', $currencyBaseRate);
        if($base_conv_rate < 1) return array("status"=>"error", "message"=>WsLang('AffiliateUpBaseOtherCurrency'), "id"=>0);
        $ids = "";
        foreach($invoices as $row)
        {
            $ids .= _s('id', $row);
            $ids .=", ";
        }
        $ids = rtrim($ids, ", ");
        $isInvoicesExist = full_query("select * from invoices_details where user_id='$user_id' and type='Invoice' and pid in (".$ids.")");
        if(!empty($isInvoicesExist)) return ["status"=>"error", "message"=>"Invoice Creation Failed due to invoice already exist as unpaid, Plz pay asap.", "id"=>isset($isInvoicesExist[0]->invoice_id) ? $isInvoicesExist[0]->invoice_id:0];        
        $added_by = $user_id;
        if($source <> "CLIENT") $added_by = $this->uid;
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');
        $invoices_creation_count = 0;
        $payment_Due_days = GetConfigs('CRON_INVOICE_DUE_DAYS');
        $payment_Due_days = ($payment_Due_days > 0) ? $payment_Due_days:10;

        $date = new DateTime('+'.$payment_Due_days.' day');
        $due_date= $date->format('Y-m-d h:i:s');
        $invoice_no = $this->generate_new_invoice_no();
        $payment_method = 2;
        $gateway_id = 2;
        $ChildsAdded = 0;
        $sale_amount = 0;
        $discount_amount = 0;
        $paid_amount = 0;
        $tax_amount = 0;
        $tax_type = "";
        $cost_amount = 0;
        foreach($invoices as $row)
        {
            $sale_amount += _s('sale_amount', $row);
            $discount_amount += _s('discount_amount', $row);
            $paid_amount += _s('paid_amount', $row);
            $tax_amount += _s('tax_amount', $row);
            $cost_amount += _s('cost_amount', $row);
            $tax_type = _s('tax_type', $row);
        }
        $header = ['invoice_no'=>$invoice_no, 'cost_amount'=>$cost_amount, 'sale_amount'=>$sale_amount, 'discount_amount'=>$discount_amount, 
        'entry_date'=>$entry_date, 'updated_at'=>$entry_date, 'due_date'=>$due_date, 'paid_date'=>$due_date, 'status'=>2, 'currency'=>$icurrency, 'user_id'=>$user_id, 'base_conv_rate'=>$base_conv_rate, "tax_type"=>$tax_type, "invoice_type"=>"Invoice"];
        $this->db->insert(WST_INV, $header);
        $invoiceId = $this->db->insert_id();
        foreach($invoices as $row)
        {
            $id = _s('id', $row);
            $rinvoice_no = _s('invoice_no', $row);
            $sale_amount = _s('sale_amount', $row);
            $discount_amount = _s('discount_amount', $row);
            $paid_amount = _s('paid_amount', $row);
            $tax_amount = _s('tax_amount', $row);
            $cost_amount = _s('cost_amount', $row);
            $tax_type = _s('tax_type', $row);
            $due_date = _s('due_date', $row);
            $childs = ['pid'=>$id, 'invoice_id'=>$invoiceId, 'user_id'=>$user_id, 'description'=>"Invoice #:".$rinvoice_no.", Dated:".$due_date, 'cost'=>$cost_amount, 'rate'=>$sale_amount, 'discount'=>$discount_amount, 'base_conv_rate'=>$base_conv_rate, 'taxable'=>"YES", 'qty'=>1, 'type'=>"Invoice"];
            $isDone = $this->db->insert(WST_INV_DETAIL, $childs);
            if($isDone) $ChildsAdded++;
        }
        $TotalInvoices = count($invoices);
        if($TotalInvoices<>$ChildsAdded)
        {
            return ["status"=>"error", "message"=>"Invoice Creation failed due to mismatched Invoices Count", "id"=>0];
        }
        $this->AddFeeToInvoice($invoiceId);
        return ["status"=>"success", "message"=>"Invoice Created Successfully", "id"=>$invoiceId];
    }
    function invoice_payment_capture($id=0)
    {
        $id = (int)$id>0 ? $id:0;
        if($id == 0) return ["status"=>"error","message"=>"Invoice ID empty"];
        $InvoiceInfo = get_one("select a.id as invoice_id,a.user_id,a.invoice_no,b.id as card_id,b.payment_method,a.payment_method as iv_payment_method,a.status from invoices a join clients_credit_cards b on a.user_id=b.user_id and b.is_default='YES' where a.id=?",[$id]);
        if(empty($InvoiceInfo)) return ["status"=>"error","message"=>"Invoice or Client Saved Payment method not found"];
        $iv_status = _s("status",$InvoiceInfo,0);
        if($iv_status == 3) return ["status"=>"error","message"=>"Invoice status already marked as paid, So change invoice status to unpaid 1st then capture the payment"];
        $iv_payment_method = _s("iv_payment_method",$InvoiceInfo,0);
        $payment_method = _s("payment_method",$InvoiceInfo,0);
        $card_id = _s("card_id",$InvoiceInfo,0);
        $invoice_id = _s("invoice_id",$InvoiceInfo,0);
        $user_id = _s("user_id",$InvoiceInfo,0);
        $invoice_no = _s("invoice_no",$InvoiceInfo,"");
        if($iv_payment_method != $payment_method) $this->db->update("invoices",["payment_method"=>$payment_method],["id"=>$invoice_id]);
        $arg = ["card_id"=>$card_id,"invoice_id"=>$invoice_id,"user_id"=>$user_id,"gateway_id"=>$payment_method];
        $response = $this->Gateway->Capture($arg);
        $status = _s("status",$response,"error");
        $message = _s("message",$response,"");
        if(empty($message) && $status == "error") $message = "Payment Capturing failed by gateway";
        if(empty($message) && $status == "success") $message = "Payment Captured successfully";
        return ["status"=>$status,"message"=>$message];
    }
    function process_creditcard_payments($arg=[])
    {
        $CPDB = GetConfigs('CRON_CREDIT_CARD_PROCESS_DAYS_BEFORE',1);
        $CAO = GetConfigs('CRON_CREDIT_CARD_ATTEMPT_ONCE',"NO");
        $CRW = GetConfigs('CRON_CREDIT_CARD_RETRY_WEEKLY',1);
        $where = [];
        $where[] = "a.status=2";
        $where[] = "(a.due_date = DATE_ADD(CURDATE(), INTERVAL ".$CPDB." DAY) OR a.due_date < CURDATE())";
        if($CAO == "YES") $where[] = "a.last_capture_attempt is null";
        $whereStr = implode(" and ",$where);
        $UnpaidInvoices = full_query("select a.id as invoice_id,a.user_id,a.invoice_no,b.id as card_id,b.payment_method,a.payment_method as iv_payment_method from invoices a join clients_credit_cards b on a.user_id=b.user_id and b.is_default='YES' where ".$whereStr." order by a.id asc");
        $ids = [];
        $counts = 0;
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');
        $currentWeekNumber = Carbon::now()->weekOfYear;
        if(empty($UnpaidInvoices)) return ["counts"=>$counts,"ids"=>$ids];
        foreach($UnpaidInvoices as $row)
        {
            $iv_payment_method = $row->iv_payment_method;
            $payment_method = $row->payment_method;
            $card_id = $row->card_id;
            $invoice_id = $row->invoice_id;
            $user_id = $row->user_id;
            $invoice_no = $row->invoice_no;
            if($iv_payment_method != $payment_method) $this->db->update("invoices",["payment_method"=>$payment_method],["id"=>$invoice_id]);
            $arg = ["card_id"=>$card_id,"invoice_id"=>$invoice_id,"user_id"=>$user_id,"gateway_id"=>$payment_method];
            $response = $this->Gateway->Capture($arg);
            $status = _s("status",$response,"error");
            $message = _s("message",$response,"");
            
            $this->db->update("invoices",["last_capture_attempt"=>$entry_date],["id"=>$invoice_id]);
            $isAttempsInfo = $this->GetInvoiceOrderData($invoice_id);
            $FieldName = "CC-ATTEMPT-INFO-".$invoice_id;
            $retryTrue = true;
            $tries = 0;
            $cWeekNum = $currentWeekNumber;
            if(!empty($isAttempsInfo))
            {
                $isInfoExist = _s($FieldName,$isAttempsInfo);
                if(!empty($isInfoExist))
                {
                    $week = _s("week",$isInfoExist,0);
                    $tries = _s("tries",$isInfoExist,0);
                    if($currentWeekNumber == $week && $tries == $CRW) $retryTrue = false;
                    if($currentWeekNumber != $week)
                    {
                        $cWeekNum = $currentWeekNumber;
                        $tries = 0;
                    }
                }
            }
            if($retryTrue)
            {
                if($status == "success")
                {
                    $counts++;
                    $ids[] = $invoice_id;
                    logActivity(0,"Cron: Credit Card Payment captured successfully",$arg); 
                }
                else
                {
                    $this->SetInvoiceOrderData($invoice_id,$FieldName,["week"=>$cWeekNum,"tries"=>$tries+1]);
                    logActivity(0,"Cron: Credit Card Payment capturing failed",$arg); 
                }
            }
        }
        return ["counts"=>$counts,"ids"=>$ids];
    }
    function generate_overdue_invoices($user_id=0,$isOverdue=true)
    {
        $iOverdue = $isOverdue == true ? 1:0;
        if($user_id == 0) return ["status"=>"error", "message"=>"Client ID must required"];
        $isGenerated = $this->auto_invoices_generation(["user_id"=>$user_id,"overdue"=>$iOverdue]);
        $counts = iset("counts", $isGenerated, 0);
        if($counts>0) return ["status"=>"success", "message"=>"Client Invoices generated successfully"];
        return ["status"=>"error", "message"=>"Client Invoices not generated maybe overdue services/domain not found"];
    }
    function auto_invoices_generation($arg=[])
    {
        $cron_invoice_generation = GetConfigs('CRON_INVOICE_GENERATION');
        $defaultDays  = ($cron_invoice_generation  > 0) ? $cron_invoice_generation :10;
        $user_id =_s('user_id', $arg,0);
        $overdue =_s('overdue', $arg,0);
        $whereServices = [];
        $whereDomains = [];
        if($overdue == 1 && $user_id>0)
        {
            $whereServices[] = " a.user_id='".$user_id."' ";
            //$whereServices[] = " a.next_invoice_date <= DATE_SUB(CURDATE(), INTERVAL ".$defaultDays." DAY) ";
            $whereServices[] = " a.next_due_date < CURDATE() ";
            $whereDomains[] = " user_id='".$user_id."' ";
            $whereDomains[] = " nextduedate < CURDATE() ";
            //$whereDomains[] = " nextinvoicedate <= DATE_SUB(CURDATE(), INTERVAL ".$defaultDays." DAY) ";
        }else{
            $whereServices[] = " a.next_due_date between CURDATE() AND DATE(NOW() + INTERVAL ".$defaultDays." DAY)";
            $whereDomains[] = " nextduedate between CURDATE() AND DATE(NOW() + INTERVAL ".$defaultDays." DAY) ";
        }
        $users_array = [];
        $arrays = [];
        $ServicesResults = full_query("select a.user_id, GROUP_CONCAT(DISTINCT a.id) as services from hosting a join products_list p on a.package_id=p.id where ".implode(' and ',$whereServices)." and a.status='Active' and a.billing_cycle not in ('price_onetime_fee') and concat(p.account_type,a.user_id,a.id,a.invoice_id) not in (select concat(type,user_id,pid,invoice_id) from invoices_details where invoice_id not in (select id from invoices where status=9)) GROUP BY a.user_id");
        if(!empty($ServicesResults))
        {
            foreach($ServicesResults as $row)
            {
                $user = _s("user_id",$row,0);
                $services_count = _s("services",$row,"");
                if($user>0) $users_array[$user]['services'] = $services_count;
            }
        }
        $DomainsResults = full_query("select user_id,group_concat(distinct id) as domains from ".WST_DOM." where ".implode(' and ',$whereDomains)." and status in ('Active', 'Grace', 'Redemption', 'Expired') and concat(user_id,id,invoice_id) not in (select concat(user_id,pid,invoice_id) from invoices_details where type in ('domain-register','domain-transfer','DomainRenewal','Domain') and invoice_id not in (select id from invoices where status=9)) GROUP BY user_id");
        if(!empty($DomainsResults))
        {
            foreach($DomainsResults as $row)
            {
                $user = _s("user_id",$row,0);
                $domains_count = _s("domains",$row,"");
                if($user>0) $users_array[$user]['domains'] = $domains_count;
            }
        }
        if(!empty($users_array))
        {
            foreach ($users_array as $user => $array)
            {
                $services = _s("services",$array,"");
                $domains = _s("domains",$array,"");
                $arrays[] = ['user_id'=>$user, 'services'=>$services, 'domains'=>$domains];
            }
        }
        return  $this->auto_create_invoice($arrays);
    }
    function CreateInvoiceByApi($args=[])
    {
        $user_id = _s("user_id",$args);
        $user_id = (int)$user_id>0 ? $user_id:0;
        $status = _s("status",$args,1);
        $status = (int)$status>0 ? $status:1;
        $line_items = _s("line_items",$args,"");
        $payment_method = _s("payment_method",$args,0);
        $payment_method = (int)$payment_method>0 ? $payment_method:0;
        $send_invoice = _s("send_invoice",$args,"NO");
        $send_invoice = $send_invoice == "YES" ? "YES":"NO";
        $auto_apply_credit = _s("auto_apply_credit",$args,"NO");
        $auto_apply_credit = $auto_apply_credit == "YES" ? "YES":"NO";

        $TAX_CONFIGURATIONS = GetConfigs('TAX_CONFIGURATIONS');
        $TAX_CONFIGURATIONS = !empty($TAX_CONFIGURATIONS) ? _jd($TAX_CONFIGURATIONS, true):[];
        $TaxSupport = iset("TaxSupport", $TAX_CONFIGURATIONS) == "Enable" ? "YES":"NO";
        $SITE_TAX_TYPE = GetConfigs('SITE_TAX_TYPE') == "Exclusive" ? "Exclusive":"Inclusive"; 

        if($user_id == 0) return ["status"=>"error","message"=>"Client Unique ID empty in user_id"];
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1) return ["status"=>"error","message"=>WsLang('MsgUpdateProfileCurrency')];
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        $base_conv_rate = (float)$base_conv_rate>0 ? $base_conv_rate:0;
        $bcCode = _s('code', $currencyBaseRate);
        if($base_conv_rate == 0) return ["status"=>"error","message"=>WsLang('AffiliateUpBaseOtherCurrency')];
        $InvoicesDataSet = [];
        $sale_amount = 0;
        $discount_amount = 0;
        if(!empty($line_items))
        {
            $line_items = correctJSON($line_items);
            $isValid = isValidJSON($line_items);
            if($isValid === false) return ["status"=>"error","message"=>"Please Enter Valid Json Items Lines"];
            $line_items = json_decode($line_items,true);
            $ItemsErrors = [];
            if(!empty($line_items))
            {
                foreach($line_items as $row)
                {
                    $ItemErrors = [];
                    $rServiceId = _s("service_id",$row);
                    $rDomainId = _s("domain_id",$row);
                    $rName = _s("name",$row,"");
                    $rQty = _s("qty",$row,1);
                    $rRate = _s("rate",$row,0);
                    $rDiscount = _s("discount",$row,0);
                    $rCost = _s("cost",$row,0);                    
                    if(!isset($rQty)) $ItemErrors[] = "qty";
                    if(!isset($rDiscount)) $ItemErrors[] = "discount";
                    if($rServiceId>0)
                    {
                        $hostingInfo =   $this->db->select('*')->where(['id'=>$rServiceId])->limit(1)->get(WST_HOST)->row();
                        if(empty($hostingInfo)) $ItemErrors[] = "Service Info not found against requested service_id";
                        $package_id = _s('package_id', $hostingInfo);
                        $duration = _s('billing_cycle', $hostingInfo);
                        $next_invoice_date = _s('next_invoice_date', $hostingInfo);
                        $productInfo = $this->Products->products_info_by_id($package_id);
                        $order_type = _s('account_type', $productInfo);
                        $description = _s('title', $productInfo);
                        $taxable = "";
                        if($TaxSupport == "YES") $taxable = _s('apply_tax', $productInfo);
                        $domain_name = _s('domain_name', $hostingInfo);
                        $price =  $this->Products->get_products_pricing($package_id, $order_type);
                        if($rRate>0)
                        {
                            $rate = $rRate;
                        }else{
                            $rate = (!empty($bcCode)) ? $price[$bcCode][$duration]:0;
                        }
                        $qty = $rQty>0 ? $rQty:1;
                        $discount = $rDiscount>0 ? $rDiscount:0;
                        $amount = Multiply($rate,$qty);
                        $durationTitle = $this->Config->price_duration_names($duration);
                        $durationDays = $this->Config->price_duration_days($duration);
                        $FromDate = date('d M, Y', _t($next_invoice_date));
                        $ToDate = date('d M, Y', _t($next_invoice_date.' + '.$durationDays.' days'));
                        if(!empty($domain_name)) $description .= " - ".$domain_name;
                        if(!empty($durationTitle)) $description .= " (Duration : ".$FromDate." to ".$ToDate.")";
                        $InvoicesDataSet[] = ['pid'=>$rServiceId, 'invoice_id'=>0, 'user_id'=>$user_id, 'description'=>$description, 'rate'=>$amount, 'discount'=>$discount, 'base_conv_rate'=>$base_conv_rate, 'taxable'=>$taxable, 'qty'=>$qty, 'type'=>$order_type];
                    }else if($rDomainId>0)
                    {
                        $domainInfo =   $this->db->select('*')->where(['id'=>$rDomainId])->limit(1)->get('domains')->row();
                        $package_id = _s('pid', $domainInfo);
                        $registrationperiod = _s('registrationperiod', $domainInfo);
                        $description = _s('domain', $domainInfo);
                        $nextduedate = _s('nextduedate', $domainInfo);
                        $old_invoice_id = _s('invoice_id', $domainInfo);
                        $duration = $this->Config->duration_years_to_name($registrationperiod);
                        $durationDays = $this->Config->price_duration_days($duration);
                        $durationTitle = $this->Config->price_duration_names($duration);
                        $order_type = 'DomainRenewal';
                        $price =  $this->Products->get_products_pricing($package_id, 'domain-renewal');
                        if($rRate>0)
                        {
                            $rate = $rRate;
                        }else{
                            $rate = (!empty($bcCode)) ? $price[$bcCode][$duration]:0;
                        }
                        $qty = $rQty>0 ? $rQty:1;
                        $discount = $rDiscount>0 ? $rDiscount:0;
                        //$amount = Multiply($rate,$qty);

                        $FromDate = date('d M, Y', _t($nextduedate));
                        $ToDate = date('d M, Y', _t($nextduedate.' + '.$durationDays.' days'));
                        if(!empty($durationTitle)) $description .= " (Duration : ".$FromDate." to ".$ToDate.")";                       
                        $InvoicesDataSet[] = ['pid'=>$rDomainId, 'invoice_id'=>0, 'user_id'=>$user_id, 'description'=>$description, 'rate'=>$rate, 'discount'=>$discount, 'base_conv_rate'=>$base_conv_rate, 'taxable'=>"YES", 'qty'=>$qty, 'type'=>$order_type];
                    }else{
                        if(!isset($rName)) $ItemErrors[] = "name";
                        if(!isset($rCost)) $ItemErrors[] = "cost";
                        if(!isset($rRate)) $ItemErrors[] = "rate";
                        $rate = $rRate;
                        $qty = $rQty;
                        $discount = $rDiscount;
                        $InvoicesDataSet[] = ['pid'=>0, 'invoice_id'=>0, 'user_id'=>$user_id, 'description'=>$rName,'rate'=>$rRate, 'discount'=>$rDiscount, 'base_conv_rate'=>$base_conv_rate, 'taxable'=>"YES", 'qty'=>$rQty, 'type'=>"Custom"];
                    }
                    $sale_amount += $rate*$qty;
                    $discount_amount += $discount;                    
                    if(!empty($ItemErrors)) $ItemsErrors[] = "Items JSON Keys not found ".implode(", ",$ItemErrors);
                }
            }
            if(!empty($ItemsErrors)) return ["status"=>"error","message"=>"Item Lines Have Errors: ".implode(PHP_EOL,$ItemsErrors)];
        }
        $added_by = 0;
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');
        $payment_Due_days = GetConfigs('CRON_INVOICE_DUE_DAYS');
        $payment_Due_days = ($payment_Due_days > 0) ? $payment_Due_days:10;
        $date = new DateTime('+'.$payment_Due_days.' day');
        $due_date= $date->format('Y-m-d h:i:s');
        $invoice_no = $this->generate_new_invoice_no();
        $this->db->trans_begin();
        $this->db->query("insert into ".WST_INV." (invoice_no, sale_amount, discount_amount, entry_date, due_date, paid_date, status, currency, user_id, base_conv_rate, payment_method) values ('$invoice_no', '$sale_amount', '$discount_amount', '$entry_date', '$due_date', '$due_date','$status', '$icurrency', '$user_id', '$base_conv_rate', '$payment_method')");
        $id = $this->db->insert_id();
        if(!empty($InvoicesDataSet))
        {
            foreach($InvoicesDataSet as $child)
            {
                $pid = _s('pid', $child);
                $type = _s('type', $child);
                $qty = _s('qty', $child);
                $description = _s('description', $child);
                $description = str_replace("'","",$description);
                $discount = _s('discount', $child);
                $taxable = _s('taxable', $child);
                $amount = iset("rate", $child, 0);
                $camount = iset("cost", $child, 0)*iset("qty", $child, 1);
                $sale_amount +=$amount;
                $discount_amount +=$discount;
            $this->db->query("insert into ".WST_INV_DETAIL." (pid, type, invoice_id, rate, user_id, description, discount, base_conv_rate, taxable, qty,cost) values ('$pid', '$type','$id', '$amount', '$user_id', '$description', '$discount', '$base_conv_rate', '$taxable','$qty','$camount')");
            }
        }
        if ($this->db->trans_status() === FALSE)
        {
            $this->db->trans_rollback();
            logActivity(0, WsLang('WSLM-0115').' '.$invoice_no, $this->db->error());   
            return ["status"=>"error","message"=>WsLang('WSLM-0116')];
        }
        $this->db->trans_commit();
        $this->CostUpdateInInvoice($id);
        $this->Tax->ApplyTaxToInvoice($id, $user_id);        
        if($auto_apply_credit == "YES") $this->AutoCreditApplyToInvoice($id,"Credit Apply by API");
        $this->store_client_data_snapshot($id, $user_id);
        logActivity(0, WsLang('WSLM-0119').' '.$invoice_no, $this->db->error());   
        if($send_invoice == "YES")
        {
        run_hook('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$id, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'API'));
        RunWsCommand('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$id, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'API'));
        }
        return ["status"=>"success","message"=>WsLang('WSLM-0117'),"id"=>$id];
    }
    function auto_create_invoice($arg=[])
    {
        $added_by = 0;
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');
        $invoices_creation_count = 0;
        $arrayIds = [];
        $DOMAIN_DISABLE_GRACE = GetConfigs('DOMAIN_DISABLE_GRACE');
        $DOMAIN_DISABLE_GRACE = ($DOMAIN_DISABLE_GRACE == "NO") ? "NO":"YES";
        $DOMAIN_EXPIRY_FEE_HANDLING = GetConfigs('DOMAIN_EXPIRY_FEE_HANDLING');
        $DOMAIN_EXPIRY_FEE_HANDLING = ($DOMAIN_EXPIRY_FEE_HANDLING == "EXISTING") ? "EXISTING":"NEW";

        $CRON_INVOICE_GENERATION = GetConfigs('CRON_INVOICE_GENERATION');
        $CRON_INVOICE_GENERATION = ($CRON_INVOICE_GENERATION > 0) ? $CRON_INVOICE_GENERATION:15;
        $CRON_INVOICE_GENERATION = $CRON_INVOICE_GENERATION+5;
        $payment_Due_days = GetConfigs('CRON_INVOICE_DUE_DAYS');
        $payment_Due_days = ($payment_Due_days > 0) ? $payment_Due_days:10;

        $date = new DateTime('+'.$payment_Due_days.' day');
        $due_date= $date->format('Y-m-d h:i:s');
        
        $TAX_CONFIGURATIONS = GetConfigs('TAX_CONFIGURATIONS');
        $TAX_CONFIGURATIONS = !empty($TAX_CONFIGURATIONS) ? _jd($TAX_CONFIGURATIONS, true):[];
        $TaxSupport = iset("TaxSupport", $TAX_CONFIGURATIONS) == "Enable" ? "YES":"NO";
        $SITE_TAX_TYPE = GetConfigs('SITE_TAX_TYPE') == "Exclusive" ? "Exclusive":"Inclusive"; 
        $invoice_countinuous_generation = GetConfigs('INVOICE_COUNTINUOUS_GENERATION');
        $InvoicesDataSet = [];

        if(!empty($arg))
        {
            foreach ($arg as $arr)
            {
                $user_id = _s('user_id', $arr);    
                /***************************************** Continuous Invoice Generation ***********************************
                  If YES, invoices will be generated for each cycle even if the previous invoice remains unpaid
                ************************************************************************************************************/
                $invoice_generation_countinuous = 0;
                if($invoice_countinuous_generation == 'YES')
                {
                  $invoice_generation_countinuous = 1;
                }
                else
                {
                    //$isUnpaidInvoicesExist = $this->unpaid_invoices_by_user_id($user_id);
                    //$invoice_generation_countinuous = (empty($isUnpaidInvoicesExist)) ? 1:0;
                    $invoice_generation_countinuous = 1;
                }
                if($invoice_generation_countinuous == 1)
                {
                    $services = _s('services', $arr);
                    $domains = _s('domains', $arr);
                    $userInfo = $this->Account->getUserInfoById($user_id);
                    $icurrency = _s('currency', $userInfo);
                    if($icurrency <1){ return array("2", WsLang('MsgUpdateProfileCurrency'));}
                    $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
                    $base_conv_rate = _s('base_conv_rate', $currencyBaseRate, 0);
                    $bcCode = _s('code', $currencyBaseRate);
                    if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
                    $invoice_no = "";                
                    $sale_amount = 0;
                    $discount_amount = 0;
                    $InvoicesDataSet[$user_id]["header"] = ['invoice_no'=>$invoice_no, 'sale_amount'=>$sale_amount, 'discount_amount'=>$discount_amount, 'entry_date'=>$entry_date, 'due_date'=>$due_date, 'paid_date'=>$due_date, 'status'=>2, 'currency'=>$icurrency, 'user_id'=>$user_id, 'base_conv_rate'=>$base_conv_rate];
            
                    $taxable = $TaxSupport;
                    $invoiceId = 0;
                    $serviceSegments = isset($services) ? _ex(",", $services):[];
                    foreach($serviceSegments as $service)
                    {
                        if($service > 0)
                        {
                            $hostingInfo =   $this->db->select('*')->where(['id'=>$service])->limit(1)->get(WST_HOST)->row();
                            $package_id = _s('package_id', $hostingInfo);
                            $duration = _s('billing_cycle', $hostingInfo);
                            $next_invoice_date = _s('next_invoice_date', $hostingInfo);
                            $productInfo = $this->Products->products_info_by_id($package_id);
                            $order_type = _s('account_type', $productInfo);
                            $description = _s('title', $productInfo);
                            if($TaxSupport == "YES") $taxable = _s('apply_tax', $productInfo);
                            $domain_name = _s('domain_name', $hostingInfo);
                            $price =  $this->Products->get_products_pricing($package_id, $order_type);  
                            if(!empty($bcCode))
                            {
                                $rate = $price[$bcCode][$duration];
                            }else{
                                $rate = 0;
                            }
                            $qty = 1;
                            $discount = 0;
                            $amount = Multiply($rate,$qty);
                            $sale_amount += $amount;
                            $discount_amount += $discount;
                            $durationTitle = $this->Config->price_duration_names($duration);
                            $durationDays = $this->Config->price_duration_days($duration);
                            $FromDate = date('d M, Y', _t($next_invoice_date));
                            $ToDate = date('d M, Y', _t($next_invoice_date.' + '.$durationDays.' days'));
                            $SqlFromDate = date('Y-m-d', _t($next_invoice_date.' - '.$CRON_INVOICE_GENERATION.' days'));
                            $SqlToDate = date('Y-m-d', _t($next_invoice_date.' + '.$durationDays.' days'));
                            if(!empty($domain_name)) $description .= " - ".$domain_name;
                            if(!empty($durationTitle)) $description .= " (Duration : ".$FromDate." to ".$ToDate.")";
                            $sql = "select * from invoices where user_id='$user_id' and status<>9 and entry_date between DATE_FORMAT('$SqlFromDate', '%Y/%m/%d' ) AND DATE_FORMAT('$SqlToDate', '%Y/%m/%d') and id in (select invoice_id from invoices_details where pid='$service' and type='$order_type')";
                            $isExist = full_query($sql);
                            if(empty($isExist))
                            $InvoicesDataSet[$user_id]["childs"][] = ['pid'=>$service, 'invoice_id'=>$invoiceId, 'user_id'=>$user_id, 'description'=>$description, 'rate'=>$amount, 'discount'=>$discount, 'base_conv_rate'=>$base_conv_rate, 'taxable'=>$taxable, 'qty'=>$qty, 'type'=>$order_type];
                        }
                    }
                    $serviceSegments = isset($domains) ? _ex(",", $domains):[];
                    foreach($serviceSegments as $domain)
                    {
                        if($domain > 0)
                        {
                            $domainInfo =   $this->db->select('*')->where(['id'=>$domain])->limit(1)->get('domains')->row();
                            $package_id = _s('pid', $domainInfo);
                            $registrationperiod = _s('registrationperiod', $domainInfo);
                            $description = _s('domain', $domainInfo);
                            $nextduedate = _s('nextduedate', $domainInfo);
                            $old_invoice_id = _s('invoice_id', $domainInfo);
                            $duration = $this->Config->duration_years_to_name($registrationperiod);
                            $durationDays = $this->Config->price_duration_days($duration);
                            $durationTitle = $this->Config->price_duration_names($duration);
                            $order_type = 'DomainRenewal';
                            $price =  $this->Products->get_products_pricing($package_id, 'domain-renewal');  
                            if(!empty($bcCode))
                            {
                                $rate = $price[$bcCode][$duration];
                            }else{
                                $rate = 0;
                            }
                            $qty = 1;
                            $discount = 0;
                            $amount = Multiply($rate,$qty);
                            $sale_amount += $amount;
                            $discount_amount += $discount;
    
                            $FromDate = date('d M, Y', _t($nextduedate));
                            $ToDate = date('d M, Y', _t($nextduedate.' + '.$durationDays.' days'));
                            if(!empty($durationTitle)) $description .= " (Duration : ".$FromDate." to ".$ToDate.")";
    
                            $SqlFromDate = date('Y-m-d', _t($nextduedate.' - '.$CRON_INVOICE_GENERATION.' days'));
                            $SqlToDate = date('Y-m-d', _t($nextduedate.' + '.$durationDays.' days'));
                            $sql = "select * from invoices where user_id='$user_id'  and entry_date between DATE_FORMAT('$SqlFromDate', '%Y/%m/%d' ) AND DATE_FORMAT('$SqlToDate', '%Y/%m/%d') and id in (select invoice_id from invoices_details where pid='$domain' and type='$order_type')";
                            $isExist = full_query($sql);
                            if(empty($isExist))                        
                            $InvoicesDataSet[$user_id]["childs"][] = ['pid'=>$domain, 'invoice_id'=>$invoiceId, 'user_id'=>$user_id, 'description'=>$description, 'rate'=>$amount, 'discount'=>$discount, 'base_conv_rate'=>$base_conv_rate, 'taxable'=>$taxable, 'qty'=>$qty, 'type'=>$order_type];
                        }
                    }
                    if(!isset($InvoicesDataSet[$user_id]["childs"])) unset($InvoicesDataSet[$user_id]);
                }
            }
        }
        if(!empty($InvoicesDataSet))
        {
            foreach($InvoicesDataSet as $user_id=>$invoices)
            {
                $invoice_no = $this->generate_new_invoice_no();
                $InvoicesDataSet[$user_id]["header"]["invoice_no"] = $invoice_no;
                $InvoicesDataSet[$user_id]["header"]["tax_type"] = $SITE_TAX_TYPE;
                $header = $InvoicesDataSet[$user_id]["header"];
                $childs = $InvoicesDataSet[$user_id]["childs"];
                $this->db->insert(WST_INV, $header);
                $invoiceId = $this->db->insert_id();
                $sale_amount = 0;
                $discount_amount = 0;
                $ChildsAdded = 0;
                foreach($childs as $child)
                {
                    $pid = _s('pid', $child);
                    $type = _s('type', $child);
                    $childsDataSet=$child;
                    $childsDataSet["invoice_id"] = $invoiceId;
                    $amount = iset("rate", $child, 0)*iset("qty", $child, 1);
                    $sale_amount +=$amount;
                    $isDone = $this->db->insert(WST_INV_DETAIL, $childsDataSet);
                    if($isDone)
                    {
                        $ChildsAdded++;
                        if($type == "DomainRenewal"){
                            $this->db->query("update domains set invoice_id='$invoiceId', nextinvoicedate=DATE(nextinvoicedate) + INTERVAL +".$durationDays." DAY where id='$pid'");
                        }else{
                            $this->db->query("update ".WST_HOST." set invoice_id='$invoiceId', next_invoice_date=DATE(next_invoice_date) + INTERVAL +".$durationDays." DAY where id='$pid'");
                        }
                    } 
                }
                if($ChildsAdded > 0)
                {
                    $this->db->query("update ".WST_INV." set sale_amount='$sale_amount', discount_amount='$discount_amount' where id='$invoiceId'");
                    $this->AddFeeToInvoice($invoiceId);
                    $this->CostUpdateInInvoice($invoiceId);
                    $invoices_creation_count++;
                    $arrayIds[] = $invoiceId;
                    $this->Tax->ApplyTaxToInvoice($invoiceId, $user_id);
                    $this->store_client_data_snapshot($invoiceId, $user_id);
                    run_hook('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$invoiceId, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'autogen'));
                    RunWsCommand('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$invoiceId, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'autogen'));
                    logActivity(0, 'New Invoice Created, Invoice No is '.$invoice_no, $this->db->error());                    
                }
                else
                {
                    logActivity(0, 'New Invoice Creation Failed, Invoice No is '.$invoice_no, $this->db->error());   
                }
            }
        }
        if($DOMAIN_DISABLE_GRACE == "NO")
        {
            $DomainsGraceRedemption = full_query("select a.*, 
(select count(1) from invoices_details where pid=a.id and type='Custom' and description='Domain Grace Period Fee') as gadded, 
(select count(1) from invoices_details where pid=a.id and type='Custom' and description='Domain Redemption Period Fee') as radded
from (
SELECT a.id, i.id as invoice_id, a.user_id, i.currency, i.base_conv_rate, a.pid, a.nextduedate, i.base_conv_rate*t.grace_period_fee as grace_period_fee, i.base_conv_rate*t.redemption_period_fee as redemption_period_fee, case when a.status in ('Expired', 'Grace') then 'grace' else 'redemption' end as fee_type
from domains a 
join domains_tlds t on a.pid=t.id 
join invoices_details iv on a.id=iv.pid and iv.type='DomainRenewal'
join invoices i on iv.invoice_id=i.id and i.status in (2, 7, 8)
where a.status in ('Grace', 'Redemption', 'Expired') and (t.grace_period_duration+t.redemption_period_duration)>0
) a");
            $DgrInvoices = [];
            if(!empty($DomainsGraceRedemption))
            {
                foreach($DomainsGraceRedemption as $row)
                {
                    $grace_period_fee = _s('grace_period_fee', $row);
                    $redemption_period_fee = _s('redemption_period_fee', $row);
                    $gadded = _s('gadded', $row);
                    $radded = _s('radded', $row);
                    $fee_type = _s('fee_type', $row);
                    //Grace Perion
                    if($grace_period_fee>0 && $gadded == 0 && $fee_type == "grace")
                    {
                        $DgrInvoices[$row->id] = ["pid"=>_s('id', $row), "type"=>"Custom", "qty"=>1, "iv_type"=>$DOMAIN_EXPIRY_FEE_HANDLING, "invoice_id"=>_s('invoice_id', $row), "discount"=>0, "base_conv_rate"=>_s('base_conv_rate', $row), "user_id"=>_s('user_id', $row), "currency"=>_s('currency', $row), "description"=>"Domain Grace Period Fee", "rate"=>$grace_period_fee];
                    }
                    //Redemption Period
                    if($redemption_period_fee>0 && $radded == 0 && $fee_type == "redemption")
                    {
                        $this->db->delete(WST_INV_DETAIL, ["description"=>"Domain Grace Period Fee", "pid"=>$row->id, "type"=>"Custom"]);
                        $DgrInvoices[$row->id] = ["pid"=>_s('id', $row), "type"=>"Custom", "qty"=>1, "iv_type"=>$DOMAIN_EXPIRY_FEE_HANDLING, "invoice_id"=>_s('invoice_id', $row), "discount"=>0, "base_conv_rate"=>_s('base_conv_rate', $row), "user_id"=>_s('user_id', $row), "currency"=>_s('currency', $row), "description"=>"Domain Redemption Period Fee", "rate"=>$redemption_period_fee];
                    }
                }
            }

            if(!empty($DgrInvoices))
            {
                foreach($DgrInvoices as $row)
                {
                    $ChildsAdded = 0;
                    $iv_type = iset("iv_type", $row);
                    $user_id = iset("user_id", $row);
                    $rate = iset("rate", $row);
                    $icurrency = iset("currency", $row);
                    $base_conv_rate = iset("base_conv_rate", $row);
                    $invoice_id = iset("invoice_id", $row);
                    $description = iset("description", $row);
                    $isHeaderExist = false;
                    $invoice_no = $invoice_id;

                    if($iv_type == "NEW")
                    {
                        $invoice_no = $this->generate_new_invoice_no();
                        $header = ['invoice_no'=>$invoice_no, 'sale_amount'=>$rate, 'discount_amount'=>0, 'entry_date'=>$entry_date, 'due_date'=>$due_date, 'paid_date'=>$due_date, 'status'=>2, 'currency'=>$icurrency, 'user_id'=>$user_id, 'base_conv_rate'=>$base_conv_rate, 'tax_type'=>$SITE_TAX_TYPE];
                        $this->db->insert(WST_INV, $header);
                        $invoice_id = $this->db->insert_id();
                        if($invoice_id>0) $isHeaderExist = true;
                    }
                    else
                    {
                        $isHeaderExist = true;
                    }
                    if($isHeaderExist)
                    {
                        $childsDataSet = ['pid'=>iset("pid", $row), 'invoice_id'=>$invoice_id, 'user_id'=>$user_id, 'description'=>$description, 'rate'=>$rate, 'discount'=>0, 'base_conv_rate'=>$base_conv_rate, 'taxable'=>$taxable, 'qty'=>$qty, 'type'=>"Custom"];
                        $isDone = $this->db->insert(WST_INV_DETAIL, $childsDataSet);
                        if(!empty($isDone)) $ChildsAdded++;
                    }
                    if($ChildsAdded > 0)
                    {
                        $invoices_creation_count++;
                        $arrayIds[] = $invoice_id;
                        $this->db->query("update invoices set sale_amount=(select sum(rate) from invoices_details where invoice_id=".$invoice_id.") where id=".$invoice_id);
                        $this->AddFeeToInvoice($invoice_id);
                        $this->CostUpdateInInvoice($invoice_id);
                        $this->Tax->ApplyTaxToInvoice($invoice_id, $user_id);
                        if($iv_type == "NEW")
                        {
                            $this->store_client_data_snapshot($invoice_id, $user_id);
                            run_hook('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$invoice_id, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'autogen'));
                            RunWsCommand('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$invoice_id, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'autogen'));
                            logActivity(0, 'New Invoice Created, Invoice No is '.$invoice_no, $this->db->error());                    
                        }
                        else
                        {
                            run_hook('InvoiceModified', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
                            RunWsCommand('InvoiceModified', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
                        }
                    }
                    else
                    {
                        logActivity(0, 'New Invoice Creation Failed, Invoice ID is '.$invoice_id, $this->db->error());   
                    }
                }
            }
        }
        return ['counts'=>$invoices_creation_count, 'ids'=>$arrayIds];
    }
    function invoice_send_reminder($invoice_id=0, $reminder_no=0)
    {
      if($reminder_no == 0) $template = 'InvoicePaymentReminder';
      if($reminder_no == 1){ $template = 'InvoicePaymentFirstoverdueReminder';}
      if($reminder_no == 2){ $template = 'InvoicePaymentSecondoverdueReminder';}
      if($reminder_no == 3){ $template = 'InvoicePaymentThirdoverdueReminder';}
       run_hook($template, ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES', 'reminder_no'=>$reminder_no]);
       RunWsCommand($template, array('invoice_id'=>$invoice_id, 'SendEmail'=>'YES'));
    }
    function store_client_data_snapshot($invoice_id=0, $user_id=0){
        $invoice_save_client_info = GetConfigs('INVOICE_SAVE_CLIENT_INFO');
        if($invoice_save_client_info == 'YES')
        {
            $info = $this->Account->getUserInfoById($user_id);
            $this->db->where(" id='$invoice_id' and user_id='$user_id'");
            $query = $this->db->update(WST_INV, 
                [
                    'first_name'=>_s('first_name', $info), 
                    'last_name'=>_s('last_name', $info), 
                    'company_name'=>_s('company_name', $info), 
                    'email'=>_s('email', $info), 
                    'address1'=>_s('address1', $info), 
                    'city'=>_s('city', $info), 
                    'state'=>_s('state', $info), 
                    'postcode'=>_s('postcode', $info), 
                    'country'=>_s('country', $info), 
                    'phonenumber'=>_s('phonenumber', $info), 
                ]);
        }
    }
    function create_invoice_by_quote($quote_id=0, $currency=0, $icounts=0, $due_date="", $deposit_percentage=0, $deposit_due_date="", $payment_due_date="", $notification="", $user_id=0)
    {
      $currencyBaseRate = $this->Config->getCurrencyInfoById($currency);
      $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
      if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
        $invoicesCreated = [];
        $iCreationErrors = [];
        for($i=0;$i<$icounts;$i++)
        {
            $invoice_no = $this->generate_new_invoice_no();
            $saleResult =  get_one("select sum(rate*qty) as amount, sum(((rate*qty)/100)*discount) as discount from ".WST_QUO_ITEMS." where quote_id='$quote_id'");
            $sale_amount = _s('amount', $saleResult);
            $discount_amount = _s('discount', $saleResult);
            $entry_date = Carbon::now()->format('Y-m-d');
            $TotalDepositPercentage = 100;
            $FirstInvoicePercentage = $TotalDepositPercentage;
            $first_sale_amount = $sale_amount;
            $first_discount_amount = PercentByVal($discount_amount,100,$FirstInvoicePercentage);
            $firstDesc = '';
            $due_date = date('Y-m-d', _t($due_date));
            if($icounts>1)
            {
                 if($i == 0){
                    $FirstInvoicePercentage = $deposit_percentage;
                    $first_sale_amount = PercentByVal($sale_amount,100,$FirstInvoicePercentage);
                    $first_discount_amount = PercentByVal($discount_amount,100,$FirstInvoicePercentage);
                    $firstDesc = ' ('.$FirstInvoicePercentage.'% Deposit)';
                    $due_date = date('Y-m-d', _t($deposit_due_date));
                 }else{
                      $FirstInvoicePercentage = $TotalDepositPercentage-$deposit_percentage;
                      $first_sale_amount = PercentByVal($sale_amount,100,$FirstInvoicePercentage);
                      $first_discount_amount = PercentByVal($discount_amount,100,$FirstInvoicePercentage);
                      $firstDesc = ' ('.$FirstInvoicePercentage.'% Balance from Deposit)';
                      $due_date = date('Y-m-d', _t($payment_due_date));
                 }
            }
            $this->db->trans_begin();
            $this->db->query("insert into ".WST_INV." (invoice_no, sale_amount, discount_amount, entry_date, due_date, status, currency, user_id, base_conv_rate) values ('$invoice_no', '$first_sale_amount', '$first_discount_amount', '$entry_date', '$due_date', 2, '$currency', '$user_id', '$base_conv_rate')");
            $id = $this->db->insert_id();
            $this->db->query("insert into ".WST_INV_DETAIL." (invoice_id, user_id, description, rate, discount, base_conv_rate, taxable, qty, type)(select $id, $user_id, concat(description, '$firstDesc'), ((rate/100)*$FirstInvoicePercentage), discount, base_conv_rate, taxable, qty, type from ".WST_QUO_ITEMS." where quote_id='$quote_id')");

            if ($this->db->trans_status() === FALSE)
            {
                $this->db->trans_rollback();
                $iCreationErrors[]=['text'=>WsLang('WSLM-0115').' '.$invoice_no, 'text2'=>WsLang('WSLM-0116'), 'error'=>$this->db->error()];
            }
            else
            {
                $invoicesCreated[$i] = ['id'=>$id, 'user_id'=>$user_id, 'invoice_no'=>$invoice_no];
                $this->db->trans_commit();
            }
        }        
        if(!empty($iCreationErrors)){
            $errorsMsg = [];
            foreach($iCreationErrors as $error)
            {
                $text = _s('text', $error);
                $derror = _s('error', $error);
                $errorsMsg[]=$text;
                logActivity(0, $text, $derror);  
            }
            return array("2", _em(' <br> ', $errorsMsg));
        }
        $invoicesIds = [];
        $s=0;
        foreach($invoicesCreated as $invoice){
            $id = _s('id', $invoice);
            $user_id = _s('user_id', $invoice);
            $invoice_no = _s('invoice_no', $invoice);
            $invoicesIds[]=$id;
            $this->CostUpdateInInvoice($id);
            $this->store_client_data_snapshot($id, $user_id);
            $this->Tax->ApplyTaxToInvoice($id, $user_id);
            RunWsCommand('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$id, 'status'=>'UnPaid', 'SendEmail'=>$notification));
            RunWsCommand('AcceptQuote', array('quote_id'=>$quote_id, 'invoice_id'=>$id, 'SendEmail'=>$notification));
            run_hook('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$id, 'status'=>'UnPaid', 'SendEmail'=>$notification, 'source'=>'adminarea'));
            run_hook('AcceptQuote', array('quote_id'=>$quote_id, 'invoice_id'=>$id, 'SendEmail'=>$notification));
            logActivity(0, 'New Invoice Created, Invoice No is '.$invoice_no, []);
        }
        if(count($invoicesIds) == 1){
          return array("1", WsLang('WSLM-0117'), $invoicesIds[0]);
        }else{
            $ids = (!empty($invoicesIds)) ? _em(', ', $invoicesIds):'';
          return array("1", WsLang('WSLM-0118')." ".$ids, "");
        }
    }

    function invoice_create($user_id=0)
    {
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1){ return array("2", WsLang('MsgUpdateProfileCurrency'));}
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
        $added_by = $this->uid;
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');
        $payment_Due_days = GetConfigs('CRON_INVOICE_DUE_DAYS');
        $payment_Due_days = ($payment_Due_days > 0) ? $payment_Due_days:10;
        $date = new DateTime('+'.$payment_Due_days.' day');
        $due_date= $date->format('Y-m-d h:i:s');
        $invoice_no = $this->generate_new_invoice_no();
        $sale_amount = 0;
        $discount_amount = 0;
        $this->db->trans_begin();
        $this->db->query("insert into ".WST_INV." (invoice_no, sale_amount, discount_amount, entry_date, due_date, paid_date, status, currency, user_id, base_conv_rate) values ('$invoice_no', '$sale_amount', '$discount_amount', '$entry_date', '$due_date', '$due_date', 1, '$icurrency', '$user_id', '$base_conv_rate')");
        $id = $this->db->insert_id();
        if ($this->db->trans_status() === FALSE)
        {
            $this->db->trans_rollback();
            logActivity(0, WsLang('WSLM-0115').' '.$invoice_no, $this->db->error());   
            return array("2", WsLang('WSLM-0116'));
        }
        $this->db->trans_commit();
        $this->store_client_data_snapshot($id, $user_id);
        logActivity(0, WsLang('WSLM-0119').' '.$invoice_no, $this->db->error());   
        return array("1", WsLang('WSLM-0117'), $id);                        
    }
    function invoice_funds_added()
    {
        $amount = __post("amount", true);
        $user_id = __post("user_id", true);          
        return  $this->create_funds_invoice($user_id, $amount);
    }

    function add_funds_by_client($user_id=0, $amount=0)
    {
        $minD = GetConfigs('CREDIT_MIN_DEPOSIT');
        $maxD = GetConfigs('CREDIT_MAX_DEPOSIT');
        $maxB = GetConfigs('CREDIT_MAX_BALANCE');
        $funds_require_an_order = GetConfigs('CREDIT_FUNDS_REQUIRE_AN_ORDER');
        $cfe = GetConfigs('CREDIT_FUNDS_ENABLE');
        $ac = $this->client_credit_balance($user_id);
        if($minD > $amount) return ['status'=>'error', 'message'=>WsLang('WSLM-0120'), 'invoiceId'=>0];
        if($amount>$maxD) return ['status'=>'error', 'message'=>WsLang('WSLM-0121'), 'invoiceId'=>0];
        if($ac >= $maxB) return ['status'=>'error', 'message'=>WsLang('WSLM-0122'), 'invoiceId'=>0];
        $aca = $ac+$amount;
        if($aca>=$maxB) return ['status'=>'error', 'message'=>WsLang('WSLM-0123'), 'invoiceId'=>0];
        if($cfe != 'YES') return array('status'=>'error', 'message'=>WsLang('WSLM-0124'), 'invoiceId'=>0);
        //if($funds_require_an_order == 'YES') return array('status'=>'error', 'message'=>WsLang('WSLM-0125'), 'invoiceId'=>0);
        $info = $this->create_funds_invoice($user_id, $amount);
        return array('status'=>(($info[0] == 1) ? 'success':'error'), 'message'=>$info[1], 'invoiceId'=>$info[2]);
    }
    function create_funds_invoice($user_id=0, $amount=0)
    {
        if(empty($user_id)) return array("2", WsLang('WSLM-0126'));
        if(empty($amount)) return array("2", WsLang('WSLM-0127'));
        if($this->Config->letters_exist($amount) == 1) return array("2", WsLang('WSLM-0128'));
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1){ return array("2", WsLang('MsgUpdateProfileCurrency'));}
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
        $added_by = $this->uid;
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');        
        $payment_Due_days = GetConfigs('CRON_INVOICE_DUE_DAYS');
        $payment_Due_days = ($payment_Due_days > 0) ? $payment_Due_days:10;        
        $date = new DateTime('+'.$payment_Due_days.' day');
        $due_date= $date->format('Y-m-d h:i:s');
        $invoice_no = $this->generate_new_invoice_no();        
        $sale_amount = 0;
        $discount_amount = 0;
        $this->db->trans_begin();
        $this->db->query("insert into ".WST_INV." (invoice_no, sale_amount, discount_amount, entry_date, due_date, paid_date, status, currency, user_id, base_conv_rate) values ('$invoice_no', '$amount', '0', '$entry_date', '$due_date', '$due_date', 2, '$icurrency', '$user_id', '$base_conv_rate')");
        $id = $this->db->insert_id();
        $this->db->query("insert into ".WST_INV_DETAIL." (invoice_id, user_id, description, rate, discount, base_conv_rate, taxable, qty, type) values ($id, $user_id, 'Add Funds', $amount, 0, $base_conv_rate, 'NO', 1, 'AddFund')");
        if ($this->db->trans_status() === FALSE)
        {
            $this->db->trans_rollback();
            logActivity(0, WsLang('WSLM-0115').' '.$invoice_no, $this->db->error());   
            return array("2", WsLang('WSLM-0116'));                       
        }
        $this->db->trans_commit();
        $this->CostUpdateInInvoice($id);
        $this->Tax->ApplyTaxToInvoice($id, $user_id);
        $this->store_client_data_snapshot($id, $user_id);
        run_hook('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$id, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'clientarea'));
        RunWsCommand('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$id, 'status'=>'UnPaid', 'SendEmail'=>'YES'));
        logActivity(0, WsLang('WSLM-0118').' '.$invoice_no, $this->db->error());   
        return array("1", WsLang('WSLM-0117'), $id);                        
    }
    function invoice_header($invoice_id=0)
    {
        $info =  $this->invoice_info($invoice_id);
        $statusInfo = $this->invoices_status_by_id(_s('status', $info));
        $available_credits = $this->client_credit_balance(_s('user_id', $info));
        $invoice_credits = $this->invoice_credit_balance($invoice_id);   
        $cbr = $this->Config->getCurrencyInfoById(_s('currency', $info));
        $base_conv_rate = _s('base_conv_rate', $info);
        $code = _s('code', $cbr);
        $sb = _s('symbol', $cbr);
        $sp = _s('symbol_position', $cbr);
        $sale_amount = _s('sale_amount', $info);
        $discount_amount = _s('discount_amount', $info);
        $paid_amount = _s('paid_amount', $info);
        $balance = $sale_amount - ($paid_amount+$discount_amount);
        $saleamount = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$sale_amount]);
        $discountamount = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$discount_amount]);
        $paidamount = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$paid_amount]);
        $bbalance = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$balance]);
        $bavailable_credits = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$available_credits]);
        $binvoice_credits = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$invoice_credits]);
        $baseCurrency = $this->Currency->getBaseCurrency(0);    
        $entry_date = ConvertDateToFormat(['date'=>$info->entry_date]);
        $due_date = ConvertDateToFormat(['date'=>$info->due_date]);
        $paid_date = ConvertDateToFormat(['date'=>$info->paid_date]);
      return array(
        'Currency' => 
        array(
          'Base' => [
            'Code'=>_s('code', $baseCurrency), 
            'symbol_position'=>_s('symbol_position', $baseCurrency), 
            'symbol'=>_s('symbol', $baseCurrency), 
            'base_conv_rate'=>_s('base_conv_rate', $baseCurrency), 
        ], 
          'Invoice' => [
            'Code'=>_s('code', $cbr), 
            'symbol_position'=>$cbr->symbol_position, 
            'symbol'=>$cbr->symbol, 'base_conv_rate'=>_s('base_conv_rate', $info)
        ]
          ), 
        'Amount'=> array(
          'With_Symbol'=> array('sale_amount'=>$saleamount, 'discount_amount'=>$discountamount, 'paid_amount'=>$paidamount, 'balance'=>$bbalance, 'available_credits'=>$bavailable_credits, 'invoice_credits'=>$binvoice_credits), 
          'WithOut_Symbol'=> array('sale_amount'=>$sale_amount, 'discount_amount'=>$discount_amount, 'paid_amount'=>$paid_amount, 'balance'=>$balance, 'available_credits'=>$available_credits, 'invoice_credits'=>$invoice_credits)
        ), 
        'invoice_no'=>$info->invoice_no, 
        'entry_date'=>$entry_date, 
        'due_date'=>$due_date, 
        'paid_date'=>$paid_date, 
        'status_id'=>_s('id', $statusInfo), 
        'status_name'=>_s('title', $statusInfo), 
        'status_color'=>_s('color', $statusInfo), 
      );
    }
    public function invoices_status_list_by_clientside($user_id=0)
    {
        if($user_id>0)
        {
            $query = $this->db->query("select a.id, a.title, a.color, (select count(*) from ".WST_INV." where status=a.id and user_id='$user_id') as invoices from ".WST_INV_STATUS." a where a.id in (2,3,5,7) order by a.id asc");
        }else{
            $query = $this->db->query("select a.id, a.title, a.color, (select count(*) from ".WST_INV." where status=a.id and user_id='$user_id') as invoices from ".WST_INV_STATUS." a where a.id not in (1) order by a.id asc");
        }
        $data = $query->result();
        return _je($data);
    }
    public function client_invoices_list_by_clientside($user_id=0, $status="", $pageno=1)
    {
        if(!empty($user_id)) $where[] = " a.user_id ='".$user_id."'";
        if(!empty($status)) $where[] = " a.status ='".$status."'";
        if(!empty($where)) $where = " where "._em(' and ', $where);
        $countRecords = get_one("select count(a.id) as total_rows from ".WST_INV." a  ".$where);
        $countRecords = _s('total_rows', $countRecords);
  
      $total_records_per_page = GetConfigs('SITE_PER_PAGE_RECORDS');
      $calc_page = ($pageno - 1) * $total_records_per_page;
      $query = $this->db->query("select a.entry_date, a.due_date, a.paid_date, a.invoice_no, a.id, a.sale_amount, a.paid_amount, a.discount_amount, b.title as status_name, c.symbol, c.symbol_position from ".WST_INV." a inner join ".WST_INV_STATUS." b on a.status=b.id inner join ".WST_CURRENCIES." c on a.currency=c.id  ".$where." and a.status not in (1) order by a.id  limit ".$calc_page.", ".$total_records_per_page);
         $pagination = $this->Config->pagination_info($countRecords, $pageno, $total_records_per_page, $calc_page);
         $data = array("totalresults"=>$countRecords, "pagination"=>$pagination, "invoices"=>$query->result());
         return _je($data);
    }
    /* ********************************************************************
     * client_invoices_list - get all Invoices based on client id and search filters
     * ********************************************************************
     */
    public function client_invoices_list($user_id=0, $pageno=1)
    {
        $fm =   __post(array('user_id', 'invoice_no', 'entry_date', 'due_date', 'paid_date', 'payment_method', 'status'), TRUE);
        $where = [];
        $postArray = [];
        foreach ($fm as $key => $value) : 
            $postArray[$key] =$value;
        endforeach;
        //$user_id = __post('user_id', true);
        $invoice_no = __post('invoice_no', true);
        $edate = __post('entry_date', true);
        $ddate = __post('due_date', true);
        $pdate = __post('paid_date', true);
        $entry_date = isset($edate) ? _ex('-', $edate):[];
        $due_date = isset($ddate) ? _ex('-', $ddate):[];
        $paid_date = isset($ddate) ? _ex('-', $pdate):[];
        $payment_method = __post('payment_method', true);
        $status = __post('status', true);
        $date_from = isset($entry_date[0]) ? date('Y-m-d', _t($entry_date[0])):'';
        $date_to = isset($entry_date[1]) ? date('Y-m-d', _t($entry_date[1])):'';
        $due_date_from = isset($due_date[0]) ? date('Y-m-d', _t($due_date[0])):'';
        $due_date_to = isset($due_date[1]) ? date('Y-m-d', _t($due_date[1])):'';
        $paid_date_from = isset($paid_date[0]) ? date('Y-m-d', _t($paid_date[0])):'';
        $paid_date_to = isset($paid_date[1]) ? date('Y-m-d', _t($paid_date[1])):'';
        if(!empty(__post('entry_date', true))) $where[] = " a.entry_date >='".$date_from."' and a.entry_date <='".$date_to."' ";
        if(!empty(__post('due_date', true))) $where[] = " a.due_date >='".$due_date_from."' and a.due_date <='".$due_date_to."' ";
        if(!empty(__post('paid_date', true))) $where[] = " a.paid_date >='".$paid_date_from."' and a.paid_date <='".$paid_date_to."' ";
        if(!empty($user_id)) $where[] = " a.user_id ='".$user_id."'";
        if(!empty($invoice_no)) $where[] = " a.invoice_no ='".$invoice_no."'";
        if(!empty($payment_method)) $where[] = " a.payment_method ='".$payment_method."'";
        if(!empty($status)) $where[] = " a.status ='".$status."'";
        if(count($where) > 0) :
          setSession("ClientInvoiceFilters",$where);
          setSession("ClientInvoiceForm",$postArray);
        endif;
        $rpt_filters = getSession("ClientInvoiceFilters",[]);
        if(!empty($rpt_filters)) $rpt_filters = " where "._em(' and ', $rpt_filters);
        $countRecords = get_one("select count(a.id) as total_rows from ".WST_INV." a  ".$rpt_filters);
        $countRecords = _s('total_rows', $countRecords);
        $page_no = (__segment(4) > 0) ? __segment(4) : 1;
        $total_records_per_page = GetConfigs('SITE_PER_PAGE_RECORDS');
        $calc_page = ($page_no - 1) * $total_records_per_page;
        $pagination = $this->Config->pagination_links($countRecords, $page_no, $total_records_per_page, '/admin/client-invoices/'.$user_id.'/', $calc_page);
        $query = $this->db->query("select a.entry_date, a.discount_amount, a.due_date, a.paid_date, a.invoice_no, a.id, a.sale_amount, a.paid_amount,b.color,b.title as status_name, c.symbol, c.symbol_position, a.base_conv_rate from ".WST_INV." a inner join ".WST_INV_STATUS." b on a.status=b.id inner join ".WST_CURRENCIES." c on a.currency=c.id  ".$rpt_filters." order by a.id  limit ".$calc_page.", ".$total_records_per_page);
        $client_invoices = $query->result();
        $fmParameters = getSession("ClientInvoiceForm", []);
        $clients_option_list = $this->Account->clients_option_list($user_id);
        $client_sticky_notes_list = $this->Admin->client_sticky_notes_list($user_id);
        $client_tab_links = $this->Admin->client_tab_links($user_id, __segment(2));
        $invoices_status_list  = $this->Config->invoices_status_list();
        $payment_methods = $this->Views->select('payment_method', 'select', '', WsLang('SelectPaymentMethod'), $this->Config->payment_methods(), 'id', 'title', iset("payment_method", $fmParameters));
        $invoices_status_list = $this->Views->select('status', 'select', '', WsLang('InvoiceSelectStatus'), $this->Config->invoices_status_list(), 'id', 'title', iset("status", $fmParameters));
          $baseCurrency = $this->Currency->getBaseCurrency(0);
        $file = "client-invoices.php";
        $tpath = ltrim($this->aTemplate, '/').'templates/';
        $filepath =  $tpath.$file;
        $html="";
        if (file_exists($filepath)){
            include_once($filepath);
        }
        else
        {
            $html = WsFileNotExist($file, $tpath);
        } 
        return $html;
  }
    /* ********************************************************************
     * client_account_statement - get Account Statement based on client id and search filters
     * ********************************************************************
     */
    public function client_account_statement($user_id=0, $pageno=1)
    {        
        $fm =   __post(array('user_id', 'invoice_no', 'entry_date', 'due_date', 'paid_date', 'payment_method', 'status'), TRUE);
        $where = [];
        $postArray = [];
        foreach ($fm as $key => $value) : 
            $postArray[$key] =$value;
        endforeach;
        //$user_id = __post('user_id', true);
        $invoice_no = __post('invoice_no', true);
        $entry_date = __post('entry_date', true);
        $entry_date = isset($entry_date) ? _ex('-', $entry_date):[];
        $due_date = __post('due_date', true);
        $due_date = isset($due_date) ? _ex('-', $due_date):[];
        $paid_date = __post('paid_date', true);
        $paid_date = isset($paid_date) ? _ex('-', $paid_date):[];
        $payment_method = __post('payment_method', true);
        $status = __post('status', true);
        $date_from = isset($entry_date[0]) ? date('Y-m-d', _t($entry_date[0])):'';
        $date_to = isset($entry_date[1]) ? date('Y-m-d', _t($entry_date[1])):'';
        $due_date_from = isset($due_date[0]) ? date('Y-m-d', _t($due_date[0])):'';
        $due_date_to = isset($due_date[1]) ? date('Y-m-d', _t($due_date[1])):'';
        $paid_date_from = isset($paid_date[0]) ? date('Y-m-d', _t($paid_date[0])):'';
        $paid_date_to = isset($paid_date[1]) ? date('Y-m-d', _t($paid_date[1])):'';
        if(!empty(__post('entry_date', true))){$where[] = " a.entry_date >='".$date_from."' and a.entry_date <='".$date_to."' ";}
        if(!empty(__post('due_date', true))){$where[] = " a.due_date >='".$due_date_from."' and a.due_date <='".$due_date_to."' ";}
        if(!empty(__post('paid_date', true))){$where[] = " a.paid_date >='".$paid_date_from."' and a.paid_date <='".$paid_date_to."' ";}
        if(!empty($user_id)){$where[] = " a.user_id ='".$user_id."'";}
        if(!empty($invoice_no)){$where[] = " a.invoice_no ='".$invoice_no."'";}
        if(!empty($payment_method)){$where[] = " a.payment_method ='".$payment_method."'";}
        if(!empty($status)){$where[] = " a.status ='".$status."'";}
        if(count($where) > 0) :
          setSession("ClientInvoiceFilters",$where);
          setSession("ClientInvoiceForm",$postArray);
        endif;
        $rpt_filters = getSession("ClientInvoiceFilters",[]);
       if(!empty($rpt_filters)) $rpt_filters = " where "._em(' and ', $rpt_filters);
        $query = $this->db->query("select a.entry_date, a.due_date, a.paid_date, a.invoice_no, a.id, a.sale_amount, a.discount_amount, a.paid_amount, b.title as status_name, c.symbol, c.symbol_position, a.base_conv_rate, c.code from ".WST_INV." a inner join ".WST_INV_STATUS." b on a.status=b.id inner join ".WST_CURRENCIES." c on a.currency=c.id  ".$rpt_filters." order by a.id");
        $client_invoices = $query->result();
        $fmParameters = getSession("ClientInvoiceForm",[]);
        $html="";
        $file = "client_account_statement.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            $html= WsFileNotExist($file, $tpath);
        }
        return $html;
    }
    function invoice_info($id=0)
    {
      return $this->db->select('*')->where(["id"=>$id])->limit(1)->get(WST_INV)->row();
    }
    function GetInvoiceInfo($invoice_id=0)
    {
        $array=[];
        $invoice_info = $this->Invoices->invoice_info($invoice_id); 
        if(!empty($invoice_info))
        {
            $array['invoice']['invoiceid'] = $invoice_id;
            $array['invoiceid'] = $invoice_id;
            $array['invoicenum'] = $invoice_id;
            $array['marketing_emails_opt_in'] = false;
            $baseCurrency = $this->Currency->getBaseCurrency($invoice_info->currency);
            $currCode = $baseCurrency->code;
            $currConvRate = $baseCurrency->base_conv_rate;
            $amount = $invoice_info->sale_amount-($invoice_info->discount_amount+$invoice_info->paid_amount);
            $currencyCode = $currency_info->code;
            $currencyAmount = $amount;
            if($currencyCode != $currCode)
            {
                $currencyAmount = $amount/$currConvRate;
                $currencyCode = $currCode;
            }
           $array['invoice']['description'] = '';
           $array['description'] = '';
           $array['amount'] = $currencyAmount;
           $array['invoice']['amount'] = $currencyAmount;
           $array['invoice']['currency'] = $currencyCode;
           $array['currency'] = $currencyCode;
           $array['invoice']['currencyCode'] = $currencyCode;
           $array['payment_method'] = $invoice_info->payment_method;
           $array['invoice']['payment_method'] = $invoice_info->payment_method;
           $array['invoice']['user_id'] = $invoice_info->user_id;
           $array['user_id'] = $invoice_info->user_id;
        }
        return $array;
    }    
    function invoice_items_list($invoice_id=0)
    {
        $query = $this->db->query("select a.id, a.description, a.type, a.rate, a.qty, a.discount, (a.qty * a.rate) AS amount, b.currency, c.symbol, c.symbol_position, b.base_conv_rate, b.id AS invoice_id, b.invoice_no, b.user_id, b.payment_method, a.pid, s.title AS status, b.paid_date from invoices_details a join invoices b on b.id=a.invoice_id join currencies c on c.id=b.currency join invoices_status s on b.status=s.id where a.invoice_id=? order by a.id", [$invoice_id]);
        return  $query->result();
    }
    function invoice_items_list_byInvoice($invoice_id=0, $user_id=0)
    {
        $query = $this->db->query("select id, pid, type, is_module_run from invoices_details where invoice_id=? and user_id=? and type in ('hosting', 'Others', 'PromoHosting', 'Addon', 'SSL', 'Custom', 'other', 'server', 'reseller', 'DomainRenewal')", [$invoice_id, $user_id]);
        return  $query->result();
    }
    function transaction_info($transaction_id=0){
      $info = get_one("select a.user_id, a.id, a.description, a.payment_method, a.transaction_no, b.title as payent_title, a.base_conv_rate, a.amount_in, a.amount_out, a.fees, a.paymet_date, a.currency, c.symbol, c.symbol_position, a.refund_type,a.invoice_id from ".WST_INV_PAY." a inner join ".WST_PAY_METHOD." b on a.payment_method=b.id inner join ".WST_CURRENCIES." c on c.id=a.currency where a.id=?", [$transaction_id]);
        return $info;
    }
    function GetRefundEntriesByGateway($id)
    {
      return $this->db->select('*')->where(["refund_id"=>$id,"refund_type"=>"Gateway"])->limit(1)->get(WST_INV_PAY)->row();
    }
    function GetRefundEntriesByCredit($id)
    {
      return $this->db->select('*')->where(["refund_id"=>$id,"refund_type"=>"Credit"])->limit(1)->get(WST_INV_PAY)->row();
    }
    function DoTransactionValidate($invoice_id=0, $transaction_no=0)
    {
        return $this->db->select('*')->where(["invoice_id"=>$invoice_id, "transaction_no"=>$transaction_no])->limit(1)->get(WST_INV_PAY)->row();
    }
    function GetTransactionById($id=0)
    {
      $info = get_one("select * FROM ".WST_INV_PAY." WHERE id=?", [$id]);
      return $info;
    }
    function transaction_balance($id=0)
    {
      $info = get_one("select SUM(amount_in-amount_out) AS balance FROM ".WST_INV_PAY." WHERE (id=? OR refund_id=?)", [$id, $id]);
      return _s('balance', $info, 0);
    }
    function invoice_delete_payment_transaction($invoice_id=0, $entry_id=0, $entry_type="")
    {  
        $ti = $this->transaction_info($entry_id);
        if(empty($ti)) return array("2","Payment Entry Deletion failed due to Entry not exist");
        if(empty($entry_type)) $entry_type=$ti->refund_type;
        if($invoice_id == 0) $invoice_id = $ti->invoice_id;
        if($entry_type == 'ivCredit') return array("2", WsLang('WSLM-0129')); 
        if($entry_type == "Normal")
        {
            $isExist = $this->GetRefundEntriesByGateway($entry_id);
            if(!empty($isExist))
            {
                $msg = "Payment Entry Deletion failed due to refunded by Payment Gateway (".$entry_id.")";
                logActivity(0,$msg,[]);
                return array("2",$msg);
            }
            $isExist = $this->GetRefundEntriesByCredit($entry_id);
            if(!empty($isExist))
            {
                $msg = "Payment Entry Deletion failed due to refunded by Credit to Client (Credit Transaction ID:".$isExist->id."), So plz delete this 1st";
                logActivity(0,$msg,[]);
                return array("2",$msg);
            }
            $isRefundSupported = $this->Gateway->isRefundSupportedByGateway($ti->payment_method);
            if($isRefundSupported)
            {
                $msg = "Payment Entry Deletion not allowed due to refund supported by Payment Gateway, So plz refund the transaction instead of deletion";
                logActivity(0,$msg,[]);
                return array("2",$msg);
            }
        }
        if($entry_type == "Gateway")
        {
            $msg = "Payment Entry Deletion failed due to Payment made through payment Gateway (".$entry_id."), So, Plz refund to customer instead of deletion.";
            logActivity(0,$msg,[]);
            return array("2",$msg);
        }
        if($entry_type == 'Credit')
        {
            $isDone = $this->ClientCreditRemove(["isPosted"=>false, "user_id"=>_s('user_id', $ti), "description"=>WsLang('WSLM-0130'), "entry_date"=>Carbon::now()->format('Y-m-d'), "amount_in"=>0, "amount_out"=>_s('amount_out', $ti,0), "invoice_id"=>$invoice_id, "trans_id"=>$entry_id]);
            if($isDone[0] == 2){return $isDone;}
        }
        $isDeleted = $this->db->delete(WST_INV_PAY, ['id'=>$entry_id, 'invoice_id'=>$invoice_id]);
        if (!$isDeleted)
        {
            logActivity(0, WsLang('WSLM-0131').' '.$entry_id, $this->db->error());
            return array("2", WsLang('WSLM-0132'));
        }
        run_hook('DelInvoicePayment', ['invoice_id'=>$invoice_id, 'trans_id'=>$entry_id, 'entry_type'=>_s('refund_type', $ti)]);
        $this->db->delete('clients_credits', ['trans_id'=>$entry_id]);
        $this->invoice_change_status($invoice_id);
        logActivity(0, WsLang('WSLM-0133').' '.$entry_id, $this->db->error());
        return array("1", WsLang('WSLM-0134'));
    }
    function GetInvoiceOrderData($invoice_id=0)
    {
        $array = [];
        $query = $this->db->query("select * from invoices_payments_data where invoice_id=?",[$invoice_id]);
        $Results = $query->result();
        if(!empty($Results))
        {
            foreach($Results as $row)
            {
                $field_value = $row["field_value"];
                $field_value = (is_object($field_value)) ? json_decode($field_value,true):$field_value;
                $array[$row["field_name"]] =$field_value;
            }
        }
        return $array;
    }    
    function SetInvoiceOrderData($invoice_id=0, $field="", $data=[])
    {
        $data = (is_array($data)) ? json_encode($data):$data;
        $isExist = $this->db->select('*')->where(["invoice_id"=>$invoice_id,"field_name"=>$field])->limit(1)->get("invoices_payments_data")->row();
        if(!empty($isExist))
        {
            $isAdded = $this->db->update("invoices_payments_data",["field_value"=>$data],["invoice_id"=>$invoice_id,"field_name"=>$field]);
        }
        else
        {
            $isAdded = $this->db->insert("invoices_payments_data",["invoice_id"=>$invoice_id,"field_name"=>$field,"field_value"=>$data]);
        }
        return $isAdded;        
    }
    function reversePaymentActions($invoice_id=0, $user_id=0)
    {
        $doChangeInvoiceStatus = $this->Config->getConfig("CRON_CHANGE_INVOICES_STATUS");
        $doChangeInvoiceStatus = ($doChangeInvoiceStatus == "YES") ? true:false;
        $doChangeDueDates = $this->Config->getConfig("CRON_CHANGE_DUE_DATES");
        $doChangeDueDates = ($doChangeDueDates == "YES") ? true:false;
        if ($doChangeInvoiceStatus)
        {
            $isChanged = $this->db->update("invoices",["status"=>6],["id"=>$invoice_id]);
            if($isChanged) logActivity($user_id,"Payment Reversal - Invoice Status set to Collections - Invoice ID: " .$invoice_id,[]);
        }
        $items = $this->invoice_items_list($invoice_id);
        foreach ($items as $item)
        {
            if($item->pid>0)
            {
                if(in_array($item->type,['hosting','SSL','Addon','Others','PromoHosting','Setup','other','server','reseller','Upgrade','config']))
                {
                    if ($doChangeDueDates)
                    {
                        if ($item->type == "Addon")
                        {
                            $activityLogEntry = "Payment Reversal - Modified Service Addon - Next Due Date changed from ";
                            $activityLogSuffix = " - Service ID: " . $item->pid . " - Addon ID: " . $item->pid;
                        }
                        else
                        {
                            $activityLogEntry = "Payment Reversal - Modified Product/Service - Next Due Date changed from ";
                            $activityLogSuffix = " - Service ID: " . $item->pid;
                        }
                        $ServiceInfo = $this->Products->GetServiceInfo($item->pid);
                        $defaultNextDueDate = $ServiceInfo->reg_date;
                        $nextDueDate = $ServiceInfo->next_due_date;
                        if (!empty($nextDueDate))
                        {
                            if($nextDueDate != "0000-00-00" && $nextDueDate != "1970-01-01")
                            {
                                $nextDueDate = Carbon::createFromFormat("Y-m-d", $nextDueDate);
                            }
                        }
                        if ($nextDueDate instanceof Carbon)
                        {
                            $activityLogEntry .= $nextDueDate->toDateString() . " to";
                            $nextDueDate = $nextDueDate->subMonths($this->Config->price_duration_months($ServiceInfo->billing_cycle));
                            $activityLogEntry .= " " . $nextDueDate->toDateString();
                        } else {
                            $activityLogEntry .= $nextDueDate . " to " . $defaultNextDueDate;
                        }
                        $activityLogEntry .= " - User ID: " . $ServiceInfo->user_id;
                        if($item->type == "Upgrade")
                        {
                            $this->Provisioning->accountSuspend(["id"=>$item->pid,"send_mail"=>"YES","reason"=>"Due to Payment Reversal Suspended"]);
                        }
                        $isUpdated = $this->db->update('hosting',["next_due_date"=>$nextDueDate,"overide_suspend_until"=>$nextDueDate,"next_invoice_date"=>$nextDueDate,"termination_date"=>$nextDueDate],["id"=>$item->pid]);
                        if($isUpdated)
                        {
                            logActivity($ServiceInfo->user_id, $activityLogEntry . $activityLogSuffix,[]);
                        }
                    }
                }
                if($item->type == 'AddFund')
                {
                    $isReversed = $this->ClientCreditRemove(["isPosted"=>false, "user_id"=>$item->user_id, "description"=>"Funds Reversed By Gateway", "entry_date"=>Carbon::now()->format('Y-m-d h:i:s'), "amount_in"=>0, "amount_out"=>$item->amount, "invoice_id"=>$invoice_id, "trans_id"=>0]);
                    if($isReversed[0] == 1) logActivity($item->user_id,"Funds Reversal - Removed Credit - User ID: " . $item->user_id . " - Amount: " .$item->amount,[]);
                }
            }
        }
    }    
    function paymentReversed($reverseTransactionId="0", $originalTransactionId="0", $invoice_id = 0, $gateway = "")
    {
        $transaction = $isExist = $this->db->select('*')->where(["invoice_id"=>$invoice_id,"transaction_no"=>$originalTransactionId,"payment_method"=>$gateway])->limit(1)->get("invoices_payments")->row();
        if(empty($isExist)) return ["status"=>"error","message"=>"Transaction Not Found"];
        $isExist = $this->db->where(["invoice_id"=>$invoice_id,"payment_method"=>$gateway,"refund_id"=>$isExist->refund_id])->from("invoices_payments")->count_all_results();
        if($isExist>0) return ["status"=>"error","message"=>"Transaction Already Reversed"];
        $transactions = $this->db->where(["invoice_id"=>$invoice_id,"transaction_no"=>$reverseTransactionId,"payment_method"=>$gateway])->from("invoices_payments")->count_all_results();
        if ($transactions>1) return ["status"=>"error","message"=>"Multiple Original Transaction matches - Reversal not Available"];
        $data=[];
        $data["invoice_id"] = $transaction->invoice_id;
        $data["transaction_id"] = $transaction->id;
        $data["RefundType"] = "Reversed";
        $data["date"] = date("Y-m-d");
        $data["amount"] = $transaction->amount_in;
        $data["notification"] = "YES";
        $data["trno"] = $transaction->transaction_no;
        $data["fees"] = $transaction->fees * -1;
        $isReversed = $this->invoice_refunded($data);
        if($isReversed[0] == 1)
        {
            $this->reversePaymentActions($transaction->invoice_id, $transaction->user_id);
            return ["status"=>"success","message"=>$isReversed[1]];
        }
        return ["status"=>"error","message"=>$isReversed[1]];
    }    
    function invoice_add_payment()
    {
        $invoice_id = __post('iid', true);
        $icurrency = __post('icurrency', true);
        $user_id = __post('iuser_id', true);
        $payment_method_id = __post('payment_method_id', true);
        $date = __post('date', true);
        $amount = __post('amount', true);
        $trno = __post('trno', true);
        $fee = __post('fee', true);
        $notification = __post('notification', true);
        $payment_added = $this->add_payment($invoice_id, $icurrency, $user_id, $payment_method_id, $date, $amount, $trno, $fee, $notification, 'Normal', 0, 'IN', "Invoice Payment Added");
        if($payment_added[0] == 1) $this->SetInvoiceOrderData($invoice_id,"iv-trans-".$invoice_id."-".$payment_added[2]."-pay-".$type,$payment_added);
        return $payment_added;
    }
    function AddInvoicePayment($arg=[])
    {
        $invoice_id =_s('invoice_id', $arg);
        $icurrency =_s('currency', $arg);
        $user_id =_s('user_id', $arg);
        $payment_method_id =_s('payment_method', $arg);
        $GatewayParameters = $this->Gateway->GetParameters(["gateway_id"=>$payment_method_id, "user_id"=>$user_id, "invoice_id"=>$invoice_id]);
        $icurrency = iset("currency", $GatewayParameters);
        $InvoiceCurrencyCode = iset("InvoiceCurrencyCode", $GatewayParameters);
        $date = Carbon::now()->format('Y-m-d h:i:s');
        $amount =_s('amount', $arg,0);
        $trno =_s('trno', $arg);
        $fee =_s('fee', $arg,0);
        $notification =_s('notification', $arg);
        if(is_numeric($icurrency))
        {
            $baseCurrency = $this->Currency->getBaseCurrency($icurrency);
        }else{
            $baseCurrency = $this->Currency->getCurrencyByCode($icurrency);
        }
        $icurrency = $currCode = _s('id', $baseCurrency);
        $currConvRate = _s('base_conv_rate', $baseCurrency);
        if(_s('code', $baseCurrency) != $InvoiceCurrencyCode)
        {
            $amount = Devide($amount,_s('base_conv_rate', $baseCurrency));
            $fee = Devide($fee,_s('base_conv_rate', $baseCurrency));
            $baseCurrency = $this->Currency->getCurrencyByCode($InvoiceCurrencyCode);
            $icurrency = _s('id', $baseCurrency);
            $currConvRate = _s('base_conv_rate', $baseCurrency);
            $amount = Multiply($amount,$currConvRate);
            $fee = Multiply($fee,$currConvRate);
        }
        $type = 'Normal';
        $IsCreditInvoice = $this->IsCreditInvoice($invoice_id);
        if($IsCreditInvoice)
        {
            $type = 'AddFund';
            $this->type = $type;
        }
        $desc = "Invoice Payment Added";
        if($IsCreditInvoice) $desc = "Invoice Payment Added By Add Fund Invoice";
        $payment_added = $this->add_payment($invoice_id, $icurrency, $user_id, $payment_method_id, $date, $amount, $trno, $fee, $notification, $type, 0, 'IN', $desc);
        if($payment_added[0] == 1)
        {
            $this->SetInvoiceOrderData($invoice_id,"iv-trans-".$invoice_id."-".$payment_added[2]."-pay-".$type,$payment_added);
            return array('status'=>'success', 'message'=>$payment_added[1]);
        }
        return array('status'=>'error', 'message'=>$payment_added[1]);
    }
    function IsCreditInvoice($invoice_id=0)
    {
        $isExist = full_query("select type from invoices_details where invoice_id='$invoice_id' and type='AddFund'");
        if(!empty($isExist)) return true;
        return false;
    }
    function add_payment($invoice_id=0, $icurrency=0, $user_id=0, $payment_method_id=0, $date="", $amount=0, $trno=0, $fee=0, $notification="NO", $RefundType="", $transaction_id=0, $entry_type="", $description="")
    {
        $icurrency = (int)$icurrency>0 ? $icurrency:0;
        $amount = (float)$amount>0 ? $amount:0;
        $invoice_info =  $this->invoice_info($invoice_id);
        if(empty($invoice_info)) return array("2","Invoice not found or exist");
        if($icurrency == 0) $icurrency = $invoice_info->currency;
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');
        if(empty($date)) $date = $entry_date;
        if($amount<=0) $amount = $invoice_info->sale_amount-($invoice_info->discount_amount+$invoice_info->paid_amount);
        if($payment_method_id <1) $payment_method_id = $invoice_info->payment_method;
        if($user_id <1) $user_id = $invoice_info->user_id;

        $notification = ($notification == 'YES') ? 'YES':'NO';
        if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
        if(empty($icurrency)) return array("2", WsLang('WSLM-0136'));
        if(empty($user_id)) return array("2", WsLang('WSLM-0126'));
        if(empty($payment_method_id)) return array("2", WsLang('WSLM-0137'));
        if(empty($date)) return array("2", WsLang('WSLM-0138'));
        if(empty($amount)) return array("2", WsLang('WSLM-0127'));
        if($this->Config->letters_exist($amount) == 1) return array("2", WsLang('WSLM-0128'));
        //if(empty($trno)){ return array("2", "Please Enter Transaction no");}
        if(empty($notification)) return array("2", WsLang('WSLM-0139'));
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
        $added_by = $this->uid;
        $paymet_date = date('Y-m-d', _t($date));
        $data = array('description' => $description, 'refund_type' => $RefundType, 'refund_id' => $transaction_id, 'entry_date' => $entry_date, 'paymet_date' => $paymet_date, 'invoice_id' => $invoice_id, 'fees' => $fee, 'transaction_no' => $trno, 'base_conv_rate' => $base_conv_rate, 'payment_method' => $payment_method_id, 'currency' => $icurrency, 'user_id' => $user_id);

        if($entry_type == 'IN'){
            $data['amount_in'] = $amount;
            $data['amount_out'] = 0;
            $this->last_paid_amount = $amount;
        }else{
            $data['amount_in'] = 0;
            $data['amount_out'] = $amount;
        }

        $isDone =   $this->db->insert(WST_INV_PAY, $data);
        $trans_id = $this->db->insert_id();
        if($isDone)
        {
            $this->trans_id = $trans_id;
            $this->invoice_change_status($invoice_id);     
            $invoice_info =  $this->invoice_info($invoice_id);
            if(empty($invoice_info)) return ["status"=>"error", "message"=>WsLang('OrderInvoiceNotExist')];
            $message = WsLang('WSLM-0140');
            
            $IsCreditInvoice = $this->IsCreditInvoice($invoice_id);
            if(!$IsCreditInvoice)
            {
                $order_info =  $this->Cart->order_info_by_invoice($invoice_id);
                if(!empty($order_info))
                {
                    $response = $this->Cart->AutomaticRenewOnPayments(["invoice_id"=>$invoice_id, 'send_email'=>$notification]);
                }
                if($response["status"] == "error") $message .="<br>".$response["message"];
                logActivity(0, $message, $this->db->error());  
                //$this->ClientCreditAdd(["user_id"=>$user_id, "description"=>WsLang('WSLM-0141').' #'.$invoice_id, "entry_date"=>$paymet_date, "amount_in"=>$amount, "amount_out"=>0, "invoice_id"=>$invoice_id, "trans_id"=>$trans_id]);
            }
            else
            {
                if(in_array($this->type, ["ivDel", "ivAdd","AddFund"]))
                {
                    if($entry_type == "IN" && $this->type == "AddFund")
                    {
                        $this->db->query("delete from clients_credits where invoice_id='".$invoice_id."' and trans_id in (select id from invoices_payments where invoice_id='".$invoice_id."')");
                        $invoicePaymentsQuery = $this->db->query("select sum(rate*base_conv_rate) as amounts from invoices_details where invoice_id='".$invoice_id."' and type='AddFund'");
                        $invoicePaymentsRes = $invoicePaymentsQuery->result();
                        $amount_in = $invoicePaymentsRes[0]->amounts;
                        $this->ClientCreditAdd(["user_id"=>$user_id, "description"=>WsLang('WSLM-0141').' #'.$invoice_id, "entry_date"=>$paymet_date, "amount_in"=>$amount_in, "amount_out"=>0, "invoice_id"=>$invoice_id, "trans_id"=>$trans_id]);
                    }/*
                    else
                    {
                        $isDone = $this->ClientCreditRemove(["user_id"=>$user_id, "description"=>"Credit Refunded", "entry_date"=>$paymet_date, "amount_in"=>0, "amount_out"=>$amount, "invoice_id"=>$invoice_id, "trans_id"=>0]);
                    }*/
                }
            }
            
            run_hook('AddInvoicePayment', ['trans_id'=>$trans_id, 'invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
            RunWsCommand('AddInvoicePayment', ['trans_id'=>$trans_id, 'invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
            run_hook('AddTransaction', ['trans_id'=>$trans_id, 'invoice_id'=>$invoice_id, 'user_id'=>$user_id, 'currency'=>$icurrency, 'gateway'=>$payment_method_id, 'date'=>$entry_date, 'description'=>'Payment Added', 'amountin'=>$amount, 'fees'=>$fee, 'amountout'=>0, 'rate'=>0, 'gateway_trans_id'=>$transaction_id, 'refundid'=>0, 'SendEmail'=>'YES']);
            RunWsCommand('AddTransaction', ['trans_id'=>$trans_id, 'invoice_id'=>$invoice_id, 'user_id'=>$user_id, 'currency'=>$icurrency, 'gateway'=>$payment_method_id, 'date'=>$entry_date, 'description'=>'Payment Added', 'amountin'=>$amount, 'fees'=>$fee, 'amountout'=>0, 'rate'=>0, 'gateway_trans_id'=>$transaction_id, 'refundid'=>0, 'SendEmail'=>'YES']);
            return array("1", $message, $trans_id);
        }
        logActivity(0, WsLang('WSLM-0142'), $this->db->error());   
        return array("2", WsLang('WSLM-0142'), 0);                       
    }
    function invoice_refunded($arg=[])
    {
        if(empty($arg))
        {
            $fee=0;
            $invoice_id = __post('invoice_id', true);
            $transaction_id = __post('transaction_id', true);
            $RefundType = __post('RefundType', true);
            $date = __post('date', true);
            $amount = __post('amount', true);
            $notification = __post('notification', true);
            $trno = __post('trno', true);
        }
        else
        {
          $invoice_id =_s('invoice_id', $arg);
          $transaction_id =_s('transaction_id', $arg);
          $RefundType =_s('RefundType', $arg);
          $date =_s('date', $arg);
          $amount =_s('amount', $arg);
          $notification =_s('notification', $arg);
          $trno =_s('trno', $arg);
          $fee =_s('fees', $arg);
        }
        $entry_date = Carbon::now()->format('Y-m-d h:i:s');
        if(empty($date)) $date = $entry_date;        
      //$trno = 0;

      if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
      if($transaction_id <1) return array("2", WsLang('WSLM-0143'));

      $transaction_info = $this->transaction_info($transaction_id);
      $payment_method = $transaction_info->payment_method;
      $icurrency = $transaction_info->currency;
      $user_id = $transaction_info->user_id;
      if($amount<=0) $amount = $transaction_info->amount_in;

      if(empty($RefundType)) return array("2", WsLang('WSLM-0144'));
      if(empty($date)) return array("2", WsLang('WSLM-0138'));
      if(empty($amount)) return array("2", WsLang('WSLM-0127'));
      if($this->Config->letters_exist($amount) == 1) return array("2", WsLang('WSLM-0128'));
      if(empty($notification)) return array("2", WsLang('WSLM-0139'));
      
        if($RefundType == 'Manual')
        {
            $trno = 0;
            $isDone =   $this->add_payment($invoice_id, $icurrency, $user_id, 1, $date, $amount, $trno, $fee, $notification, $RefundType, $transaction_id, 'OUT', "Payment Refunded using Manual Refund By Externally Processed");
            if($isDone[0] == 1)
            {
                logActivity(0, WsLang('WSLM-0145'),[]);
                $this->SetInvoiceOrderData($invoice_id,"iv-trans-".$invoice_id."-".$isadded[2]."-manual-refund",$isDone);
                $hookArrays = ['invoice_id'=>$invoice_id, 'trans_id'=>$transaction_id, 'amount'=>$amount, 'type'=>$RefundType, 'SendEmail'=>'YES'];
                run_hook('InvoiceRefunded', $hookArrays);
                RunWsCommand('InvoiceRefunded', $hookArrays);
                run_hook('ManualRefund', $hookArrays);
                RunWsCommand('ManualRefund', $hookArrays);
                return array("1", WsLang('WSLM-0145'));                        
            }
            logActivity(0, WsLang('WSLM-0147').' ('.$isDone[1].')', $this->db->error());   
            return array("2", WsLang('WSLM-0147').' ('.$isDone[1].')');                       
        }
        if($RefundType == 'Credit')
        {
            $trno = 0;
            $description = WsLang('WSLM-0146');
            $amount_out = 0;
            $isDone =  $this->ClientCreditAdd(["user_id"=>$user_id, "description"=>$description, "entry_date"=>$date, "amount_in"=>$amount, "amount_out"=>$amount_out, "invoice_id"=>0, "trans_id"=>0]);
            if($isDone[0] == 1)
            {
                $isadded = $this->add_payment($invoice_id, $icurrency, $user_id, 1, $date, $amount, $trno, $fee, $notification, $RefundType, $transaction_id, 'OUT', "Payment Added as Credit to Client Account");
                $this->db->update("clients_credits", ["trans_id"=>$isadded[2]], ["id"=>$isDone[2]]);
                $this->SetInvoiceOrderData($invoice_id,"iv-trans-".$invoice_id."-".$isadded[2]."-refund-credit",$isadded);
                logActivity(0, WsLang('WSLM-0145'),[]);
                run_hook('InvoiceRefunded', array('invoice_id'=>$invoice_id, 'SendEmail'=>'YES'));
                RunWsCommand('InvoiceRefunded', array('invoice_id'=>$invoice_id, 'SendEmail'=>'YES'));
                return array("1", WsLang('WSLM-0145'));                        
            }
            logActivity(0, WsLang('WSLM-0147').' ('.$isDone[1].')', $this->db->error());   
            return array("2", WsLang('WSLM-0147').' ('.$isDone[1].')');
        }
        if($RefundType == 'Gateway')
        {
            $description = WsLang('WSLM-0146');
            $amount_out = 0;
            $isDone = $this->Gateway->Refund(["gateway_id"=>$payment_method, "invoice_id"=>$invoice_id, "transaction_id"=>$transaction_id, "transid"=>$trno]);
            $rawdata = iset("rawdata", $isDone,[]);
            if(iset("status", $isDone) == "error")
            {
                $msg = iset("message", $isDone);
                logActivity(0, $msg, $rawdata);  
                return ["2",$msg];
            }
            $gtrno = iset("transid", $isDone,0);
            $isAdded = $this->add_payment($invoice_id, $icurrency, $user_id, $payment_method, $date, $amount, $gtrno, $fee, $notification, $RefundType, $transaction_id, 'OUT', "Payment Refunded using Selected Payment Method");
            AddGatewayLogs(['invoice_id'=>$invoice_id, 'user_id'=>$user_id, 'payment_method'=>$payment_method, 'response'=>$isDone]);
            $msg = "Payment Refunded to Client and Payment Entry Out Successfully from Transaction Ledger";
            if($isAdded[0] == 2) $msg = "Payment Refunded to Client but Payment Entry Out Failed from Transaction Ledger";
            if(is_array($rawdata) || is_object($rawdata)) $rawdata = _je($rawdata);
            $this->SetInvoiceOrderData($invoice_id,"iv-trans-".$invoice_id."-".$isAdded[2]."-refund-gateway",$rawdata);
            logActivity(0, $msg, $rawdata);  
            run_hook('InvoiceRefunded', array('invoice_id'=>$invoice_id, 'SendEmail'=>'YES'));
            RunWsCommand('InvoiceRefunded', array('invoice_id'=>$invoice_id, 'SendEmail'=>'YES'));
            return array("1", WsLang('WSLM-0145')); 
        }
        if($RefundType == 'Reversed')
        {
            $description = "Pyment Reversed by Gateway";
            $amount_out = 0;
            $isAdded = $this->add_payment($invoice_id, $icurrency, $user_id, $payment_method, $date, $amount, $trno, $fee, $notification, $RefundType, $transaction_id, 'OUT', "Payment Reversed By Payment Gateway");
            AddGatewayLogs(['invoice_id'=>$invoice_id, 'user_id'=>$user_id, 'payment_method'=>$payment_method, 'response'=>$isAdded]);
            $msg = "Payment Refunded to Client and Payment Entry Out Successfully from Transaction Ledger";
            if($isAdded[0] == 2) $msg = "Payment Refunded to Client but Payment Entry Out Failed from Transaction Ledger";
            if(is_array($isAdded) || is_object($isAdded)) $rawdata = _je($isAdded);
            logActivity(0, $msg, $rawdata);  
            if($isAdded[0] == 1)
            {
                $this->SetInvoiceOrderData($invoice_id,"iv-trans-".$invoice_id."-".$isAdded[2]."-reverse-gateway",$rawdata);
                run_hook('PaymentReversedNotification', array('invoice_id'=>$invoice_id, 'transaction_id'=>$transaction_id, 'SendEmail'=>'YES'));
                RunWsCommand('Payment Reversed Notification', array('invoice_id'=>$invoice_id, 'transaction_id'=>$transaction_id, 'SendEmail'=>'YES'));
            }
            return array("1", WsLang('WSLM-0145'));                        
        }
    }
    function invoice_refund_form($invoice_id=0, $transaction_id=0)
    {
        $file = "invoice_refund_form.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            echo WsFileNotExist($file, $tpath);
        }
    }
    function invoice_funds_create_form($user_id=0)
    {
        $file = "invoice_funds_create_form.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            echo WsFileNotExist($file, $tpath);
        }
    }
    function credit_form($user_id=0, $type="")
    {
        $file = "credit_form.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            echo WsFileNotExist($file, $tpath);
        }
    }
    function invoice_item_delete($invoice_id=0, $item_id=0)
    {
        //$invoice_info = $this->invoice_info($invoice_id);
        //$user_id = _s('user_id', $invoice_info, 0);        
        $isDone = $this->db->delete(WST_INV_DETAIL, ['id'=>$item_id, 'invoice_id'=>$invoice_id]);
        $this->invoice_update_header_by_child($invoice_id, 0);
        if($isDone)
        {
            logActivity(0, WsLang('WSLM-0149').' '.$item_id, $this->db->error());    
            $this->Tax->ApplyTaxToInvoice($invoice_id, 0);
            return array("1", WsLang('WSLM-0148'));                        
        }
        logActivity(0, WsLang('WSLM-0150').' '.$item_id, $this->db->error());   
        return array("2", WsLang('WSLM-0150').' '.$item_id);                       
    }
    function invoice_payment_method_change($invoice_id=0, $payment_method_id=0)
    {
        $oldGateway = $this->invoice_info($invoice_id);
        $oldMethodId = _s('payment_method', $oldGateway);
        if($oldMethodId!=$payment_method_id)
        {
            $this->db->where("id = '$invoice_id'");
            $isDone = $this->db->update(WST_INV, array('payment_method'=>$payment_method_id));
            if($isDone){
                $msg = WsLang('WSLM-0151');
                logActivity(0, $msg, []);    
                run_hook('InvoiceChangeGateway', ['invoice_id'=>$invoice_id, 'old_gateway_id'=>$oldMethodId, 'new_gateway_id'=>$payment_method_id, 'SendEmail'=>'YES']);
                RunWsCommand('InvoiceChangeGateway', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
                return array("1", $msg);                        
            }
            $msg = WsLang('WSLM-0152');
            logActivity(0, $msg, $this->db->error());   
            return array("2", $msg);                       
        }
    }
    function invoice_status_change($invoice_id=0, $status_id=0)
    {
          if($status_id == 8)
          {
            $status_id=2;
            $statusCode=8;
          }else{
            $statusCode = $status_id;
          }          
          if($statusCode == 3)
          {
                //Paid
                run_hook('InvoicePaidPreEmail', ['invoice_id'=>$invoice_id, 'trans_id'=>$this->trans_id, 'SendEmail'=>'YES']);
                RunWsCommand('InvoicePaidPreEmail', ['invoice_id'=>$invoice_id, 'trans_id'=>$this->trans_id, 'SendEmail'=>'YES']);
          }
        $isDone = $this->db->update(WST_INV, ['status'=>$status_id], ['id'=>$invoice_id]);
        if($isDone)
        { 
          $statusInfo = $this->invoices_status_by_id($status_id);
          logActivity(0, 'Invoice Status Changed as '._s('title', $statusInfo).', Invoice ID is '.$invoice_id, $this->db->error());
          if($statusCode == 3){ //Paid
                run_hook('InvoicePaid', ['invoice_id'=>$invoice_id, 'trans_id'=>$this->trans_id, 'SendEmail'=>'YES']);
                RunWsCommand('InvoicePaid', ['invoice_id'=>$invoice_id, 'trans_id'=>$this->trans_id, 'SendEmail'=>'YES']);
                $order_info = $this->Cart->order_info_by_invoice($invoice_id);
                if($order_info)
                {
                    $order_no = _s('order_no', $order_info);
                    $hookArrays = [];
                    $hookArrays['invoice_id'] = $invoice_id;
                    $hookArrays['order_id'] = $order_no;
                    $hookArrays['order'] = $order_info;
                    $hookArrays['SendEmail'] = 'YES';
                    $hookArrays['items'] = $this->Cart->orders_details_items($order_no);
                    run_hook('OrderPaid', $hookArrays);
                    RunWsCommand('OrderPaid', $hookArrays);
                }
            }
          if($statusCode == 2)
          { //UnPaid
                run_hook('InvoiceUnpaid', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
                RunWsCommand('InvoiceUnpaid', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
          }
          if($statusCode == 8){ //Publish
                run_hook('InvoiceCreationAdminArea', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
                RunWsCommand('InvoiceCreationAdminArea', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
                RunWsCommand('InvoiceCreated', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES', 'source'=>'adminarea']);
            }
          if($statusCode == 4){ // Cancelled
              run_hook('InvoiceCancelled', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
              RunWsCommand('InvoiceCancelled', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
            }
         $this->Affiliates->updateInvoiceStatus(['invoice_id'=>$invoice_id, 'status'=>$statusCode]);
            return array("1", WsLang('WSLM-0153'));                        
        }else{
          logActivity(0, WsLang('WSLM-0154').' '.$invoice_id, $this->db->error());   
            return array("2", WsLang('WSLM-0154').' '.$invoice_i);                       
        }                
    }
    function client_credit_delete($user_id=0, $id=0)
    {
        $isDone = $this->db->delete(WST_CCREDITS, ['id'=>$id, 'user_id'=>$user_id]);
        if($isDone){
          logActivity(0, WsLang('WSLM-0155').' '.$id, $this->db->error());    
            return array("1", WsLang('WSLM-0155').' '.$id);                        
        }else{
          logActivity(0, WsLang('WSLM-0156').' '.$id, $this->db->error());   
            return array("2", WsLang('WSLM-0156').' '.$id);                       
        }                
    }
    function client_credit_balance($user_id=0){
        $cinRecords = get_one("select ifnull(sum(amount_in-amount_out), 0) as amount  from ".WST_CCREDITS." where user_id=?", [$user_id]);
        return _s('amount', $cinRecords, 0);
        return 0;
    }
    function invoice_credit_balance($invoice_id=0)
    {
        $cRecords = get_one("select sum(amount_in-amount_out) as amount from ".WST_CCREDITS." where invoice_id=?", [$invoice_id]);
        $amount = _s('amount', $cRecords, 0);
        return abs($amount)>0 ? abs($amount):0;
    }
    function invoice_change_status($invoice_id=0)
    {
        $this->invoice_update_header_by_child($invoice_id, 1);
    }
    function invoice_update_header_by_child($invoice_id=0, $change_status=0)
    {
      $saleResult =  get_one("select sum(rate*qty) as amount, sum(discount) as discount, sum(cost) as cost from ".WST_INV_DETAIL." where invoice_id='$invoice_id'");
      $sale_amount = _s('amount', $saleResult);
      $discount_amount = _s('discount', $saleResult, 0);
      $cost_amount = _s('cost', $saleResult, 0);
      $totalPayable = $sale_amount-$discount_amount;
      $paymentResult =  get_one("select sum(amount_in-amount_out) as amount_in from ".WST_INV_PAY." where invoice_id='$invoice_id'");
      $amount_in = _s('amount_in', $paymentResult, 0);
      //$balance = $this->invoice_credit_balance($invoice_id);
      //$amount_in += $balance;
        $data = array('sale_amount'=>$sale_amount, 'paid_amount'=>$amount_in, 'discount_amount'=>$discount_amount, 'cost_amount'=>$cost_amount);
        if($this->last_paid_amount > 0) $data['last_paid_amount'] = $this->last_paid_amount;
        if($change_status > 0)
        {
          $amountDiff = $totalPayable-$amount_in;
          if($amountDiff > 1){
            $data['status'] = 2;
            $data['paid_date'] = '';
            $this->Affiliates->updateInvoiceStatus(['invoice_id'=>$invoice_id, 'status'=>2]);
          }else{
            $data['paid_date'] = Carbon::now()->format('Y-m-d h:i:s');          
            $data['status'] = 3;          
            $this->Affiliates->updateInvoiceStatus(['invoice_id'=>$invoice_id, 'status'=>3]);
          }
        }
       $updated =  $this->db->update(WST_INV, $data, ['id'=>$invoice_id]);
       $this->CostUpdateInInvoice($invoice_id);
       $this->Tax->ApplyTaxToInvoice($invoice_id, 0);
       if($updated) run_hook('UpdateInvoiceTotal', array('invoice_id'=>$invoice_id, 'SendEmail'=>'YES'));
       if($updated) RunWsCommand('UpdateInvoiceTotal', array('invoice_id'=>$invoice_id, 'SendEmail'=>'YES'));
    }
    function client_credit_add()
    {
        if(__post())
        {
            $user_id = __post('user_id', true);
            $description = __post('description', true);
            $date = __post('date', true);
            $amount_out = 0;
            $amount_in = __post('amount', true);
            $invoice_id = 0;
            return $this->ClientCreditAdd(["isPosted"=>true, "user_id"=>$user_id, "description"=>$description, "entry_date"=>$date, "amount_in"=>$amount_in, "amount_out"=>$amount_out, "invoice_id"=>$invoice_id]);
        }
    }
    function ClientCreditAdd($args=[])
    {
        $defaultDate = date('Y-m-d');
        $admin_id =iset("admin_id", $args,0);
        $user_id =iset("user_id", $args);
        $description =iset("description", $args);
        $date =iset("entry_date", $args,"");
        if(empty($date)) $date = $defaultDate;        
        $amount_in =iset("amount_in", $args, 0);
        $amount_out =iset("amount_out", $args, 0);
        $invoice_id =iset("invoice_id", $args, 0);
        $isPosted = !empty(iset("isPosted", $args,0));
        if($user_id <1) return ["2", WsLang('WSLM-0135')];
        if(empty($description)) return ["2", WsLang('WSLM-0157')];
        if(empty($date)) return ["2", WsLang('WSLM-0138')]; 
        //ManualCreditAdd
        $AmountEntered = $amount_out+$amount_in;
        if(empty($AmountEntered)) return ["2", WsLang('WSLM-0127')];
        if($this->Config->letters_exist($AmountEntered) == 1) return ["2", WsLang('WSLM-0128')];
        
        if($AmountEntered == 0) return ["2", WsLang('WSLM-0159')];
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1) return ["2", WsLang('MsgUpdateProfileCurrency')];
        
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        if($base_conv_rate == 0) return ["2", WsLang('AffiliateUpBaseOtherCurrency')];
        $description = nl2br($description);
        $added_by = (int)$admin_id > 0 ? $admin_id:$this->uid;
        $entry_date = date('Y-m-d', _t($date));

        $data = ['currency' => $icurrency, 'description' => $description, 'amount_in' => $amount_in, 'amount_out' => $amount_out, 'invoice_id' => $invoice_id, 'base_conv_rate' => $base_conv_rate, 'entry_date' => $entry_date, 'admin_id' => $added_by, 'user_id' => $user_id, 'trans_id' =>0];
        $isDone =   $this->db->insert(WST_CCREDITS, $data);
        $cid = $this->db->insert_id();
        if($isDone)
        {
            $this->credit_update($invoice_id, $cid);
            if($isPosted)
            {
                run_hook('AddCreditToClient', ['user_id'=>$user_id, 'amount'=>$amount_in, 'cid'=>$cid, 'description'=>$description]);
            }
            logActivity(0, WsLang('WSLM-0160'), $this->db->error());  
            return array("1", WsLang('WSLM-0160'), $cid);
        }
        logActivity(0, WsLang('WSLM-0161'), $this->db->error());   
        return array("2", WsLang('WSLM-0161'));                       
    }
    function client_credit_remove()
    {
        if(__post())
        {
            $user_id = __post('user_id', true);
            $description = __post('description', true);
            $date = __post('date', true);
            $amount_in = 0;
            $amount_out = __post('amount', true);
            $invoice_id = 0;
            return $this->ClientCreditRemove(["isPosted"=>true, "user_id"=>$user_id, "description"=>$description, "entry_date"=>$date, "amount_in"=>$amount_in, "amount_out"=>$amount_out, "invoice_id"=>$invoice_id]);
        }
    }
    
    function ClientCreditRemove($args=[])
    {
        $user_id =iset("user_id", $args);
        $description =iset("description", $args);
        $defaultDate = date('Y-m-d');
        $date =iset("entry_date",$args,"");
        if(empty($date)) $date = $defaultDate;
        $amount_in =iset("amount_in", $args, 0);
        $amount_out =iset("amount_out", $args, 0);
        $invoice_id =iset("invoice_id", $args);
        $isPosted = !empty(iset("isPosted", $args));
        $amountInOut = $amount_in+$amount_out;
        $balanceAmount = $this->client_credit_balance($user_id);
        $nbalanceAmount = $balanceAmount-$amount_out;
        if($nbalanceAmount<0) return ["2", "Client having insufficient credits, Removal not allowed. Credit Balance eq ".$balanceAmount];
        if($user_id <1) return ["2", WsLang('WSLM-0135')];
        if(empty($description)) return ["2", WsLang('WSLM-0157')];
        if(empty($date)) return ["2", WsLang('WSLM-0138')]; 
        //ManualCreditAdd
        if(empty($amountInOut)) return ["2", WsLang('WSLM-0127')];
        if($this->Config->letters_exist($amountInOut) == 1) return ["2", WsLang('WSLM-0128')];
        
        if($amountInOut == 0) return ["2", WsLang('WSLM-0159')];
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1) return ["2", WsLang('MsgUpdateProfileCurrency')];
        
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        if($base_conv_rate == 0) return ["2", WsLang('AffiliateUpBaseOtherCurrency')];
        $description = nl2br($description);
        $added_by = $this->uid;
        $entry_date = date('Y-m-d', _t($date));

        $data = ['currency' => $icurrency, 'description' => $description, 'amount_in' => $amount_in, 'amount_out' => $amount_out, 'invoice_id' => $invoice_id, 'base_conv_rate' => $base_conv_rate, 'entry_date' => $entry_date, 'admin_id' => $added_by, 'user_id' => $user_id, 'trans_id' =>0];
        $isDone =   $this->db->insert(WST_CCREDITS, $data);
        $cid = $this->db->insert_id();
        if($isDone)
        {
            $this->credit_update($invoice_id, $cid);
            if($isPosted) run_hook('DelCreditToClient', ['user_id'=>$user_id, 'amount'=>$amount_out, 'cid'=>$cid, 'description'=>$description]);
            logActivity(0, WsLang('WSLM-0160'), $this->db->error());  
            return array("1", WsLang('WSLM-0160'), $cid);
        }
        logActivity(0, WsLang('WSLM-0161'), $this->db->error());   
        return array("2", WsLang('WSLM-0161'));                       
        //'Del'
    }
    function AutoCreditApplyToInvoice($invoice_id=0,$description="")
    {
        $invoice_info =  $this->invoice_info($invoice_id);
        if(empty($invoice_info)) return array("2","Invoice not found or exist");
        if(empty($user_id)) $user_id = $invoice_info->user_id;
        $balanceAmount = $this->client_credit_balance($user_id);
        $balanceAmount = (float)$balanceAmount > 0 ? $balanceAmount:0;
        if($balanceAmount<=0) return ["2", "Client having insufficient credits,Credit Balance eq ".$balanceAmount];
        $invoice_bal_amount = $invoice_info->sale_amount-($invoice_info->discount_amount+$invoice_info->paid_amount);
        $invoice_bal_amount = (float)$invoice_bal_amount > 0 ? $invoice_bal_amount:0;
        if($invoice_bal_amount<=0) return ["2", "Client Invoice due amount is less then or eq to 0"];
        $amount = $balanceAmount>=$invoice_bal_amount ? $invoice_bal_amount:$balanceAmount;
        return $this->invoice_credit_add(["invoice_id"=>$invoice_id,"description"=>$description,"amount"=>$amount]);
    }
    function invoice_credit_add($args=[])
    {
        if(!empty($args))
        {
            $invoice_id = _s('invoice_id',$args,0);
            $user_id = _s('user_id',$args,0);
            $description = _s('description',$args,0);
            $date = _s('date',$args,"");
            $amount_in = _s('amount',$args,0);
            $notification = _s('notification',$args,"NO");
            $amount_in = (float)$amount_in>0 ? $amount_in:0;
            $defaultDate = date('Y-m-d');
            if(empty($date)) $date = $defaultDate;
        }else{
            $invoice_id = __post('invoice_id', true);
            $user_id = __post('user_id', true);
            $description = __post('description', true);
            $date = __post('date', true);
            $amount_in = __post('amount', true);            
            $notification = "YES";
        }
        $invoice_info =  $this->invoice_info($invoice_id);
        if(empty($invoice_info)) return array("2","Invoice not found or exist");
        if(empty($user_id)) $user_id = $invoice_info->user_id;
        $invoice_bal_amount = $invoice_info->sale_amount-($invoice_info->discount_amount+$invoice_info->paid_amount);
        if($amount_in > 0 && $amount_in>$invoice_bal_amount) $amount_in= $invoice_bal_amount;
        if($amount_in == 0) $amount_in=$invoice_bal_amount;
        if($amount_in<=0) return ["2", "Credit Applying failed due to invoice due amount or credit entered amount is less then or equal to ".$amount_in];
        $balanceAmount = $this->client_credit_balance($user_id);
        $nbalanceAmount = $balanceAmount-$amount_in;
        if($nbalanceAmount<0) return ["2", "Client having insufficient credits. Credit Balance eq ".$balanceAmount];

        $amount_out = 0;
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1) return ["2", WsLang('MsgUpdateProfileCurrency')];
        $add = $this->ClientCreditAdd(["user_id"=>$user_id, "description"=>$description, "entry_date"=>$date, "amount_in"=>0, "amount_out"=>$amount_in, "invoice_id"=>$invoice_id, "trans_id"=>0]);
        if($add[0] == 1)
        {
            $this->add_payment($invoice_id, $icurrency, $user_id, 1, $date, $amount_in, 0, 0,$notification, 'ivCredit', 0, 'IN', "Payment Added using Invoice By Client Credit");
            $this->invoice_change_status($invoice_id);
        }
        return $add;
    }
    function invoice_credit_remove()
    {
        $user_id = __post('user_id', true);
        $description = __post('description', true);
        $date = __post('date', true);
        $amount = __post('amount', true);
        $amount = $amount>0 ? $amount:0;
        $invoice_id = __post('invoice_id', true);
        $notification = ($notification == 'YES') ? 'YES':'NO';
        if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
        if(empty($user_id)) return array("2", WsLang('WSLM-0126'));
        if(empty($date)) return array("2", WsLang('WSLM-0138'));
        if(empty($amount)) return array("2", WsLang('WSLM-0127'));
        if($this->Config->letters_exist($amount) == 1) return array("2", WsLang('WSLM-0128'));
        if(empty($notification)) return array("2", WsLang('WSLM-0139'));
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
        $added_by = $this->uid;
        $paymet_date = date('Y-m-d', _t($date));
        $amount = Devide($amount,$base_conv_rate);        
        $userInfo = $this->Account->getUserInfoById($user_id);
        $icurrency = _s('currency', $userInfo);
        if($icurrency <1) return ["2", WsLang('MsgUpdateProfileCurrency')];
        $remove = $this->ClientCreditRemove(["isPosted"=>false, "user_id"=>$user_id, "description"=>$description, "entry_date"=>$date, "amount_in"=>$amount, "amount_out"=>0, "invoice_id"=>$invoice_id, "trans_id"=>0]);
        if($remove[0] == 1)
        {
            $invoice_info =  $this->invoice_info($invoice_id);
            $payment_method = $invoice_info->payment_method>0 ? $invoice_info->payment_method:1;
            $data = ['description'=>$description, 'refund_type'=>"ivCredit", 'refund_id'=>0, 'entry_date'=>$date, 'paymet_date'=> $paymet_date, 'invoice_id' =>$invoice_id, 'fees'=>0, 'transaction_no'=>0, 'base_conv_rate'=>$base_conv_rate, 'payment_method'=>$payment_method, 'currency'=>$icurrency, 'user_id'=>$user_id];
            $data['amount_in'] = 0;
            $data['amount_out'] = $amount;
            $isDone =   $this->db->insert(WST_INV_PAY, $data);
            $trans_id = $this->db->insert_id();
            run_hook('RemoveClientCreditFromInvoice', ['user_id'=>$user_id, 'amount'=>$amount, 'cid'=>$remove[2], 'description'=>$description]);
            $this->invoice_change_status($invoice_id);
        }
        return $remove;
    }
    function credit_update($invoice_id=0, $cid=0)
    {
        $this->db->query("update ".WST_CCREDITS." set trans_id=(select max(id) from invoices_payments where invoice_id='".$invoice_id."') where invoice_id='".$invoice_id."' and id='".$cid."'");        
    }
    function client_credits_list($user_id=0)
    {
      $link = __segment(2);
      if($user_id > 0){
        $countRecords = get_one("select count(id) as total_rows from ".WST_CCREDITS." where user_id='$user_id'");
        $countRecords = _s('total_rows', $countRecords, 0);
        $page_no = (__segment(4) > 0) ? __segment(4) : 1;
        $total_records_per_page = GetConfigs('SITE_PER_PAGE_RECORDS');
        $calc_page = ($page_no - 1) * $total_records_per_page;
        $pagination = $this->Config->pagination_links($countRecords, $page_no, $total_records_per_page, '/admin/'.$link.'/'.$user_id.'/', $calc_page);
        $query = $this->db->query("select a.id, a.admin_id, a.entry_date, a.description, a.user_id, a.invoice_id, (a.amount_in-a.amount_out) AS balance,  
        ((a.amount_in-a.amount_out)/a.base_conv_rate) as net_amount, (select concat(first_name, ' ', last_name) from ".WST_CLIENTS." where id=a.admin_id) as admin_name, b.symbol, b.symbol_position from ".WST_CCREDITS." a inner join ".WST_CURRENCIES." b on a.currency=b.id where a.user_id='$user_id' order by a.id asc limit ".$calc_page.", ".$total_records_per_page);
        $client_credits_list = $query->result();
        $clients_option_list = $this->Account->clients_option_list($user_id);
        $client_sticky_notes_list = $this->Admin->client_sticky_notes_list($user_id);
        $client_tab_links = $this->Admin->client_tab_links($user_id, $link);
        $baseCurrency = $this->Currency->getBaseCurrency(0);
        $file = "client_credits_list.php";
        $filepath =  $this->tpath.$file;
        $html="";
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            $html= WsFileNotExist($file, $tpath);
        }
        return $html;
      }
    }
    function CostUpdateInInvoice($invoice_id=0)
    {
        $items = [];
        $invoiceDetails = full_query("select * from invoices_details where invoice_id='$invoice_id'");
        if(!empty($invoiceDetails))
        {
            foreach($invoiceDetails as $row)
            {
                $id = _s('id', $row);
                $pid = _s('pid', $row);
                $user_id = _s('user_id', $row);
                $type = _s('type', $row);
                $cost = _s('cost', $row);
                $rate = _s('rate', $row);
                $base_conv_rate = _s('base_conv_rate', $row)>0 ? $row->base_conv_rate:1;
                if($cost == 0 && $rate>0)
                {
                    $base_conv_rate = _s('base_conv_rate', $row, 0)>0 ? $row->base_conv_rate:1;
                    if(in_array($type, ['hosting', 'Others', 'PromoHosting', 'Upgrade', 'Addon', 'SSL', 'other', 'server', 'reseller']) && $pid>0)
                    {
                        $service_info = $this->Admin->services_info($pid);
                        if(!empty($service_info))
                        {
                            $package_id = _s('package_id', $service_info);
                            $billing_cycle = _s('billing_cycle', $service_info);
                            $productInfo =  $this->Products->products_info_by_id($package_id);
                            $price_duration = _s('price_duration', $productInfo);
                            $DurationMonths = $this->Config->price_duration_months($price_duration);
                            $BillingMonths = $this->Config->price_duration_months($billing_cycle);
                            $totalYears = Devide($BillingMonths,$DurationMonths);
                            //$totalYears = $BillingMonths;
                            $scost = _s('cost', $productInfo,0);
                            $cost = Multiply($scost,$totalYears);
                        }
                    }
                    if(in_array($type, ['domain-transfer', 'domain-register', 'DomainRenewal', 'Domain']) && $pid>0)
                    {
                        $domainInfo = $this->Domain->domain_info($pid);
                        $registrationperiod = _s('registrationperiod', $domainInfo,1);
                        $TldId = _s('pid', $domainInfo,0);
                        $TldInfo = $this->Domain->domainTldInfoById($TldId);
                        $default_registration_period = _s('default_registration_period',$TldInfo);
                        $duration_years = $this->Config->duration_years($default_registration_period);
                        $duration_years = $duration_years>0 ? $duration_years:1;
                        $totalYears = Devide($registrationperiod,$duration_years);
                        $dcost = _s('cost', $TldInfo, 0);
                        $cost = Multiply($dcost,$totalYears);
                    }
                    if($type == "config" && $pid>0)
                    {
                        $coptions_result = get_one("select cost from ".WST_PRO_CFG_GRP_OPTS." where id=$pid");
                        $ocost = _s('cost', $coptions_result, 0);
                        $hoptions_result = get_one("select relid from hosting_config_options where optionid=$pid");
                        $relid = _s('relid', $hoptions_result);
                        $service_info = $this->Admin->services_info($relid);
                        $package_id = _s('package_id', $service_info);
                        $billing_cycle = _s('billing_cycle', $service_info);
                        $productInfo =  $this->Products->products_info_by_id($package_id);
                        $price_duration = _s('price_duration', $productInfo);
                        $DurationMonths = $this->Config->price_duration_months($price_duration);
                        $BillingMonths = $this->Config->price_duration_months($billing_cycle);
                        $totalYears = Devide($BillingMonths,$DurationMonths);
                        $cost = Multiply($ocost,$totalYears);
                    }
                    if($type == "LateFee")
                    {
                        $cost = 0;
                    }
                    if(in_array($type, ['Setup', 'Custom', 'AddFund', 'Invoice']))
                    {
                        $cost = _s('rate', $row);
                    }
                    $items[$id] = ["cost"=>$cost, "pid"=>$pid, "user_id"=>$user_id];
                }
            }
            if(!empty($items))
            {
                foreach($items as $key=>$row)
                {
                    $cost = iset("cost", $row);
                    $this->db->update("invoices_details", ["cost"=>$cost], ["id"=>$key]);
                }
            }
        }
        $invoiceDetails = get_one("select sum(cost) as cost_amount from invoices_details where invoice_id='$invoice_id'");
        $cost_amount = _s('cost_amount', $invoiceDetails);
        $tcost = $cost_amount>0 ? $cost_amount:0;
        $this->db->update("invoices", ["cost_amount"=>$tcost], ["id"=>$invoice_id]);
    }
    function invoice_client_item_add()
    {
        $AmountType = __post("AmountType", true);
        $service_id = __post("service_id", true);
        $DurationType = __post("DurationType", true);
        $service_info = $this->Admin->services_info($service_id);
        $duration = $service_info->billing_cycle;
        $product_id = $service_info->package_id;

        $invoice_id = __post("iid", true);
        $options = __post("options", true);
        $discount = __post("discount", true);
        $addons = __post("addons", true);
        $icurrency = __post("icurrency", true);
        if(empty($DurationType)) $DurationType = "Existing";
        if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
        if(empty($product_id)) return array("2", WsLang('WSLM-0162'));
        if(empty($duration)) return array("2", WsLang('WSLM-0163'));
        $user_id = __post('iuser_id', true);
        $info = $this->Products->products_info_by_id($product_id);
        $ginfo = $this->Products->products_services_group_info(_s('gid', $info));
        
        $DurationDays = $this->Config->price_duration_days($duration);
        $DateFrom = date("Y-m-d");
        if($DurationType == "Existing")
        {
            $next_due_date = _s('next_due_date', $service_info,"");
            if(!empty($next_due_date)) $DateFrom = date('Y-m-d',strtotime($next_due_date));
        }
        $DateTo = date('jS M, y', _t($DateFrom. ' + '.$DurationDays.' days'));
        $DateFrom = date("jS M, y",strtotime($DateFrom));
        
        $productDurationName = $DateFrom." To ".$DateTo;
        $account_type = _s('account_type', $info);
        $price_duration = _s('price_duration', $info);
        $domain_name = _s('domain_name', $service_info,"");
        $DefaultMonths = $this->Config->price_duration_months($price_duration);
        $SelectedMonths = $this->Config->price_duration_months($duration);
        $TotalMonths = Devide($SelectedMonths,$DefaultMonths);
        
        $cost = _s('cost', $info);
        $cost = Multiply($cost,$TotalMonths);

        $rate = 0;
        $table = '';
        if($AmountType == "Current")
        {
            $rate += $service_info->amount;
        }
        else
        {
            $price = $this->Products->product_price($product_id, $duration, $account_type, $icurrency);
            $rate += $price;
        }
        $table .= _s('title', $ginfo).' - '._s('title', $info);
        if(!empty($domain_name)) $table .= " (".$domain_name.")";
         $table .= ' <b>'.WsLang('Duration').' : </b>'.$productDurationName.PHP_EOL;
        if(!empty($options))
        {
            foreach ($options as $op)
            {
                $gquery = get_one("select title from ".WST_PRO_CFG_GRP_OPT." where id in (select distinct cid from ".WST_PRO_CFG_GRP_OPTS." where id=$op)");
                $gtitle = _s('title', $gquery);                
                $cquery = get_one("select title, cost from ".WST_PRO_CFG_GRP_OPTS." where id=$op");
                $ctitle = _s('title', $cquery);
                $ocost = _s('cost', $cquery);
                $cost += Multiply($ocost,$TotalMonths);

                $price = $this->Products->product_price($op, $duration, 'config', $icurrency);
                $rate += $price;
                if($price >0)
                {
                    $table .= '<b>'.$gtitle.' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
                else
                {
                    $table .= '<b>'.$gtitle.' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
            }
        }
        if(!empty($addons))
        {
            foreach ($addons as $addon)
            {
                $addonId = $addon;
                $productInfo = $this->Products->products_info_by_id($addonId);
                $order_type = _s('account_type', $productInfo);
                $ctitle = _s('title', $productInfo);
                $acost = _s('cost', $productInfo);
                $cost += Multiply($acost,$TotalMonths);
                $price = $this->Products->product_price($addon, $duration, 'other', $icurrency);
                $rate += $price;
                if($price >0)
                {
                    $table .= '<b>'.WsLang('Addon').' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
                else
                {
                    $table .= '<b>'.WsLang('Addon').' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
            }
        }
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        $cost = Multiply($cost,$base_conv_rate);
        if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
    
        $name = nl2br($table);
        $added_by = $this->uid;
        $entry_date = date('Y-m-d');
        $discount = Multiply($rate,Devide($discount,100));
        $data = array('description' => $name, 'qty' => 1, 'rate' => $rate, 'cost' => $cost, 'pid' => $service_id, 'base_conv_rate' => $base_conv_rate, 'discount' => $discount, 'invoice_id' => $invoice_id, 'user_id' => $user_id, 'type'=>_s('account_type', $info), 'taxable'=>_s('apply_tax', $info), 'is_module_run'=>"RENEW");
        $isDone =   $this->db->insert(WST_INV_DETAIL, $data);
        if($isDone)
        {
            $this->invoice_update_header_by_child($invoice_id, 0);
            $id = $this->db->insert_id();
            logActivity(0, WsLang('WSLM-0164'), '');  
            return array("1", WsLang('WSLM-0164'));                        
        }
        logActivity(0, WsLang('WSLM-0165'), $this->db->error());
        return array("2", WsLang('WSLM-0165'));
    }
    function invoice_predefine_item_add()
    {
        $product_id = __post("product_id", true);
        $duration = __post("product_duration", true);
        $invoice_id = __post("iid", true);
        $options = __post("options", true);
        $discount = __post("discount", true);
        $addons = __post("addons", true);
        $icurrency = __post("icurrency", true);
        
        if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
        if(empty($product_id)) return array("2", WsLang('WSLM-0162'));
        if(empty($duration)) return array("2", WsLang('WSLM-0163'));
        
        $user_id = __post('iuser_id', true);
        $info = $this->Products->products_info_by_id($product_id);
        $ginfo = $this->Products->products_services_group_info(_s('gid', $info));
        
        $DurationDays = $this->Config->price_duration_days($duration);
        $DateFrom = date("Y-m-d");
        $DateTo = date('jS M, y', _t($DateFrom. ' + '.$DurationDays.' days'));
        $DateFrom = date("jS M, y");
        
        $productDurationName = $DateFrom." To ".$DateTo;
        $account_type = _s('account_type', $info);
        $price_duration = _s('price_duration', $info);
        $DefaultMonths = $this->Config->price_duration_months($price_duration);
        $SelectedMonths = $this->Config->price_duration_months($duration);
        $TotalMonths = Devide($SelectedMonths,$DefaultMonths);
        
        $cost = _s('cost', $info);
        $cost = Multiply($cost,$TotalMonths);
        
        $rate = 0;
        $table = '';
        $price = $this->Products->product_price($product_id, $duration, $account_type, $icurrency);
        $rate += $price;
        $table .= _s('title', $ginfo).' - '._s('title', $info).' <b>'.WsLang('Duration').' : </b>'.$productDurationName.PHP_EOL;
        if(!empty($options))
        {
            foreach ($options as $op)
            {
                $gquery = get_one("select title from ".WST_PRO_CFG_GRP_OPT." where id in (select distinct cid from ".WST_PRO_CFG_GRP_OPTS." where id=$op)");
                $gtitle = _s('title', $gquery);                
                $cquery = get_one("select title, cost from ".WST_PRO_CFG_GRP_OPTS." where id=$op");
                $ctitle = _s('title', $cquery);
                $ocost = _s('cost', $cquery);
                $cost += Multiply($ocost,$TotalMonths);

                $price = $this->Products->product_price($op, $duration, 'config', $icurrency);
                $rate += $price;
                if($price >0)
                {
                    $table .= '<b>'.$gtitle.' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
                else
                {
                    $table .= '<b>'.$gtitle.' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
            }
        }
        if(!empty($addons))
        {
            foreach ($addons as $addon)
            {
                $addonId = $addon;
                $productInfo = $this->Products->products_info_by_id($addonId);
                $order_type = _s('account_type', $productInfo);
                $ctitle = _s('title', $productInfo);
                $acost = _s('cost', $productInfo);
                $cost += Multiply($acost,$TotalMonths);
                $price = $this->Products->product_price($addon, $duration, 'other', $icurrency);
                $rate += $price;
                if($price >0)
                {
                    $table .= '<b>'.WsLang('Addon').' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
                else
                {
                    $table .= '<b>'.WsLang('Addon').' :</b>'.PHP_EOL.$ctitle.PHP_EOL;
                }
            }
        }
        $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
        $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
        $cost = Multiply($cost,$base_conv_rate);
        if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
    
        $name = nl2br($table);
        $added_by = $this->uid;
        $entry_date = date('Y-m-d');
        $discount = Multiply($rate,Devide($discount,100));
        $data = array('description' => $name, 'qty' => 1, 'rate' => $rate, 'cost' => $cost, 'pid' => $product_id, 'base_conv_rate' => $base_conv_rate, 'discount' => $discount, 'invoice_id' => $invoice_id, 'user_id' => $user_id, 'type'=>_s('account_type', $info), 'taxable'=>_s('apply_tax', $info));
        $isDone =   $this->db->insert(WST_INV_DETAIL, $data);
        if($isDone)
        {
            $this->invoice_update_header_by_child($invoice_id, 0);
            $id = $this->db->insert_id();
            logActivity(0, WsLang('WSLM-0164'), '');  
            return array("1", WsLang('WSLM-0164'));                        
        }
        logActivity(0, WsLang('WSLM-0165'), $this->db->error());
        return array("2", WsLang('WSLM-0165'));
    }
    function invoice_item_add()
    {
        $invoice_id = __post('iid', true);
        $name = __post('name', true);
        $qty = __post('qty', true);
        $rate = __post('rate', true);
        $cost = __post('cost', true);
        $discount = __post('discount', true);
        $icurrency = __post('icurrency', true);
        $user_id = __post('iuser_id', true);
        $itype = __post('type', true);
        $itype = !empty($itype) ? $itype:'Custom';
        if(__post())
        {
            if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
            if(empty($name)) return array("2", WsLang('ProductEnterName'));
            if(empty($qty)) return array("2", WsLang('WSLM-0167'));
            if(empty($cost)) return array("2", "Please Enter Cost, Because Cost Required for Profit & Loss Statement");
            if(empty($rate)) return array("2", WsLang('WSLM-0168'));
            if($this->Config->letters_exist($qty) == 1) return array("2", WsLang('WSLM-0169'));
            if($this->Config->letters_exist($rate) == 1) return array("2", WsLang('WSLM-0170'));
            if($this->Config->letters_exist($discount) == 1) return array("2", WsLang('WSLM-0171'));
            if($this->Config->letters_exist($cost) == 1) return array("2", "Cost Amount should be digits");
            $currencyBaseRate = $this->Config->getCurrencyInfoById($icurrency);
            $base_conv_rate = _s('base_conv_rate', $currencyBaseRate);
            if($base_conv_rate == 0) return array("2", WsLang('AffiliateUpBaseOtherCurrency'));
            $name = nl2br(htmlentities($name));
            $discountAmount = Multiply($rate,Devide($discount,100)); 
            $added_by = $this->uid;
            $entry_date = Carbon::now()->format('Y-m-d');
            $data = array('description' => $name, 'qty' => $qty, 'cost' => $cost, 'rate' => $rate, 'base_conv_rate' => $base_conv_rate, 'discount' => $discountAmount, 'invoice_id' => $invoice_id, 'user_id' => $user_id, 'type'=>$itype, 'taxable'=>'YES');
            $isDone =   $this->db->insert(WST_INV_DETAIL, $data);
            if($isDone)
            {
                $this->invoice_update_header_by_child($invoice_id, 0);
                $id = $this->db->insert_id();
                logActivity(0, WsLang('WSLM-0164'), $this->db->error());  
                return array("1", WsLang('WSLM-0164'));                        
            }
            logActivity(0, WsLang('WSLM-0165'), $this->db->error());   
            return array("2", WsLang('WSLM-0165'));                       
        }
    }
    function product_duration($invoice_id=0, $product_id=0)
    {
        $invoice_info = $this->invoice_info($invoice_id);  
        echo $this->Products->product_duration($product_id, _s('currency', $invoice_info));
    }
    function config_options_by_product($invoice_id=0, $product_id=0, $duration="", $serviceId=0)
    {
        $invoice_info = $this->invoice_info($invoice_id);  
        echo $this->Products->config_options_by_product(["serviceId"=>$serviceId,"productId"=>$product_id, "duration"=>$duration, "currency"=>_s('currency', $invoice_info)]);
    }
    function config_options_by_service($invoice_id=0, $product_id=0, $duration="", $serviceId=0)
    {
        $invoice_info = $this->invoice_info($invoice_id);  
        echo $this->Products->config_options_by_service(["serviceId"=>$serviceId,"productId"=>$product_id, "duration"=>$duration, "currency"=>_s('currency', $invoice_info)]);
    }
    function invoice_delete($invoice_id=0){
        if (!preg_match('/\./', $invoice_id)) return $this->invoice_delete_by_id($invoice_id);
        $ids = explode(".",$invoice_id);
        $total = count($ids);
        $errors = [];
        $success = 0;
        foreach($ids as $id)
        {
            $isDeleted = $this->invoice_delete_by_id($id);
            if($isDeleted[0] == 2)
            {
                $errors[] = $isDeleted[1];
            }else{
                $success++;
            }
        }
        $deleted = !empty($errors) ? count($errors) : 0;
        if($success>0) return [1,$success."/".$total." Invoices deleted successfully"];
        return [2,$deleted."/".$total." Features deletion failed"];        
    }
    function invoice_delete_by_id($invoice_id=0)
    {
        if($invoice_id < 1) return array("2", "Please Select Invoice...");
        $invoice_info = $this->invoice_info($invoice_id);  
        $invoice_info = _je($invoice_info);
        $invoice_info = _jd($invoice_info, true);
        $this->db->trans_begin();
        //$this->db->query("update from ".WST_INV_DETAIL." where invoice_id='$invoice_id'");
        $isDone = $this->db->query("update ".WST_INV." set status=9 where id='$invoice_id'");
        if ($this->db->trans_status() === FALSE)
        {
            $this->db->trans_rollback();
            logActivity(0, WsLang('WSLM-0173').' '.$invoice_id, $this->db->error());   
            return array("2", WsLang('WSLM-0173').' '.$invoice_id);                       
        }
        $this->db->trans_commit();
        run_hook('InvoiceDeleted', $invoice_info);
        logActivity(0, WsLang('WSLM-0174').' '.$invoice_id, $this->db->error());    
        if($isDone) return array("1", WsLang('WSLM-0174').' '.$invoice_id, "/admin/billing-Invoices-status/2");         
    }
    function invoice_options($args = [])
    {
        $data = [];
        if(empty($args))
        {
            $invoice_id = __post('iid', true);
            $edate = __post('edate', true);
            $ddate = __post('ddate', true);
            $payment_method_id = __post('payment_method_id', true);
            $tax1 = __post('tax1', true);
            $tax2 = __post('tax2', true);
            $ivno = __post('ivno', true);
            $status = __post('status', true);
            $entry_date = date('Y-m-d', _t($edate));
            $due_date = date('Y-m-d', _t($ddate));
            if(empty($edate)) return array("2", WsLang('WSLM-0175'));
            if(empty($ddate)) return array("2", WsLang('WSLM-0176'));
            if(empty($payment_method_id)) return array("2", WsLang('WSLM-0137'));
            if(empty($status)) return array("2", WsLang('WSLM-0177'));
            $data = array('entry_date'=>$entry_date, 'due_date'=>$due_date, 'status'=>$status,'invoice_no'=>$ivno);
        }else{
            $invoice_id = _s("invoice_id",$args);
            $status = _s("status",$args,"");
            $payment_method_id = _s("payment_method_id",$args,0);
            $tax_amount = _s("tax_amount",$args,0);
            $edate = _s("entry_date",$args,"");
            $ddate = _s("due_date",$args,"");
            $paid_date = _s("paid_date",$args,"");
            $notes = _s("notes",$args,"");
            
            if(!empty($edate))
            {
                $entry_date = date('Y-m-d', _t($edate));
                $data["entry_date"] = $entry_date;
            }
            if(!empty($ddate))
            {
                $due_date = date('Y-m-d', _t($ddate));
                $data["due_date"] = $due_date;
            }
            if(!empty($paid_date))
            {
                $paid_date = date('Y-m-d', _t($paid_date));
                $data["paid_date"] = $paid_date;
            }
            if(!empty($status)) $data["status"] = $status;
            if(!empty($notes)) $data["notes"] = $notes;
            if(!empty($tax_amount)) $data["tax_amount"] = $tax_amount;
            if(!empty($payment_method_id)) $data["payment_method_id"] = $payment_method_id;
        }
        if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
        if(empty($data)) return array("2", "Updateable values empty");
        
        $isDone = $this->db->update(WST_INV, $data, ['id'=>$invoice_id]);
        if($isDone)
        {
            logActivity(0, WsLang('WSLM-0178'), $this->db->error());  
            run_hook('InvoiceModified', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
            RunWsCommand('InvoiceModified', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
            $this->invoice_payment_method_change($invoice_id, $payment_method_id);
            return array("1", WsLang('WSLM-0178'));      
        }
        logActivity(0, WsLang('WSLM-0179'), $this->db->error());   
        return array("2", WsLang('WSLM-0179'));                       
    }
    function invoice_notes()
    {
      $invoice_id = __post('iid', true);
      $notes   =   html_escape(__post('notes', TRUE));
      if($invoice_id <1){ return array("2", WsLang('WSLM-0135'));}
      if(empty($notes)){ return array("2", WsLang('ToDoEnterNote'));}
        $isDone = $this->db->update(WST_INV, array('notes'=>$notes), ['id'=>$invoice_id]);
        if($isDone)
        {
            logActivity(0, WsLang('WSLM-0166'), $this->db->error());  
            return array("1", WsLang('WSLM-0166'));                        
        }
        logActivity(0, WsLang('WSLM-0172'), $this->db->error());   
        return array("2", WsLang('WSLM-0172'));                       
    }
    function addInvoiceItemForm($id=0)
    {
        $file = "invoice_add_item_form.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            echo WsFileNotExist($file, $tpath);
        }        
    }
    function splitInvoiceForm($id=0)
    {
        $query = $this->db->query("select a.id, a.description, a.rate, a.qty, a.discount, b.currency, c.symbol, c.symbol_position from ".WST_INV_DETAIL." a inner join ".WST_INV." b on b.id=a.invoice_id inner join ".WST_CURRENCIES." c on c.id=b.currency where a.invoice_id=? order by a.id",[$id]);
        $items = $query->result();
        $file = "invoice_split_item_form.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            echo WsFileNotExist($file, $tpath);
        }        
    }
    function split_invoice_create()
    {
        $redirect = __post('redirect', true);
        $old_invoice_id = $invoice_id = __post('invoice_id', true);
        $invoice_info = $this->invoice_info($invoice_id);
        $user_id = _s('user_id', $invoice_info, 0);
        $entries = __post('entries');
        $total_items = __post('total_items');
        $total_items = (int)$total_items>0 ? $total_items:0;
        if($invoice_id <1) return array("2", WsLang('WSLM-0135'));
        if(empty($entries)) return array("2","Please Select Invoice entry");
        $selected_entries = count($entries);
        if($total_items == $selected_entries) return array("2","Split Invoice creation not allowed due to you selected all the items from old invoice");
        $invoice_no = $this->generate_new_invoice_no();
        
        $ids = implode(",",$entries);
        $sale_amount = 0;
        $discount_amount = 0;
        $this->db->trans_begin();
        $this->db->query("insert into ".WST_INV." (user_id,invoice_no,cost_amount,sale_amount,discount_amount,paid_amount,tax_amount,tax_type,last_paid_amount,entry_date,updated_at,due_date,paid_date,last_capture_attempt,status,payment_method,gateway_id,notes,currency,base_conv_rate,first_name,last_name,company_name,email,address1,city,state,postcode,country,phonenumber,date_refunded,date_cancelled,credit,invoice_type) select user_id,'".$invoice_no."',cost_amount,sale_amount,discount_amount,paid_amount,tax_amount,tax_type,last_paid_amount,entry_date,updated_at,due_date,paid_date,last_capture_attempt,status,payment_method,gateway_id,notes,currency,base_conv_rate,first_name,last_name,company_name,email,address1,city,state,postcode,country,phonenumber,date_refunded,date_cancelled,credit,invoice_type from ".WST_INV." where id=?",[$invoice_id]);
        $nid = $this->db->insert_id();
        $this->db->query("insert into ".WST_INV_DETAIL." (invoice_id, user_id, description, rate, discount, base_conv_rate, taxable, qty, type) select ".$nid.", user_id, description, rate, discount, base_conv_rate, taxable, qty, type from ".WST_INV_DETAIL." where id in (".$ids.")");
        $this->db->query("update ".WST_INV." set 
        sale_amount=(select sum(rate*qty) from ".WST_INV_DETAIL." where invoice_id=".$nid."),
        cost_amount=(select sum(cost*qty) from ".WST_INV_DETAIL." where invoice_id=".$nid."),
        discount_amount=(select sum(discount*qty) from ".WST_INV_DETAIL." where invoice_id=".$nid."),
        paid_amount=0 where id=?",[$nid]);
        if ($this->db->trans_status() === FALSE)
        {
            $this->db->trans_rollback();
            logActivity(0, 'Split Invoice Rollback and Invoice No is '.$invoice_no, $this->db->error());   
            return array("2",'Split Invoice Rollback and Invoice No is '.$invoice_no);     
        }
        $this->db->query("delete from ".WST_INV_DETAIL." where id in (".$ids.")");
        $this->db->trans_commit();
        $this->split_invoice(['user_id'=>$user_id, 'invoice_id'=>$nid, 'old_invoice_id'=>$old_invoice_id, 'status'=>'UnPaid', 'SendEmail'=>'YES']);
        run_hook('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$nid, 'status'=>'UnPaid', 'SendEmail'=>'YES', 'source'=>'adminarea'));
        RunWsCommand('InvoiceCreated', array('user_id'=>$user_id, 'invoice_id'=>$nid, 'status'=>'UnPaid', 'SendEmail'=>'YES'));
        logActivity(0, 'Split Invoice Generated Successfully and Invoice No is '.$invoice_no, $this->db->error());
        return array("1",'Split Invoice Generated Successfully and Invoice No is '.$invoice_no, $nid,$redirect);                        
    }
    function split_invoice($arg=[])
    {
        run_hook('InvoiceSplit', array('user_id'=>$user_id, 'invoice_id'=>$invoiceId, 'old_invoice_id'=>$old_invoice_id, 'status'=>'UnPaid', 'SendEmail'=>'YES'));
        //RunWsCommand('InvoiceSplit', array('user_id'=>$user_id, 'invoice_id'=>$invoiceId, 'status'=>'UnPaid', 'SendEmail'=>'YES'));
        //logActivity(0, 'New Invoice Created, Invoice No is '.$invoice_no, $error);   
    }    
    function invoice($panelTitle, $id)
    {
        $html = "";
        $file = "invoice-edit.php";
        $tpath = ltrim($this->aTemplate, '/').'templates/';
        $filepath =  $tpath.$file;
        if (file_exists($filepath))
        {
          include_once($filepath);
        }else{
          $html =  WsFileNotExist($file, $tpath);
        } 
        return $html;
    }
   function invoiceViewByClient($invoice_id=0)
   {
        $invoice_id = ($invoice_id>0) ? $invoice_id:0;
        $SITE_EMAIL_LOGO = GetConfigs('SITE_EMAIL_LOGO');
        $SITE_LOGO = GetConfigs('SITE_LOGO');        
        $SITE_LOGO = (!empty($SITE_EMAIL_LOGO)) ? $SITE_EMAIL_LOGO:$SITE_LOGO;
        $payment_details = GetConfigs('INVOICE_PAY_DETAILS');
        $INVOICE_PDF_FONT = GetConfigs('INVOICE_PDF_FONT');

        $info = $this->invoice_info($invoice_id);  
        $getUserId = $this->Account->getUserInfoById(_s('user_id', $info)); 
        $statusInfo = $this->invoices_status_by_id(_s('status', $info));
        if(_s('user_id', $info) == $this->uid)
        {
            run_hook('ViewInvoiceDetailsPage', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
            RunWsCommand('ViewInvoiceDetailsPage', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
        }
        $InvoiceData = [];
        $InvoiceData["Info"]["No"] = _s('invoice_no', $info);
        $InvoiceData["Info"]["Notes"] = _s('notes', $info);
        $InvoiceData["Info"]["TaxType"] = _s('tax_type', $info);
        $InvoiceData["Info"]["TaxAmount"] = _s('tax_amount', $info);
        $InvoiceData["Info"]["DueDate"] = date('l jS \of F Y', _t($info->due_date));
        $InvoiceData["Info"]["Date"] = date('l jS \of F Y', _t($info->entry_date));
        $InvoiceData["Info"]["PaymentMethod"] = _s('payment_method', $info);
        $InvoiceData["Info"]["For"] = 'CLIENT';
        $InvoiceData["Info"]["Status"]=[
            "Title"=>_s('title', $statusInfo), 
            "Color"=>_s('color', $statusInfo), 
        ];
        $InvoiceData["Logo"] = $SITE_LOGO;
        $InvoiceData["Font"] = $INVOICE_PDF_FONT;
        $InvoiceData["Gateway"]=[];
        $GatewaysList = [];
        if(_s('status', $info) == 2)
        {
            $invoice_client_choose_gateway = GetConfigs('INVOICE_CLIENT_CHOOSE_GATEWAY');
            if($invoice_client_choose_gateway == 'YES')
            {
                $currency_info = $this->Currency->getBaseCurrency(_s('currency', $info));
                if($info->payment_method > 0)
                {
                    $GatewayForm = $this->Gateway->gateway_link(['invoice'=>$info, 'client'=>$getUserId, 'currency'=>$currency_info]);
                    $InvoiceData["Gateway"]["Form"] = $GatewayForm;
                }
                $gateways_list = $this->Gateway->gateways_list();
                foreach($gateways_list as $g)
                {
                    if($g->id > 0)
                    {
                        $glogo = $this->Gateway->get_gateway_logo($g->name);
                        if(!empty($glogo)) $GatewaysList[]=['Id'=>$g->id, 'Name'=>$g->name, 'Logo'=>$glogo, 'Title'=>$g->title, 'Description'=>$g->description];
                    }
                }
            }
        }
        $InvoiceData["Gateway"]["List"] = $GatewaysList;
        $InvoiceData["Client"]["Id"]=$getUserId->id;
        $InvoiceData["Client"]["FullName"]=$getUserId->first_name." ".$getUserId->last_name;
        $InvoiceData["Client"]["FirstName"]=$getUserId->first_name;
        $InvoiceData["Client"]["LastName"]=$getUserId->last_name;
        $InvoiceData["Client"]["Gender"]=$getUserId->gender;
        $InvoiceData["Client"]["CompanyName"]=$getUserId->company_name;
        $InvoiceData["Client"]["Email"]=$getUserId->email;
        $InvoiceData["Client"]["Address1"]=$getUserId->address1;
        $InvoiceData["Client"]["Address2"]=$getUserId->address2;
        $InvoiceData["Client"]["City"]=$getUserId->city;
        $InvoiceData["Client"]["State"]=$getUserId->state;
        $InvoiceData["Client"]["PostCode"]=$getUserId->postcode;
        $InvoiceData["Client"]["Country"]=$getUserId->country;
        $InvoiceData["Client"]["PhoneNumber"]=$getUserId->phonenumber;
        $InvoiceData["PayTo"]=nl2br($payment_details);
        $query = $this->db->query("select a.id, a.description, a.rate, a.qty, a.discount, b.currency, c.symbol, c.symbol_position from ".WST_INV_DETAIL." a inner join ".WST_INV." b on b.id=a.invoice_id inner join ".WST_CURRENCIES." c on c.id=b.currency where a.invoice_id='$invoice_id' order by a.id");
        $items = $query->result();
        $InvoiceData["Items"] = [];
        $sDiscount = 0;
        $sTotal = 0;
        $sTotalDue = 0;
        foreach ($items as $item)
        {
            $amount = Multiply($item->rate,$item->qty);
            $discount = $item->discount;
            $sDiscount += $discount;
            $sTotal += $amount;
            $sTotalDue += $amount-$discount;
            
            $ccamount = AmountConvertToCurrencyFormate(['p'=>$item->symbol_position, 's'=>$item->symbol, 'amount'=>$amount]);
            $ccdiscount = AmountConvertToCurrencyFormate(['p'=>$item->symbol_position, 's'=>$item->symbol, 'amount'=>$discount]);
            $InvoiceData["Items"][]=['Description'=>$item->description, 'Rate'=>$item->rate, 'Qty'=>$item->qty, 'Amount'=>$ccamount, 'Discount'=>$ccdiscount];
        }
        $paidAmount = _s('paid_amount', $info);
        $sTotalDue -= $paidAmount;
        if(isset($tax_amount))
        {
            if($tax_amount>0) $sTotalDue += $tax_amount;
        }
        $InvoiceData["Info"]["CurrencySymbol"] = $item->symbol;
        $InvoiceData["Info"]["CurrencySymbolPosition"] = $item->symbol_position;
        $sp =$item->symbol_position;
        $sb =$item->symbol;
        $csTotal = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$sTotal]);
        $csDiscount = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$sDiscount]);
        $cpaidAmount = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$paidAmount]);
        $ctax_amount = 0;
        if(isset($tax_amount)) $ctax_amount = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$tax_amount]);
        $csTotalDue = AmountConvertToCurrencyFormate(['p'=>$sp, 's'=>$sb, 'a'=>$sTotalDue]);
        $InvoiceData["Summary"] = ['SubTotal'=>$csTotal, 'Discount'=>$csDiscount, 'Credit'=>$cpaidAmount, 'Tax'=>$ctax_amount, 'TotalDue'=>$csTotalDue];
        $query = $this->db->query("select a.id, a.refund_type, a.description, a.payment_method, a.transaction_no, b.title as payent_title, a.base_conv_rate, a.amount_in, a.amount_out, a.fees, a.paymet_date, a.currency, c.symbol, c.symbol_position from ".WST_INV_PAY." a inner join ".WST_PAY_METHOD." b on a.payment_method=b.id inner join ".WST_CURRENCIES." c on c.id=a.currency where a.invoice_id='$invoice_id' order by a.id");
        $items = $query->result();
        $InvoiceData["Payments"]=[];
        foreach ($items as $item)
        {
            $amount = Multiply($item->base_conv_rate,$item->amount_in)>0 ? $item->amount_in:'-'.$item->amount_out;
            $fees = Multiply($item->base_conv_rate,$item->fees);
            $csp = $item->symbol_position;
            $csb = $item->symbol;
            $refund_type = $item->refund_type;
            $paymet_date = ConvertDateToFormat(['date'=>$item->paymet_date]);
            $ccamount = AmountConvertToCurrencyFormate(['p'=>$csp, 's'=>$csb, 'amount'=>$amount]);
            $ccfees = AmountConvertToCurrencyFormate(['p'=>$csp, 's'=>$csb, 'amount'=>$fees]);
            $InvoiceData["Payments"][]=['TransactionId'=>$item->transaction_no, 'TransactionDate'=>$paymet_date, 'PaymentMethod'=>$item->payent_title, 'Amount'=>$ccamount, 'Fees'=>$ccfees];
        }
        return $InvoiceData;
    }
   function invoice_view($invoice_id=0, $invoice_for="", $isDownload='')
   {
      $template = config_item('aTemplate');
      $SITE_EMAIL_LOGO = GetConfigs('SITE_EMAIL_LOGO');
      $SITE_LOGO = GetConfigs('SITE_LOGO');
      
      $SITE_LOGO = (!empty($SITE_EMAIL_LOGO)) ? $SITE_EMAIL_LOGO:$SITE_LOGO;
      $payment_details = GetConfigs('INVOICE_PAY_DETAILS');
      $INVOICE_PDF_FONT = GetConfigs('INVOICE_PDF_FONT');
      $SITE_CLIENT_TEMPLATE = GetConfigs('SITE_CLIENT_TEMPLATE');
      
      if($invoice_for !='ADMIN')
      {
        if(isset($_POST["ipayment_method"])){
            $ipayment_method =  __post('ipayment_method', true);
            if($ipayment_method > 0){
              $this->db->where("id = '$invoice_id'");
              $this->db->update(WST_INV, array('payment_method' => $ipayment_method));
            }
        }        
      }
      $info = $this->invoice_info($invoice_id);  
      $getUserId = $this->Account->getUserInfoById(_s('user_id', $info)); 
      $statusInfo = $this->invoices_status_by_id(_s('status', $info));
      if($invoice_for !='ADMIN')
      {
        if(_s('user_id', $info) == $this->uid) 
          run_hook('ViewInvoiceDetailsPage', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
        if(_s('user_id', $info) == $this->uid) 
          RunWsCommand('ViewInvoiceDetailsPage', ['invoice_id'=>$invoice_id, 'SendEmail'=>'YES']);
      }
        $tax_amount= _s('tax_amount', $info);
        $tax_type= _s('tax_type', $info);
        $file = "invoice_view.php";
        $filepath =  $this->tpath.$file;
        $table = "";
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            $table =  WsFileNotExist($file, $tpath);
        }
        return $table;      
    }
    function GetTransactionInfo($id=0)
    {
        $Query = $this->db->query("select * from ".WST_INV_PAY." where id=?", [$id]);
        $Records = $Query->result();
        $invoice_id = isset($Records[0]->invoice_id) ? $Records[0]->invoice_id:0;
        $payment_method = isset($Records[0]->payment_method) ? $Records[0]->payment_method:0;
        $transaction_no = isset($Records[0]->transaction_no) ? $Records[0]->transaction_no:0;
        $TransInfo = $this->Gateway->TransactionInformation(['gateway_id'=>$payment_method, 'invoice_id'=>$invoice_id, 'transaction_id'=>$id, 'transaction_no'=>$transaction_no]);
        $html = "";
        $file = "GetTransactionInfo.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            $html =  WsFileNotExist($file, $tpath);
        }
        return $html; 
    }
    public function client_transactions_list($user_id=0)
    {
        if($user_id > 0)
        {
            $summary = $this->transactions_summary($user_id);
            $countQuery = get_one("select count(id) as total_rows from ".WST_INV_PAY." where user_id='$user_id'");
            $countRecords = _s('total_rows', $countQuery);      
            $page_no = (__segment(4) > 0) ? __segment(4) : 1;
            $total_records_per_page = GetConfigs('SITE_PER_PAGE_RECORDS');
            $calc_page = ($page_no - 1) * $total_records_per_page;
            $pagination = $this->Config->pagination_links($countRecords, $page_no, $total_records_per_page, '/admin/client-transactions/'.$user_id.'/', $calc_page);
            $clients_option_list = $this->Account->clients_option_list($user_id);
            $client_sticky_notes_list = $this->Admin->client_sticky_notes_list($user_id);
            $client_tab_links = $this->Admin->client_tab_links($user_id, 'client-transactions');
            $baseCurrency = $this->Currency->getBaseCurrency(0);
            $query = $this->db->query("select a.id, a.refund_type, a.description, a.payment_method, a.transaction_no, b.title as payent_title, a.base_conv_rate, a.amount_in, a.amount_out, a.fees, a.paymet_date, a.currency, c.symbol, c.symbol_position from ".WST_INV_PAY." a inner join ".WST_PAY_METHOD." b on a.payment_method=b.id inner join ".WST_CURRENCIES." c on c.id=a.currency where a.user_id='$user_id' order by a.id desc limit ".$calc_page.", ".$total_records_per_page);
            $items = $query->result();
            $sDiscount = 0;
            $sTotal = 0;
            $sTotalDue = 0;
            $table = "";
            $file = "client_transactions_list.php";
            $filepath =  $this->tpath.$file;
            if (file_exists($filepath))
            {
                include_once($filepath);
            }else{
                $table =  WsFileNotExist($file, $tpath);
            }
            return $table; 
        }
    }    
    function billing_balances_list()
    {
        return $this->Gateway->Balance();
    }
    /* ********************************************************************
     * billing_invoices_list - get all Invoices based on search filters
     * ********************************************************************
     */
    public function billing_invoices_list($pageno=0)
    {
        $summary = $this->transactions_summary(0);
        $where = [];
        $postArray = [];
        $fm =   __post(['user_id', 'invoice_no', 'entry_date', 'due_date', 'paid_date', 'payment_method', 'status'], TRUE);
      foreach ($fm as $key => $value) : 
        $postArray[$key] =$value;
      endforeach;

        if(__post())
        {
            $user_id = __post('user_id', true);
            $invoice_no = __post('invoice_no', true);
            $entry_date = _ex('-', __post('entry_date', true));
            $due_date = _ex('-', __post('due_date', true));
            $paid_date = _ex('-', __post('paid_date', true));
            $payment_method = __post('payment_method', true);
            $date_from = date('Y-m-d', _t($entry_date[0]));
            $date_to = date('Y-m-d', _t($entry_date[1]));
            $due_date_from = date('Y-m-d', _t($due_date[0]));
            $due_date_to = date('Y-m-d', _t($due_date[1]));
            $paid_date_from = date('Y-m-d', _t($paid_date[0]));
            $paid_date_to = date('Y-m-d', _t($paid_date[1]));
            $status =  __post('status', true);
        }

        if(!empty(__post('entry_date', true))){$where[] = " a.entry_date >='".$date_from."' and a.entry_date <='".$date_to."' ";}
        if(!empty(__post('due_date', true))){$where[] = " a.due_date >='".$due_date_from."' and a.due_date <='".$due_date_to."' ";}
        if(!empty(__post('paid_date', true))){$where[] = " a.paid_date >='".$paid_date_from."' and a.paid_date <='".$paid_date_to."' ";}
        if(!empty($user_id)){$where[] = " a.user_id ='".$user_id."'";}
        if(!empty($invoice_no)){$where[] = " a.invoice_no ='".$invoice_no."'";}
        if(!empty($payment_method)){$where[] = " a.payment_method ='".$payment_method."'";}
        if(!empty($status)){
            if($status == 2) $where[] = " a.status in (2, 7) ";
            if($status == 7) $where[] = " a.status in (2, 7) and a.due_date>CURDATE()";
            if(!in_array($status, [7, 2]))
            {
              $where[] = " a.status ='".$status."'";              
            }
        }
    if(count($where) > 0) :
      setSession("billingFilters",$where);
      setSession("billingForm",$postArray);
    endif;
    if(!$pageno) : 
      setSession("billingFilters",'');
      setSession("billingForm",'');
    endif;
    $rpt_filters = getSession("billingFilters",[]);
   if(!empty($rpt_filters))
   {
    $rpt_filters = _em(' and ', $rpt_filters);
    $countQuery = get_one("select count(a.id) as total_rows from ".WST_INV." a where ".$rpt_filters);
    $countRecords = _s('total_rows', $countQuery);
      $page_no = ($pageno > 0) ? $pageno : 0;
      if($page_no == 0)
      {
        $page_no = (__segment(3) > 0) ? __segment(3) : 1;    
      }
      $total_records_per_page = GetConfigs('SITE_PER_PAGE_RECORDS');
      $calc_page = ($page_no - 1) * $total_records_per_page;
      $pagination = $this->Config->pagination_links($countRecords, $page_no, $total_records_per_page, '/admin/billing-Invoices/', $calc_page);
      $query = $this->db->query("select a.*, b.title as status_name, (select concat(first_name, ' ', last_name) from ".WST_CLIENTS." where id=a.user_id)  as user_name, cc.code, cc.symbol, cc.symbol_position from ".WST_INV." a inner join ".WST_INV_STATUS." b on a.status=b.id join currencies cc on a.currency=cc.id  where ".$rpt_filters." order by a.id  limit ".$calc_page.", ".$total_records_per_page);
      $data = $query->result();
    }
      return array("summary"=>$summary, "result"=>$data, "pagination"=>$pagination);
  }    
  function transactions_summary($user_id=0)
  {
        $user_id = ($user_id > 0) ? " user_id = '$user_id' and ":'';
        $qAmount = $this->db->select('ifnull(sum((sale_amount-discount_amount)/base_conv_rate), 0) as sale_amount, ifnull(sum(paid_amount/base_conv_rate), 0) as paid_amount')->where($user_id." status not in (1, 4) ")->limit(1)->get(WST_INV)->row();
        $overAmount = $this->db->select('ifnull(sum(((sale_amount-discount_amount)-paid_amount)/base_conv_rate), 0) as sale_amount')->where($user_id." status=7 ")->limit(1)->get(WST_INV)->row();
        $unpaidAmount = $this->db->select('ifnull(sum(((sale_amount-discount_amount)-paid_amount)/base_conv_rate), 0) as sale_amount')->where($user_id." status=2 ")->limit(1)->get(WST_INV)->row();
        $qOthers = $this->db->select('ifnull(sum(amount_out/base_conv_rate), 0) as amount_out, ifnull(sum(fees/base_conv_rate), 0) as fees, ifnull(sum(amount_in*base_conv_rate), 0) as amount_in')->where($user_id." user_id > 0 ")->limit(1)->get(WST_INV_PAY)->row();
        $file = "transactions_summary.php";
        $filepath =  $this->tpath.$file;
        $html = "";
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            $html = WsFileNotExist($file, $tpath);
        }
       return $html;              
    }
    function TransactionsList($invoice_id=0)
    {
        $query = $this->db->query("select a.id, a.refund_type, a.description, a.payment_method, a.transaction_no, b.title as payent_title, a.base_conv_rate, a.amount_in, a.amount_out, a.fees, a.paymet_date, a.currency, c.symbol, c.symbol_position from ".WST_INV_PAY." a inner join ".WST_PAY_METHOD." b on a.payment_method=b.id inner join ".WST_CURRENCIES." c on c.id=a.currency where a.invoice_id='$invoice_id' order by a.id");
        return $query->result();
    }
    function transactions($invoice_id, $type=2, $link=1)
    {
        $items = $this->TransactionsList($invoice_id);
        $file = "transactions.php";
        $filepath =  $this->tpath.$file;
        $table="";
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            $table=WsFileNotExist($file, $tpath);
        }
        return $table;
    }

    function invoice_items($id)
    {
        $query = $this->db->query("select a.id, a.description, a.rate, a.qty, a.discount, b.currency, c.symbol, c.symbol_position from ".WST_INV_DETAIL." a inner join ".WST_INV." b on b.id=a.invoice_id inner join ".WST_CURRENCIES." c on c.id=b.currency where a.invoice_id='$id' order by a.id");
        $items = $query->result();
        $file = "invoice_items.php";
        $filepath =  $this->tpath.$file;
        if (file_exists($filepath))
        {
            include_once($filepath);
        }else{
            echo WsFileNotExist($file, $tpath);
        }
    }
    function generate_new_invoice_no(){
        $No_increment = GetConfigs('INVOICE_INCREMENTATION_NO');
        $No_increment = (int)$No_increment > 0 ? $No_increment: 1; 
        $No_start = GetConfigs('INVOICE_STARTING_NO',1);
        $No_start = (int) $No_start > 0 ? $No_start:1;
        $invoice_no_format = GetConfigs('INVOICE_SEQUENCE_NUMBER_FORMAT');
        $inc_no = GetConfigs('INVOICE_INCREMENT_NO');
        $inc_no = (int)$inc_no > 0 ? $inc_no : $No_start;
        if(strpos($invoice_no_format, 'NUMBER') == false){
          $invoice_no_format = $invoice_no_format.'{NUMBER}';
        }
        $inc_no = $inc_no+$No_increment;
        $invoice_no_format = _r(["{NUMBER}", "{DAY}", "{MONTH}", "{YEAR}"], [$inc_no, date('d'), date('m'), date('Y')], $invoice_no_format);
        $this->Config->updateConfigs('INVOICE_INCREMENT_NO', $inc_no);
        return $invoice_no_format;          
    }
}