<?php
/**
 * WHMCS File Manager Module
 * This is the filemanager  Files Management Addons Module
 * @author Khawar Shahzad (hostarina.com)
 * @license MIT
 */


/**
 * Define gateway configuration options.
 *
 * The fields you define here determine the configuration options that are
 * presented to administrator users when activating and configuring your
 * payment gateway module for use.
 *
 * Supported field types include:
 * * text
 * * password
 * * yesno
 * * dropdown
 * * radio
 * * textarea
 *
 * Examples of each field type and their possible configuration parameters are
 * provided in the sample function below.
 *
 * @return array
 */
function files_manager_config()
{
        // the friendly display name for a payment gateway should be
        // defined here for backwards compatibility
    return array(
            "name" => "Files Manager", 
            "description" => "WHMSOSL Files Manager gives you ability to add/edit/delete and view directories/files in ".WHA, 
            "version" => "1.0", 
            "author" => WHA, 
            "author_url" => "", 
            "icon" => "icon-stack", 
            "configs"=>array(
                "menu_enabled"=>array(
                                    "Name" => "Menu Enable", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Enable"=>"enable", "Disable"=>"disable"), 
                                    "Description" => "Menu enable/disable...", 
                                    "Default" => "enable"
                                    ), 
                "allow_upload" => array (
                                    "Name" => "Upload Files", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Allow"=>"allow", "Deny"=>"deny"), 
                                    "Description" => "Upload Files Allow...", 
                                    "Default" => "allow"
                                    ), 
                "allow_delete" => array (
                                    "Name" => "Files Deletion", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Allow"=>"allow", "Deny"=>"deny"), 
                                    "Description" => "Files Deletion Allow...", 
                                    "Default" => "allow"
                                    ), 
                "allow_rename" => array (
                                    "Name" => "Rename Files", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Allow"=>"allow", "Deny"=>"deny"), 
                                    "Description" => "Files Rename Allow...", 
                                    "Default" => "allow"
                                    ), 
                "allow_new_folder" => array (
                                    "Name" => "New Folder", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Allow"=>"allow", "Deny"=>"deny"), 
                                    "Description" => "Allow New Folder Creation...", 
                                    "Default" => "allow"
                                    ), 
                "allow_new_file" => array (
                                    "Name" => "New File", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Allow"=>"allow", "Deny"=>"deny"), 
                                    "Description" => "Allow New File Creation...", 
                                    "Default" => "allow"
                                    ), 
                "allow_duplicate" => array (
                                    "Name" => "Copy Folder/File", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Allow"=>"allow", "Deny"=>"deny"), 
                                    "Description" => "Allow Copy/Duplicate File/Folder...", 
                                    "Default" => "allow"
                                    ), 
                "upload_allowed_file_types" => array (
                                    "Name" => "Allowed File Extensions", 
                                    "Type" => "text", 
                                    "Size" => "200", 
                                    "DivColumns"=>"6", 
                                    "Description" => "Enter Extensions name with comma(, ) as html, css, js, php, txt....", 
                                    "Default" => "html, css, js, php, txt"
                                    ), 
                "demo_mode" => array (
                                    "Name" => "Demo Mode", 
                                    "Type" => "dropdown", 
                                    "Size" => "25", 
                                    "DivColumns"=>"6", 
                                    "Options"=>array("Enable"=>"enable", "Disable"=>"disable"), 
                                    "Description" => "Demo or Live Mode Enable/Disable...", 
                                    "Default" => "enable"
                                    ), 
                                )
    );
}

function files_manager_activate(){
    
}

function files_manager_deactivate(){
    
}
function files_manager_ajax($act='', $arg=[]){
    $ws =& get_instance();
    $uinfo = $ws->Account->GetCurrentUser();
    $userid = $uinfo->userid;
    $is_admin = $uinfo->is_admin;
    $userid=($userid>0) ? $userid:0;
    if($userid<1){
        echo displayMsgBox("Authentication", "Please Sigin to access Files Manager");
        die();
    }   
    if($is_admin<>1){
        echo displayMsgBox("Authentication", "Only Admin allowed to access Files Manager");
        die();
    }   
    include('main.php');
}
function files_manager_output()
{   
    $ws =& get_instance();
    $uinfo = $ws->Account->GetCurrentUser();
    $userid = $uinfo->userid;
    $userid=(!empty($userid)) ? $userid:0;
    $is_admin = $uinfo->is_admin;
    if($userid == 0){
        $html =displayMsgBox("Authentication", "Please Sigin to access Files Manager");
    }
    else
    {
    if($is_admin<>1){
        $html = displayMsgBox("Authentication", "Only Admin allowed to access Files Manager");
        return $html;
    }
        
    include('main.php');
$html ='<div class="content-wrapper"><!doctype html>
<html class="menu-'.(($menu_exists ? 'enabled' : 'disabled sidebar-closed')).'">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="robots" content="noindex, nofollow">
    <title>'.(($init_path ? basename($init_path) : '/')).'</title>
    <link href="/vendors/ws/modules/files_manager/main.css" rel="stylesheet">
  </head>
  <body class="body-loading"><svg viewBox="0 0 18 18" class="svg-preloader svg-preloader-active preloader-body"><circle cx="9" cy="9" r="8" pathLength="100" class="svg-preloader-circle"></svg>
    <main id="main">';
            if($menu_exists) {
            $html .='<div id="sidebarleft" style="overflow-y: auto;padding: 0px;width: 23%;float:left;background:#ECEFF1;">
                <aside id="sidebar">
                  <button id="sidebar-toggle" type="button" class="btn-icon hide"></button>
                  <div id="sidebar-inner">
                    <div id="sidebar-topbar" class="hide"></div>
                    <div id="sidebar-menu"></div>
                  </div>
                </aside>
                <div id="sidebar-bg"></div> 
            </div>
            <div style="padding: 0px;width:77%;float:right;">';
        }else{
        $html .='<div style="padding: 0px;width:100%;float:left;">';
        }
        $html .='<nav id="topbar" '.((!empty(SmartfileManager::$config['topbar_sticky'])) ? 'class="topbar-sticky"':'').'>
            <div id="topbar-top">
                <div id="topbar-breadcrumbs" style="width:70%;">
                  <div class="breadcrumbs-info"></div>
                  <div id="breadcrumbs"></div>
                </div>                 
              <div id="search-container"><input id="search" type="search" placeholder="search" size="1" spellcheck="false" autocomplete="off" autocorrect="off" autocapitalize="off" disabled></div>
              <div id="change-layout" class="dropdown hide"></div>
              <div id="change-sort" class="dropdown hide"></div>
            </div>
            <div id="topbar-info" class="info-hidden"></div>
            <div id="files-sortbar"></div>
          </nav>
          <!-- files list container -->
          <div id="files-container"><div id="files" class="list files-'.(SmartfileManager::$config['layout']).'"></div></div>
        </div>
    </main>
    <style>
        #sidebarleft::-webkit-scrollbar, 
        #files-container > div::-webkit-scrollbar {
            width: 5px;
        }
        #sidebarleft::-webkit-scrollbar-track, 
        #files-container > div::-webkit-scrollbar-track {
            -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);
        }
        #sidebarleft::-webkit-scrollbar-thumb {
          background-color: #008fcf;
          outline: 1px solid #008fcf;
        }        
        #files-container > div::-webkit-scrollbar-thumb {
          background-color: #008fcf;
          outline: 1px solid #008fcf;
        }        
    </style>
            <script>
            $(document).ready(function(){
               var h = $(window).height();
               var sh = h-45;
               var fh = h-212;
               $("body").css("overflow", "hidden");
               $("#sidebarleft").css("height", sh+"px");
               $("#files-container>div").css("overflow-y", "scroll");
               $("#files-container>div").css("height", fh+"px");
            });
            </script>

    <!-- modal -->
    <div id="modal-bg"></div>
    <div class="modal" id="files_modal" tabindex="-1" role="dialog" data-action="close"></div>

    <!-- context menu -->
    <div id="contextmenu" class="dropdown-menu"></div>

    <!-- Javascript -->
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@11.3.10/dist/sweetalert2.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/animejs@3.2.1/lib/anime.min.js"></script>
    <!--<script src="https://cdn.jsdelivr.net/npm/list.js@2.3.1/dist/list.min.js"></script>-->
    <script src="https://cdn.jsdelivr.net/npm/@exeba/list.js@2.3.1/dist/list.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/yall-js@3.2.0/dist/yall.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/filesize@8.0.7/lib/filesize.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/screenfull@5.2.0/dist/screenfull.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/dayjs@1.10.7/dayjs.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/dayjs@1.10.7/plugin/localizedFormat.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/dayjs@1.10.7/plugin/relativeTime.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/js-file-downloader@1.1.24/dist/js-file-downloader.min.js"></script>
    <style>
       
    </style>
    <script>
var _c = '.(_je($json_config, JSON_PRETTY_PRINT|JSON_UNESCAPED_UNICODE|JSON_PARTIAL_OUTPUT_ON_ERROR)).';
var CodeMirror = {};
    </script>
    <script src="/vendors/ws/modules/files_manager/main.js"></script>
  </body>
</html></div>';
    }    
return $html;
}
