<?php
use WsWaf\Db;
use WsWaf\Logger;
use WsWaf\Handler;
use WsWaf\Common;
class firewall_class
{
    protected $db = [];
    protected $Logger = [];
    protected $Handler = [];
    protected $Common = [];
    protected $uid = 0;
    function __construct() {
        $this->db = new Db();
        $this->Logger = new Logger();
        $this->Common = new Common();    
        $this->Handler = new Handler();  
        $ws = & get_instance();
        $uinfo = $ws->Account->GetCurrentUser();
        $this->uid = _s('userid',$uinfo,0);
    }    
    function GetActions($act="Home")
    {
        $actions = [
            "Home"=>["Function"=>"GetHome", "Template"=>"Home.tpl"], 
            "SystemHealth"=>["Function"=>"SystemHealth", "Template"=>"SystemHealth.tpl"], 
            "BlockedIps"=>["Function"=>"GetBlockedIps", "Template"=>"BlockedIps.tpl"], 
            "WhiteListedIps"=>["Function"=>"GetWhiteListedIps", "Template"=>"WhiteListedIps.tpl"], 
            "IpLogs"=>["Function"=>"GetIpLogs", "Template"=>"IpLogs.tpl"], 
            "RulesManagement"=>["Function"=>"GetRulesManagement", "Template"=>"RulesManagement.tpl"], 
            "AddEditRuleForm"=>["Function"=>"AddEditRuleForm", "Template"=>"AddEditRuleForm.tpl"], 
            "AddEditRuleSave"=>["Function"=>"AddEditRuleSave", "Template"=>""], 
            "Environment"=>["Function"=>"GetEnvironment", "Template"=>"Environment.tpl"], 
            //"BotManagement"=>["Function"=>"GetBotManagement", "Template"=>"BotManagement.tpl"], 
            //"BotLogs"=>["Function"=>"GetBotLogs", "Template"=>"BotLogs.tpl"], 
            //"AddEditBotForm"=>["Function"=>"AddEditBotForm", "Template"=>"AddEditBotForm.tpl"], 
            //"AddEditBotSave"=>["Function"=>"AddEditBotSave", "Template"=>""], 
            "SaveConfigurations"=>["Function"=>"SaveConfigurations", "Template"=>""], 
            "DeleteCustomBot"=>["Function"=>"DeleteCustomBot", "Template"=>""], 
            "IpRemove"=>["Function"=>"IpRemove", "Template"=>""], 
            "IpRemoveFromWhitelist"=>["Function"=>"IpRemoveFromWhitelist", "Template"=>""], 
            "IpWhiteForm"=>["Function"=>"IpWhiteForm", "Template"=>"IpWhiteListForm.tpl"], 
            "IpBlockForm"=>["Function"=>"IpBlockForm", "Template"=>"IpBlockForm.tpl"], 
            "IpHitsHistory"=>["Function"=>"IpHitsHistory", "Template"=>"IpHitsHistory.tpl"], 
            "IpHitsHistoryClear"=>["Function"=>"IpHitsHistoryClear", "Template"=>""], 
            "IpBlockSave"=>["Function"=>"IpBlockSave", "Template"=>""], 
            "IpWhiteSave"=>["Function"=>"IpWhiteSave", "Template"=>""], 
            "Configurations"=>["Function"=>"GetConfigurations", "Template"=>"Configurations.tpl"], 
            "Htaccess"=>["Function"=>"GetHtaccess", "Template"=>"Htaccess.tpl"], 
            ];
        return isset($actions[$act]) ? $actions[$act]:[];
    }
    function GetDocTypes(){
        return [
                "Document"=>"User Documentation Guide", 
                "Technical"=>"Developers Technical Documentation", 
                "API"=>"API Technical Documentation", 
                "GuidesTutorials"=>"Guides & Tutorials", 
            ];
    }
    function GetTabs()
    {
        $tabs = 
        [
            ["Name"=>"", "Tab"=>"TabFwHome", "Icon"=>"icon-home", "Default"=>"Active", "Js"=>"Home"], 
            ["Name"=>"Blocked IPs", "Tab"=>"TabFwBlockedIps", "Icon"=>"", "Default"=>"", "Js"=>"BlockedIps"], 
            ["Name"=>"Whitelisted IPs", "Tab"=>"TabFwWhiteListedIps", "Icon"=>"", "Default"=>"", "Js"=>"WhiteListedIps"], 
            ["Name"=>"IP Logs", "Tab"=>"TabFwIpLogs", "Icon"=>"", "Default"=>"", "Js"=>"IpLogs"], 
            ["Name"=>"Rules", "Tab"=>"TabFwRulesManagement", "Icon"=>"", "Default"=>"", "Js"=>"RulesManagement"], 
            ["Name"=>"Environment", "Tab"=>"TabFwEnvironment", "Icon"=>"", "Default"=>"", "Js"=>"Environment"], 
            ["Name"=>"Configurations", "Tab"=>"TabFwConfigurations", "Icon"=>"", "Default"=>"", "Js"=>"Configurations"], 
            ["Name"=>"Htaccess", "Tab"=>"TabFwHtaccess", "Icon"=>"", "Default"=>"", "Js"=>"Htaccess"], 
        ];
            //["Name"=>"BOT Management", "Tab"=>"TabFwBotManagement", "Icon"=>"", "Default"=>"", "Js"=>"BotManagement"], 
            //["Name"=>"BOT Logs", "Tab"=>"TabFwBotLogs", "Icon"=>"", "Default"=>"", "Js"=>"BotLogs"], 
            //["Name"=>"Categories", "Tab"=>"TabFw", "Icon"=>"", "Default"=>"", "Js"=>"Categories"], 
            //["Name"=>"Document", "Tab"=>"TabDmDocumentations", "Icon"=>"", "Default"=>"hide", "Js"=>"GetDocument"], 
        return $tabs;
    }
    function GetHome($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["FwConfigs"] = $this->db->GetConfiguration();
        $date = date('Y-m').'-01';
        $edate = date('Y-m').'-31';

        $sql = $this->db->nsSelect("select sum(a.month_visits) as month_visits, sum(a.month_unique_visits) as month_unique_visits, sum(a.today_visits) as today_visits, sum(a.year_unique_visits) as year_unique_visits, sum(a.year_visits) as year_visits, sum(a.year_unique_visits) as year_unique_visits from (select count(1) as month_visits, count(distinct ip) as month_unique_visits, 0 as today_visits, 0 as today_unique_visits, 0 as year_visits, 0 as year_unique_visits from waf_ip_hits_history where MONTH(entry_date) = MONTH(CURRENT_DATE()) AND YEAR(entry_date) = YEAR(CURRENT_DATE())
union all
select 0 as month_visits, 0 as month_unique_visits, count(distinct ip) as today_visits, count(distinct ip) as today_unique_visits, 0 as year_visits, 0 as year_unique_visits from waf_ip_hits_history where DATE(entry_date)=CURDATE()
union ALL
select 0 as month_visits, 0 as month_unique_visits, 0 as today_visits, 0 as today_unique_visits, count(1) as year_visits, count(distinct ip) as year_unique_visits from waf_ip_hits_history where YEAR(entry_date)=YEAR(now())) a");
        $ThisMonth = isset($sql[0]["month_visits"]) ? $sql[0]["month_visits"]:0;
        $ThisMonthUnique = isset($sql[0]["month_unique_visits"]) ? $sql[0]["month_unique_visits"]:0;
        $TodayUnique = isset($sql[0]["today_unique_visits"]) ? $sql[0]["today_unique_visits"]:0;
        $Today = isset($sql[0]["today_visits"]) ? $sql[0]["today_visits"]:0;
        $ThisYearUnique = isset($sql[0]["year_unique_visits"]) ? $sql[0]["year_unique_visits"]:0;
        $ThisYear = isset($sql[0]["year_visits"]) ? $sql[0]["year_visits"]:0;

        $sql = $this->db->nsSelect("select sum(a.month_pages) as month_pages, sum(a.month_unique_pages) as month_unique_pages, sum(a.today_pages) as today_pages, sum(a.year_unique_pages) as year_unique_pages, sum(a.year_pages) as year_pages, sum(a.year_unique_pages) as year_unique_pages from (select count(1) as month_pages, count(distinct ip) as month_unique_pages, 0 as today_pages, 0 as today_unique_pages, 0 as year_pages, 0 as year_unique_pages from waf_page_hits where MONTH(entry_date) = MONTH(CURRENT_DATE()) AND YEAR(entry_date) = YEAR(CURRENT_DATE())
union all
select 0 as month_pages, 0 as month_unique_pages, count(distinct ip) as today_pages, count(distinct ip) as today_unique_pages, 0 as year_pages, 0 as year_unique_pages from waf_page_hits where DATE(entry_date)=CURDATE()
union ALL
select 0 as month_pages, 0 as month_unique_pages, 0 as today_pages, 0 as today_unique_pages, count(1) as year_pages, count(distinct ip) as year_unique_pages from waf_page_hits where YEAR(entry_date)=YEAR(now())) a");
        $ThisMonthPages = isset($sql[0]["month_pages"]) ? $sql[0]["month_pages"]:0;
        $ThisMonthPagesUnique = isset($sql[0]["month_unique_pages"]) ? $sql[0]["month_unique_pages"]:0;
        $TodayPagesUnique = isset($sql[0]["today_unique_pages"]) ? $sql[0]["today_unique_pages"]:0;
        $TodayPages = isset($sql[0]["today_pages"]) ? $sql[0]["today_pages"]:0;
        $ThisYearPages = isset($sql[0]["year_pages"]) ? $sql[0]["year_pages"]:0;
        $ThisYearPagesUnique = isset($sql[0]["year_unique_pages"]) ? $sql[0]["year_unique_pages"]:0;
        $Stats["TodayVisits"] = $Today;
        $Stats["TodayUnique"] = $TodayUnique;
        $Stats["ThisMonthVisits"] = $ThisMonth;
        $Stats["ThisMonthUnique"] = $ThisMonthUnique;
        $Stats["ThisYearVisits"] = $ThisYear;
        $Stats["ThisYearUnique"] = $ThisYearUnique;

        $Stats["TodayPages"] = $TodayPages;
        $Stats["TodayUniquePages"] = $TodayPagesUnique;
        $Stats["ThisMonthPages"] = $ThisMonthPages;
        $Stats["ThisMonthUniquePages"] = $ThisMonthPagesUnique;
        $Stats["ThisYearPages"] = $ThisYearPages;
        $Stats["ThisYearUniquePages"] = $ThisYearPagesUnique;

        $Stats["TotalIpBlocks"] = $this->db->GetIpsBanListCount();
        $Stats["TotalIpWhiteListed"] = $this->db->GetIpsWhiteListCount();
        $Stats["TotalBots"] = $this->db->GetBotsListCount();
        $Stats["TotalBotsActive"] = $this->db->GetBotsListCount(["status"=>"Enable"]);

        $data["Stats"] = $Stats;
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function GetWhiteListedIps($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $ws = & get_instance();
        $data["IpsWhiteList"] = $ws->Account->whitelist_ips();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function IpRemoveFromWhitelist($arg=[])
    {
        $id = $arg[0];
        $isDeleted = $this->db->DoUnlistIpWhite($id);
        if($isDeleted["status"] == "success")
        {
            logActivity($this->uid,"IP deleted from whitelist successfully",[]);
        }else{
            logActivity($this->uid,"IP deletion from whitelist failed",[]);
        }
        return _je($isDeleted);
    }
    function GetRulesCategories()
    { 
        return [
            "CMD"=>"Shell Commands", 
            "RM"=>"Server Request Method (REQUEST_METHOD)", 
            "SQL"=>"SQL Injection", 
            "DIR"=>"Path Traversal", 
            "URI"=>"URL Injections", 
        ];
    }
    function GetRulesManagement($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["RuleList"] = $this->db->GetRuleList();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function SystemHealth($arg=[]){
        $data = $arg;
        $id = $arg[0];
        $data["id"] = ($id >0) ? $id:0;
        $Template = $arg["Template"];
        $data["Results"] =  $this->Common->SystemSecurityChecks();;
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function AddEditRuleForm($arg=[]){
        $data = $arg;
        $id = $arg[0];
        $data["id"] = ($id >0) ? $id:0;
        $Template = $arg["Template"];
        $data["Categories"] = $this->GetRulesCategories();
        if($id > 0){
            $data["RuleInfo"] = $this->db->GetRuleInfoById($id);            
        }
        else
        {
            $data["RuleInfo"] = ["regex"=>"", "name"=>"", "category"=>"", "status"=>"", "custom"=>"", "id"=>0];
        }
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function AddEditRuleSave($arg=[])
    {
        $id = $_POST["id"];
        $name = $_POST["name"];
        $custom = $_POST["custom"];
        $category = $_POST["category"];
        $regex = $_POST["regex"];
        $status = $_POST["status"];
        $data = ["name"=>$name, "category"=>$category, "regex"=>$regex, "status"=>$status];
        if($id > 0)
        {
            $data["updated_at"] = time();
            $isDone = $this->db->UpdateRule($data, $id); 
            if($isDone["status"] == "success")
            {
                logActivity($this->uid,"WAF Rule updated successfully",$data);
            }else{
                logActivity($this->uid,"WAF Rule updation failed ",$data);
            }
        }else{
            $data["custom"] = $custom;
            $data["created_at"] = time();
            $data["updated_at"] = time();
            $isDone = $this->db->AddNewRule($data);
            if($isDone["status"] == "success")
            {
                logActivity($this->uid,"WAF Rule created successfully",$data);
            }else{
                logActivity($this->uid,"WAF Rule creation failed ",$data);
            }
        }
        if($isDone["status"] == "success") run_hook("AfterCronJob", ["Regenerate"=>true]);
        return _je($isDone);
    }    
    function DeleteCustomRule($arg=[])
    {
        $id = $arg[0];
        $isDeleted = $this->db->DeleteRule($id);
        if($isDeleted["status"] == "success")
        {
            logActivity($this->uid,"WAF Rule deleted successfully",[]);
        }else{
            logActivity($this->uid,"WAF Rule deletion failed ",[]);
        }
        if($isDeleted["status"] == "success") run_hook("AfterCronJob", ["Regenerate"=>true]);
        return _je($isDeleted);
    }
    function GetBotManagement($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["BotList"] = $this->db->GetBotsList();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function GetEnvironment($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["SessionPath"] = ini_get('session.save_path');
        $errors = [];
        if(!empty(__post()))
        {
            $ini_data = $_POST["ini_data"];
            $filepath = ".user.ini";
            $handle = fopen($filepath, 'w');
            if(!$handle) $errors = ["status"=>"error", "message"=>"INI File Opening Issue"];
            if(empty($errors))
            {
                $success = fwrite($handle, $ini_data);
                fclose($handle); 
                if($success)
                {
                    $errors = ["status"=>"success", "message"=>"INI File Updated Successfully"];
                }
                else
                {
                    $errors = ["status"=>"error", "message"=>"INI File Updation Failed"];
                }
            }            
        }
        $data["IniChangesRes"] = $errors;
        $data["CheckList"] = $this->Common->environmentCheck();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function GetBlockedIps($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["IpsBanList"] = $this->db->GetIpsBanList();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function GetBotLogs($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["BotLogs"] = $this->db->GetBotHitsLogs();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function GetConfigurations($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["FwConfigs"] = $this->db->GetConfiguration();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function GetHtaccess($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["FwHtaccess"] = $this->db->GetHtaccessFile();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function GetBotCategories()
    { 
        return [
            "Other"=>"Other", 
            "Search bot"=>"Search bot", 
            "Social Media Agent"=>"Social Media Agent", 
            "Crawler"=>"Crawler", 
            "Site Monitor"=>"Site Monitor", 
            "Service Agent"=>"Service Agent", 
            "Benchmark"=>"Benchmark", 
            "Security Checker"=>"Security Checker", 
            "Feed Fetcher"=>"Feed Fetcher", 
            "Feed Parser"=>"Feed Parser", 
            "Network Monitor"=>"Network Monitor", 
            "Read-it-later Service"=>"Read-it-later Service", 
            "Search tools"=>"Search tools", 
            "Security search bot"=>"Security search bot", 
            "Validator"=>"Validator", 
        ];
    }
    function SaveConfigurations($arg=[])
    {
        foreach($_POST as $k=>$v)
        {

            $isExist = $this->db->nsOne("waf_configuration", ["config_name"=>$k]);
            if(!empty($isExist))
            {
                $this->db->nsUp("waf_configuration", ["config_value"=>$v], $isExist["id"]);
            }else{
                $this->db->nsAdd("waf_configuration", ["config_name"=>$k, "config_value"=>$v]);                
            }
        }
        logActivity($this->uid,"WAF Setting Changed successfully",[]);
        return _je(["status"=>"success", "message"=>"Firewall Setting Changed Successfully"]);
    }    
    function AddEditBotForm($arg=[]){
        $data = $arg;
        $id = $arg[0];
        $data["id"] = ($id >0) ? $id:0;
        $Template = $arg["Template"];
        $data["Categories"] = $this->GetBotCategories();
        if($id > 0){
            $data["BotInfo"] = $this->db->GetBotInfoById($id);            
        }
        else
        {
            $data["BotInfo"] = ["regex"=>"", "name"=>"", "category"=>"", "url"=>"", "producer_name"=>"", "status"=>"", "id"=>0];
        }
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function AddEditBotSave($arg=[])
    {
        $id = $_POST["id"];
        $name = $_POST["name"];
        $custom = $_POST["custom"];
        $category = $_POST["category"];
        $company = $_POST["company"];
        $url = $_POST["url"];
        $regex = $_POST["regex"];
        $status = $_POST["status"];
        $data = ["name"=>$name, "category"=>$category, "company"=>$company, "url"=>$url, "regex"=>$regex, "status"=>$status];
        if($id > 0)
        {
            $data["updated_at"] = time();
            $isDone = $this->db->UpdateBot($data, $id);            
        }else{
            $data["custom"] = $custom;
            $data["created_at"] = time();
            $data["updated_at"] = time();
            $isDone = $this->db->AddNewBot($data);
        }
        if($isDone["status"] == "success") run_hook("AfterCronJob", ["Regenerate"=>true]);
        return _je($isDone);
    }    
    function DeleteCustomBot($arg=[])
    {
        $id = $arg[0];
        $isDeleted = $this->db->DeleteBot($id);
        if($isDeleted["status"] == "success") run_hook("AfterCronJob", ["Regenerate"=>true]);
        return _je($isDeleted);
    }
    function GetIpLogs($arg=[])
    {
        $data = $arg;
        $id = $arg[0];
        $Template = $arg["Template"];
        $data["IpLogs"] = $this->db->GetIpLogs();
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function IpHitsHistory($arg=[]){
        $data = $arg;
        $ip = $arg[0];
        $Template = $arg["Template"];
        $data["IpHits"] = $this->db->GetIpHitsHistory($ip);
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function IpHitsHistoryClear($arg=[])
    {
        $ip = $arg[0];
        $isDeleted = $this->db->DoIpHitsClear($ip);
        if($isDeleted["status"] == "success")
        {
            logActivity($this->uid,"IP Hits history deleted successfully",[]);
        }else{
            logActivity($this->uid,"IP Hits history deletion failed ",[]);
        }
        return _je($isDeleted);
    }
    function IpRemove($arg=[])
    {
        $id = $arg[0];
        $isDeleted = $this->db->DoUnbanIp($id);
        if($isDeleted["status"] == "success")
        {
            logActivity($this->uid,"IP deleted from blacklist successfully",[]);
        }else{
            logActivity($this->uid,"IP deletion from blacklist failed ",[]);
        }
        return _je($isDeleted);
    }
    function IpWhiteForm($arg=[]){
        $data = $arg;
        $type = $data[0];
        $Template = $arg["Template"];
        $data["isHideType"] = (!empty($type)) ? 'hide':'';
        $data["Selected"] = (!empty($type)) ? $type:'System';
    
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function IpBlockForm($arg=[]){
        $data = $arg;
        $Template = $arg["Template"];
        if(!empty($Template))
        {
            return $this->LoadTemplate($Template, "", $data);
        }
    }
    function IpBlockSave($arg=[])
    {
        $ip = $_POST["ip"];
        $reason = $_POST["reason"];
        $type = $_POST["type"];
        $isDone = $this->db->addIpToBlacklist(["ip"=>$ip, "reason"=>$reason, "type"=>$type]);
        if($isDone["status"] == "success")
        {
            logActivity($this->uid,"IP added to blacklist successfully",$_POST);
        }else{
            logActivity($this->uid,"IP insertion to blacklist failed ",$_POST);
        }
        return _je($isDone);
    }
    function IpWhiteSave($arg=[])
    {
        $ip = $_POST["ip"];
        $reason = $_POST["reason"];
        $type = $_POST["type"];
        $type = (!empty($type)) ? $type:"System";
        $isDone = $this->db->addIpToWhitelist(["ip"=>$ip, "reason"=>$reason, "type"=>$type, "is_permanent"=>1]);
        if($isDone["status"] == "success")
        {
            logActivity($this->uid,"IP added to whitelist successfully and IP:".$ip,[]);
        }else{
            logActivity($this->uid,"IP insetion to whitelist failed and IP:".$ip,[]);
        }
        return _je($isDone);
    }
    function LoadTemplate($template="", $dir="", $data=[])
    {
        $ws = & get_instance();
        if(!empty($data)){
            foreach($data as $k=>$v)
            {
                $ws->smarty->assign($k, $v);  
            }
        }
        if(empty($dir)) $dir = __DIR__."/templates/";
       return  $ws->smarty->fetch($dir.$template);
    }
}