<?php 
use WsWaf\Db;
use WsWaf\Common;
add_hook('AfterCronJob', 1, function($vars=[])
{
    $db = new Db();
    $db->GetIpsWhiteListTimeExpire();
    $Config = $db->GetConfiguration();
    $TorProjectEnable = $Config["TorProjectEnable"];
    if($TorProjectEnable == 'Enable')
    {
        $file = 'vendors/ws-waf/payloads/tor.txt';
        $isExist = true;
        if (!file_exists($file)) $isExist = false;
        if($isExist)
        {
            $todaydate = date('d-m-Y');
            $CreationDate = date("d-m-Y", filemtime($file));
            $isExist = ($todaydate <> $CreationDate) ? false:true;
        }
        if($isExist)
        {
            $payloads = @file($file);
            if($payloads !== false)
            {
                $isExist = (empty($payloads)) ? false:true;
            }
            else
            {
                $isExist = false;
            }
        }
        if(!$isExist)
        {
            $tor_exit_node_list = @file("https://check.torproject.org/exit-addresses");
            if(!empty($tor_exit_node_list))
            {
                $contents = [];
                foreach($tor_exit_node_list as $line)
                {
                    $p = _ex(' ', $line);
                    if($p[0] == 'ExitAddress') $contents[$p[1]] = $p[1];
                }
                file_put_contents($file, _em("\n", $contents));
            }
        }
    }
        $file = 'vendors/ws-waf/payloads/uri.txt';
        $isExist = true;
        if (!file_exists($file)) $isExist = false;
        if($isExist)
        {
            $todaydate = date('d-m-Y');
            $CreationDate = date("d-m-Y", filemtime($file));
            $isExist = ($todaydate <> $CreationDate) ? false:true;
        }
        if($isExist)
        {
            $payloads = @file($file);
            if($payloads !== false)
            {
                $isExist = (empty($payloads)) ? false:true;
            }
            else
            {
                $isExist = false;
            }
        }
        if(!$isExist)
        {
            $rules = $db->GetRuleList(["status"=>"Enable", "category"=>"URI"]);
            $contents = "";
            foreach($rules as $b)
            {
                $regex = $b["regex"];
                $parts = _ex(", ", $regex);
                foreach($parts as $p)
                {
                    if(!empty($p)) $contents .= $p."".PHP_EOL;
                }
            }
            file_put_contents($file, $contents);
        }
        /*
        $file = 'vendors/ws-waf/payloads/bot.txt';
        $isExist = true;
        if (!file_exists($file)) $isExist = false;
        if($isExist)
        {
            $todaydate = date('d-m-Y');
            $CreationDate = date("d-m-Y", filemtime($file));
            $isExist = ($todaydate <> $CreationDate) ? false:true;
        }
        if($isExist)
        {
            $payloads = @file($file);
            if($payloads !== false)
            {
                $isExist = (empty($payloads)) ? false:true;
            }
            else
            {
                $isExist = false;
            }
        }
        $Regenerate = @$vars["Regenerate"];
        if($Regenerate) $isExist=false;
        if(!$isExist)
        {
            $BotsList = [];
            //Check Bot which are enabled by Firewall GUI
            $GetBots = $db->GetBots(["status"=>"Enable"]);
            foreach($GetBots as $b)
            {
                $regex = $b["regex"];
                $name = $b["name"];
                $BotsList[] = ["name"=>$name, "regex"=>$regex];
            }
            $contents = "";
            foreach($BotsList as $b)
            {
                $contents .= _je($b)."".PHP_EOL;
            }
            file_put_contents($file, $contents);
        }*/
        $file = 'vendors/ws-waf/payloads/dir.txt';
        $isExist = true;
        if (!file_exists($file)) $isExist = false;
        if($isExist)
        {
            $todaydate = date('d-m-Y');
            $CreationDate = date("d-m-Y", filemtime($file));
            $isExist = ($todaydate <> $CreationDate) ? false:true;
        }
        if($isExist)
        {
            $payloads = @file($file);
            if($payloads !== false)
            {
                $isExist = (empty($payloads)) ? false:true;
            }
            else
            {
                $isExist = false;
            }
        }
        $Regenerate = @$vars["Regenerate"];
        if($Regenerate) $isExist=false;
        if(!$isExist)
        {
            $rules = $db->GetRuleList(["status"=>"Enable", "category"=>"DIR"]);
            $contents = "";
            foreach($rules as $b)
            {
                $regex = $b["regex"];
                $parts = _ex(", ", $regex);
                foreach($parts as $p)
                {
                    if(!empty($p)) $contents .= $p."".PHP_EOL;
                }
            }
            file_put_contents($file, $contents);
        }        
        $file = 'vendors/ws-waf/payloads/cmd.txt';
        $isExist = true;
        if (!file_exists($file)) $isExist = false;
        if($isExist)
        {
            $todaydate = date('d-m-Y');
            $CreationDate = date("d-m-Y", filemtime($file));
            $isExist = ($todaydate <> $CreationDate) ? false:true;
        }
        if($isExist)
        {
            $payloads = @file($file);
            if($payloads !== false)
            {
                $isExist = (empty($payloads)) ? false:true;
            }
            else
            {
                $isExist = false;
            }
        }
        $Regenerate = @$vars["Regenerate"];
        if($Regenerate) $isExist=false;
        if(!$isExist)
        {
            $rules = $db->GetRuleList(["status"=>"Enable", "category"=>"CMD"]);
            $contents = "";
            foreach($rules as $b)
            {
                $regex = $b["regex"];
                $parts = _ex(", ", $regex);
                foreach($parts as $p)
                {
                    if(!empty($p)) $contents .= $p."".PHP_EOL;
                }
            }
            file_put_contents($file, $contents);
        }        
    
});