<?php
use WsWaf\Db;
use WsWaf\Common;
class Widget_General_Security
{
    function Output()
    {
        $Class = new Common();
        $ci =& get_instance();
        $SystemSecurityChecks = $Class->SystemSecurityChecks();
        $stats = isset($SystemSecurityChecks["stats"]) ? $SystemSecurityChecks["stats"]:[];
        $countSuccess = isset($stats["passed"]) ? $stats["passed"]:0;
        $countWarnings = isset($stats["warnings"]) ? $stats["warnings"]:0;
        $countDanger = isset($stats["failed"]) ? $stats["failed"]:0;
        $totalCount = $countSuccess + $countDanger;
        $countPercent = $totalCount > 0 ? round (($countSuccess / $totalCount) * 100, 0): 100;
    
        $ratingMsg = '<span style="color:#49a94d;">Good</span>';
        $ratingIcon = '<i class="icon-screen3" style="color:#49a94d;font-size: 42px;"></i>';
        if ($countPercent < 50)
        {
            $ratingMsg = '<span  style="color:#ff0000;">Poor</span>';
            $ratingIcon = '<i class="icon-screen3" style="color:#ff0000;font-size: 42px;"></i>';
        }        
        
          $output ='<style>
          .widget-health-padded {
                padding: 20px;
                max-height: 300px;
                overflow: auto;
                width: 100%;
                font-family: arial;                
            }
            .icon-stats .item {
                clear: both;
            }
            .widget-health-padded .item .icon-holder {
                margin-top: -8px;
                font-size: 42px;
            }
            .icon-stats .icon-holder {
                float: left;
                font-size: 36px;
            }
    .icon-stats .data {
    margin-left: 50px;
    }
    .icon-stats .data div {
    white-space: nowrap;
    }
    .icon-stats .number {
    font-size: 20px;
    }
    .icon-stats a, .icon-stats a:active, .icon-stats a:hover {
    color: inherit;
    text-decoration: none;
    }
          </style>
          <div class="row">
            <div class="widget-health-padded icon-stats">
                <div class="row">
                    <div class="col-sm-7">
                        <div class="item">
                            <div class="icon-holder text-center">
                                '.$ratingIcon.'
                            </div>
                            <div class="data">
                                <div class="note">
                                    Overall Rating
                                </div>
                                <div class="number">
                                    '.$ratingMsg.'
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-5 text-right">
                        <a onclick="Firewall.SystemHealth();" class="btn btn-default btn-sm">
                            <i class="icon-arrow-right8"></i> View Issues
                        </a>
                    </div>
                </div>
            
                <div class="clearfix"></div>
                <div class="progress mt-10 mb-10">
                    <div class="progress-bar progress-bar-success progress-bar-striped" role="progressbar" id="SecurityHealtsCheck" aria-label="Security Healts Check" aria-valuenow="'.$countPercent.'" aria-valuemin="0" aria-valuemax="100" style="width: '.$countPercent.'%">
                        <span class="sr-only">'.$countPercent.'% Complete (success)</span>
                    </div>
                </div>
            
                <div class="row">
                    <div class="col-sm-5 text-center">
                        <i class="icon-warning2"></i> '.$countWarnings.' Warnings
                    </div>
                    <div class="col-sm-7 text-center text-danger">
                        <i class="icon-cross"></i> '.$countDanger.' Needing Attention
                    </div>
                </div>
            </div>          
          </div>';
        return [
            'id'=>5, 
            'title'=>'System Health', 
            'description'=>'', 
            'weight'=>12, 
            'columns'=>4, 
            'DisplayTitle'=>true, 
            'WidgetOwnLayout'=>false, 
            'content'=>$output
        ];
    }
}