<?php 
    $id = $segment[1];
    $appInfo = integrations_curl('app/'.$id);
    $app = _jd($appInfo);
    $module_type = $app->category->module_type;
    $vFileName = $app->latest_versions->vFileName;
    $listings_id = $app->latest_versions->listings_id;

    $fileUrl = "https://whasols.com/storage/marketplace_listings/downloads/".$listings_id."/".$vFileName;
    $newfile = "storage/temps/".$vFileName;
    if($module_type == "builtin") $extractPath = "vendors/ws/modules/";
    if($module_type == "addon") $extractPath = "modules/addons/";
    if($module_type == "domain") $extractPath = "modules/registrars/";
    if($module_type == "server") $extractPath = "modules/servers/";
    if($module_type == "security") $extractPath = "modules/security/";
    if($module_type == "payment") $extractPath = "modules/gateways/";
    if($module_type == "exchange") $extractPath = "modules/exchange_rates/";
    if($module_type == "email") $extractPath = "modules/emailers/";
    if($module_type == "sms") $extractPath = "modules/sms_gateways/";
    if($module_type == "theme") $extractPath = "templates/";
    if($module_type == "auth_signin") $extractPath = "modules/auth_sign/";
    if(empty($extractPath)){
        echo _je(["status"=>"error", "message"=>"Installation failed due to File Extraction Path not found, Contact with ".WHA." Support team...."]);
        die();
    }

    if(empty($vFileName))
    {
        echo _je(["status"=>"error", "message"=>"Installation file not found at remote server...."]);
        die();
    }
    if(strlen($vFileName) < 5)
    {
        echo _je(["status"=>"error", "message"=>"Installation file name is invalied...."]);
        die();
    }
    if (file_exists($newfile))
    {
        $zip = new ZipArchive;
        $res = $zip->open($newfile);
        if ($res === TRUE)
        {
            $parts = $zip->getNameIndex(0);
            $part = _ex("/", $parts);
            $filename = $part[0];
            // Extract file
            $zip->extractTo($extractPath);
            $zip->close();
            //unlink($newfile);
            $isExist = full_query("select * from addons_installed where id='$id'");
            if(empty($isExist)) insert_query("addons_installed", ["id"=>$id, "module_name"=>$filename]);
            InstallModule(['module_type'=>$module_type, 'module_name'=>$filename]);
            echo _je(["status"=>"success", "message"=>"Installation Successfully completed...."]);
            die();
        }
        echo _je(["status"=>"error", "message"=>"Installation failed, Contact with ".WHA." Support team...."]);
        die();
    }
    if(!copy($fileUrl, $newfile))
    {
        $errors = [];
        // Handle the error
        $error = error_get_last();
        if ($error !== null) {
            $errors[] = "Installation file fetching failed from remote server, Error: " . $error['message'];
        }
        else
        {
            $errors[] = "Installation file fetching failed from remote server, Error: An unknown error occurred during file copy.";
        }
        if(!empty($errors))
        {
            $ch = curl_init($fileUrl);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            $fileContent = curl_exec($ch);
            if (curl_errno($ch))
            {
                $errors[] = 'cURL error: ' . curl_error($ch);
            }
            else
            {
                if(!file_put_contents($newfile, $fileContent))
                {
                    $errors[] = "File put content function not working at your hosting";
                }
                else
                {
                    $errors = [];
                }
            }
            curl_close($ch);
        }
        if(!empty($errors))
        {
            $errors = implode("<br>",$errors);   
            echo _je(["status"=>"error", "message"=>"".$errors]);
            die();
        }
    }
    $zip = new ZipArchive;
    $res = $zip->open($newfile);
    if ($res === TRUE)
    {
        $parts = $zip->getNameIndex(0);
        $part = _ex("/", $parts);
        $filename = $part[0];
        // Extract file
        $zip->extractTo($extractPath);
        $zip->close();
        //unlink($newfile);
        $isExist = full_query("select * from addons_installed where id='$id'");
        if(empty($isExist)) insert_query("addons_installed", ["id"=>$id, "module_name"=>$filename]);
        InstallModule(['module_type'=>$module_type, 'module_name'=>$filename]);
        echo _je(["status"=>"success", "message"=>"Installation Successfully completed...."]);
        die();
    }
    echo _je(["status"=>"error", "message"=>"Installation failed, Contact with ".WHA." Support team...."]);