<?php
class imp_whasols
{
    function Notes()
    {
        $notes = [];
        $tblregistrars = GetTableRows("SELECT distinct name as registrar from domains_registrar");
        if(!empty($tblregistrars))
        {
            $totalReg = count($tblregistrars);
            $utotalReg = [];
            foreach($tblregistrars as $reg)
            {
                $rInfo = GetRegistrarInfoByName($reg->registrar);
                if(empty($rInfo)) $utotalReg[] = $reg->registrar;
            }
            if(count($utotalReg)>0)
            {
                $notes[] = $totalReg.' Total Domain Registrars Found but which Registrars not Installed/Active mention below:<br><b>'._em("</b>, <b>", $utotalReg).'</b>';
            }
        }
        return $notes;
    }
    function ValidateTables()
    {
        ExeSql("delete from clients where group_id in (select id from clients_groups where is_admin=1)");
        full_query("delete from clients where group_id not in (select id from clients_groups where is_admin=1)");
        $dbTablesList = $this->GetTablesList();
        $mdb_name = DB_DATABASE;
        $excludeTables = [
            'migration','migration_details','products_avg_cost','wsam_affiliates_info','email_templates','waf_rules','waf_page_hits','waf_ip_hits_history','waf_ddos',
            'waf_filter_logs','waf_ip_hits','waf_logs','log_activity','log_whois','log_sessions_history','log_sessions','waf_configuration','configuration',
            'menus','menus_auth','site_menus','automation_tasks','automation_status','automation_tasks_status','ci_exceptions','languages'
        ];
        $excludeTables = implode("','",$excludeTables);
        $Results = full_query("SELECT DISTINCT TABLE_NAME FROM information_schema.columns WHERE table_schema = '".$mdb_name."' AND TABLE_NAME IN (SELECT TABLE_NAME FROM information_schema.tables WHERE table_schema = '".$mdb_name."' AND table_rows > 0 and TABLE_NAME not in ('".$excludeTables."'))");
        if(!empty($Results))
        {
            foreach($Results as $row)
            {
                $name = $row->TABLE_NAME;
                $Required = in_array($name, $dbTablesList) ? true:false;
                $tables[] = ["Name"=>$name, "Title"=>$name, "Required"=>$Required];
            }
        }
        return $this->GetPassedFailed($tables);
    }
    function GetTablesList()
    {
        $mdb_name = getSession("mdb_name");
        $tables = GetTableRows("SELECT distinct TABLE_NAME FROM information_schema.columns WHERE table_schema = '".$mdb_name."'");
        $nTables = [];
        if(!empty($tables))
        {
            foreach($tables as $t)
            {
                $nTables[$t->TABLE_NAME] = $t->TABLE_NAME;       
            }
        }
        return $nTables;
    }
    function GetPassedFailed($tables)
    {
        $dbTablesList = $this->GetTablesList();
        $nTables = [];
        $passed = 0;
        $failed = 0;
        foreach($tables as $tbl)
        {
            $Name = $tbl["Name"];
            $nTables[$Name] = $tbl;
            if(in_array($Name, $dbTablesList))
            {
                $nTables[$Name]["Exist"] = true;
                $passed++;
            }
            else
            {
                $nTables[$Name]["Exist"] = false;
                $failed++;
            }
        }
        return ["Tables"=>$nTables, "Passed"=>$passed, "Failed"=>$failed];
    }
    function Import($table="")
    {
        $Results = GetTableRows("select * from ".$table);
        $Data = [];
        if(!empty($Results))
        {
            foreach($Results as $row)
            {
               $Data[] = _jd(_je($row),true);
            }
        }
        $truncate = ($table == "clients") ? false:true;
        return ImportData($Data,$table,$table,"",$truncate);
    }
}