<?php
class imp_whmcs
{
    function Notes()
    {
        $m_from = strtoupper(getSession("m_from"));
        $notes = [];
        $tblregistrars = GetTableRows("SELECT distinct registrar from tblregistrars");
        if(!empty($tblregistrars))
        {
            $totalReg = count($tblregistrars);
            $utotalReg = [];
            foreach($tblregistrars as $reg)
            {
                $rInfo = GetRegistrarInfoByName($reg->registrar);
                if(empty($rInfo)) $utotalReg[] = $reg->registrar;
            }
            if(count($utotalReg)>0)
            {
                $notes[] = $totalReg.' Total Domain Registrars Found but which Registrars not Installed/Active mention below:<br><b>'._em("</b>, <b>", $utotalReg).'</b>';
            }
        }
        $tblgateways = GetTableRows("select distinct gateway from tblpaymentgateways");
        if(!empty($tblgateways))
        {
            $totalReg = count($tblgateways);
            $utotalReg = [];
            foreach($tblgateways as $reg)
            {
                $rInfo = getGatewayInfoByName($reg->gateway);
                if(empty($rInfo)) $utotalReg[] = $reg->gateway;
            }
            if(count($utotalReg)>0)
            {
                $notes[] = $totalReg.' Total Payment Gateways Found but which Gateways not Installed/Active mention below:<br><b>'._em("</b>, <b>", $utotalReg).'</b>';
            }
        } 
        return $notes;
    }
    
    function ValidateTables()
    {
        //Clients Table Updation
        ExeSql("UPDATE tblclients SET currency = (SELECT a.mid FROM (SELECT a.id,(SELECT MIN(id) FROM tblcurrencies WHERE code = a.code) AS mid FROM tblcurrencies a) a WHERE a.id <> a.mid AND tblclients.currency = a.id) where currency in (select a.id from (select a.id,(select min(id) from tblcurrencies where code=a.code) as mid from tblcurrencies a) a where a.id<>a.mid)");
        //Accounts Table Updation
        ExeSql("UPDATE tblaccounts SET currency = (SELECT a.mid FROM (SELECT a.id, a.code, a.prefix, a.suffix, a.format, a.rate, a.default,(SELECT MIN(id) FROM tblcurrencies WHERE code = a.code) AS mid FROM tblcurrencies a) a WHERE a.id <> a.mid AND tblaccounts.currency = a.id) where currency in (select a.id from (select a.id,a.code,a.prefix,a.suffix,a.format,a.rate,a.default,(select min(id) from tblcurrencies where code=a.code) as mid from tblcurrencies a) a where a.id<>a.mid)");
        $tables = [
                ["Name"=>"tblclientgroups", "Title"=>"Client Groups", "Required"=>true, ], 
                ["Name"=>"tblcurrencies", "Title"=>"Currencies", "Required"=>true, ], 
                ["Name"=>"tblclients", "Title"=>"Clients", "Required"=>true, ], 
                ["Name"=>"tblcredit", "Title"=>"Credits", "Required"=>true, ], 
                ["Name"=>"tblcreditcards", "Title"=>"Credit Cards", "Required"=>true, ], 
                ["Name"=>"tblclientsfiles", "Title"=>"Client Files", "Required"=>true, ], 
                ["Name"=>"tbladminroles", "Title"=>"Admin Roles", "Required"=>true, ], 
                ["Name"=>"tbladmins", "Title"=>"Admins", "Required"=>true, ], 
                ["Name"=>"tblusers", "Title"=>"Users", "Required"=>true, ], 
                ["Name"=>"tblusers_clients", "Title"=>"User Clients", "Required"=>true, ], 
                ["Name"=>"tblcontacts", "Title"=>"Contacts", "Required"=>true, ], 
                ["Name"=>"tblaffiliates", "Title"=>"Affiliates", "Required"=>true, ], 
                ["Name"=>"tblaffiliates_referrers", "Title"=>"Affiliates Referrers", "Required"=>true, ], 
                ["Name"=>"tblaffiliateswithdrawals", "Title"=>"Affiliates Withdrawals", "Required"=>true, ], 
                ["Name"=>"tblaffiliates_hits", "Title"=>"Affiliates Hits", "Required"=>true, ], 
                ["Name"=>"tblaffiliatespending", "Title"=>"Affiliates Pending", "Required"=>true, ], 
                ["Name"=>"tblticketbreaklines", "Title"=>"Ticket Break Lines", "Required"=>true, ], 
                ["Name"=>"tblticketfeedback", "Title"=>"Ticket Feedback", "Required"=>true, ], 
                ["Name"=>"tblticketnotes", "Title"=>"Ticket Notes", "Required"=>true, ], 
                ["Name"=>"tbltickettags", "Title"=>"Tickets Tags", "Required"=>true, ], 
                ["Name"=>"tblticketspamfilters", "Title"=>"Tickets Spam Filters", "Required"=>true, ], 
                ["Name"=>"tblticketescalations", "Title"=>"Tickets Escalations", "Required"=>true, ], 
                ["Name"=>"tbltickets", "Title"=>"Tickets", "Required"=>true, ], 
                ["Name"=>"tblticketdepartments", "Title"=>"Ticket Departments", "Required"=>true, ], 
                ["Name"=>"tblticketlog", "Title"=>"Ticket Logs", "Required"=>true, ], 
                ["Name"=>"tblticketreplies", "Title"=>"Tickets Replies", "Required"=>true, ], 
                ["Name"=>"tbltax", "Title"=>"Tax", "Required"=>true, ], 
                ["Name"=>"tblknowledgebase", "Title"=>"Knowledgebase", "Required"=>true, ], 
                ["Name"=>"tblticket_watchers", "Title"=>"Ticket Watchers", "Required"=>true, ], 
                ["Name"=>"tblbannedips", "Title"=>"Banned IPs", "Required"=>true, ], 
                ["Name"=>"tblknowledgebasecats", "Title"=>"KB Categories", "Required"=>true, ], 
                ["Name"=>"tblticketpredefinedreplies", "Title"=>"Ticket Predefined Replies", "Required"=>true, ], 
                ["Name"=>"tblticketpredefinedcats", "Title"=>"Tickets Predefined Categories", "Required"=>true, ], 
                //["Name"=>"tblwhoislog", "Title"=>"Whois Logs", "Required"=>true, ], 
               // ["Name"=>"tblemails", "Title"=>"Emails", "Required"=>true, ], 
                ["Name"=>"tblactivitylog", "Title"=>"Activity Logs", "Required"=>true, ], 
                ["Name"=>"tblgatewaylog", "Title"=>"Gateway Logs", "Required"=>true, ], 
                ["Name"=>"tblbannedemails", "Title"=>"Banned EMails", "Required"=>true, ], 
                ["Name"=>"tblcalendar", "Title"=>"Calendar", "Required"=>true, ], 
                ["Name"=>"tbldownloadcats", "Title"=>"Downloads Cats", "Required"=>true, ], 
                ["Name"=>"tbldownloads", "Title"=>"Downloads", "Required"=>true, ], 
                ["Name"=>"tblnotes", "Title"=>"Notes", "Required"=>true, ], 
                ["Name"=>"tblnetworkissues", "Title"=>"Network Issues", "Required"=>true, ], 
                ["Name"=>"tblannouncements", "Title"=>"Announcements", "Required"=>true, ], 
                ["Name"=>"tblmodulequeue", "Title"=>"Module Queues", "Required"=>true, ], 
                ["Name"=>"tbltodolist", "Title"=>"ToDo List", "Required"=>true, ], 
                ["Name"=>"tblaccounts", "Title"=>"Accounts", "Required"=>true, ], 
                ["Name"=>"tblcancelrequests", "Title"=>"Cancel Requests", "Required"=>true, ], 
                ["Name"=>"tblpromotions", "Title"=>"Promotions", "Required"=>true, ], 
                ["Name"=>"tbllinks", "Title"=>"Links", "Required"=>true, ], 
                ["Name"=>"tbldomainpricing", "Title"=>"Domain Pricing", "Required"=>true, ], 
                ["Name"=>"tbldomains", "Title"=>"Domains", "Required"=>true, ], 
                ["Name"=>"tbldomainreminders", "Title"=>"Domain Reminders", "Required"=>true, ], 
                ["Name"=>"tbldomainsadditionalfields", "Title"=>"Domains Additional Fields", "Required"=>true, ], 
                ["Name"=>"tblservergroups", "Title"=>"Server Groups", "Required"=>true, ], 
                ["Name"=>"tblservers", "Title"=>"Servers", "Required"=>true, ], 
                ["Name"=>"tblquotes", "Title"=>"Quotes", "Required"=>true, ], 
                ["Name"=>"tblquoteitems", "Title"=>"Quote Details", "Required"=>true, ], 
                ["Name"=>"tblorders", "Title"=>"Orders", "Required"=>true, ], 
                ["Name"=>"tblinvoices", "Title"=>"Invoices", "Required"=>true, ], 
                ["Name"=>"tblinvoiceitems", "Title"=>"Invoices Details", "Required"=>true, ], 
                ["Name"=>"tblproductgroups", "Title"=>"Products Groups", "Required"=>true, ], 
                ["Name"=>"tblproducts", "Title"=>"Products", "Required"=>true, ], 
                ["Name"=>"tblhosting", "Title"=>"Hosting", "Required"=>true, ], 
                ["Name"=>"tblpricing", "Title"=>"Pricing", "Required"=>true, ], 
                ["Name"=>"tblcustomfields", "Title"=>"Custom Fields", "Required"=>true, ], 
                ["Name"=>"tblcustomfieldsvalues", "Title"=>"Custom Fields Values", "Required"=>true, ], 
                ["Name"=>"tblhostingconfigoptions", "Title"=>"Hosting Config Options", "Required"=>true, ], 
                ["Name"=>"tblproductconfiggroups", "Title"=>"Product Config Groups", "Required"=>true, ], 
                ["Name"=>"tblproductconfigoptions", "Title"=>"Product Config Options", "Required"=>true, ], 
                ["Name"=>"tblproductconfigoptionssub", "Title"=>"Product Config Options Sub", "Required"=>true, ], 
                ["Name"=>"mod_licensing", "Title"=>"Mod Licensing", "Required"=>false, ], 
                ["Name"=>"mod_pleskaccounts", "Title"=>"Plesk Accounts", "Required"=>false, ], 
                ];
                $mdb_name = getSession("mdb_name");
                $tablesList = [];
                foreach($tables as $tbl)
                {
                    $Name = $tbl["Name"];
                    $result = GetTableRows("SELECT distinct TABLE_NAME FROM information_schema.tables WHERE table_schema = '".$mdb_name."' and table_name='".$Name."' AND table_rows > 0");
                    if(!empty($result)) $tablesList[] = $tbl;
                }
                return $this->GetPassedFailed($tablesList);
    }
    function GetTablesList()
    {
        $mdb_name = getSession("mdb_name");
        $tables = GetTableRows("SELECT distinct TABLE_NAME FROM information_schema.columns WHERE table_schema = '".$mdb_name."'");
        $nTables = [];
        if(!empty($tables))
        {
            foreach($tables as $t)
            {
                $nTables[$t->TABLE_NAME] = $t->TABLE_NAME;       
            }
        }
        return $nTables;
    }
    function GetPassedFailed($tables)
    {
        $dbTablesList = $this->GetTablesList();
        $nTables = [];
        $passed = 0;
        $failed = 0;
        foreach($tables as $tbl)
        {
            $Name = $tbl["Name"];
            $nTables[$Name] = $tbl;
            if(in_array($Name, $dbTablesList))
            {
                $nTables[$Name]["Exist"] = true;
                $passed++;
            }
            else
            {
                $nTables[$Name]["Exist"] = false;
                $failed++;
            }
        }
        return ["Tables"=>$nTables, "Passed"=>$passed, "Failed"=>$failed];
    }
    function Import($table="")
    {
        return $this->$table();
    }
    function ImportClients($Clients=[])
    {
        delete_query(WST_CLIENTS, ["group_id"=>1]);
        $total = count($Clients);
        $added = 0;
        $maxId = max(array_keys($Clients));
        $admins = full_query("select * from clients where group_id<>1");
        if(!empty($admins))
        {
            foreach($admins as $row)
            {
                $maxId++;
                $group_id = $row->group_id;
                update_query("clients",["id"=>$maxId],["id"=>$row->id]);
                if($group_id == 2)
                {
                    full_query("insert into menus_auth (role_id,menu_id) select ".$group_id." as role_id,id from menus where id not in (select menu_id from menus_auth where role_id=".$group_id.")");
                }
            }
        }
        foreach($Clients as $data)
        {
            $isExist = getUserInfoById($data["id"]);
            if(empty($isExist))
            {
                $isDone = insert_query("clients", $data);
                GenerateSupportPin($data["id"]);
                if($isDone) $added++;
            }
            else
            {
                $added++;
            }
        }
        if($added == $total) return ["status"=>"success", "message"=>$total." Clients Imported Successfully"];
        if($added>0) return ["status"=>"success", "message"=>$added."/".$total." Clients Imported Successfully"];
        return ["status"=>"error", "message"=>"Clients Importion Failed"];
    }
    function ImportAffiliatesPending($Datas=[])
    {
        trunc_query("wsam_affiliates_pendings");
        trunc_query("wsam_affiliates_invoices");
        $total = count($Datas);
        $added = 0;
        foreach($Datas as $data)
        {
            $Invoices = $data;
            unset($data["clearing_date"]);
            unset($data["invoice_id"]);
            $isDone = insert_query("wsam_affiliates_pendings", $data);
            if($isDone)
            {
                insert_query("wsam_affiliates_invoices", $Invoices);                
                $added++;
            }
        }
        if($added == $total) return ["status"=>"success", "message"=>$total." Affiliates Pending Imported Successfully"];
        if($added>0) return ["status"=>"success", "message"=>$added."/".$total." Affiliates Pending Imported Successfully"]; 
        return ["status"=>"error", "message"=>"Affiliates Pending Importion Failed"];
    }
    function tblquotes()
    {
        $Data = [];
        $Results = GetTableRows("select a.*, (select currency from tblclients where id=a.userid) as currency_id from tblquotes a");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $currency = 0;
                if(isset($row->currency_id))
                {
                    $currency = ($row->currency_id>0) ? $row->currency_id:$row->currency;
                }
                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "subject"=>isset($row->subject) ? $row->subject:'', 
                        "status"=>isset($row->stage) ? $row->stage:'', 
                        "valid_until"=>isset($row->validuntil) ? $row->validuntil:'', 
                        "user_id"=>isset($row->userid) ? $row->userid:'', 
                        "is_existing_client"=>isset($row->userid) ? ($row->userid>0 ? 'YES':'NO'):'NO', 
                        "first_name"=>isset($row->firstname) ? $row->firstname:'', 
                        "last_name"=>isset($row->lastname) ? $row->lastname:'', 
                        "company_name"=>isset($row->companyname) ? $row->companyname:'', 
                        "email"=>isset($row->email) ? $row->email:'', 
                        "address1"=>isset($row->address1) ? $row->address1:'', 
                        "address2"=>isset($row->address2) ? $row->address2:'', 
                        "city"=>isset($row->city) ? $row->city:'', 
                        "state"=>isset($row->state) ? $row->state:'', 
                        "post_code"=>isset($row->postcode) ? $row->postcode:'', 
                        "country"=>isset($row->country) ? $row->country:'', 
                        "phone_number"=>isset($row->phonenumber) ? $row->phonenumber:'', 
                        "tax_id"=>isset($row->tax_id) ? $row->tax_id:'', 
                        "currency"=>$currency, 
                        "subtotal"=>isset($row->subtotal) ? $row->subtotal:'', 
                        "tax1"=>isset($row->tax1) ? $row->tax1:'', 
                        "tax2"=>isset($row->tax2) ? $row->tax2:'', 
                        "total"=>isset($row->total) ? $row->total:'', 
                        "proposal_notes"=>isset($row->proposal) ? $row->proposal:'', 
                        "customer_notes"=>isset($row->customernotes) ? $row->customernotes:'', 
                        "admin_notes"=>isset($row->adminnotes) ? $row->adminnotes:'', 
                        "date_created"=>isset($row->datecreated) ? $row->datecreated:'', 
                        "last_modified"=>isset($row->lastmodified) ? $row->lastmodified:'', 
                        "date_sent"=>isset($row->datesent) ? $row->datesent:'', 
                        "date_accepted"=>isset($row->dateaccepted) ? $row->dateaccepted:'', 
                    ];
            }
        }
        return ImportData($Data, "Quotes", "quotes","",true); 
    }
    function tblquoteitems()
    {
        $Data = [];
        $Results = GetTableRows("select a.*, c.currency as currency_id from tblquoteitems a join tblquotes c on a.quoteid=c.id ");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $cInfo = getCurrencyById($row->currency_id);
                $base_conv_rate=1;
                if(!empty($cInfo))
                {
                    $base_conv_rate=$cInfo->base_conv_rate;
                }
                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "quote_id"=>isset($row->quoteid) ? $row->quoteid:'', 
                        "description"=>isset($row->description) ? $row->description:'', 
                        "qty"=>isset($row->quantity) ? $row->quantity:'', 
                        "rate"=>isset($row->unitprice) ? $row->unitprice:'', 
                        "discount"=>isset($row->discount) ? $row->discount:'', 
                        "taxable"=>isset($row->taxable) ? $row->taxable:'', 
                        "entry_date"=>isset($row->created_at) ? $row->created_at:'', 
                        "update_date"=>isset($row->updated_at) ? $row->updated_at:'', 
                        "base_conv_rate"=>$base_conv_rate, 
                        "added_by"=>0, 
                        "type"=>"Custom", 
                    ];
            }
        }
        return ImportData($Data, "Quote Items", "quotes_items","",true); 
    }
    function tblorders()
    {
        $Data = [];
        $Results = GetTableRows("select a.*, c.currency as currency_id from tblorders a join tblclients c on a.userid=c.id");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $cInfo = getCurrencyById($row->currency_id);
                $base_conv_rate=1;
                if(!empty($cInfo))
                {
                    $base_conv_rate=$cInfo->base_conv_rate;
                }
                $gatewayname = $row->paymentmethod;
                if($gatewayname == "banktransfer") $gatewayname = "bankdeposit";
                $gatewayname = (!empty($gatewayname)) ? $gatewayname:'bankdeposit';
                $gateway=0;
                if(!empty($gatewayname))
                {
                    $gInfo = getGatewayInfoByName($gatewayname);
                    if(!empty($gInfo))
                    {
                        $gateway = ($gInfo->id>0) ? $gInfo->id:0;
                    }
                }
                
                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "currency"=>isset($row->currency_id) ? $row->currency_id:'', 
                        "base_conv_rate"=>isset($base_conv_rate) ? $base_conv_rate:'', 
                        "order_no"=>isset($row->ordernum) ? $row->ordernum:'', 
                        "user_id"=>isset($row->userid) ? $row->userid:'', 
                        "entry_date"=>isset($row->date) ? $row->date:'', 
                        "coupon_code"=>isset($row->promocode) ? $row->promocode:'', 
                        "promotype"=>isset($row->promotype) ? $row->promotype:'', 
                        "promovalue"=>isset($row->promovalue) ? $row->promovalue:'', 
                        "orderdata"=>isset($row->orderdata) ? $row->orderdata:'', 
                        "payment_method"=>isset($gateway) ? $gateway:'', 
                        "invoice_id"=>isset($row->invoiceid) ? $row->invoiceid:'', 
                        "status"=>isset($row->status) ? $row->status:'', 
                        "ip_address"=>isset($row->ipaddress) ? $row->ipaddress:'', 
                        "fraudmodule"=>isset($row->fraudmodule) ? $row->fraudmodule:'', 
                        "fraudoutput"=>isset($row->fraudoutput) ? $row->fraudoutput:'', 
                        "notes"=>isset($row->notes) ? $row->notes:'', 
                    ];
            }
        }
        return ImportData($Data, "Orders", "orders","",true); 
    }
    function tblinvoices()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblinvoices");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $status=0;
                if(isset($row->status))
                {
                    if($row->status == "Draft") $status=1;
                    if($row->status == "UnPaid") $status=2;
                    if($row->status == "Paid") $status=3;
                    if($row->status == "Cancelled") $status=4;
                    if($row->status == "Refunded") $status=5;
                    if($row->status == "Collection") $status=6;
                    if($row->status == "OverDue") $status=7;
                    if($row->status == "Published") $status=8;
                }
                $gatewayname = isset($row->paymentmethod) ? $row->paymentmethod:'banktransfer';
                if($gatewayname == "banktransfer") $gatewayname = "bankdeposit";
                $gatewayname = (!empty($gatewayname)) ? $gatewayname:'bankdeposit';
                $gateway=0;
                if(!empty($gatewayname))
                {
                    $gInfo = getGatewayInfoByName($gatewayname);
                    if(!empty($gInfo))
                    {
                        $gateway = ($gInfo->id>0) ? $gInfo->id:0;
                    }
                }
                $user_id = ($row->userid>0) ? $row->userid:0;
                $currency_id = 0;
                $uInfo = getUserInfoById($user_id);
                if(!empty($uInfo))
                {
                    $name = $uInfo->first_name.' '.$uInfo->last_name;
                    $currency_id = $uInfo->currency;
                }                
                $cInfo = getCurrencyById($currency_id);
                $base_conv_rate=1;
                if(!empty($cInfo))
                {
                    $base_conv_rate=$cInfo->base_conv_rate;
                }
                $tax_amount = 0;
                if(isset($row->tax))
                {
                    $tax_amount = $row->tax;
                    if(isset($row->tax2))
                    {
                        $tax_amount += $row->tax2;
                    }
                }
                $invoicenum = $row->invoicenum;
                if(empty($invoicenum)) $invoicenum = $row->id;
                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "user_id "=>isset($user_id) ? $user_id:'', 
                        "entry_date"=>isset($row->date) ? $row->date:'', 
                        "due_date"=>isset($row->duedate) ? $row->duedate:'', 
                        "paid_date"=>isset($row->datepaid) ? $row->datepaid:'', 
                        "last_capture_attempt"=>isset($row->last_capture_attempt) ? $row->last_capture_attempt:'', 
                        "date_refunded"=>isset($row->date_refunded) ? $row->date_refunded:'', 
                        "date_cancelled"=>isset($row->date_cancelled) ? $row->date_cancelled:'', 
                        "sale_amount"=>isset($row->subtotal) ? $row->subtotal:'', 
                        "credit"=>isset($row->credit) ? $row->credit:'', 
                        "tax_amount"=>$tax_amount, 
                        "status"=>isset($status) ? $status:'', 
                        "currency"=>isset($currency_id) ? $currency_id:'', 
                        "base_conv_rate"=>isset($base_conv_rate) ? $base_conv_rate:'', 
                        "payment_method"=>isset($gateway) ? $gateway:'', 
                        "gateway_id"=>isset($gateway) ? $gateway:'', 
                        "notes"=>isset($row->notes) ? $row->notes:'', 
                        "updated_at"=>isset($row->date) ? $row->date:'', 
                        "invoice_no"=>$invoicenum, 
                        "tax_type"=>"Exclusive", 
                        "paid_amount"=>($status == 3) ? $row->subtotal:0, 
                        "last_paid_amount"=>($status == 3) ? $row->subtotal:0, 
                    ];
            }
        }
        return ImportData($Data, "Invoices", "invoices","",true); 
    }
    function tblinvoiceitems()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblinvoiceitems");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = ($row->userid>0) ? $row->userid:0;
                $currency_id = 0;
                $uInfo = getUserInfoById($user_id);
                if(!empty($uInfo))
                {
                    $name = $uInfo->first_name.' '.$uInfo->last_name;
                    $currency_id = $uInfo->currency;
                }                
                $cInfo = getCurrencyById($currency_id);
                $base_conv_rate=1;
                if(!empty($cInfo))
                {
                    $base_conv_rate=$cInfo->base_conv_rate;
                }
                $type="";
                if(isset($row->type))
                {
                    $type = $row->type;
                    if($type == "DomainRegister") $type="domain-register";
                    if($type == "DomainTransfer") $type="domain-transfer";
                    if($type == "Item") $type="Custom";
                    if($type == "DomainAddonDNS") $type="Domain";
                    if($type == "DomainAddonIDP") $type="Domain";
                    if($type == "DomainRedemptionFee") $type="Domain";
                    if($type == "DomainAddonEMF") $type="Domain";
                    if($type == "PromoDomain") $type="Domain";
                    if($type == "Usage") $type="config";
                    if($type == "Domain") $type="Domain";
                    if($type == "Invoice") $type="other";
                    if($type == "AddFunds") $type="AddFund";
                }
                if(empty($type)) $type="other";
                $description = nl2br($row->description);
                
                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "user_id "=>isset($user_id) ? $user_id:'', 
                        "invoice_id "=>isset($row->invoiceid) ? $row->invoiceid:'', 
                        "type"=>isset($type) ? $type:'', 
                        "pid"=>isset($row->relid) ? $row->relid:'', 
                        "description"=>$description, 
                        "rate"=>isset($row->amount) ? $row->amount:0, 
                        "qty"=>1, 
                        "is_module_run"=>"YES", 
                        "discount"=>0, 
                        "base_conv_rate"=>isset($base_conv_rate) ? $base_conv_rate:'', 
                        "taxable"=>isset($row->taxed) ? ($row->taxed>0 ? 'YES':'NO'):'', 
                    ];
            }
        }
        return ImportData($Data, "Invoices Details", "invoices_details","",true); 
    }
    function mod_pleskaccounts()
    {
        $Data = [];
        $Results = GetTableRows("select * from mod_pleskaccounts");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "userid"=>$row->userid, 
                        "usertype "=>$row->usertype, 
                        "panelexternalid "=>$row->panelexternalid, 
                    ];
            }
        }
        return ImportData($Data, "Plesk Accounts", "mod_pleskaccounts","",true); 
    }
    function mod_licensing()
    {
        $Data = [];
        $Results = GetTableRows("select * from mod_licensing");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "serviceid "=>$row->serviceid, 
                        "addon_id "=>$row->addon_id, 
                        "licensekey "=>$row->licensekey, 
                        "validdomain "=>$row->validdomain, 
                        "validip "=>$row->validip, 
                        "validdirectory "=>$row->validdirectory, 
                        "reissues "=>$row->reissues, 
                        "status "=>$row->status, 
                        "lastaccess "=>$row->lastaccess, 
                    ];
            }
        }
        return ImportData($Data, "Mod Licensings", "mod_licensing","",true); 
    }
    function tblhosting()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblhosting order by id asc");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $gatewayname = "banktransfer";
                if(isset($row->paymentmethod))
                {
                    $gatewayname = $row->paymentmethod;
                }
                if($gatewayname == "banktransfer") $gatewayname = "bankdeposit";
                $gatewayname = (!empty($gatewayname)) ? $gatewayname:'bankdeposit';
                $gateway=0;
                if(!empty($gatewayname))
                {
                    $gInfo = getGatewayInfoByName($gatewayname);
                    if(!empty($gInfo))
                    {
                        $gateway = ($gInfo->id>0) ? $gInfo->id:0;
                    }
                }
                $billingcycle = "";
                if(isset($row->billingcycle)) $billingcycle = $row->billingcycle;
                if(strlen($billingcycle)<5) $billingcycle = "Annually";
                if(empty($billingcycle)) $billingcycle = "Annually";
                $billingcycle = GetPriceDurationNameByKey($billingcycle);
                $info = get_one("products_list",['id'=>$row->packageid]);
                $next_invoice_date = $completed_date = $termination_date = $nextduedate = isset($row->nextduedate) ? $row->nextduedate:'';
                $overidesuspenduntil = isset($row->overidesuspenduntil) ? $row->overidesuspenduntil:'';
                if($billingcycle == "price_onetime_fee")
                {
                    $nextduedate = isset($row->regdate) ? $row->regdate:'';
                    $termination_date = isset($row->regdate) ? $row->regdate:'';
                    $completed_date = isset($row->regdate) ? $row->regdate:'';
                    $overidesuspenduntil = isset($row->regdate) ? $row->regdate:'';
                    $next_invoice_date = isset($row->regdate) ? $row->regdate:'';
                }
                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "user_id"=>isset($row->userid) ? $row->userid:0, 
                        "order_id"=>isset($row->orderid) ? $row->orderid:0, 
                        "tid"=>isset($info->tid) ? $info->tid:0, 
                        "gid"=>isset($info->gid) ? $info->gid:0, 
                        "package_id"=>isset($row->packageid) ? $row->packageid:'', 
                        "server_id"=>isset($row->server) ? $row->server:0, 
                        "parent_id"=>0, 
                        "is_module_run"=>"YES", 
                        "reg_date"=>isset($row->regdate) ? $row->regdate:'', 
                        "domain_name"=>isset($row->domain) ? $row->domain:'', 
                        "payment_method"=>isset($gateway) ? $gateway:'', 
                        "first_payment_amount"=>isset($row->firstpaymentamount) ? $row->firstpaymentamount:0, 
                        "amount"=>isset($row->amount) ? $row->amount:'', 
                        "billing_cycle"=>isset($billingcycle) ? $billingcycle:'', 
                        "next_due_date"=>isset($nextduedate) ? $nextduedate:'', 
                        "next_invoice_date"=>isset($next_invoice_date) ? $next_invoice_date:'', 
                        "termination_date"=>isset($termination_date) ? $termination_date:'', 
                        "completed_date"=>isset($completed_date) ? $completed_date:'', 
                        "status"=>isset($row->domainstatus) ? $row->domainstatus:'', 
                        "user_name"=>isset($row->username) ? $row->username:'', 
                        "password"=>isset($row->password) ? $row->password:'', 
                        "notes"=>isset($row->notes) ? $row->notes:'', 
                        "sub_scription_id"=>isset($row->subscriptionid) ? $row->subscriptionid:'', 
                        "promo_id"=>isset($row->promoid) ? $row->promoid:'', 
                        "suspend_reason"=>isset($row->suspendreason) ? $row->suspendreason:'', 
                        "overide_auto_suspend"=>isset($row->overideautosuspend) ? $row->overideautosuspend:'', 
                        "overide_suspend_until"=>isset($overidesuspenduntil) ? $overidesuspenduntil:'', 
                        "dedicated_ip"=>isset($row->dedicatedip) ? $row->dedicatedip:'', 
                        "assigned_ips"=>isset($row->assignedips) ? $row->assignedips:'', 
                        "ns1"=>isset($row->ns1) ? $row->ns1:'', 
                        "ns2"=>isset($row->ns2) ? $row->ns2:'', 
                        "disk_usage"=>isset($row->diskusage) ? $row->diskusage:'', 
                        "disk_limit"=>isset($row->disklimit) ? $row->disklimit:'', 
                        "bandwidth_usage"=>isset($row->bwusage) ? $row->bwusage:'', 
                        "bandwidth_limit"=>isset($row->bwlimit) ? $row->bwlimit:'', 
                        "last_update"=>isset($row->regdate) ? $row->regdate:'', 
                        "entry_date"=>isset($row->regdate) ? $row->regdate:'', 
                        "update_date"=>isset($row->regdate) ? $row->regdate:'', 
                    ];
            }
        }
        
        $Results = GetTableRows("select * from tblhostingaddons order by id asc");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $gatewayname = "banktransfer";
                if(isset($row->paymentmethod)) $gatewayname = $row->paymentmethod;
                if($gatewayname == "banktransfer") $gatewayname = "bankdeposit";
                $gatewayname = (!empty($gatewayname)) ? $gatewayname:'bankdeposit';
                $gateway=0;
                if(!empty($gatewayname))
                {
                    $gInfo = getGatewayInfoByName($gatewayname);
                    if(!empty($gInfo))
                    {
                        $gateway = ($gInfo->id>0) ? $gInfo->id:0;
                    }
                }
                $billingcycle = "";
                if(isset($row->billingcycle)) $billingcycle = $row->billingcycle;
                if(strlen($billingcycle)<5) $billingcycle = "Annually";
                if(empty($billingcycle)) $billingcycle = "Annually";
                $billingcycle = GetPriceDurationNameByKey($billingcycle);
                $info = get_one("products_list",['old_id'=>$row->addonid]);
                $next_invoice_date = $completed_date = $termination_date = $nextduedate = isset($row->nextduedate) ? $row->nextduedate:'';
                $overidesuspenduntil = isset($row->overidesuspenduntil) ? $row->overidesuspenduntil:'';
                if($billingcycle == "price_onetime_fee")
                {
                    $nextduedate = isset($row->regdate) ? $row->regdate:'';
                    $termination_date = isset($row->regdate) ? $row->regdate:'';
                    $completed_date = isset($row->regdate) ? $row->regdate:'';
                    $overidesuspenduntil = isset($row->regdate) ? $row->regdate:'';
                    $next_invoice_date = isset($row->regdate) ? $row->regdate:'';
                }
                $Data[]=[
                        "user_id"=>isset($row->userid) ? $row->userid:0, 
                        "order_id"=>isset($row->orderid) ? $row->orderid:0, 
                        "tid"=>isset($info->tid) ? $info->tid:0, 
                        "gid"=>isset($info->gid) ? $info->gid:0, 
                        "package_id"=>isset($info->id) ? $info->id:0, 
                        "server_id"=>isset($row->server) ? $row->server:0, 
                        "parent_id"=>isset($row->hostingid) ? $row->hostingid:0, 
                        "is_module_run"=>"YES", 
                        "reg_date"=>isset($row->regdate) ? $row->regdate:'', 
                        "domain_name"=>isset($info->domain_name) ? $info->domain_name:'', 
                        "payment_method"=>isset($gateway) ? $gateway:'', 
                        "first_payment_amount"=>isset($row->firstpaymentamount) ? $row->firstpaymentamount:0, 
                        "amount"=>isset($row->firstpaymentamount) ? $row->firstpaymentamount:0, 
                        "billing_cycle"=>isset($billingcycle) ? $billingcycle:'', 
                        "next_due_date"=>isset($nextduedate) ? $nextduedate:'', 
                        "next_invoice_date"=>isset($next_invoice_date) ? $next_invoice_date:'', 
                        "termination_date"=>isset($termination_date) ? $termination_date:'', 
                        "completed_date"=>isset($completed_date) ? $completed_date:'', 
                        "status"=>isset($row->status) ? $row->status:'', 
                        "notes"=>isset($row->notes) ? $row->notes:'', 
                        "sub_scription_id"=>isset($row->subscriptionid) ? $row->subscriptionid:0, 
                        "overide_suspend_until"=>isset($overidesuspenduntil) ? $overidesuspenduntil:'', 
                        "dedicated_ip"=>isset($info->dedicated_ip) ? $info->dedicated_ip:'', 
                        "assigned_ips"=>isset($info->assigned_ips) ? $info->assigned_ips:'', 
                        "ns1"=>isset($info->ns1) ? $info->ns1:'', 
                        "ns2"=>isset($info->ns2) ? $info->ns2:'', 
                        "last_update"=>isset($info->last_update) ? $info->last_update:'', 
                        "entry_date"=>isset($row->regdate) ? $row->regdate:'', 
                        "update_date"=>isset($row->regdate) ? $row->regdate:'', 
                        "overide_auto_suspend"=>0, 
                        "disk_usage"=>0, 
                        "disk_limit"=>0, 
                        "bandwidth_usage"=>0, 
                        "bandwidth_limit"=>0, 
                    ];
            }
        }        
        $res = ImportData($Data, "Hosting/Service", "hosting","",true); 
        full_query("UPDATE products_list AS pl JOIN (SELECT pid,CASE WHEN price_annually_fee > 0 THEN 'price_annually_fee' WHEN price_semi_annually_fee > 0 THEN 'price_semi_annually_fee' WHEN price_quarterly_fee > 0 THEN 'price_quarterly_fee' WHEN price_monthly_fee > 0 THEN 'price_monthly_fee' WHEN price_onetime_fee > 0 THEN 'price_onetime_fee' ELSE 'price_annually_fee' END AS duration FROM products_list_prices WHERE product_type NOT IN ('domain-transfer', 'domain-register', 'domain-renewal', 'domain')) AS pr ON pl.id = pr.pid SET pl.price_duration = pr.duration");
        return $res;
    }
    function tblpricing()
    {
        $CurrenciesList = GetCurrenciesList();
        $Data = [];
        $Results = GetTableRows("select a.*, (select code from tblcurrencies where id=a.currency) as code from tblpricing a where a.currency not in (select a.id from (select a.id,a.code,a.prefix,a.suffix,a.format,a.rate,a.default,(select min(id) from tblcurrencies where code=a.code) as mid from tblcurrencies a) a where a.id<>a.mid) and a.type<>'domainaddons' order by a.id,a.currency asc");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $otype = $type = "";
                if(isset($row->type)) $otype = $type = $row->type;
                
                if(!in_array($type, ['domainregister', 'domaintransfer', 'domainrenewal', 'domain','domainrenew','Addon']))
                {
                    //$PTypeRes = get_one("select account_type from products_list where id=".$row->relid);
                    //if(isset($PTypeRes->account_type)) $type = $PTypeRes->account_type;
                }
                if($type=='hostingaccount') $type="hosting";
                if($type=='product') $type="hosting";
                if($type=='addon') $type="Addon";
                if($type=='usage') $type="services";
                if($type=='domainaddons') $type="domain";
                if($type=='configoptions') $type="config";
                if($type=='domainregister') $type="domain-register";
                if($type=='domaintransfer') $type="domain-transfer";
                if($type=='domainrenew') $type="domain-renewal";
                $currencyid = _s('currency',$row,0);
                $currency = isset($row->code) ? $row->code:'';
                if(strlen($currency) == 3)
                {
                    if(in_array($type, ['domain-register', 'domain-transfer', 'domain-renewal', 'domain']))
                    {
                    $Data[]=[
                            "id"=>isset($row->id) ? $row->id:'', 
                            "product_type"=>isset($type) ? $type:'', 
                            "currency_code"=>isset($currency) ? $currency:'', 
                            "pid"=>isset($row->relid) ? $row->relid:'', 
                            "price_annually_fee"=>isset($row->msetupfee) ? $row->msetupfee:'', 
                            "price_biennially_fee"=>isset($row->qsetupfee) ? $row->qsetupfee:'', 
                            "price_triennially_fee"=>isset($row->ssetupfee) ? $row->ssetupfee:'', 
                            "price_four_years_fee"=>isset($row->asetupfee) ? $row->asetupfee:'', 
                            "price_five_years_fee"=>isset($row->bsetupfee) ? $row->bsetupfee:'', 
                            "price_six_years_fee"=>isset($row->monthly) ? $row->monthly:'', 
                            "price_seven_years_fee"=>isset($row->quarterly) ? $row->quarterly:'', 
                            "price_eight_years_fee"=>isset($row->semiannually) ? $row->semiannually:'', 
                            "price_nine_years_fee"=>isset($row->annually) ? $row->annually:'', 
                            "price_ten_years_fee"=>isset($row->biennially) ? $row->biennially:'', 
                        ];
                    }
                    else
                    {
                        if($otype == "addon")
                        {
                            $relid = isset($row->relid) ? $row->relid:0;
                            $info = get_one("products_list",['old_id'=>$relid]);
                            $relid = _s("id",$info,0);
                        }else{
                            $relid = isset($row->relid) ? $row->relid:0;
                        }
                        if($relid>0)
                        {
                        $Data[]=[
                                "id"=>isset($row->id) ? $row->id:'', 
                                "product_type"=>isset($type) ? $type:'', 
                                "currency_code"=>isset($currency) ? $currency:'', 
                                "pid"=>isset($relid) ? $relid:'', 
                                "setup_monthly_fee"=>isset($row->msetupfee) ? $row->msetupfee:'', 
                                "setup_quarterly_fee"=>isset($row->qsetupfee) ? $row->qsetupfee:'', 
                                "setup_semi_annually_fee"=>isset($row->ssetupfee) ? $row->ssetupfee:'', 
                                "setup_annually_fee"=>isset($row->asetupfee) ? $row->asetupfee:'', 
                                "setup_biennially_fee"=>isset($row->bsetupfee) ? $row->bsetupfee:'', 
                                "setup_triennially_fee"=>isset($row->tsetupfee) ? $row->tsetupfee:'', 
                                "price_monthly_fee"=>isset($row->monthly) ? $row->monthly:'', 
                                "price_quarterly_fee"=>isset($row->quarterly) ? $row->quarterly:'', 
                                "price_semi_annually_fee"=>isset($row->semiannually) ? $row->semiannually:'', 
                                "price_annually_fee"=>isset($row->annually) ? $row->annually:'', 
                                "price_biennially_fee"=>isset($row->biennially) ? $row->biennially:'', 
                                "price_triennially_fee"=>isset($row->triennially) ? $row->triennially:'', 
                                "old_triennially_fee"=>isset($row->triennially) ? $row->triennially:'', 
                                "old_monthly_fee"=>isset($row->monthly) ? $row->monthly:'', 
                                "old_quarterly_fee"=>isset($row->quarterly) ? $row->quarterly:'', 
                                "old_semi_annually_fee"=>isset($row->semiannually) ? $row->semiannually:'', 
                                "old_annually_fee"=>isset($row->annually) ? $row->annually:'', 
                                "old_biennially_fee"=>isset($row->biennially) ? $row->biennially:'', 
                            ];
                        }
                    }
                }
            }
        }
        
        $res = ImportData($Data, "Products/Domains Pricing", "products_list_prices","",true); 
        full_query("UPDATE products_list AS pl JOIN (SELECT pid,CASE WHEN price_annually_fee > 0 THEN 'price_annually_fee' WHEN price_semi_annually_fee > 0 THEN 'price_semi_annually_fee' WHEN price_quarterly_fee > 0 THEN 'price_quarterly_fee' WHEN price_monthly_fee > 0 THEN 'price_monthly_fee' WHEN price_onetime_fee > 0 THEN 'price_onetime_fee' ELSE 'price_annually_fee' END AS duration FROM products_list_prices WHERE product_type NOT IN ('domain-transfer', 'domain-register', 'domain-renewal', 'domain')) AS pr ON pl.id = pr.pid SET pl.price_duration = pr.duration");
        return $res;
    }
    function tblproducts()
    {
        $Data = [];
        $mpid = 0;
        $Results = GetTableRows("select a.*, (SELECT GROUP_CONCAT(download_id) FROM tblproduct_downloads where product_id=a.id) as downloads_files, (select GROUP_CONCAT(upgrade_product_id) from tblproduct_upgrade_products where product_id=a.id) as product_upgrade_plans from tblproducts a order by a.id asc");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $type=isset($row->type) ? $row->type:'';
                $tid=0;
                $eid_welcome=0;
                $price_duration = "price_annually_fee";
                $server_config_option_show = "NO";
                if($type == "hostingaccount") $type="hosting";
                if($type == "reselleraccount") $type="reseller";
                if($type == "hosting")
                {
                    $tid=1;
                    $eid_welcome=1;
                    $price_duration = "price_annually_fee";
                }
                if($type == "reseller"){
                    $tid=2;
                    $eid_welcome=4;
                    $price_duration = "price_monthly_fee";
                    $server_config_option_show = "YES";
                }
                if($type == "server"){
                    $tid=3;
                    $eid_welcome=17;
                    $price_duration = "price_monthly_fee";
                    $server_config_option_show = "YES";
                }
                if($type == "other")
                {
                    $tid=4;
                    $eid_welcome=18;
                    $price_duration = "price_annually_fee";
                }
                
                if($row->paytype == "free") $price_duration = "Free";
                if($row->paytype == "onetime") $price_duration = "price_onetime_fee";
                
                $freedomainpaymentterms = [];
                if(isset($row->freedomainpaymentterms))
                {
                    $cycles = _ex(", ", $row->freedomainpaymentterms);
                }else{
                    $cycles = $freedomainpaymentterms;
                }
                foreach($cycles as $c)
                {
                    $freedomainpaymentterms[] = GetPriceDurationNameByKey($c);
                }                
                $mpid = isset($row->id) ? $row->id:0;
                $tagline = "";
                if(isset($row->is_featured) && isset($row->tagline))
                {
                    if($row->is_featured>0) $tagline=$row->tagline;
                }
                $isHidden = isset($row->hidden) ? ($row->hidden>0 ? 'YES':'NO'):'NO';
                $showdomainoptions = isset($row->showdomainoptions) ? ($row->showdomainoptions>0 ? 'YES':'NO'):'NO';
                $stockcontrol = isset($row->stockcontrol) ? ($row->stockcontrol>0 ? 'YES':'NO'):'NO';
                $proratabilling = isset($row->proratabilling) ? ($row->proratabilling>0 ? 'YES':'NO'):'NO';
                $autosetup = "MANUALLY";
                $freedomain = "FREE_WO_RENEWAL";
                if(isset($row->autosetup))
                {
                    $autosetup = $row->autosetup == 'payment' ? 'PAYMENT_RECEIPT':($row->autosetup == "on" ? 'ORDER_ACCEPTTED':'MANUALLY');
                }
                if(isset($row->freedomain))
                {
                    $freedomain = $row->freedomain == 'once' ? 'FREE_WO_RENEWAL ':($row->freedomain == "on" ? 'FREE_W_RENEWAL':'FREE_WO_RENEWAL');
                }
                $configoptionsupgrade = isset($row->configoptionsupgrade) ? ($row->configoptionsupgrade>0 ? 'YES':'NO'):'NO';
                $overagesenabled = isset($row->overagesenabled) ? ($row->overagesenabled>0 ? 'ENABLE':'DISABLE'):'DISABLE';
                $tax = isset($row->tax) ? ($row->tax>0 ? 'YES':'NO'):'NO';
                $retired = isset($row->retired) ? ($row->retired>0 ? 'YES':'NO'):'NO';
                $affiliatepaytype = "Use Default";
                $affiliateonetime = "One Time";
                if(isset($row->affiliatepaytype))
                {
                    $affiliatepaytype = $row->affiliatepaytype == 'fixed' ? 'Fixed Amount':($row->affiliatepaytype == 'percentage' ? 'Percentage':'Use Default');
                }
                if(isset($row->affiliateonetime))
                {
                    $affiliateonetime = $row->affiliateonetime>0 ? 'One Time':'Recurring';
                }
                
                $Data[]=[
                    "old_id"=>0, 
                    "id"=>isset($row->id) ? $row->id:'', 
                    "account_type"=>isset($type) ? $type:'', 
                    "price_duration"=>isset($price_duration) ? $price_duration:'', 
                    "server_config_option_show"=>isset($server_config_option_show) ? $server_config_option_show:'', 
                    "tid"=>isset($tid) ? $tid:'', 
                    "gid"=>isset($row->gid) ? $row->gid:'', 
                    "title"=>isset($row->name) ? $row->name:'', 
                    "server_package_name"=>isset($row->configoption1) ? $row->configoption1:'', 
                    "downloads_files"=>isset($row->downloads_files) ? $row->downloads_files:'', 
                    "product_upgrade_plans"=>isset($row->product_upgrade_plans) ? $row->product_upgrade_plans:'', 
                    "custom_link"=>isset($row->slug) ? $row->slug:'', 
                    "description"=>isset($row->description) ? $row->description:'', 
                    "is_hidden"=>isset($isHidden) ? $isHidden:'', 
                    "domain_registration_option"=>isset($showdomainoptions) ? $showdomainoptions:'', 
                    "eid_welcome"=>isset($eid_welcome) ? $eid_welcome:'', 
                    "is_stock_control"=>isset($stockcontrol) ? $stockcontrol:'', 
                    "unit_in_stock"=>isset($row->qty) ? $row->qty:'', 
                    "prorata_billing_enable"=>isset($proratabilling) ? $proratabilling:'', 
                    "prorata_billing_day"=>isset($row->proratadate) ? $row->proratadate:'', 
                    "charge_next_month"=>isset($row->proratachargenextmonth) ? $row->proratachargenextmonth:'', 
                    "payment_time"=>isset($row->paytype) ? $row->paytype:'', 
                    "subdomain_options"=>isset($row->subdomain) ? $row->subdomain:'', 
                    "product_setup_after"=>isset($autosetup) ? $autosetup:'', 
                    "server_type"=>isset($row->servertype) ? $row->servertype:'', 
                    "server_group_id"=>isset($row->servergroup) ? $row->servergroup:'', 
                    "free_domain"=>isset($freedomain) ? $freedomain:'', 
                    "free_domain_period"=>isset($freedomainpaymentterms) ? _em(", ", $freedomainpaymentterms):'', 
                    "free_domain_tlds"=>isset($row->freedomaintlds) ? $row->freedomaintlds:'', 
                    "recurring_cycles_limit"=>isset($row->recurringcycles) ? $row->recurringcycles:'', 
                    "auto_terminate_days"=>isset($row->autoterminatedays) ? $row->autoterminatedays:'', 
                    "product_upgrade_plans_enable"=>isset($configoptionsupgrade) ? $configoptionsupgrade:'', 
                    "is_overages_billing"=>isset($overagesenabled) ? $overagesenabled:'', 
                    "disk_usage_limits"=>isset($row->overagesdisklimit) ? $row->overagesdisklimit:'', 
                    "bandwidth_usage_limits"=>isset($row->overagesbwlimit) ? $row->overagesbwlimit:'', 
                    "disk_usage_limits_cost"=>isset($row->overagesdiskprice) ? $row->overagesdiskprice:'', 
                    "bandwidth_usage_limits_cost"=>isset($row->overagesbwprice) ? $row->overagesbwprice:'', 
                    "apply_tax"=>isset($tax) ? $tax:'', 
                    "is_affiliate_payout_type"=>isset($affiliateonetime) ? $affiliateonetime:'', 
                    "custom_affiliate_payout"=>isset($affiliatepaytype) ? $affiliatepaytype:'', 
                    "retired"=>isset($retired) ? $retired:'', 
                    "affiliate_pay_amount"=>isset($row->affiliatepayamount) ? $row->affiliatepayamount:'', 
                    "orderby"=>isset($row->order) ? $row->order:'', 
                    "highlight_text"=>isset($tagline) ? $tagline:'', 
                    "entry_date"=>isset($row->created_at) ? $row->created_at:'', 
                    "update_date"=>isset($row->updated_at) ? $row->updated_at:'', 
                    "auto_terminate_email"=>148, 
                    "product_upgrade_email"=>0, 
                    "module_configurations"=>
                    _je([
                    "configoption1"=>isset($row->configoption1) ? $row->configoption1:'', 
                    "configoption2"=>isset($row->configoption2) ? $row->configoption2:'', 
                    "configoption3"=>isset($row->configoption3) ? $row->configoption3:'', 
                    "configoption4"=>isset($row->configoption4) ? $row->configoption4:'', 
                    "configoption5"=>isset($row->configoption5) ? $row->configoption5:'', 
                    "configoption6"=>isset($row->configoption6) ? $row->configoption6:'', 
                    "configoption7"=>isset($row->configoption7) ? $row->configoption7:'', 
                    "configoption8"=>isset($row->configoption8) ? $row->configoption8:'', 
                    "configoption9"=>isset($row->configoption9) ? $row->configoption9:'', 
                    "configoption10"=>isset($row->configoption10) ? $row->configoption10:'', 
                    "configoption11"=>isset($row->configoption11) ? $row->configoption11:'', 
                    "configoption12"=>isset($row->configoption12) ? $row->configoption12:'', 
                    "configoption13"=>isset($row->configoption13) ? $row->configoption13:'', 
                    "configoption14"=>isset($row->configoption14) ? $row->configoption14:'', 
                    "configoption15"=>isset($row->configoption15) ? $row->configoption15:'', 
                    "configoption16"=>isset($row->configoption16) ? $row->configoption16:'', 
                    "configoption17"=>isset($row->configoption17) ? $row->configoption17:'', 
                    "configoption18"=>isset($row->configoption18) ? $row->configoption18:'', 
                    "configoption19"=>isset($row->configoption19) ? $row->configoption19:'', 
                    "configoption20"=>isset($row->configoption20) ? $row->configoption20:'', 
                    "configoption21"=>isset($row->configoption21) ? $row->configoption21:'', 
                    "configoption22"=>isset($row->configoption22) ? $row->configoption22:'', 
                    "configoption23"=>isset($row->configoption23) ? $row->configoption23:'', 
                    "configoption24"=>isset($row->configoption24) ? $row->configoption24:'', 
                    ])
                    ];
            }
        }

        $Results = GetTableRows("select * from tbladdons");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $mpid++;
                $type='Addon';
                $tid=5;
                $eid_welcome=0;
                $price_duration = "price_annually_fee";
                if($type == "hostingaccount") $type="hosting";
                if($type == "reselleraccount") $type="reseller";
                if($type == "hosting") $eid_welcome=1;
                if($type == "reseller") $eid_welcome=4;
                if($type == "server")
                {
                    $eid_welcome=17;
                    $price_duration = "price_monthly_fee";
                }
                if($type == "other") $eid_welcome=18;
                if(isset($row->billingcycle))
                {
                    if($row->billingcycle == "free") $price_duration = "Free";
                    if($row->billingcycle == "onetime") $price_duration = "price_onetime_fee";
                }
                $info = get_max("products_group",['group_type'=>"hosting"],"id");
                $gid = _s("id",$info,0);
                $product_upgrade_plans = isset($row->packages) ? ltrim($row->packages, ", "):'';
                $tax = isset($row->tax) ? ($row->tax>0 ? 'YES':'NO'):'NO';
                $hidden = isset($row->hidden) ? ($row->hidden>0 ? 'YES':'NO'):'NO';
                $retired = 0;
                if(isset($row->retired)) $retired +=$row->retired;
                if(isset($row->suspendproduct)) $retired +=$row->suspendproduct;
                $suspendproduct = $retired>0 ? 'YES':'NO';
                $is_stock_control = isset($row->stockcontrol) ? ($row->stockcontrol>0 ? 'YES':'NO'):'NO';
                $prorata_billing_enable = isset($row->prorate) ? ($row->prorate>0 ? 'YES':'NO'):'NO';
                $product_setup_after = "MANUALLY";
                if(isset($row->autoactivate))
                {
                    $product_setup_after = $row->autoactivate == 'payment' ? 'PAYMENT_RECEIPT':($row->autoactivate == "order" ? 'ORDER_ACCEPTTED':'MANUALLY');
                }

                $Data[]=[
                    "id"=>$mpid, 
                    "old_id"=>isset($row->id) ? $row->id:'', 
                    "title"=>isset($row->name) ? $row->name:'', 
                    "server_type"=>isset($row->module) ? $row->module:'', 
                    "price_duration"=>isset($price_duration) ? $price_duration:'', 
                    "server_group_id"=>isset($row->server_group_id) ? $row->server_group_id:'', 
                    "product_upgrade_plans"=>isset($product_upgrade_plans) ? $product_upgrade_plans:'', 
                    "description"=>isset($row->description) ? $row->description:'', 
                    "payment_time"=>isset($row->billingcycle) ? $row->billingcycle:'', 
                    "unit_in_stock"=>isset($row->allowqty) ? $row->allowqty:'', 
                    "apply_tax"=>isset($tax) ? $tax:'', 
                    "is_hidden"=>isset($hidden) ? $hidden:'', 
                    "orderby"=>isset($row->order) ? $row->order:'', 
                    "retired"=>isset($suspendproduct) ? $suspendproduct:'', 
                    "product_setup_after"=>isset($product_setup_after) ? $product_setup_after:'', 
                    "is_stock_control"=>isset($is_stock_control) ? $is_stock_control:'', 
                    "prorata_billing_enable"=>isset($prorata_billing_enable) ? $prorata_billing_enable:'', 
                    "entry_date"=>isset($row->created_at) ? $row->created_at:'', 
                    "update_date"=>isset($row->updated_at) ? $row->updated_at:'', 
                    "eid_welcome"=>isset($eid_welcome) ? $eid_welcome:'', 
                    "tid"=>isset($tid) ? $tid:'', 
                    "gid"=>isset($gid) ? $gid:'', 
                    "prorata_billing_day"=>isset($row->weight) ? $row->weight:'', 
                    "charge_next_month"=>isset($row->weight) ? $row->weight:'', 
                    "account_type"=>"other", 
                    "domain_registration_option"=>'NO', 
                    "free_domain"=>'NONE', 
                    "free_domain_period"=>"", 
                    "free_domain_tlds"=>"", 
                    "recurring_cycles_limit"=>0, 
                    "auto_terminate_days"=>0, 
                    "auto_terminate_email"=>148, 
                    "product_upgrade_plans_enable"=>'NO', 
                    "product_upgrade_email"=>0, 
                    "is_overages_billing"=>'DISABLE', 
                    "disk_usage_limits"=>0, 
                    "bandwidth_usage_limits"=>0, 
                    "disk_usage_limits_cost"=>0, 
                    "bandwidth_usage_limits_cost"=>0, 
                    "is_affiliate_payout_type"=>'Recurring', 
                    "custom_affiliate_payout"=>'Use Default', 
                    "affiliate_pay_amount"=>0, 
                    "highlight_text"=>'', 
                    "module_configurations"=>_je([])
                    ];
            }
        }
        return ImportData($Data, "Products/Services", "products_list","",true); 
    }
    function tblcustomfields()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblcustomfields");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $type=isset($row->type) ? $row->type:'other';
                if($type == "addon") $type="other";
                if($type == "product") $type="hosting";
                $PTypeRes = GetTableRows("select type from tblproducts where id=".$row->relid);
                if(isset($PTypeRes[0]->type)) $type = $PTypeRes[0]->type;

                $adminonly = isset($row->adminonly) ? ($row->adminonly>0 ? 'YES':'NO'):'NO';
                $required = isset($row->required) ? ($row->required>0 ? 'YES':'NO'):'NO';
                $showorder = isset($row->showorder) ? ($row->showorder>0 ? 'YES':'NO'):'NO';
                $showinvoice = isset($row->showinvoice) ? ($row->showinvoice>0 ? 'YES':'NO'):'NO';

                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "type"=>isset($type) ? $type:'', 
                        "relid"=>isset($row->relid) ? $row->relid:'', 
                        "fieldname"=>isset($row->fieldname) ? $row->fieldname:'', 
                        "fieldtitle"=>isset($row->fieldname) ? $row->fieldname:'', 
                        "fieldtype"=>isset($row->fieldtype) ? $row->fieldtype:'', 
                        "description"=>isset($row->description) ? $row->description:'', 
                        "fieldoptions"=>isset($row->fieldoptions) ? $row->fieldoptions:'', 
                        "adminonly"=>isset($adminonly) ? $adminonly:'', 
                        "required"=>isset($required) ? $required:'', 
                        "showorder"=>isset($showorder) ? $showorder:'', 
                        "showinvoice"=>isset($showinvoice) ? $showinvoice:'', 
                        "validation"=>isset($row->regexpr) ? $row->regexpr:'', 
                        "sortorder"=>isset($row->sortorder) ? $row->sortorder:'', 
                        "created_at"=>isset($row->created_at) ? $row->created_at:'', 
                        "updated_at"=>isset($row->updated_at) ? $row->updated_at:'', 
                    ];
            }
        }
        return ImportData($Data, "Product Custom Fileds", "hosting_custom_fields","",true); 
    }
    function tblproductconfiggroups()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblproductconfiggroups order by id asc");
        if(!empty($Results))
        {   
            $mid = 0;
            foreach($Results as $row)
            {
                $mid = $row->id;
                $Data[]=[
                        "id"=>$row->id, 
                        "title"=>isset($row->name) ? $row->name:'', 
                        "description"=>isset($row->description) ? $row->description:'', 
                        "is_deleteable"=>'YES', 
                        "module"=>' ', 
                    ];
            }
            $mid = $mid+1;
            $Data[]=[
                    "id"=>$mid, 
                    "title"=>"WHMBCS-DOMAINS-OPTIONS", 
                    "description"=>"Domains Options", 
                    "is_deleteable"=>'NO', 
                    "module"=>'domain', 
                ];
            
        }
        return ImportData($Data, "Configureable Groups", "products_config_groups"); 
    }
    function tblproductconfigoptions()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblproductconfigoptions order by id asc");
        if(!empty($Results))
        {   
            $mid = 0;
            foreach($Results as $row)
            {
                $mid = $row->id;
                $type=isset($row->optiontype) ? $row->optiontype:'DROPDOWN';
                if($type == 1) $type = "DROPDOWN";
                if($type == 4) $type = "QUANTITY";
                if($type == 2) $type = "RADIO";
                if($type == 3) $type = "CHECKBOX";
                $Data[]=[
                        "id"=>isset($row->id) ? $row->id:'', 
                        "gid"=>isset($row->gid) ? $row->gid:'', 
                        "title"=>isset($row->optionname) ? $row->optionname:'', 
                        "type"=>isset($type) ? $type:'', 
                        "qty_min"=>isset($row->qtyminimum) ? $row->qtyminimum:1, 
                        "qty_max"=>isset($row->qtymaximum) ? $row->qtymaximum:1, 
                        "orderby"=>isset($row->order) ? ($row->order>0 ? $row->order:$row->id):0, 
                        "fieldname"=>"config_option_".$row->gid, 
                        "is_hidden"=>isset($row->hidden) ? ($row->hidden>0 ? 'YES':'NO'):'NO', 
                    ];
            }
            $mid = $mid+1;
            $info = get_max("products_config_groups",['title'=>"WHMBCS-DOMAINS-OPTIONS"],"id");
            $Data[]=[
                    "id"=>$mid, 
                    "gid"=>isset($info->id) ? $info->id:0, 
                    "title"=>"Domain Addons", 
                    "type"=>"CHECKBOX", 
                    "qty_min"=>0, 
                    "qty_max"=>1, 
                    "orderby"=>$mid, 
                    "is_hidden"=>'NO', 
                    "fieldname"=>'domain_addons', 
                    "fielddesc"=>'Domain Extra Features', 
                ];
            
        }
        return ImportData($Data, "Configureable Groups Options", "products_config_groups_options"); 
    }
    function tblproductconfigoptionssub()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblproductconfigoptionssub order by id asc");
        if(!empty($Results))
        {   
            $mid = 0;
            foreach($Results as $row)
            {
                $mid = $row->id;
                $title = $row->optionname;
                if(strlen($title)<=1) $title=1;
                if($title == 1){
                    $cinfo = get_max("products_config_groups_options",['id'=>$row->configid],'title');
                    $title = _s("title",$cinfo,"");
                }
                if(empty($title)) $title=1;
                
                $Data[]=[
                        "id"=>$row->id, 
                        "cid"=>$row->configid, 
                        "title"=>$title, 
                        "orderby"=>($row->sortorder>0) ? $row->sortorder:$row->id, 
                        "is_hidden"=>($row->hidden>0) ? 'YES':'NO', 
                    ];
            }
            $mid = $mid+1;
            $ginfo = get_max("products_config_groups",['title'=>"WHMBCS-DOMAINS-OPTIONS"]);
            $cinfo = get_max("products_config_groups_options",['gid'=>_s("id",$ginfo,0)]);
            $Data[]=[
                    "id"=>$mid, 
                    "cid"=>_s("id",$cinfo,0), 
                    "title"=>"WHASOLS-DNS-MANAGEMENT", 
                    "orderby"=>$mid, 
                    "is_hidden"=>'NO', 
                ];
            $mid = $mid+1;
            $Data[]=[
                    "id"=>$mid, 
                    "cid"=>_s("id",$cinfo,0), 
                    "title"=>"WHASOLS-EMAIL-FORWARDING", 
                    "orderby"=>$mid, 
                    "is_hidden"=>'NO', 
                ];
            $mid = $mid+1;
            $Data[]=[
                    "id"=>$mid, 
                    "cid"=>_s("id",$cinfo,0), 
                    "title"=>"WHASOLS-ID-PROTECTION", 
                    "orderby"=>$mid, 
                    "is_hidden"=>'NO', 
                ];
            
        }
        return ImportData($Data, "Configureable Groups Options Childs", "products_config_groups_options_childs"); 
    }
    function tblhostingconfigoptions()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblhostingconfigoptions");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "relid"=>$row->relid, 
                        "optionid"=>$row->optionid, 
                        "qty"=>$row->qty, 
                    ];
            }
        }
        return ImportData($Data, "Hosting/Services Config Options", "hosting_config_options","",true); 
    }
    function tblcustomfieldsvalues()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblcustomfieldsvalues");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "fieldid"=>isset($row->fieldid) ? $row->fieldid:'', 
                        "relid"=>isset($row->relid) ? $row->relid:'', 
                        "value"=>isset($row->value) ? $row->value:'', 
                        "created_at"=>isset($row->created_at) ? $row->created_at:'', 
                        "updated_at"=>isset($row->updated_at) ? $row->updated_at:'', 
                    ];
            }
        }
        return ImportData($Data, "Product Custom Fileds Values", "hosting_custom_fields_value","",true); 
    }
    function tblservergroups()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblservergroups");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "name"=>$row->name, 
                        "is_server_fill"=>($row->filltype == 1) ? 'YES':'NO', 
                    ];
            }
        }
        return ImportData($Data, "Servers Groups", "hosting_servers_groups","",true); 
    }
    function tblproductgroups()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblproductgroups order by id asc");
        if(!empty($Results))
        {
            $mid = 0;
            foreach($Results as $row)
            {
                $mid = $row->id;
                $Data[]=[
                        "id"=>$row->id, 
                        "title"=>isset($row->name) ? $row->name:'', 
                        "link"=>isset($row->slug) ? $row->slug:'', 
                        "headline"=>isset($row->headline) ? $row->headline:' ', 
                        "tagline"=>isset($row->tagline) ? $row->tagline:' ', 
                        "order_template"=>"boxed.tpl", 
                        "hidden"=>isset($row->hidden) ? ($row->hidden>0 ? 'YES':'NO'):'NO', 
                        "orderby"=>isset($row->order) ? $row->order:0, 
                        "group_type"=>'hosting', 
                        "entry_date"=>isset($row->created_at) ? $row->created_at:'', 
                        "updated_at"=>isset($row->updated_at) ? $row->updated_at:'', 
                    ];
            }
            $id = $mid+1;
        }
        return ImportData($Data, "Products Groups", "products_group","",true); 
    }
    function tblservers()
    {
        $Data = [];
        $Results = GetTableRows("select a.*, (select max(groupid) from tblservergroupsrel where serverid=a.id) as gid from tblservers a");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "gid"=>($row->gid>0) ? $row->gid:0, 
                        "name"=>isset($row->name) ? $row->name:'', 
                        "ipaddress"=>isset($row->ipaddress) ? $row->ipaddress:'', 
                        "assignedips"=>isset($row->assignedips) ? $row->assignedips:'', 
                        "hostname"=>isset($row->hostname) ? $row->hostname:'', 
                        "monthly_cost"=>isset($row->monthlycost) ? $row->monthlycost:'', 
                        "data_center"=>isset($row->noc) ? $row->noc:'', 
                        "status_address"=>isset($row->statusaddress) ? $row->statusaddress:'', 
                        "ns1"=>isset($row->nameserver1) ? $row->nameserver1:'', 
                        "ns1ip"=>isset($row->nameserver1ip) ? $row->nameserver1ip:'', 
                        "ns2"=>isset($row->nameserver2) ? $row->nameserver2:'', 
                        "ns2ip"=>isset($row->nameserver2ip) ? $row->nameserver2ip:'', 
                        "ns3"=>isset($row->nameserver3) ? $row->nameserver3:'', 
                        "ns3ip"=>isset($row->nameserver3ip) ? $row->nameserver3ip:'', 
                        "ns4"=>isset($row->nameserver4) ? $row->nameserver4:'', 
                        "ns4ip"=>isset($row->nameserver4ip) ? $row->nameserver4ip:'', 
                        "ns5"=>isset($row->nameserver5) ? $row->nameserver5:'', 
                        "ns5ip"=>isset($row->nameserver5ip) ? $row->nameserver5ip:'', 
                        "max_accounts"=>isset($row->maxaccounts) ? $row->maxaccounts:'', 
                        "type"=>isset($row->type) ? $row->type:'', 
                        "username"=>isset($row->username) ? $row->username:'', 
                        "password"=>isset($row->password) ? $row->password:'', 
                        "accesshash"=>isset($row->accesshash) ? $row->accesshash:'', 
                        "port"=>isset($row->port) ? $row->port:'', 
                        "is_secure"=>($row->secure == "on") ? 'https://':'http://', 
                        "is_disabled"=>($row->disabled>0) ? 'Disabled':'Enabled', 
                        "status"=>($row->disabled>0) ? 'Inactive':'Active', 
                    ];
            }
        }
        return ImportData($Data, "Servers", "hosting_servers","",true); 
    }
    function tbldomainsadditionalfields()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbldomainsadditionalfields");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "domain_id"=>isset($row->domainid) ? $row->domainid:'', 
                        "field_name"=>isset($row->name) ? $row->name:'', 
                        "field_value"=>isset($row->value) ? $row->value:'', 
                        "entry_date"=>isset($row->created_at) ? $row->created_at:'', 
                        "update_date"=>isset($row->updated_at) ? $row->updated_at:'', 
                    ];
            }
        }
        return ImportData($Data, "Domains Additional Fields", "domains_additional_fields","",true); 
    }
    function tbldomainreminders()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbldomainreminders");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "domain_id"=>isset($row->domain_id) ? $row->domain_id:'', 
                        "date"=>isset($row->date) ? $row->date:'', 
                        "recipients"=>isset($row->recipients) ? $row->recipients:'', 
                        "type"=>isset($row->type) ? $row->type:'', 
                        "days_before_expiry"=>isset($row->days_before_expiry) ? $row->days_before_expiry:'', 
                    ];
            }
        }
        return ImportData($Data, "Domains Reminders", "domains_reminders","",true); 
    }
    function tbldomains()
    {
        $tldslist =[]; 
        $Results = GetTableRows("select * from tbldomainpricing");        
        foreach($Results as $row)
        {
            $tld = _r('.', '', $row->extension);
            $tldslist[$tld] = $row->id;
        }
        $Data = [];
        $Results = GetTableRows("select * from tbldomains");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $type = "domain-register";
                if(isset($row->type))
                {
                    if($row->type == "Transfer") $type="domain-transfer";
                }
                $registrar_name = isset($row->registrar) ? $row->registrar:'';
                $registrar=0;
                if(!empty($registrar_name))
                {
                    $rInfo = GetRegistrarInfoByName($registrar_name);
                    if(!empty($rInfo)) $registrar = $rInfo->id;
                }
                $gatewayname = isset($row->paymentmethod) ? $row->paymentmethod:'banktransfer';
                if($gatewayname == "banktransfer") $gatewayname = "bankdeposit";
                $gatewayname = (!empty($gatewayname)) ? $gatewayname:'bankdeposit';
                $gateway=0;
                if(!empty($gatewayname))
                {
                    $gateway=0;
                    $gInfo = getGatewayInfoByName($gatewayname);
                    if(!empty($gInfo))
                    {
                        $gateway = ($gInfo->id>0) ? $gInfo->id:0;
                    }
                }
                $tld = _r('.', '', GetDomainTldInfoByName($row->domain));
                $pid = isset($tldslist[$tld]) ? $tldslist[$tld]:0;
                $Data[]=[
                        "pid"=>$pid, 
                        "id"=>$row->id, 
                        "user_id"=>isset($row->userid) ? $row->userid:0, 
                        "order_id"=>isset($row->orderid) ? $row->orderid:0, 
                        "registrationperiod"=>isset($row->registrationperiod) ? $row->registrationperiod:1, 
                        "promoid"=>isset($row->promoid) ? $row->promoid:0, 
                        "dnsmanagement"=>isset($row->dnsmanagement) ? $row->dnsmanagement:0, 
                        "emailforwarding"=>isset($row->emailforwarding) ? $row->emailforwarding:0, 
                        "idprotection"=>isset($row->idprotection) ? $row->idprotection:0, 
                        "is_premium"=>isset($row->is_premium) ? $row->is_premium:0, 
                        "donotrenew"=>isset($row->donotrenew) ? $row->donotrenew:0, 
                        "synced"=>isset($row->synced) ? $row->synced:0, 
                        "type"=>isset($type) ? $type:'', 
                        "registrationdate"=>isset($row->registrationdate) ? $row->registrationdate:'', 
                        "domain"=>isset($row->domain) ? $row->domain:'', 
                        "firstpaymentamount"=>isset($row->firstpaymentamount) ? $row->firstpaymentamount:'', 
                        "recurringamount"=>isset($row->recurringamount) ? $row->recurringamount:'', 
                        "registrar"=>isset($registrar) ? $registrar:'', 
                        "expirydate"=>isset($row->expirydate) ? $row->expirydate:'', 
                        "subscriptionid"=>isset($row->subscriptionid) ? $row->subscriptionid:'', 
                        "status"=>isset($row->status) ? $row->status:'', 
                        "nextduedate"=>isset($row->nextduedate) ? $row->nextduedate:'', 
                        "nextinvoicedate"=>isset($row->nextinvoicedate) ? $row->nextinvoicedate:'', 
                        "additionalnotes"=>isset($row->additionalnotes) ? $row->additionalnotes:'', 
                        "paymentmethod"=>isset($gateway) ? $gateway:'', 
                        "reminders"=>isset($row->reminders) ? $row->reminders:'', 
                        "created_at"=>isset($row->registrationdate) ? $row->registrationdate:'', 
                        "updated_at"=>isset($row->updated_at) ? $row->updated_at:'', 
                    ];
            }
        }
        return ImportData($Data, "Domains", "domains","",true); 
    }    
    function tbldomainpricing()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbldomainpricing");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $grace_period_duration = GetDomainsGracePeriod($row->extension);
                $redemption_period_duration = GetDomainsRedemptionGracePeriod($row->extension);
                $Data[]=[
                        "id"=>$row->id, 
                        "name"=>isset($row->extension) ? $row->extension:'', 
                        "auto_registration"=>isset($row->autoreg) ? $row->autoreg:'', 
                        "created_at"=>isset($row->created_at) ? $row->created_at:'', 
                        "updated_at"=>isset($row->updated_at) ? $row->updated_at:'', 
                        "featured"=>isset($row->group) ? strtoupper($row->group):'', 
                        "orderby"=>isset($row->order) ? $row->order:0, 
                        "grace_period_duration"=>isset($row->grace_period) ? $row->grace_period:$grace_period_duration, 
                        "grace_period_fee"=>isset($row->grace_period_fee) ? $row->grace_period_fee:0, 
                        "redemption_period_duration"=>isset($row->redemption_grace_period) ? $row->redemption_grace_period:$redemption_period_duration, 
                        "redemption_period_fee"=>isset($row->redemption_grace_period_fee) ? $row->redemption_grace_period_fee:0, 
                        "dns_management"=>isset($row->dnsmanagement) ? 'YES':'NO', 
                        "email_forwarding"=>isset($row->emailforwarding) ? 'YES':'NO', 
                        "id_protection"=>isset($row->idprotection) ? 'YES':'NO', 
                        "epp_code"=>isset($row->eppcode) ? 'YES':'NO', 
                    ];
            }
        }
        return ImportData($Data, "Domains TLDs", "domains_tlds","",true); 
    }
    function tbllinks()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbllinks");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "name"=>isset($row->name) ? $row->name:'', 
                        "link"=>isset($row->link) ? $row->link:'', 
                        "clicks"=>isset($row->clicks) ? $row->clicks:0, 
                        "conversions"=>isset($row->conversions) ? $row->conversions:0, 
                    ];
            }
        }
        return ImportData($Data, "Links", "links_tracking","",true); 
    }
    function tblpromotions()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblpromotions");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $products_cycles = [];
                $cycles = isset($row->cycles) ? _ex(", ", $row->cycles):[];
                if(!empty($cycles))
                {
                    foreach($cycles as $c)
                    {
                        $products_cycles[] = GetPriceDurationNameByKey($c);
                    }
                }
                $products_cycles = isset($products_cycles) ? _em(", ", $products_cycles):'';
                $Data[]=[
                        "id"=>$row->id, 
                        "code"=>isset($row->code) ? $row->code:'', 
                        "type"=>isset($row->type) ? $row->type:'', 
                        "value"=>isset($row->value) ? $row->value:'', 
                        "domains_cycles"=>'', 
                        "products_cycles"=>isset($products_cycles) ? $products_cycles:'', 
                        "appliesto"=>isset($row->appliesto) ? $row->appliesto:'', 
                        "requires"=>isset($row->requires) ? $row->requires:'', 
                        "start_date"=>isset($row->startdate) ? $row->startdate:'', 
                        "end_date"=>isset($row->expirationdate) ? $row->expirationdate:'', 
                        "max_uses"=>isset($row->maxuses) ? $row->maxuses:'', 
                        "uses"=>isset($row->uses) ? $row->uses:'', 
                        "upgradeconfig"=>isset($row->upgradeconfig) ? $row->upgradeconfig:'', 
                        "notes"=>isset($row->notes) ? $row->notes:'', 
                        "recurring"=>isset($row->recurring) ? 'YES':'NO', 
                        "recurfor"=>isset($row->recurfor) ? $row->recurfor:0, 
                        "existing_client"=>isset($row->requiresexisting) ? 'YES':'NO', 
                        "once_per_client"=>isset($row->onceperclient) ? 'YES':'NO', 
                        "life_time_promo"=>isset($row->lifetimepromo) ? 'YES':'NO', 
                        "apply_once"=>isset($row->applyonce) ? 'YES':'NO', 
                        "new_signups"=>isset($row->newsignups) ? 'YES':'NO', 
                        "requires_existing"=>isset($row->existingclient) ? 'YES':'NO', 
                        "upgrades"=>isset($row->upgrades) ? 'YES':'NO', 
                    ];
            }
        }
        return ImportData($Data, "Promotions", "promotions","",true); 
    }
    function tblcancelrequests()
    {
        $Data = [];
        $Results = GetTableRows("select a.*, h.userid, h.packageid from tblcancelrequests a left join tblhosting h on a.relid=h.id");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "user_id"=>($row->userid>0) ? $row->userid:0, 
                    "created_at"=>isset($row->date) ? $row->date:'', 
                    "updated_at"=>isset($row->date) ? $row->date:'', 
                    "date"=>isset($row->date) ? $row->date:'', 
                    "cancellation_date"=>isset($row->date) ? $row->date:'', 
                    "pid"=>isset($row->relid) ? $row->relid:'', 
                    "reason"=>isset($row->reason) ? $row->reason:'', 
                    "type"=>isset($row->type) ? $row->type:'', 
                    "status"=>"Completed", 
                    "invoices_status"=>"Completed", 
                    "product_type"=>"hosting", 
                    ];
            }
        }
        return ImportData($Data, "Cancellation Requests", "hosting_cancel_requests","",true); 
    }
    function tblaccounts()
    {
        $Data = [];
        $Results = GetTableRows("select a.*, c.currency as currency_id from tblaccounts a join tblclients c on a.userid=c.id");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $refund_type = "Normal";
                $currency=0;
                if(isset($row->currency))
                {
                    $currency = ($row->currency>0) ? $row->currency:0;
                    $currency = ($currency) ? $currency:$row->currency_id;
                    $currency = ($currency) ? $currency:0;
                }
                $gateway = 0;
                $gatewayname = isset($row->gateway) ? $row->gateway:'banktransfer';
                if($gatewayname == "mailin") $gatewayname = "bankdeposit";
                if($gatewayname == "banktransfer") $gatewayname = "bankdeposit";
                $gatewayname = (!empty($gatewayname)) ? $gatewayname:'bankdeposit';
                if(!empty($gatewayname))
                {
                    $gInfo = getGatewayInfoByName($gatewayname);
                    if(!empty($gInfo))
                    {
                        $gateway = ($gInfo->id>0) ? $gInfo->id:0;
                    }
                }
                if($row->amountout>0) $refund_type="Manual";
                if($row->refundid > 0)
                {
                    if($gatewayname == "mailin") $refund_type="Manual";
                    if($gatewayname == "bankdeposit") $refund_type="Manual";
                    if($gatewayname <> "bankdeposit") $refund_type="Gateway";
                }
                
                $Data[]=[
                    "id"=>$row->id, 
                    "user_id"=>($row->userid>0) ? $row->userid:0, 
                    "currency"=>isset($currency) ? $currency:'', 
                    "payment_method"=>isset($gateway) ? $gateway:'', 
                    "entry_date"=>isset($row->date) ? $row->date:'', 
                    "paymet_date"=>isset($row->date) ? $row->date:'', 
                    "description"=>isset($row->description) ? $row->description:'', 
                    "amount_in"=>isset($row->amountin) ? $row->amountin:'', 
                    "fees"=>isset($row->fees) ? $row->fees:'', 
                    "amount_out"=>isset($row->amountout) ? $row->amountout:'', 
                    "base_conv_rate"=>isset($row->rate) ? $row->rate:'', 
                    "transaction_no"=>isset($row->transid) ? $row->transid:'', 
                    "refund_type"=>isset($refund_type) ? $refund_type:'', 
                    "invoice_id"=>($row->invoiceid>0) ? $row->invoiceid:0, 
                    "refund_id"=>($row->refundid>0) ? $row->refundid:0, 
                    ];
            }
        }
        return ImportData($Data, "Payment Transactions", "invoices_payments","",true); 
    }
    function tbltodolist()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbltodolist");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $status=7;
                if(isset($row->status))
                {
                    if($row->status == "Completed") $status=3;
                    if($row->status == "In Progress") $status=2;
                    if($row->status == "Postponed") $status=5;
                    if($row->status == "Won't Fix") $status=6;
                }
                $Data[]=[
                    "id"=>$row->id, 
                    "assigned_by"=>($row->admin>0) ? $row->admin:0, 
                    "entry_date"=>isset($row->date) ? $row->date:'', 
                    "title"=>isset($row->title) ? $row->title:'', 
                    "description"=>isset($row->description) ? $row->description:'', 
                    "status"=>isset($status) ? $status:'', 
                    "expiry_date"=>isset($row->duedate) ? $row->duedate:'', 
                    "priority"=>"Low", 
                    "important"=>"No", 
                    "my_day"=>"No", 
                    "my_notes"=>"No", 
                    ];
            }
        }
        return ImportData($Data, "ToDo Tasks", "todo_tasks_list","",true); 
    }
    function tblmodulequeue()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblmodulequeue");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $type = $row->service_type;
                $action = $row->module_action;
                if($type == "others") $type="other";
                if($type == "service") $type="services";
                if($type == "addon") $type="other";
                if($type == "domain")
                {
                    if($action == "RegisterDomain") $type="domain-register";
                    if($action == "RenewDomain") $type="domain-renewal";
                    if($action == "TransferDomain") $type="domain-transfer";
                }
                if($action == "Renew") $action="RenewalService";
                if($action == "RenewDomain") $action="RenewalDomain";
                $Data[]=[
                    "id"=>$row->id, 
                    "type"=>$type, 
                    "product_id"=>$row->service_id, 
                    "module"=>$row->module_name, 
                    "action"=>$action, 
                    "last_try_time"=>_t($row->last_attempt), 
                    "last_try_error"=>$row->last_attempt_error, 
                    "tries"=>($row->num_retries>0) ? $row->num_retries:0, 
                    "status"=>($row->completed>0) ? 'Completed':'Pending', 
                    "created_at"=>_t($row->created_at), 
                    "updated_at"=>_t($row->updated_at), 
                    "user_id"=>0, 
                    ];
            }
        }
        return ImportData($Data, "Modules Queue", "hosting_modules_queue","",true); 
    }
    function tblannouncements()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblannouncements");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "title"=>$row->title, 
                    "description"=>$row->announcement, 
                    "date"=>$row->date, 
                    "entry_date"=>$row->date, 
                    "update_date"=>$row->updated_at, 
                    "published"=>($row->published>0) ? 'Yes':'No', 
                    "entry_by"=>0, 
                    "update_by"=>0, 
                    "views"=>0, 
                    ];
            }
        }
        return ImportData($Data, "Announcements", "support_announcements","",true); 
    }
    function tblnetworkissues()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblnetworkissues");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $type=$row->type;
                if($type == "Other") $type="Others";
                $Data[]=[
                    "id"=>$row->id, 
                    "title"=>$row->title, 
                    "description"=>$row->description, 
                    "type"=>$type, 
                    "affecting"=>$row->affecting, 
                    "server"=>$row->server, 
                    "priority"=>$row->priority, 
                    "start_date"=>$row->startdate, 
                    "end_date"=>$row->enddate, 
                    "status"=>$row->status, 
                    "entry_date"=>$row->created_at, 
                    "update_date"=>$row->updated_at, 
                    "published"=>'Yes', 
                    "entry_by"=>0, 
                    "update_by"=>0, 
                    ];
            }
        }
        return ImportData($Data, "Network Issues", "support_network_issues","",true); 
    }
    function tblnotes()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblnotes");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "user_id"=>($row->userid>0) ? $row->userid:0, 
                    "admin_id"=>($row->adminid>0) ? $row->adminid:0, 
                    "entry_date"=>_t($row->created), 
                    "updatetime"=>_t($row->modified), 
                    "note_txt"=>$row->note, 
                    "is_sticky"=>($row->sticky>0) ? 'YES':'NO', 
                    ];
            }
        }
        return ImportData($Data, "Notes", "clients_notes","",true); 
    }
    function tbldownloads()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbldownloads");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "orderby"=>$row->id, 
                    "category_id "=>$row->category, 
                    "file_type"=>$row->type, 
                    "title"=>$row->title, 
                    "description"=>$row->description, 
                    "downloads"=>$row->downloads, 
                    "file_name"=>$row->location, 
                    "file_path"=>$row->location, 
                    "login_clients_only"=>($row->clientsonly>0) ? 'Yes':'No', 
                    "status"=>($row->hidden>0) ? 'Yes':'No', 
                    "addon_product_required"=>($row->productdownload>0) ? 'Yes':'No', 
                    "datetime"=>$row->created_at, 
                    ];
            }
        }
        return ImportData($Data, "Downloads", "downloads_files","",true); 
    }
    function tbldownloadcats()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbldownloadcats");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "orderby "=>$row->id , 
                    "parent "=>$row->parentid, 
                    "title"=>$row->name, 
                    "description"=>$row->description, 
                    "hide"=>($row->hidden>0) ? 'Yes':'No', 
                    "created_at"=>$row->created_at, 
                    "updated_at"=>$row->updated_at, 
                    ];
            }
        }
        return ImportData($Data, "Download Categories", "downloads_categories","",true); 
    }
    function tblcalendar()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblcalendar");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "name"=>$row->title, 
                    "description"=>$row->desc, 
                    "date_from"=>($row->start>0) ? date('Y-m-d', $row->start):'', 
                    "date_to"=>($row->end>0) ? date('Y-m-d', $row->end):'', 
                    "all_day"=>($row->allday>0) ? $row->allday:0, 
                    ];
            }
        }
        return ImportData($Data, "Calendar Feeds", "calendar_feeds","",true); 
    }
    function tblbannedemails()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblbannedemails");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "domain"=>$row->domain, 
                    "usage_counts"=>($row->count>0) ? $row->count:0, 
                    ];
            }
        }
        return ImportData($Data, "Banned Email", "banned_email_domain"); 
    }
    function tblgatewaylog()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblgatewaylog");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = 0;
                $invoice_id = 0;
                $response = $row->data;
                $responses = _ex(PHP_EOL, $row->data);
                foreach($responses as $res)
                {
                    $Segments = _ex("=>", $res);
                    $Segments0 = trim(@$Segments[0]);
                    if(in_array($Segments0, ["UserID", "User ID"])) $user_id = trim(@$Segments[1]);
                    if(in_array($Segments0, ["Invoice ID", "Invoice ID"])) $invoice_id = trim(@$Segments[1]);
                }
                //$invoice_id = $row->transaction_history_id;
                if (is_array($response) || is_object($response)) $response = print_r($response, true);
                $Data[]=[
                    "id"=>$row->id, 
                    "invoice_id"=>$invoice_id, 
                    "user_id"=>$user_id, 
                    "ipaddr"=>"0.0.0.0", 
                    "datetime"=>$row->date, 
                    "gateway"=>$row->gateway, 
                    "payment_method"=>0, 
                    "response"=>$response, 
                    "message"=>$row->result, 
                    ];
            }
        }
        return ImportData($Data, "Gateway Logs", "log_payments","",true); 
    }
    function tblwhoislog()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblwhoislog");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "datetime"=>$row->date, 
                    "domain"=>$row->domain, 
                    "ipaddr"=>$row->ip, 
                    "whois_info"=>$row->id, 
                    "whois_server"=>$row->id, 
                    "premium_price"=>0, 
                    ];
            }
        }
        return ImportData($Data, "Whois Logs", "log_whois","",true); 
    }
    function tblactivitylog()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblactivitylog");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "timestamp"=>$row->date, 
                    "description"=>$row->description, 
                    "user"=>$row->user, 
                    "userid"=>$row->userid, 
                    "ipaddr"=>$row->ipaddr, 
                    "error_msg"=>" ", 
                    ];
            }
        }
        return ImportData($Data, "Activity Logs", "log_activity","",true); 
    }
    function tblemails()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblemails where campaign_id=0");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $sent = "sent";
                if($row->pending>0) $sent = "pending";
                if($row->failed>0) $sent = "error";
                $Data[]=[
                    "id"=>$row->id, 
                    "user_id"=>$row->userid, 
                    "subject"=>$row->subject, 
                    "message"=>$row->message, 
                    "datetime"=>$row->date, 
                    "to"=>$row->to, 
                    "cc"=>$row->cc, 
                    "bcc"=>$row->bcc, 
                    "attachments"=>$row->attachments, 
                    "sent"=>$sent, 
                    "error_msg"=>$row->failure_reason, 
                    "relid"=>0, 
                    ];
            }
        }
        $Res = ImportData($Data, "Emails Logs", "log_emails","",true); 
        $Data = [];
        $Results = GetTableRows("select * from tblemails where campaign_id>0");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $sent = "sent";
                if($row->pending>0) $sent = "pending";
                if($row->failed>0) $sent = "error";
                $Data[]=[
                    "id"=>$row->id, 
                    "user_id"=>$row->userid, 
                    "subject"=>$row->subject, 
                    "message"=>$row->message, 
                    "datetime"=>$row->date, 
                    "to"=>$row->to, 
                    "cc"=>$row->cc, 
                    "bcc"=>$row->bcc, 
                    "attachments"=>$row->attachments, 
                    "sent"=>$sent, 
                    "error_msg"=>$row->failure_reason, 
                    "campaign_id"=>$row->campaign_id, 
                    ];
            }
            ImportData($Data, "Campaigns Logs", "email_campaigns_history","",true); 
        }
        return $Res; 
    }
    function tblticketpredefinedcats()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblticketpredefinedcats");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "title"=>$row->name, 
                    "description"=>$row->name, 
                    "parent"=>$row->parentid, 
                    "orderby"=>$row->id, 
                    "hide"=>"No", 
                    ];
            }
        }
        return ImportData($Data, "Predefined Replies Categories", "support_kb_reply_categories","",true); 
    }
    function tblticketpredefinedreplies()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblticketpredefinedreplies");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "category_id"=>$row->catid, 
                    "title"=>$row->name, 
                    "article"=>nl2br($row->reply), 
                    "views"=>0, 
                    "useful"=>0, 
                    "votes"=>0, 
                    "published"=>'Yes', 
                    "orderby"=>$row->id, 
                    "tags"=>"", 
                    ];
            }
        }
        return ImportData($Data, "Predefined Replies", "support_kb_reply_articles","",true); 
    }
    function tblknowledgebasecats()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblknowledgebasecats");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "title"=>$row->name, 
                    "description"=>$row->description, 
                    "parent"=>$row->parentid, 
                    "orderby"=>$row->id, 
                    "hide"=>'No', 
                    ];
            }
        }
        return ImportData($Data, "Knowledgebase Categories", "support_kb_categories","",true); 
    }
    function tblbannedips()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblbannedips");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "ip"=>$row->ip, 
                    "attempts"=>0, 
                    "user_id"=>0, 
                    "reason"=>$row->reason, 
                    "time"=>_t($row->expires)-7200, 
                    "type"=>'Temporary', 
                    "expires"=>_t($row->expires), 
                    ];
            }
        }
        return ImportData($Data, "Banned IPs ", "waf_ips_banlist","",true); 
    }
    function tblknowledgebase()
    {
        $Data = [];
        $Results = GetTableRows("select a.*, (select categoryid from tblknowledgebaselinks where articleid=a.id) as category_id, (SELECT GROUP_CONCAT(tag) FROM tblknowledgebasetags where articleid=a.id) as tags from tblknowledgebase a");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "title"=>$row->title, 
                    "category_id"=>$row->category_id, 
                    "article"=>$row->article, 
                    "views"=>($row->views>0) ? $row->views:0, 
                    "useful"=>($row->useful>0) ? $row->useful:0, 
                    "votes"=>($row->useful>0) ? $row->useful:0, 
                    "published"=>'YES', 
                    "orderby"=>($row->order>0) ? $row->order:0, 
                    "published_by"=>0, 
                    "tags"=>$row->tags, 
                    ];
            }
        }
        return ImportData($Data, "Knowledgebase Articles ", "support_kb_articles","",true); 
    }
    function tblticket_watchers()
    {
        $Data = [];
        $Results = GetTableRows("select * from tblticket_watchers");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "ticket_id"=>$row->ticket_id, 
                    "admin_id"=>($row->admin_id>0) ? $row->admin_id:0, 
                    "created_at"=>$row->created_at, 
                    "updated_at"=>$row->updated_at, 
                    ];
            }
        }
        return ImportData($Data, "Tickets Watchers ", "support_tickets_watchers","",true); 
    }
    function tbltax()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbltax");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "name"=>$row->name, 
                    "level"=>$row->level, 
                    "state"=>$row->state, 
                    "country"=>$row->country, 
                    "taxrate"=>$row->taxrate, 
                    ];
            }
        }
        return ImportData($Data, "Tax Rules ", "tax_rules","",true); 
    }
    function tblticketreplies()
    {
        $Data = [];
        $Results = GetTableRows("select * from tbltickets");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = ($row->userid>0) ? $row->userid:0;
                $name = $row->name;
                $email = $row->email;
                $is_admin = "NO";
                if(empty($name.$email))
                {
                    $uInfo = getUserInfoById($user_id);
                    if(!empty($uInfo))
                    {
                        $name = $uInfo->first_name.' '.$uInfo->last_name;
                        $email = $uInfo->email;
                        $group_id = ($uInfo->group_id>0) ? $uInfo->group_id:0;
                        $isAdmin = getUserGroupInfo($group_id);
                        $is_admin = ($isAdmin->is_admin == 1) ? 'YES':'NO';
                    }
                }
                $name = (!empty($name)) ? $name:' ';
                $email = (!empty($email)) ? $email:' ';
                $Data[]=[
                    "ticket_id"=>$row->id, 
                    "user_id"=>$user_id, 
                    "reply_type"=>'OPEN', 
                    "contact_id"=>($row->contactid>0) ? $row->contactid:0, 
                    "name"=>$name, 
                    "email"=>$email, 
                    "entry_date"=>$row->date, 
                    "message"=>nl2br($row->message), 
                    "is_admin"=>$is_admin, 
                    "rating"=>0, 
                    "deletable"=>"NO", 
                    ];
            }
        }
        $Results = GetTableRows("select a.*, (select userid from tbltickets where id=a.tid) as userid from tblticketreplies a");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = ($row->userid>0) ? $row->userid:0;
                $name = $row->name;
                $email = $row->email;
                $is_admin="NO";
                if(empty($name.$email))
                {
                    $uInfo = getUserInfoById($user_id);
                    if(!empty($uInfo))
                    {
                        $name = $uInfo->first_name.' '.$uInfo->last_name;
                        $email = $uInfo->email;
                        $group_id = ($uInfo->group_id>0) ? $uInfo->group_id:0;
                        $isAdmin = getUserGroupInfo($group_id);
                        $is_admin = ($isAdmin->is_admin == 1) ? 'YES':'NO';
                    }
                }
                $name = (!empty($name)) ? $name:' ';
                $email = (!empty($email)) ? $email:' ';
                $Data[]=[
                    "ticket_id"=>$row->tid, 
                    "user_id"=>$user_id, 
                    "reply_type"=>'REPLY', 
                    "contact_id"=>($row->contactid>0) ? $row->contactid:0, 
                    "name"=>$name, 
                    "email"=>$email, 
                    "entry_date"=>$row->date, 
                    "message"=>nl2br($row->message), 
                    "is_admin"=>$is_admin, 
                    "rating"=>$row->rating, 
                    "deletable"=>"NO", 
                ];
            }
        }
        return ImportData($Data, "Tickets Replies ", "support_tickets_replies","",true); 
    }
    function tblticketlog()
    {
        $Results = GetTableRows("select a.*, (select userid from tbltickets where id=a.tid) as user_id from tblticketlog a");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "user_id"=>($row->user_id>0) ? $row->user_id:0, 
                        "datetime"=>_t($row->date), 
                        "ticket_id"=>$row->tid, 
                        "message"=>$row->action, 
                ];
            }
        }
        return ImportData($Data, "Tickets Logs ", "log_ticket","",true); 
    }
    function tblticketdepartments()
    {
        $Results = GetTableRows("select * from tblticketdepartments");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                        "id"=>$row->id, 
                        "name"=>$row->name, 
                        "description"=>$row->description, 
                        "email"=>$row->email, 
                        "is_clients_only"=>($row->clientsonly == 'on') ? 'YES':'NO', 
                        "is_pipe_replies_only"=>($row->piperepliesonly == 'on') ? 'YES':'NO', 
                        "is_no_auto_responder"=>($row->noautoresponder == 'on') ? 'YES':'NO', 
                        "hidden"=>($row->hidden == 'on') ? 'YES':'NO', 
                        "orderby"=>($row->order>0) ? $row->order:0, 
                        "host_name"=>$row->host, 
                        "port_no"=>$row->port, 
                        "login_email_id"=>$row->login, 
                        "login_email_password"=>$row->password, 
                        "imap_encryption"=>'ssl-novalidate', 
                        "imap_enable"=>'NO', 
                        "feedback_request"=>($row->feedback_request>0) ? 'YES':'NO', 
                ];
            }
        }
        return ImportData($Data, "Tickets Departments ", "support_ticket_departments","",true); 
    }
    function tbltickets()
    {
        $Results = GetTableRows("select * from tbltickets");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = ($row->userid>0) ? $row->userid:0;
                $name = $row->name;
                $email = $row->email;
                if(empty($name.$email))
                {
                    $uInfo = getUserInfoById($user_id);
                    $name = $uInfo->first_name.' '.$uInfo->last_name;
                    $email = $uInfo->email;
                }                
                $isReadBy = "";
                if(isset($row->clientunread))
                {
                    $isReadBy = "Client";
                }
                else
                {
                    if(isset($row->adminunread))
                    {
                        $isReadBy = "Admin";
                    }
                }
                $Data[]=[
                    "id"=>$row->id, 
                    "ticket_no"=>isset($row->tid) ? $row->tid:0, 
                    "department_id"=>isset($row->did) ? $row->did:0, 
                    "user_id"=>$user_id, 
                    "contact_id"=>isset($row->contactid) ? $row->contactid:0, 
                    "name"=>$name, 
                    "email"=>$email, 
                    "cc_mails"=>isset($row->cc) ? $row->cc:'', 
                    "ipaddress"=>isset($row->ipaddress) ? $row->ipaddress:'', 
                    "entry_date"=>isset($row->date) ? $row->date:'', 
                    "title"=>isset($row->title) ? $row->title:'', 
                    "status"=>isset($row->status) ? $row->status:'', 
                    "priority"=>isset($row->urgency) ? $row->urgency:'', 
                    "marked_to"=>isset($row->admin) ? $row->admin:0, 
                    "last_reply_time"=>isset($row->lastreply) ? _t($row->lastreply):'', 
                    "is_flag"=>isset($row->flag) ? ($row->flag>0 ? 'YES':'NO'):'NO', 
                    "is_unread"=>$isReadBy, 
                    "service"=>isset($row->service) ? $row->service:'', 
                    "merged_ticket_id"=>isset($row->merged_ticket_id) ? $row->merged_ticket_id:0, 
                    "updated_at"=>isset($row->updated_at) ? $row->updated_at:'', 
                    "escalation_status"=>'Applied', 
                    "autoclose_date"=>isset($row->status) ? ($row->status == 'Closed' ? $row->date:''):'', 
                    ];
            }
        }
        return ImportData($Data, "Tickets", "support_tickets","",true); 
    }
    function tblticketescalations()
    {
        $Results = GetTableRows("select * from tblticketescalations");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "name"=>$row->name, 
                    "conditional_department_ids"=>$row->departments, 
                    "conditional_status_ids"=>$row->statuses, 
                    "conditional_priorities_type"=>$row->priorities, 
                    "time_elapsed"=>$row->timeelapsed, 
                    "action_department_id"=>$row->newdepartment, 
                    "action_priority_type"=>$row->newpriority, 
                    "action_status_id"=>$row->newstatus, 
                    "action_marked_to"=>$row->flagto, 
                    "action_notify_admins"=>$row->notify, 
                    "add_reply_text"=>$row->addreply, 
                    "date_created"=>time(), 
                ];
            }
        }
        return ImportData($Data, "Ticket Escalations", "email_ticket_escalations","",true); 
    }
    function tblticketspamfilters()
    {
        $Results = GetTableRows("select * from tblticketspamfilters");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $type = "";
                if(!empty($row->type))
                {
                    $type = ($row->type == "sender") ? 'email':$row->type;
                }
                $Data[]=["id"=>$row->id, "spam_type"=>$type, "spam_match"=>$row->content];
            }
        }
        return ImportData($Data, "Ticket Spam Filters", "email_ticket_spam_control","",true); 
    }
    function tbltickettags()
    {
        $Results = GetTableRows("select * from tbltickettags");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=["id"=>$row->id, "ticket_id"=>$row->ticketid, "tag"=>$row->tag];
            }
        }
        return ImportData($Data, "Ticket Tags", "support_tickets_tags","",true); 
    }
    function tblticketnotes()
    {
        $Results = GetTableRows("select * from tblticketnotes");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=["id"=>$row->id, "ticket_id"=>$row->ticketid, "user_id"=>$row->admin, "datetime"=>$row->date, "message"=>$row->message];
            }
        }
        return ImportData($Data, "Ticket Notes", "support_tickets_notes","",true); 
    }
    function tblticketfeedback()
    {
        $Results = GetTableRows("select * from tblticketfeedback");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=["id"=>$row->id, "ticket_id"=>$row->ticketid, "adminid"=>$row->adminid, "rating"=>$row->rating, "comments"=>$row->comments, "datetime"=>$row->datetime, "ip"=>$row->ip];
            }
        }
        return ImportData($Data, "Ticket Feedbacks", "support_tickets_feedback","",true); 
    }
    function tblticketbreaklines()
    {
        $Results = GetTableRows("select * from tblticketbreaklines");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=["id"=>$row->id, "breakline"=>$row->breakline];
            }
        }
        return ImportData($Data, "Ticket Breaklines", "support_ticket_breaklines", 'breakline',true); 
    }
    function tblaffiliateswithdrawals()
    {
        $Results = GetTableRows("select a.*, (select clientid from tblaffiliates where id=a.affiliateid) as user_id from tblaffiliateswithdrawals a");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = ($row->user_id>0) ? $row->user_id:0;
                $uInfo = getUserInfoById($user_id);
                $currency = 0;
                if(!empty($uInfo))
                {
                    $currency=($uInfo->currency>0) ? $uInfo->currency:0;
                }
                $Data[]=["id"=>$row->id, 
                        "user_id"=>$user_id, 
                        "invoice_id"=>0, 
                        "payment_method"=>0, 
                        "trans_id"=>0, 
                        "relid"=>0, 
                        "reffer_user_id"=>0, 
                        "payout_type"=>0, 
                        "type"=>'WITHDRAW', 
                        "currency"=>$currency, 
                        "entry_date"=>$row->date, 
                        "amount"=>$row->amount, 
                        "description"=>"Amount Withdrawals", 
                        ];
            }
        }
        return ImportData($Data, "Affiliates Withdrawals", "wsam_affiliates_trans","",true); 
    }
    function tblaffiliatespending()
    {
        $Results = GetTableRows("select a.*, (select clientid from tblaffiliates where id=a.affaccid) as user_id from tblaffiliatespending a");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = ($row->user_id>0) ? $row->user_id:0;
                $uInfo = getUserInfoById($user_id);
                $currency = 0;
                if(!empty($uInfo))
                {
                    $currency=($uInfo->currency>0) ? $uInfo->currency:0;
                }
                $Data[]=["user_id"=>$user_id, 
                        "currency"=>$currency, 
                        "invoice_id"=>$row->invoice_id, 
                        "amount"=>$row->amount, 
                        "clearing_date"=>$row->clearingdate, 
                        "entry_date"=>$row->created_at
                        ];
            }
        }
        return $this->ImportAffiliatesPending($Data); 
    }
    function tblaffiliates_hits()
    {
        $Results = GetTableRows("select a.*, (select clientid from tblaffiliates where id=a.affiliate_id) as user_id, (select referrer from tblaffiliates_referrers where id=a.referrer_id) as referrer from tblaffiliates_hits a");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=["id"=>$row->id, 
                        "user_id"=>($row->user_id>0) ? $row->user_id:0, 
                        "referrers"=>$row->referrer, 
                        "entry_date"=>$row->created_at
                        ];
            }
        }
        return ImportData($Data, "Affiliates Hits", "wsam_affiliates_hits","",true); 
    }
    function tblaffiliates_referrers()
    {
        $Results = GetTableRows("select a.*, (select clientid from tblaffiliates where id=a.affiliate_id) as user_id from tblaffiliates_referrers a");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=["id"=>$row->id, 
                        "user_id"=>($row->user_id>0) ? $row->user_id:0, 
                        "reffer_user_id"=>($row->user_id>0) ? $row->user_id:0, 
                        "referrers"=>$row->referrer, 
                        "entry_date"=>$row->created_at
                        ];
            }
        }
        return ImportData($Data, "Affiliates Referrers", "wsam_affiliates_links","",true); 
    }
    function tblaffiliates()
    {
        $Results = GetTableRows("select * from tblaffiliates");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                if($row->paytype == "percentage") $custom_affiliate_payout = "Percentage";
                if($row->paytype == "fixed") $custom_affiliate_payout = "Fixed Amount";
                if(empty($row->paytype)) $custom_affiliate_payout = "No Commission";

                $affiliate_key = crc32($row->clientid);
                $affiliate_key = strtoupper($affiliate_key);
        
                $Data[]=["id"=>$row->id, 
                        "entry_date"=>$row->date, 
                        "user_id"=>$row->clientid, 
                        "reffers"=>$row->visitors, 
                        "balance"=>$row->balance, 
                        "withdrawn"=>$row->withdrawn, 
                        "last_withdraw_date"=>"", 
                        "last_reffer_date"=>"", 
                        "affiliate_key"=>$affiliate_key, 
                        "withdraw_inrequest"=>0, 
                        "last_withdraw_inrequest_date"=>"", 
                        "custom_affiliate_payout"=>$custom_affiliate_payout, 
                        "affiliate_pay_amount"=>($row->payamount>0) ? $row->payamount:0, 
                        "is_affiliate_payout_type"=>($row->onetime>0) ? 'One Time':'Recurring', 
                        "status"=>'Active', 
                        "application_date"=>$row->created_at, 
                        "application_verify_date"=>$row->created_at, 
                        "application_verify_by"=>0, 
                        ];
            }
        }
        return ImportData($Data, "Affiliates", "wsam_affiliates_acct","",true); 
    }
    function tblcontacts()
    {
        $Results = GetTableRows("select * from tblcontacts");
        $Data = [];
        if(!empty($Results))
        {   $ws =& get_instance();
            foreach($Results as $row)
            {
                $password = GeneratePassword();
                $epassword = $ws->encryption->encrypt($password);
                $PhoneNumber = '';
                if(isset($row->phonenumber))
                {
                    $PhoneSegment = _ex(".", $row->phonenumber);
                    $PhoneNumber = isset($PhoneSegment[1]) ? _r(' ', '', $PhoneSegment[1]):'';
                }
                
                $Data[]=["id"=>$row->id, "user_id"=>$row->userid, "first_name"=>$row->firstname, "last_name"=>$row->lastname, "company_name"=>$row->companyname, "email"=>$row->email, 
                "address1"=>$row->address1, "address2"=>$row->address2, "city"=>$row->city, "state"=>$row->state, "postcode"=>$row->postcode, "country"=>$row->country, 
                "phonenumber"=>$PhoneNumber, "email_verified"=>1, 
                "tax_id"=>$row->tax_id, "password"=>$epassword, "permissions"=>$row->permissions, 
                "domain_emails"=>($row->domainemails>0) ? 1:0, "general_emails"=>($row->generalemails>0) ? 1:0, 
                "invoice_emails"=>($row->invoiceemails>0) ? 1:0, "product_emails"=>($row->productemails>0) ? 1:0, 
                "support_emails"=>($row->supportemails>0) ? 1:0, "affiliate_emails"=>($row->affiliateemails>0) ? 1:0, "pwresetkey"=>$row->pwresetkey, 
                "entry_date"=>$row->created_at, "update_date"=>$row->updated_at, "pwresetexpiry"=>_t($row->pwresetexpiry)];
            }
        }
        return ImportData($Data, "Contacts", "clients_contacts","",true); 
    }
    function tblusers_clients()
    {
        $Results = GetTableRows("select a.client_id, u.email, a.created_at, a.updated_at from tblusers_clients a join tblusers u on a.auth_user_id=u.id where a.auth_user_id<>a.client_id");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $client_id = $row->client_id;
                $email = $row->email;
                $isExist = getUserInfoByEmail($email);
                $user_id_to = 0;
                if(!empty($isExist)) $user_id_to = $isExist->id>0 ? $isExist->id:0;
                $Data[]=["user_id_to"=>$user_id_to, "invited_by"=>$client_id, "user_id_from"=>$client_id, "permissions"=>"", "created_at"=>$row->created_at, "invited_at"=>$row->created_at, "updated_at"=>$row->updated_at, "accepted_at"=>$row->updated_at];
            }
        }
        $Results = GetTableRows("select id, email, datecreated, updated_at from tblclients");
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $client_id = $row->id;
                $email = $row->email;
                $isExist = getUserInfoByEmail($email);
                $user_id_to = 0;
                if(!empty($isExist)) $user_id_to = $isExist->id>0 ? $isExist->id:0;
                $Data[]=["user_id_to"=>$user_id_to, "invited_by"=>$row->id, "user_id_from"=>$row->id, "permissions"=>"", "created_at"=>$row->datecreated, "invited_at"=>$row->datecreated, "updated_at"=>$row->updated_at, "accepted_at"=>$row->updated_at];
            }
        }
        return ImportData($Data, "Client Users ", "clients_users","",true); 
    }
    function tblusers()
    {
        $Results = GetTableRows("select * from tblusers order by id");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $password = GeneratePassword();
                $Data[]=["username"=>$row->first_name."_".$row->last_name."_".$row->id, "password"=>$password, "email_verified_time"=>_t($row->email_verified_at), "last_login_time"=>_t($row->last_login), "host"=>$row->last_hostname, "ip"=>$row->last_ip, "lastip"=>$row->last_ip, "language"=>$row->language, "first_name"=>$row->first_name, "last_name"=>$row->last_name, "email"=>$row->email, "date_created"=>$row->created_at, "entry_date"=>$row->created_at, "update_date"=>$row->updated_at];
            }
        }
        return ImportData($Data, "Users ", "clients", "email", false); 
    }
    function tbladmins()
    {
        $Results = GetTableRows("select * from tbladmins order by id");
        $Data = [];
        if(!empty($Results))
        {   $ws =& get_instance();
            foreach($Results as $row)
            {
                $password = GeneratePassword();
                $epassword = $ws->encryption->encrypt($password);                 
                $Data[]=[
                    "id"=>$row->id, 
                    "uuid"=>isset($row->uuid) ? $row->uuid:'', 
                    "roleid"=>isset($row->roleid) ? $row->roleid:'', 
                    "username"=>isset($row->username) ? $row->username:'', 
                    "password"=>$epassword, 
                    "passwordhash"=>$epassword, 
                    "authmodule"=>isset($row->authmodule) ? $row->authmodule:'', 
                    "authdata"=>isset($row->authdata) ? $row->authdata:'', 
                    "firstname"=>isset($row->firstname) ? $row->firstname:'', 
                    "lastname"=>isset($row->lastname) ? $row->lastname:'', 
                    "email"=>isset($row->email) ? $row->email:'', 
                    "signature"=>isset($row->signature) ? $row->signature:'', 
                    "notes"=>isset($row->notes) ? $row->notes:'', 
                    "template"=>isset($row->template) ? $row->template:'', 
                    "language"=>isset($row->language) ? $row->language:'', 
                    "disabled"=>isset($row->disabled) ? $row->disabled:'', 
                    "loginattempts"=>isset($row->loginattempts) ? $row->loginattempts:'', 
                    "supportdepts"=>isset($row->supportdepts) ? $row->supportdepts:'', 
                    "ticketnotifications"=>isset($row->ticketnotifications) ? $row->ticketnotifications:'', 
                    "homewidgets"=>isset($row->homewidgets) ? $row->homewidgets:'', 
                    "password_reset_key"=>isset($row->password_reset_key) ? $row->password_reset_key:'', 
                    "password_reset_data"=>isset($row->password_reset_data) ? $row->password_reset_data:'', 
                    "password_reset_expiry"=>isset($row->password_reset_expiry) ? $row->password_reset_expiry:'', 
                    "hidden_widgets"=>isset($row->hidden_widgets) ? $row->hidden_widgets:'', 
                    "widget_order"=>isset($row->widget_order) ? $row->widget_order:'', 
                    "user_preferences"=>isset($row->user_preferences) ? $row->user_preferences:'', 
                    "created_at"=>isset($row->created_at) ? $row->created_at:'', 
                    "updated_at"=>isset($row->updated_at) ? $row->updated_at:'', 
                    ];
            }
        }
        return ImportData($Data, "Admins", "login_admins"); 
    }
    function tbladminroles()
    {
        $Results = GetTableRows("select * from tbladminroles order by id");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "name"=>$row->name, 
                    "widgets"=>$row->widgets, 
                    "reports"=>$row->reports, 
                    "systememails"=>($row->systememails>0) ? 1:0, 
                    "accountemails"=>($row->accountemails>0) ? 1:0, 
                    "supportemails"=>($row->supportemails>0) ? 1:0, 
                ];
            }
        }
        return ImportData($Data, "Admin Roles ", "login_admin_roles","",true); 
    }
    function tblclientsfiles()
    {
        $Results = GetTableRows("select * from tblclientsfiles order by id");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "id"=>$row->id, 
                    "user_id"=>$row->userid, 
                    "file_name"=>$row->title, 
                    "old_file_name"=>$row->filename, 
                    "file_path"=>"", 
                    "file_size"=>"", 
                    "file_type"=>"", 
                    "datetime"=>$row->dateadded, 
                    "download_auth"=>($row->adminonly>0) ? 'Admin':'Both', 
                ];
            }
        }
        return ImportData($Data, "Client Files ", "clients_downloadable_files","",true); 
    }
    function tblcreditcards()
    {
        $Results = GetTableRows("select * from tblcreditcards order by id");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $user_id = 0;
                $status = "pending";
                if(_t($row->expiry_date)>time())
                {
                    $status="active";
                }else{
                    $status="expired";
                }
                $expiry_notice_sent = "NO";
                $Data[]=[
                    "id"=>$row->id, 
                    "payment_method"=>$row->pay_method_id, 
                    "card_type"=>$row->card_type, 
                    "last_four"=>$row->last_four, 
                    "expiry_date"=>$row->expiry_date, 
                    "card_data"=>$row->card_data, 
                    "created_at"=>$row->created_at, 
                    "updated_at"=>$row->updated_at, 
                    "deleted_at"=>$row->deleted_at, 
                    "status"=>$status, 
                    "expiry_notice_sent"=>$expiry_notice_sent, 
                ];
            }
        }
        return ImportData($Data, "Credit Cards ", "clients_credit_cards","",true); 
    }
    function tblcredit()
    {
        $Results = GetTableRows("select * from tblcredit order by id");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $amount_in = ($row->amount>0) ? $row->amount:0;
                $amount_out = ($row->amount>0) ? 0:abs($row->amount);
                $uInfo = getUserInfoById($row->clientid);
                $base_conv_rate = 1;
                $currency = 0;
                if(!empty($uInfo))
                {
                    $currency=$uInfo->currency;
                }
                $cInfo = getCurrencyById($currency);
                $base_conv_rate=1;
                if(!empty($cInfo))
                {
                    $base_conv_rate=$cInfo->base_conv_rate;
                    $currency=$cInfo->id;
                }
                $invoice_id = $row->relid;
                if($invoice_id <=0){
                    if (strpos($row->description, "Invoice #") !== false) 
                    {
                        preg_match_all('!\d+!', $row->description, $matches);
                        if(!empty($matches)) $invoice_id = ($matches[0][0]>0) ? $matches[0][0]:0;
                    }
                }
                $Data[]=[
                    "id"=>$row->id, 
                    "user_id"=>$row->clientid, 
                    "admin_id"=>$row->admin_id, 
                    "entry_date"=>$row->date, 
                    "description"=>$row->description, 
                    "amount_in"=>$amount_in, 
                    "amount_out"=>$amount_out, 
                    "invoice_id"=>$invoice_id, 
                    "base_conv_rate"=>$base_conv_rate, 
                    "currency"=>$currency, 
                    "trans_id "=>$invoice_id, 
                ];
            }
        }
        return ImportData($Data, "Client Credits ", "clients_credits","",true); 
    }
    function tblcurrencies()
    {
        $Results = GetTableRows("select a.id,a.code,a.prefix,a.suffix,a.format,a.rate,a.default from (select a.id,a.code,a.prefix,a.suffix,a.format,a.rate,a.default,(select min(id) from tblcurrencies where code=a.code) as mid from tblcurrencies a) a where a.id=a.mid order by a.id asc");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "code"=>$row->code, 
                    "symbol"=>(!empty($row->prefix)) ? $row->prefix:'', 
                    "suffix"=>(!empty($row->suffix)) ? $row->suffix:'', 
                    "format"=>'1234.56', 
                    "is_default"=>($row->default>0) ? 'YES':'NO', 
                    "base_conv_rate"=>($row->rate>0) ? $row->rate:0, 
                    "enabled"=>'YES', 
                    "symbol_position"=>'Before Amount', 
                    "decimal_mark"=>'.', 
                ];
            }
        }
        return ImportData($Data, "Currencies ", WST_CURRENCIES, "code",true); 
    }
    function tblclientgroups()
    {
        full_query("delete from clients_groups where id>=5");
        $Results = GetTableRows("select * from tblclientgroups order by id");
        $Data = [];
        if(!empty($Results))
        {   
            foreach($Results as $row)
            {
                $Data[]=[
                    "name"=>$row->groupname, 
                    "colour"=>(!empty($row->groupcolour)) ? $row->groupcolour:'#000000', 
                    "separate_invoices"=>($row->separateinvoices>0) ? 'YES':'NO', 
                    "suspterm_exempt"=>($row->susptermexempt>0) ? 'YES':'NO', 
                    "discount_percent"=>($row->discountpercent>0) ? $row->discountpercent:0, 
                    "is_changeable"=>'YES', 
                ];
            }
        }
        return ImportData($Data, "Client Groups ", "clients_groups", "name", false); 
    }
    function tblclients()
    {
        $CurrenciesList = GetCurrenciesList();
        $ClientGroups = GetClientGroups();
        $Results = GetTableRows("select a.*, (select groupname from tblclientgroups where id=a.groupid) as group_name, (select code from tblcurrencies where id=a.currency) as currency_code from tblclients a order by a.id");
        if(!empty($Results))
        {   
            $Clients = [];
            $ws =& get_instance();
            foreach($Results as $row)
            {
                $email_preferences = _jd($row->email_preferences, true);
                $PhoneSegment = _ex(".", $row->phonenumber);
                $PhoneNumber = isset($PhoneSegment[1]) ? _r(' ', '', $PhoneSegment[1]):'';
                $password = GeneratePassword();
                $epassword = $ws->encryption->encrypt($password); 
                $group_name = $row->group_name;
                $currency_code = $row->currency_code;
                $group_id = 1;
                if(!empty($group_name))
                {
                    $grpInfo = $ClientGroups[$group_name];
                    if(!empty($grpInfo))
                    {
                      $group_id = ($grpInfo["id"]>0) ? $grpInfo["id"]:1;  
                    }
                }
                $currency = 1;
                if(!empty($currency_code))
                {
                    $Info = $CurrenciesList[$currency_code];
                    if(!empty($Info))
                    {
                      $currency = ($Info["id"]>0) ? $Info["id"]:1;  
                    }
                }
                $Clients[$row->id]=["id"=>$row->id, 
                            "username"=>_l($row->firstname)."_".$row->id, 
                            "first_name"=>isset($row->firstname) ? $row->firstname:'', 
                            "last_name"=>isset($row->lastname) ? $row->lastname:'', 
                            "gender"=>0, 
                            "company_name"=>isset($row->companyname) ? $row->companyname:'', 
                            "email"=>isset($row->email) ? $row->email:'', 
                            "address1"=>isset($row->address1) ? $row->address1:'', 
                            "address2"=>isset($row->address2) ? $row->address2:'', 
                            "city"=>isset($row->city) ? $row->city:'', 
                            "state"=>isset($row->state) ? $row->state:'', 
                            "postcode"=>isset($row->postcode) ? $row->postcode:'', 
                            "country"=>isset($row->country) ? $row->country:'', 
                            "phonenumber"=>$PhoneNumber, 
                            "tax_id"=>($row->tax_id>0) ? $row->tax_id:0, 
                            "password"=>$epassword, 
                            "authmodule"=>isset($row->authmodule) ? $row->authmodule:'', 
                            "authdata"=>isset($row->authdata) ? $row->authdata:'', 
                            "currency"=>$currency, 
                            "payment_method_id"=>($row->gatewayid>0) ? $row->gatewayid:0, 
                            "credit"=>isset($row->credit) ? $row->credit:'', 
                            "tax_exempt"=>isset($row->taxexempt) ? (($row->taxexempt>0) ? 'YES':'NO') : 'NO', 
                            "late_fee_overide"=>isset($row->latefeeoveride) ? (($row->latefeeoveride>0) ? 'YES':'NO') : 'NO', 
                            "overide_due_notices"=>isset($row->overideduenotices) ? (($row->overideduenotices>0) ? 'YES':'NO') : 'NO', 
                            "separate_invoices"=>isset($row->separateinvoices) ? (($row->separateinvoices>0) ? 'YES':'NO') : 'NO', 
                            "disable_autocc"=>isset($row->disableautocc) ? (($row->disableautocc>0) ? 'YES':'NO') : 'NO', 
                            "security_qid"=>isset($row->securityqid) ? $row->securityqid:0, 
                            "security_qans"=>isset($row->securityqans) ? $row->securityqans:"", 
                            "date_created"=>isset($row->datecreated) ? $row->datecreated:'', 
                            "notes"=>isset($row->notes) ? $row->notes:'', 
                            "billing_cid"=>isset($row->billingcid) ? $row->billingcid:'', 
                            "group_id"=>$group_id, 
                            "card_type"=>isset($row->cardtype) ? $row->cardtype:'', 
                            "card_last_four"=>isset($row->cardlastfour) ? $row->cardlastfour:'', 
                            "card_number"=>isset($row->cardnum) ? $row->cardnum:'', 
                            "start_date"=>isset($row->startdate) ? $row->startdate:'', 
                            "exp_date"=>isset($row->expdate) ? $row->expdate:'', 
                            "issue_number"=>isset($row->issuenumber) ? $row->issuenumber:'', 
                            "bank_name"=>isset($row->bankname) ? $row->bankname:'', 
                            "bank_type"=>isset($row->banktype) ? $row->banktype:'', 
                            "bank_code"=>isset($row->bankcode) ? $row->bankcode:'', 
                            "bank_account"=>isset($row->bankaccount) ? $row->bankaccount:'', 
                            "gateway_id"=>isset($row->gatewayid) ? $row->gatewayid:'', 
                            "last_login_time"=>isset($row->lastlogin) ? _t($row->lastlogin):"", 
                            "ip"=>isset($row->ip) ? _t($row->ip):"0.0.0.0", 
                            "lastip"=>isset($row->ip) ? _t($row->ip):"0.0.0.0", 
                            "host"=>isset($row->host) ? $row->host:'', 
                            "status"=>isset($row->status) ? $row->status:'', 
                            "language"=>isset($row->language) ? $row->language:'', 
                            "pwd_reset_key"=>isset($row->pwd_reset_key) ? $row->pwd_reset_key:'', 
                            "pwd_reset_time"=>isset($row->pwd_reset_time) ? $row->pwd_reset_time:'', 
                            "email_optout"=>isset($row->emailoptout) ? (($row->emailoptout>0) ? 'YES':'NO') : 'NO', 
                            "marketing_emails_opt_in"=>isset($row->marketing_emails_opt_in) ? (($row->marketing_emails_opt_in>0) ? 'YES':'NO') : 'NO', 
                            "override_auto_close"=>isset($row->overrideautoclose) ? (($row->overrideautoclose>0) ? 'YES':'NO') : 'NO', 
                            "allow_sso"=>isset($row->allow_sso) ? (($row->allow_sso>0) ? 'YES':'NO') : 'NO', 
                            "email_verified"=>isset($row->email_verified) ? (($row->email_verified>0) ? 'YES':'NO') : 'NO', 
                            "email_verified_time"=>isset($row->email_verified) ? _t($row->datecreated) : '', 
                            "email_verified_code"=>"", 
                            "entry_date"=>isset($row->datecreated) ? date('Y-m-d', _t($row->datecreated)):'', 
                            "update_date"=>isset($row->updated_at) ? date('Y-m-d', _t($row->updated_at)):'', 
                            "pwd_reset_expiry"=>isset($row->pwd_reset_expiry) ? $row->pwd_reset_expiry:'', 
                            "timestamp"=>isset($row->entry_date) ? _t($row->entry_date):'', 
                            "user_login_attempts"=>0, 
                            "signature"=>isset($row->signature) ? $row->signature:'', 
                            "disable_status_update"=>'NO', 
                            "where_did_u_find_us"=>isset($row->where_did_u_find_us) ? $row->where_did_u_find_us:'', 
                            "two_fa_auth_enable"=>"NO", 
                            "two_fa_auth_key"=>"", 
                            "two_fa_auth_backup_code"=>"", 
                            "two_fa_auth_module"=>"", 
                            "additional_fields"=>"", 
                            "domain_emails"=>isset($email_preferences["domain"]) ? (($email_preferences["domain"]>0) ? 'YES':'NO') : 'NO', 
                            "general_emails"=>isset($email_preferences["general"]) ? (($email_preferences["general"]>0) ? 'YES':'NO') : 'NO', 
                            "invoice_emails"=>isset($email_preferences["invoice"]) ? (($email_preferences["invoice"]>0) ? 'YES':'NO') : 'NO', 
                            "product_emails"=>isset($email_preferences["product"]) ? (($email_preferences["product"]>0) ? 'YES':'NO') : 'NO', 
                            "support_emails"=>isset($email_preferences["support"]) ? (($email_preferences["support"]>0) ? 'YES':'NO') : 'NO', 
                            "affiliate_emails"=>isset($email_preferences["affiliate"]) ? (($email_preferences["affiliate"]>0) ? 'YES':'NO') : 'NO', 
                            "designation"=>"", 
                            "bio_info"=>""];

            }
        return $this->ImportClients($Clients); 
        }
        return ["status"=>"success", "message"=>"Clients Imported Successfully"];
    }    
}