<?php 
    if(!function_exists('SmsHook_Admin_OrderCreated'))
    {
        function SmsHook_Admin_OrderCreated($arg){
            if(!isSmsSentEnabled()) return null;
            $ws =& get_instance();
            $order_id = _s('order_id',$arg);
            $admins = _s('admins',$arg,[]);
            $GetOrderInfo = _jd(localAPI('GetOrderInfo',["id"=>$order_id]));
            if(empty($GetOrderInfo)) return null;
            $user_id = $GetOrderInfo->user_id;
            $order_no = $GetOrderInfo->order_no;
            $order_number = $GetOrderInfo->order_no;
            $invoice_id = $GetOrderInfo->invoice_id;
            $order_date = $GetOrderInfo->entry_date;
            $order_payment_method = $GetOrderInfo->payment_method_name;
            $order_notes = $GetOrderInfo->notes;
            $sale_amount = $GetOrderInfo->symbol.''.$GetOrderInfo->sale_amount;

            $GetUserInfo = localAPI('GetUserInfo',["id"=>$user_id]);
            if(empty($GetUserInfo)) return null;
            $full_name = $GetUserInfo->first_name.' '.$GetUserInfo->last_name;
            $uphonenumber = $GetUserInfo->phonenumber;
            $ucountry = $GetUserInfo->country;

            $template = $ws->Sms->getTemplateDetails(__FUNCTION__);
            if($template['active'] == "INACTIVE"){return null;}
            $admingsm = _ex(",", _r(" ", "",$template['admingsm']));
            $template['variables'] = _r(" ", "", $template['variables']);
            $replacefrom = _ex(",", $template['variables']);
            $replaceto = array($order_no, $sale_amount, $uphonenumber);
            $message = _r($replacefrom, $replaceto, $template['template']);

            $admin_gsm_country = $template['admin_gsm_country'];
            $cCode = $ws->Sms->getCountryCodeBy($admin_gsm_country);
            foreach($admingsm as $from){
                if(!empty($from)){
                $from = $cCode."".$from;    
                $from = $ws->Sms->validate_mobile_number($from, $admin_gsm_country);
                $ws->Sms->added_sms_in_queue($user_id, '', trim($from), $message, $full_name, $admin_gsm_country,true);//true means send direct message instead of inque
                }
            }            
        }
    }
    add_hook('OrderCreated', 1, 'SmsHook_Admin_OrderCreated');