<?php 
    if(!function_exists('SmsHook_Admin_TicketAdminReply'))
    {
        function SmsHook_Admin_TicketAdminReply($arg=[]){
            if(!isSmsSentEnabled()) return null;
            $ws =& get_instance();
             $ticket_id = _s('ticket_id',$arg);
            $reply_id = _s('reply_id',$arg);
            $message = _s('message',$arg,"");

           //Email Template Info
           $GetTicketInfo = $ws->Support->support_ticket_info($ticket_id);
           if(empty($GetTicketInfo)) return null;
           $ticket_subject = $GetTicketInfo->title;
           $ticket_status = $GetTicketInfo->status;
           $user_id = $GetTicketInfo->user_id;
           $GetUserInfo = $ws->Account->getUserInfoById($user_id);
           if(empty($GetUserInfo)) return null;

           $email = $GetUserInfo->email;
           $full_name = $GetUserInfo->first_name.' '.$GetUserInfo->last_name;

            $template = $ws->Sms->getTemplateDetails(__FUNCTION__);
            if(empty($template)) return null;
            if($template['active'] == "INACTIVE"){return null;}
            $admingsm = _ex(",", _r(" ", "",$template['admingsm']));
            
            $template['variables'] = _r(" ", "", $template['variables']);
            $replacefrom = _ex(",", $template['variables']);
            $replaceto = array($ticket_subject, $ticket_id);
            $message = _r($replacefrom, $replaceto, $template['template']);

            $admin_gsm_country = $template['admin_gsm_country'];
            $cCode = $ws->Sms->getCountryCodeBy($admin_gsm_country);
            foreach($admingsm as $from){
                if(!empty($from)){
                $from = $cCode."".$from;    
                $from = $ws->Sms->validate_mobile_number($from, $admin_gsm_country);
                $ws->Sms->added_sms_in_queue($user_id, '', trim($from), $message, $full_name, $admin_gsm_country);
                }
            }            
        }
    }
    add_hook('TicketAdminReply', 1, 'SmsHook_Admin_TicketAdminReply');