<?php 
    if(!function_exists('WsHook_CancellationRequestConfirmation'))
    {
        function WsHook_CancellationRequestConfirmation($arg){
            if(!isSmsSentEnabled()) return null;
            $ws =& get_instance();
            $user_id = _s('user_id',$arg,0);
            $cancellation_date = _s('cancellation_date',$arg,"");
            $service_id = _s('pid',$arg,"");
            $reason = _s('reason',$arg,"");
            $type = _s('type',$arg,"");
            $created_at = _s('created_at',$arg,"");
            $status = _s('status',$arg,"");
            $product_type = _s('product_type',$arg,"");

            $GetUserInfo = localAPI('GetUserInfo',["clientid"=>$user_id]);
            if(empty($GetUserInfo)) return null;
            if($product_type == 'domain'){
            $GetDomainInfo = _jd(localAPI('GetDomainInfo',["id"=>$service_id]));  
            if(empty($GetDomainInfo)) return null;  
            $service_product_name = $GetDomainInfo->title;            
            $service_domain = $GetDomainInfo->title;            
            }else{
            $GetProductsInfo = _jd(localAPI('GetProductsInfo',["id"=>$service_id])); 
            if(empty($GetProductsInfo)) return null;    
            $service_product_name = $GetProductsInfo->title;            
            }

            if($type == 'Immediate'){
            $cancellation_note = 'The service will be terminated within the next 24 hours.';
            }else{
            $cancellation_note = 'The service will be cancelled at the end of your current billing period.';
            }


           $email = $GetUserInfo->email;
           $full_name = $GetUserInfo->first_name.' '.$GetUserInfo->last_name;

           $TemplateInfo = localAPI('getEmailTemplate', 'CancellationRequestConfirmation');
           if(empty($TemplateInfo)) return null;    
           $TemplateMessage = html_entity_decode($TemplateInfo->message);
           $Message = _r('[service_product_name]', $service_product_name, $TemplateMessage); 
           $Message = _r('[service_domain]', $service_domain, $Message); 
           $Message = _r('[cancellation_note]', $cancellation_note, $Message); 
           $Message = _r('[customer_name]', $full_name, $Message); 
            return localAPI('WsMailSend', ['Template'=>$TemplateInfo, 'subject'=>'', 'Message'=>$Message, 'EmailTo'=>$email, 'ClientName'=>$full_name, 'ClientId'=>$user_id]);           
        }
    }
    add_hook('CancellationRequestConfirmation', 1, 'WsHook_CancellationRequestConfirmation');