<?php 
    if(!function_exists('WsHook_UpcomingDomainRenewalNotice'))
    {
        function WsHook_UpcomingDomainRenewalNotice($arg)
        {
            if(!isSmsSentEnabled()) return null;
            $ws =& get_instance();
            $domainInfo = _s('domain',$arg,[]);
            if(empty($domainInfo)) return null;
            $user_id = $domainInfo['user_id'];
            $domainid = $domainInfo['id'];
            $domain_name = $domainInfo['domain'];
            $next_due_date = $domainInfo['nextduedate'];
            $days_nextdue =  round(abs(now() - _t($next_due_date)) / (60 * 60 * 24));
            
            
            $template = $ws->Sms->getTemplateDetails(__FUNCTION__);
            if($template['active'] == "INACTIVE"){return null;}
            
            $UserInformation = $ws->Sms->get_client_info_by_id($user_id);
            if(empty($UserInformation['firstname'])) return null;
            $template['variables'] = _r(" ", "", $template['variables']);
            $replacefrom = _ex(",", $template['variables']);
            $replaceto = array($UserInformation['firstname'], $UserInformation['lastname'], $domain_name, $days_nextdue);
            $message = _r($replacefrom, $replaceto, $template['template']);
            $sms_to = $ws->Sms->validate_mobile_number($UserInformation['gsmnumber'], $UserInformation['country']);
            $ws->Sms->added_sms_in_queue($user_id, '', $sms_to, $message, $UserInformation['firstname'].' '.$UserInformation['lastname'], $UserInformation['country']);
        }
    }
    add_hook('UpcomingDomainRenewalNotice', 1, 'UpcomingDomainRenewalNotice_sms');