<?php 

    $templates = array(
                array(
                    'Module'=>'Support Messages', 
                    'hook' => 'TicketUserReply', 
                    'function' => 'SmsHook_User_TicketUserReply', 
                    'description' => array('english' => 'When user has replied on the ticket.'), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'User has replied on the ticket #{ticketno} with the subject {subject}.', 
                    'variables' => '{subject}, {ticketno}'
                ), 
                array(
                    'Module'=>'Cart Messages', 
                    'hook' => 'OrderCreated', 
                    'function' => 'SmsHook_Admin_OrderCreated', 
                    'description' => array('english' => 'When user created an order.'), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'Orders has been created. order no:{order_no}, Amount:{amount}, Mobile no:{mobile}.', 
                    'variables' => '{order_no}, {amount}, {mobile}'
                ), 
                array(
                    'Module'=>'Support Messages', 
                    'hook' => 'TicketOpen', 
                    'function' => 'SmsHook_Admin_TicketOpenAdmin', 
                    'description' => array('english' => 'When new ticket is created.'), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'A new ticket #{ticketno} with the subject {subject} has been created.', 
                    'variables' => '{subject}, {ticketno}'
                ), 
                array(
                    'Module'=>'Support Messages', 
                    'hook' => 'TicketClose', 
                    'function' => 'TicketClose_sms', 
                    'description' => array('english' => 'Ticket Closure'), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello {firstname} {lastname}, The ticket with the ticket number #{ticketno} has been successfully closed.In case of any issue, kindly contact us.', 
                    'variables' => '{firstname}, {lastname}, {ticketno}', 
                ), 
                array(
                    'Module'=>'Support Messages', 
                    'hook' => 'NetworkIssueAdd', 
                    'function' => 'NetworkIssueAdd_sms', 
                    'description' => array('english' => 'Network issue is being created.'), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello {firstname} {lastname}, We want to Informed you taht, Our Services goes down for maintenance.It will up soon.In case of any issue, kindly contact us.', 
                    'variables' => '{firstname}, {lastname}, {startdate}, {title}, {server}', 
                ), 
                array(
                    'Module'=>'Support Messages', 
                    'hook' => 'NetworkIssueClose', 
                    'function' => 'NetworkIssueClose_sms', 
                    'description' => array('english' => 'Network issue is being Resloved.'), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello {firstname} {lastname}, We want to Informed you that maintenance completed successfully and Our Services Up Now.Thank for Co-operation.', 
                    'variables' => '{firstname}, {lastname}', 
                ), 
                array(
                    'Module'=>'Support Messages', 
                    'hook' => 'AnnouncementAdd', 
                    'function' => 'AnnouncementAdd_sms', 
                    'description' => array('english' => 'Announcement is being Added.'), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello {firstname} {lastname}, We have an announcement regarding {title} for you.for checking Plz, Visit.', 
                    'variables' => '{firstname}, {lastname}, {title}', 
                ), 
                array(
                    'Module'=>'Support Messages', 
                    'hook' => 'TicketAdminReply', 
                    'function' => 'TicketAdminReply_sms', 
                    'description' => array(
                        'english' => 'After Reply By Admin'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'variables' => '{firstname}, {lastname}, {ticketsubject}', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, {ticketsubject} has been responded by admin.', 
                ), 
                array(
                    'Module'=>'Invoice Messages', 
                    'hook' => 'InvoicePaymentThirdoverdueReminder', 
                    'function' => 'InvoicePaymentReminder_thirdoverdue_sms', 
                    'description' => array(
                        'english' => 'Invoice payment reminder for third overdue'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, the payment for date {duedate}, associated with your is due for invoice {invoiceid}. Kindly make the payment at the earliest to enjoy the services.', 
                    'variables' => '{firstname}, {lastname}, {duedate}, {invoiceid}'
                ), 
                array(
                    'Module'=>'Invoice Messages', 
                    'hook' => 'InvoicePaymentSecondoverdueReminder', 
                    'function' => 'InvoicePaymentReminder_secondoverdue_sms', 
                    'description' => array(
                        'english' => 'Invoice payment reminder for second overdue'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, the payment for invoice with id {invoiceid}, associated with your is due.Kindly make the payment at the earliest to enjoy the services.', 
                    'variables' => '{firstname}, {lastname}, {duedate}, {invoiceid}'
                ), 
                array(
                    'Module'=>'Invoice Messages', 
                    'hook' => 'InvoicePaymentReminder', 
                    'function' => 'InvoicePaymentReminder_Reminder_sms', 
                    'description' => array(
                        'english' => 'Invoice Payment Reminder'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, for invoice with id {invoiceid}, The due date for the payment is {duedate}.Kindly make the payment for uninterrupted services.', 
                    'variables' => '{firstname}, {lastname}, {duedate}, {invoiceid}'
                ), 
                array(
                    'Module'=>'Invoice Messages', 
                    'hook' => 'InvoicePaymentFirstoverdueReminder', 
                    'function' => 'InvoicePaymentReminder_Firstoverdue_sms', 
                    'description' => array(
                        'english' => 'Invoice payment reminder for first overdue'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, the payment associated with your account with date {duedate} is not done yet for invoice {invoiceid}. Kindly make the payment at the earliest to enjoy the services.', 
                    'variables' => '{firstname}, {lastname}, {duedate}, {invoiceid}'
                ), 
                array(
                    'Module'=>'Invoice Messages', 
                    'hook' => 'InvoicePaid', 
                    'function' => 'InvoicePaid_sms', 
                    'description' => array(
                        'english' => 'Post Payment'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, payment for invoice with id {invoiceid} is done! Thank you.', 
                    'variables' => '{firstname}, {lastname}, {duedate}, {invoiceid}'
                ), 
                array(
                    'Module'=>'Invoice Messages', 
                    'hook' => 'InvoiceCreated', 
                    'function' => 'InvoiceCreated_sms', 
                    'description' => array(
                        
                        'english' => 'After Invoice Creation'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello {firstname} {lastname}, Your invoice with id {invoiceid} has been generated.Total amount is  {total}.The last day of payment is {duedate}.Kindly pay your bill before due date to use services without interruption.', 
                    'variables' => '{firstname}, {lastname}, {duedate}, {total}, {invoiceid}'
                ), 
                array(
                    'Module'=>'Invoice Messages', 
                    'hook' => 'InvoiceCancelled', 
                    'function' => 'InvoiceCancelled_sms', 
                    'description' => array(
                        
                        'english' => 'After Invoice Cancelled'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello {firstname} {lastname}, Your invoice with id {invoiceid} has been Cancelled.Total amount is  {total}.', 
                    'variables' => '{firstname}, {lastname}, {duedate}, {total}, {invoiceid}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'DailyCronJob', 
                    'function' => 'DomainRenewalNotice', 
                    'description' => array(
                        'english' => 'Domain Renewal Notice before {x} days.'
                    ), 
                    'type' => 'client', 
                    'extra' => '15', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, your domain- {domain} will expire in {x} days i.e. on {expirydate}.Kindly visit site to renew it.Thank You!.', 
                    'variables' => '{firstname}, {lastname}, {domain}{expirydate}, {x}'
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'UserLogin', 
                    'function' => 'SmsHook_Admin_UserLogin', 
                    'description' => array(
                        'english' => 'When client login.'
                    ), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'Client with the name- {firstname} {lastname} made entrance to the site.', 
                    'variables' => '{firstname}, {lastname}'
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'ClientEdit', 
                    'function' => 'ClientEdit_clientarea', 
                    'description' => array(
                        'english' => 'After Client Edit (OTP) Mobile Verification'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, your profile has been updated.', 
                    'variables' => '{firstname}, {lastname}'
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'ClientChangePassword', 
                    'function' => 'ClientChangePassword_sms', 
                    'description' => array(
                        'english' => 'After client change password'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'variables' => '{firstname}, {lastname}', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, password has been changed successfully.', 
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'ClientAreaRegister', 
                    'function' => 'otp_sms', 
                    'description' => array(
                        'english' => 'OTP Mobile Verification'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, OTP generated for your mobile phone verification is {otp}.', 
                    'variables' => '{firstname}, {lastname}, {otp}'
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'ClientAdd', 
                    'function' => 'SmsHook_Admin_ClientAdd', 
                    'description' => array(
                        'english' => 'When client is added.'
                    ), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'New customer {firstname} {lastname} has been added to the website.', 
                    'variables' => '{firstname}, {lastname}'
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'ClientAdd', 
                    'function' => 'ClientAdd_sms', 
                    'description' => array(
                        'english' => 'After Client Registration'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, Thank you for registering with us. The details of your account are- Email: {email} Password: {password}.', 
                    'variables' => '{firstname}, {lastname}, {email}, {password}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarRenewalFailed', 
                    'function' => 'SmsHook_Admin_AfterRegistrarRenewalFailed', 
                    'description' => array(
                        'english' => 'When domain registration failed.'
                    ), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'An error occurred while updating the domain {domain}.', 
                    'variables' => '{domain}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarRenewal', 
                    'function' => 'SmsHook_Admin_AfterRegistrarRenew', 
                    'description' => array(
                        'english' => 'When domain is renewed.'
                    ), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'The domain name {domain} has been renewed.', 
                    'variables' => '{domain}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarRenewal', 
                    'function' => 'AfterRegistrarRenewal_sms', 
                    'description' => array(
                        'english' => 'After domain renewal'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your domain {domain} is successfully renewed.', 
                    'variables' => '{firstname}, {lastname}, {domain}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'ExpiredDomainNotice', 
                    'function' => 'ExpiredDomainNotice_sms', 
                    'description' => array(
                        'english' => 'Domain Expire Notice'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your domain {domain} will expired in {days} days.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {days}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'UpcomingDomainRenewalNotice', 
                    'function' => 'UpcomingDomainRenewalNotice_sms', 
                    'description' => array(
                        'english' => 'Domain Expire Notice'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your domain {domain} will expired in {days} days.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {days}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarRegistrationFailed', 
                    'function' => 'SmsHook_Admin_AfterRegistrarRegistrationFailed', 
                    'description' => array(
                        'english' => 'Domain Registration Failure.'
                    ), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'An error occurred while recording the domain {domain}.', 
                    'variables' => '{domain}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarRegistrationFailed', 
                    'function' => 'AfterRegistrarRegistrationFailed_sms', 
                    'description' => array(
                        'english' => 'Domain Registration Failure'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, Your domain name {domain} could not be registered.', 
                    'variables' => '{firstname}, {lastname}, {domain}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarRegistration', 
                    'function' => 'SmsHook_Admin_AfterRegistrarRegistration', 
                    'description' => array(
                        'english' => 'When domain registered.'
                    ), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'New domain named {domain} have been registered.', 
                    'variables' => '{domain}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarRegistration', 
                    'function' => 'AfterRegistrarRegistration_sms', 
                    'description' => array(
                        'english' => 'After Domain Registration'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, Entries in the name field for the domain name {domain} have been successfully made.', 
                    'variables' => '{firstname}, {lastname}, {domain}'
                ), 
                array(
                    'Module'=>'Domain Messages', 
                    'hook' => 'AfterRegistrarTransfer', 
                    'function' => 'AfterRegistrarTransfer_sms', 
                    'description' => array(
                        'english' => 'After Domain Transfer'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, Entries in the name field for the domain name {domain} have been successfully Transfer.', 
                    'variables' => '{firstname}, {lastname}, {domain}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleUnsuspend', 
                    'function' => 'AfterModuleUnsuspend_sms', 
                    'description' => array(
                        'english' => 'After module unsuspend'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello! The services for the domain {domain} have now been made active.', 
                    'variables' => '{firstname}, {lastname}, {domain}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleSuspend', 
                    'function' => 'AfterModuleSuspend_sms', 
                    'description' => array(
                        'english' => 'After Module Suspension'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, The service for your account associated with the domain {domain} has been paused.Kindly contact us for more details.', 
                    'variables' => '{firstname}, {lastname}, {domain}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleCreateHosting', 
                    'function' => 'AfterModuleCreate_Hosting_sms', 
                    'description' => array(
                        'english' => 'Post Service Activation'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello! The services for the domain {domain} have now been made active.The login details for the accounts are- Username:{username} Password: {password}.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {username}, {password}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleTerminate', 
                    'function' => 'AfterModuleTerminate_sms', 
                    'description' => array(
                        'english' => 'Service Termination'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello! The services for the domain {domain} have been terminated.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {username}, {password}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleCreateResellerAccount', 
                    'function' => 'AfterModuleCreateResellerAccount_sms', 
                    'description' => array(
                        'english' => 'Reseller Account Creation'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello! The Reseller services for the domain {domain} have now been made active.The login details for the accounts are- Username:{username} Password: {password}.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {username}, {password}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleCreateOtherService', 
                    'function' => 'AfterModuleCreateOtherService_sms', 
                    'description' => array(
                        'english' => 'Other Services Account Creation'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello! The services for the domain {domain} have now been made active.The login details for the accounts are- Username:{username} Password: {password}.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {username}, {password}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleCreateDedicatedVPS', 
                    'function' => 'AfterModuleCreateDedicatedVPS_sms', 
                    'description' => array(
                        'english' => 'Dedicated/VPS Services'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello! The Dedicated/VPS services for the domain {domain} have now been made active.The login details for the accounts are- Username:{username} Password: {password}.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {username}, {password}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleChangePassword', 
                    'function' => 'AfterModuleChangePassword_sms', 
                    'description' => array(
                        'english' => 'After module password changed'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hi {firstname} {lastname}, password for the {domain} has been changed successfully.Here are the details- Username: {username} Password: {password}.', 
                    'variables' => '{firstname}, {lastname}, {domain}, {username}, {password}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AfterModuleChangePackage', 
                    'function' => 'AfterModuleChangePackage_sms', 
                    'description' => array('english' => 'Following Module Package Change'), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Hello {firstname} {lastname}, The product/service package for your domain {domain} is changed.Kindly contact us for more details.', 
                    'variables' => '{firstname}, {lastname}, {domain}'
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'AdminLogin', 
                    'function' => 'SmsHook_AdminLogin', 
                    'description' => array('english' => 'When AnyOne Login in Admin Panel.'), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'A user with the username {username} has entered the admin panel.', 
                    'variables' => '{username}'
                ), 
                array(
                    'Module'=>'Account Messages', 
                    'hook' => 'UserLogin', 
                    'function' => 'UserLogin', 
                    'description' => array('english' => 'When AnyOne Login in Client Panel.'), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'A user with the username {username} has entered the admin panel.', 
                    'variables' => '{username}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'CancellationRequest', 
                    'function' => 'SmsHook_Admin_CancellationRequest', 
                    'description' => array('english' => 'When Cancellation request is being created.'), 
                    'type' => 'admin', 
                    'extra' => '', 
                    'defaultmessage' => 'A user with the username {username} has Posted Cancellation Request.', 
                    'variables' => '{username}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'QuoteCreated', 
                    'function' => 'QuoteCreated_sms', 
                    'description' => array(
                        'english' => 'New Quote Creation'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your quote {subject} associated with the ID #{quoteid} has been Created.', 
                    'variables' => '{firstname}, {lastname}, {quoteid}, {subject}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AcceptQuote', 
                    'function' => 'AcceptQuote_sms', 
                    'description' => array(
                        'english' => 'Post Quote Acceptance'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your quote {subject} associated with the ID #{quoteid} has been Accepted.', 
                    'variables' => '{firstname}, {lastname}, {quoteid}, {subject}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'AcceptOrder', 
                    'function' => 'AcceptOrder_SMS', 
                    'description' => array(
                        'english' => 'Post Order Acceptance'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your order associated with the ID #{orderid} has been approved.', 
                    'variables' => '{firstname}, {lastname}, {orderid}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'CancelOrder', 
                    'function' => 'CancelOrder_SMS', 
                    'description' => array(
                        'english' => 'Post Order Cancelled'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your order associated with the ID #{orderid} has been Cancelled.', 
                    'variables' => '{firstname}, {lastname}, {orderid}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'OrderPaid', 
                    'function' => 'OrderPaid_SMS', 
                    'description' => array(
                        'english' => 'When First Order Paid'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your order associated with the ID #{orderid} has been Paid.', 
                    'variables' => '{firstname}, {lastname}, {orderid}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'DeleteOrder', 
                    'function' => 'DeleteOrder_SMS', 
                    'description' => array(
                        'english' => 'Post Order Deleted'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your order associated with the ID #{orderid} has been Deleted.', 
                    'variables' => '{firstname}, {lastname}, {orderid}'
                ), 
                array(
                    'Module'=>'Product/Service Messages', 
                    'hook' => 'FraudOrder', 
                    'function' => 'FraudOrder_SMS', 
                    'description' => array(
                        'english' => 'Post Order Marked as Fraud'
                    ), 
                    'type' => 'client', 
                    'extra' => '', 
                    'defaultmessage' => 'Dear {firstname} {lastname}, Your order associated with the ID #{orderid} has been marked as Fraud.', 
                    'variables' => '{firstname}, {lastname}, {orderid}'
                )
                );