<?php
function virtualmin_config($params=[])
{
    return array(
        "name" => "Virtualmin",
        "description" => "Virtualmin is an open-source web hosting control panel for Linux.",
        "version" => "1.0",
        "author" => "WHMSOLS",
        "author_url"=>"https://whmsols.com",
        "RequiresServer"=>true,//true or false
        "AutoGenerateUsernameAndPassword"=>true,//true or false
        "DefaultNonSSLPort"=>'10000',
        "DefaultSSLPort"=>'10000',
        "WebmailSSLPort"=>'',
        "WebmailNonSSLPort"=>'',
        "ServiceSingleSignOnLabel"=>'',
        "AdminSingleSignOnLabel"=>'',
        //"PackagesLoader"=>'PackagesLoader',
        "configs" =>[
            "configoption1" =>["Name"=>"Template Name","Type" => "text", "Size" => "30"],
            "configoption2" =>["Name"=>"Plan Name","Type" => "text", "Size" => "30"],
            "configoption3" =>["Name"=>"Dedicated IP","Type" => "yesno", "Description" => "Tick to auto assign next available dedicated IP"]
        ]);
}

function virtualmin_ClientArea(array $params)
{
    $domain = $params["serverhostname"] ? $params["serverhostname"] : $params["serverip"];
    $domain = explode(":", $domain);
    $port = "";
    if (count($domain) == 2) $port = $domain[1];
    $domain = $domain[0];
    if (!$port) $port = $params["serverport"];

    $domain = $domain . ":" . $port;
    $form = sprintf("<form action=\"%s://%s/session_login.cgi\" method=\"post\" target=\"_blank\">" . "<input type=\"hidden\" name=\"user\" value=\"%s\" />" . "<input type=\"hidden\" name=\"pass\" value=\"%s\" />" . "<input type=\"hidden\" name=\"notestingcookie\" value=\"1\" />" . "<input type=\"submit\" value=\"%s\" class=\"button\" />" . "</form>", $params["serverhttpprefix"],$domain,$params["username"],$params["password"],"Login to Panel");
    return $form;
}
function virtualmin_AdminLink(array $params)
{
    $domain = $params["serverhostname"] ? $params["serverhostname"] : $params["serverip"];
    $domain = explode(":", $domain);
    $port = "";
    if (count($domain) == 2) $port = $domain[1];
    $domain = $domain[0];
    if (!$port) $port = $params["serverport"];
    $domain = $domain . ":" . $port;
    $form = sprintf("<form action=\"%s://%s/session_login.cgi\" method=\"post\" target=\"_blank\">" . "<input type=\"hidden\" name=\"user\" value=\"%s\" />" . "<input type=\"hidden\" name=\"pass\" value=\"%s\" />" . "<input type=\"hidden\" name=\"notestingcookie\" value=\"1\" />" . "<input type=\"submit\" value=\"%s\" class=\"button\" />" . "</form>", $params["serverhttpprefix"],$domain,$params["serverusername"],$params["serverpassword"], "Login to Control Panel");
    return $form;
}
function virtualmin_CreateAccount($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    
    $updateData = array();
    if ($params["type"] == "reseller")
    {
        if (!$params["username"])
        {
            $username = preg_replace("/[^a-z0-9]/", "", strtolower($params["client"]["firstname"] . $params["client"]["lastname"] . $params["serviceid"]));
            $updateData["user_name"] = $username;
            $params["username"] = $username;
        }
        $postfields = array();
        $postfields["program"] = "create-reseller";
        $postfields["name"] = $params["username"];
        $postfields["pass"] = $params["password"];
        $postfields["email"] = $params["client"]["email"];
        if ($configurations["configoption2"]) {
            $postfields["plan"] = $configurations["configoption2"];
        }
        $result = virtualmin_req($params, $postfields);
    } else {
        $postfields = array();
        $postfields["program"] = "create-domain";
        $postfields["domain"] = $params["domain"];
        $postfields["user"] = $params["username"];
        $postfields["pass"] = $params["password"];
        $postfields["email"] = $params["client"]["email"];
        if ($configurations["configoption1"]) {
            $postfields["template"] = $configurations["configoption1"];
        }
        if ($configurations["configoption2"]) {
            $postfields["plan"] = $configurations["configoption2"];
        }
        if ($configurations["configoption3"]) {
            $postfields["allocate-ip"] = "";
        }
        $postfields["features-from-plan"] = "";
        $result = virtualmin_req($params, $postfields);
    }
    if ($updateData) UpdateServiceInfo($updateData,$params["serviceid"]);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Created Successfully"];
}
function virtualmin_SuspendAccount($params)
{
    if ($params["type"] == "reseller") {
        $postfields = array();
        $postfields["program"] = "modify-reseller";
        $postfields["name"] = $params["username"];
        $postfields["pass"] = md5(rand(10000, 99999999) . $params["domain"]);
        $postfields["lock"] = "1";
    } else {
        $postfields = array();
        $postfields["program"] = "disable-domain";
        $postfields["domain"] = $params["domain"];
    }
    $result = virtualmin_req($params, $postfields);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Suspended Successfully"];
}
function virtualmin_UnsuspendAccount($params)
{
    if ($params["type"] == "reseller") {
        $postfields = array();
        $postfields["program"] = "modify-reseller";
        $postfields["name"] = $params["username"];
        $postfields["pass"] = $params["password"];
        $postfields["lock"] = "0";
    } else {
        $postfields = array();
        $postfields["program"] = "enable-domain";
        $postfields["domain"] = $params["domain"];
    }
    $result = virtualmin_req($params, $postfields);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account UnSuspended Successfully"];
}
function virtualmin_TerminateAccount($params)
{
    if ($params["type"] == "reseller") {
        $postfields = array();
        $postfields["program"] = "delete-reseller";
        $postfields["name"] = $params["username"];
    } else {
        $postfields = array();
        $postfields["program"] = "delete-domain";
        $postfields["domain"] = $params["domain"];
    }
    $result = virtualmin_req($params, $postfields);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Account Terminated Successfully"];
}
function virtualmin_ChangePassword($params)
{
    $postfields = array();
    $postfields["program"] = "modify-domain";
    $postfields["domain"] = $params["domain"];
    $postfields["pass"] = $params["password"];
    $result = virtualmin_req($params, $postfields);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Password Changed Successfully"];
}
function virtualmin_ChangePackage($params)
{
    $product = $params["product"];
    $configurations = $product["configurations"];    

    $postfields = array();
    $postfields["program"] = "modify-domain";
    $postfields["domain"] = $params["domain"];
    $postfields["plan-features"] = "";
    if ($configurations["configoption1"]) {
        $postfields["template"] = $configurations["configoption1"];
    }
    if ($configurations["configoption2"]) {
        $postfields["apply-plan"] = $configurations["configoption2"];
    }
    $result = virtualmin_req($params, $postfields);
    if($result !="success") return ["status"=>"error","message"=>$result];
    return ["status"=>"success","message"=>"Package Changed Successfully"];
}
function virtualmin_UsageUpdate($params)
{
    $postfields = array();
    $postfields["program"] = "list-domains";
    $postfields["json"] = 1;
    $postfields["multiline"] = "";
    $result = virtualmin_req($params, $postfields, true);
    $result = json_decode($result, true);
    $dataArray = $result["data"];
    $serverid = $params["serverid"];
    foreach ($dataArray as $values)
    {
        $domain = $values["name"];
        $domainData = $values["values"];
        if (!$domain)
        {
            continue;
        }
        $getScalarValue = function ($key, array $data)
        {
            $value = isset($data[$key]) ? $data[$key] : 0;
            if (is_array($value)) {
                $value = array_shift($value);
            }
            return $value;
        }

        $diskusage = $getScalarValue("server_byte_quota_used", $domainData) / 1048576;
        $disklimit = $getScalarValue("server_block_quota", $domainData) / 1024;
        $bwlimit = $getScalarValue("bandwidth_byte_limit", $domainData) / 1048576;
        $bwused = $getScalarValue("bandwidth_byte_usage", $domainData) / 1048576;
        $isUpdated =  UpdateServiceInfo([
                "disk_usage" => $diskusage,
                "disk_limit" => $disklimit,
                "bandwidth_usage" => $bwused,
                "bandwidth_limit" => $bwlimit,
                "email_accounts_limit"=>0,
                "domains_limit"=>0,
                "sub_domains_limit"=>0,
                "parked_domains_limit"=>0,
                "databases_limit"=>'',
                "databases_disk_limit"=>'',
                "databases_disk_usage"=>'',
                "databases_usage"=>'',
                "parked_domains_usage"=>'',
                "sub_domains_usage"=>'',
                "domains_usage"=>'',
                "email_accounts_usage"=>'',
                "last_update"=>Carbon::now()->format('Y-m-d h:i:s')],["server_id"=>$serverid, "domain_name"=>$domain,"status"=>"Active"]);
            if($isUpdated) $count++;
    }
    if($serverid > 0)
    {
        UpdateServerInfo(['remote_acct_usage'=>$count,'up_status'=>'Up','last_check_date'=>Carbon::now()->format('Y-m-d h:i:s')],['id'=>$serverid]);
    }
    if($count>0) return array('status'=>'success','message'=>$count.' Accounts Stats Updated....');
    return ["status"=>"error","message"=>"Account Stats Updation failed"];    
}
function virtualmin_req($params, $postfields, $rawdata = false)
{
    $http = $params["serverhttpprefix"];
    $domain = $params["serverhostname"] ? $params["serverhostname"] : $params["serverip"];
    $domain = explode(":", $domain);
    $port = "";
    if (count($domain) == 2) {
        $port = $domain[1];
    }
    $domain = $domain[0];
    if (!$port) {
        $port = $params["serverport"];
    }
    $url = (string) $http . "://" . $domain . ":" . $port . "/virtual-server/remote.cgi?";
    $fieldstring = "";
    foreach ($postfields as $k => $v) {
        $fieldstring .= (string) $k . "=" . urlencode($v) . "&";
    }
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $fieldstring);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_USERPWD, $params["serverusername"] . ":" . $params["serverpassword"]);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);
    $data = curl_exec($ch);
    if (curl_errno($ch)) {
        $data = "Curl Error: " . curl_errno($ch) . " - " . curl_error($ch);
    }
    curl_close($ch);
    logModuleCall("virtualmin", $postfields["program"], $postfields, $data);
    if (strpos($data, "Unauthorized") == true) {
        return "Server Login Invalid";
    }
    if ($rawdata) {
        return $data;
    }
    $exitstatuspos = strpos($data, "Exit status:");
    $exitstatus = trim(substr($data, $exitstatuspos + 12));
    if ($exitstatus == "0") {
        $result = "success";
    } else {
        $dataarray = explode("\n", $data);
        $result = $dataarray[0];
    }
    return $result;
}